/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/path","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/strings","vs/base/node/pfs","vs/base/common/objects","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/uuid","vs/base/common/process","os","vs/platform/environment/common/environment","fs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/base/common/extpath","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/extensionManagement/common/extensionManagement","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/codicons","vs/base/common/json","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/performance","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/server/node/remoteUriTransformer","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/marshalling","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/mime","vs/base/common/glob","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","url","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/processes","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/common/severity","vs/base/common/console","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/credentials/common/credentials","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","path","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/languageFeatureRegistry","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/environment/node/argvHelper","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/workspaces/common/workspaces","vs/server/node/remoteExtensionManagement","vs/server/node/remoteTelemetryChannel","vs/server/node/remoteTelemetryService","vs/server/node/remoteFileSystemProviderServer","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/extensions/node/extensionPoints","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],we=function(J){for(var e=[],_=0,t=J.length;_<t;_++)e[_]=ve[J[_]];return e};define(ve[117],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class _{static get(){const p=new Map,k=new Map,D=new Map,R=new Map;function y(v,l){v.has(l.detail)||v.set(l.detail,-l.timestamp)}function b(v,l){let d=v.get(l.detail);!d||d>=0||v.set(l.detail,d+l.timestamp)}const T=J.getStats().slice(0).sort((v,l)=>v.timestamp-l.timestamp);for(const v of T)switch(v.type){case 10:y(p,v);break;case 11:case 12:b(p,v);break;case 21:y(k,v);break;case 22:b(k,v);break;case 33:y(D,v);break;case 34:b(D,v);break;case 31:y(R,v);break;case 32:b(R,v);break}let A=0;D.forEach(v=>A+=v);function h(v){let l=[];return v.forEach((d,g)=>l.push([g,d])),l}return{amdLoad:h(p),amdInvoke:h(k),nodeRequire:h(D),nodeEval:h(R),nodeRequireTotal:A}}static toMarkdownTable(p,k){let D="",R=[];return p.forEach((y,b)=>{R[b]=y.length}),k.forEach(y=>{y.forEach((b,T)=>{typeof b=="undefined"&&(b=y[T]="-");const A=b.toString().length;R[T]=Math.max(A,R[T])})}),p.forEach((y,b)=>{D+=`| ${y+" ".repeat(R[b]-y.toString().length)} `}),D+=`|
`,p.forEach((y,b)=>{D+=`| ${"-".repeat(R[b])} `}),D+=`|
`,k.forEach(y=>{y.forEach((b,T)=>{typeof b!="undefined"&&(D+=`| ${b+" ".repeat(R[T]-b.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=_}),define(ve[118],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(t,p){if(!t)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=_}),define(ve[37],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function _(D){return D?D.replace(/\$\((.*?)\)/g,(R,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=_;class t{constructor(R,y,b){this.id=R,this.definition=y,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function p(D,R){const y=["codicon","codicon-"+D];return R&&y.push("codicon-modifier-"+R),y}e.getClassNamesArray=p;var k;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function y(A){if(A instanceof t)return["codicon","codicon-"+A.id];const h=R.exec(A.id);if(!h)return y(t.error);let[,v,l]=h;const d=["codicon","codicon-"+v];return l&&d.push("codicon-modifier-"+l.substr(1)),d}D.asClassNameArray=y;function b(A){return y(A).join(" ")}D.asClassName=b;function T(A){return"."+y(A).join(".")}D.asCSSSelector=T})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ve[73],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function _(D){return(R,y,b)=>{let T=null,A=null;if(typeof b.value=="function"?(T="value",A=b.value):typeof b.get=="function"&&(T="get",A=b.get),!A)throw new Error("not supported");b[T]=D(A,y)}}e.createDecorator=_;function t(D,R,y){let b=null,T=null;if(typeof y.value=="function"?(b="value",T=y.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(b="get",T=y.get),!T)throw new Error("not supported");const A=`$memoize$${R}`;y[b]=function(...h){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,h)}),this[A]}}e.memoize=t;function p(D,R,y){return _((b,T)=>{const A=`$debounce$${T}`,h=`$debounce$result$${T}`;return function(...v){this[h]||(this[h]=y?y():void 0),clearTimeout(this[A]),R&&(this[h]=R(this[h],...v),v=[this[h]]),this[A]=setTimeout(()=>{b.apply(this,v),this[h]=y?y():void 0},D)}})}e.debounce=p;function k(D,R,y){return _((b,T)=>{const A=`$throttle$timer$${T}`,h=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,l=`$throttle$pending$${T}`;return function(...d){if(this[h]||(this[h]=y?y():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[h]=R(this[h],...d)),this[l])return;const g=this[v]+D;g<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[h]]),this[h]=y?y():void 0):(this[l]=!0,this[A]=setTimeout(()=>{this[l]=!1,this[v]=Date.now(),b.apply(this,[this[h]]),this[h]=y?y():void 0},g-Date.now()))}})}e.throttle=k}),define(ve[11],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(a=>{a(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=_,e.errorHandler=new _;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function p(f){y(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=p;function k(f){y(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=k;function D(f){if(f instanceof Error){let{name:s,message:a}=f;const i=f.stacktrace||f.stack;return{$isError:!0,name:s,message:a,stack:i}}return f}e.transformErrorForSerialization=D;const R="Canceled";function y(f){return f instanceof b?!0:f instanceof Error&&f.name===R&&f.message===R}e.isCancellationError=y;class b extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=b;function T(){const f=new Error(R);return f.name=f.message,f}e.canceled=T;function A(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=A;function h(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=h;function v(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function l(f){const s=new Error(`${f} has been disposed`);return s.name="DISPOSED",s}e.disposed=l;function d(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=d;class g extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=g;class S extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=S;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function C(f){const s=f;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=C;function w(f,s=Object.create(null)){const a=new Error(f);return s.actions&&(a.actions=s.actions),a}e.createErrorWithActions=w}),define(ve[17],we([0,1,11]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(Z,$=0){return Z[Z.length-(1+$)]}e.tail=t;function p(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=p;function k(Z,$,H=(V,ie)=>V===ie){if(Z===$)return!0;if(!Z||!$||Z.length!==$.length)return!1;for(let V=0,ie=Z.length;V<ie;V++)if(!H(Z[V],$[V]))return!1;return!0}e.equals=k;function D(Z,$,H){let V=0,ie=Z.length-1;for(;V<=ie;){const de=(V+ie)/2|0,De=H(Z[de],$);if(De<0)V=de+1;else if(De>0)ie=de-1;else return de}return-(V+1)}e.binarySearch=D;function R(Z,$){let H=0,V=Z.length;if(V===0)return 0;for(;H<V;){const ie=Math.floor((H+V)/2);$(Z[ie])?V=ie:H=ie+1}return H}e.findFirstInSorted=R;function y(Z,$,H){if(Z=Z|0,Z>=$.length)throw new TypeError("invalid index");let V=$[Math.floor($.length*Math.random())],ie=[],de=[],De=[];for(let ae of $){const fe=H(ae,V);fe<0?ie.push(ae):fe>0?de.push(ae):De.push(ae)}return Z<ie.length?y(Z,ie,H):Z<ie.length+De.length?De[0]:y(Z-(ie.length+De.length),de,H)}e.quickSelect=y;function b(Z,$){const H=[];let V;for(const ie of Z.slice(0).sort($))!V||$(V[0],ie)!==0?(V=[ie],H.push(V)):V.push(ie);return H}e.groupBy=b;function T(Z,$,H){const V=[];function ie(ae,fe,pe){if(fe===0&&pe.length===0)return;const X=V[V.length-1];X&&X.start+X.deleteCount===ae?(X.deleteCount+=fe,X.toInsert.push(...pe)):V.push({start:ae,deleteCount:fe,toInsert:pe})}let de=0,De=0;for(;;){if(de===Z.length){ie(de,0,$.slice(De));break}if(De===$.length){ie(de,Z.length-de,[]);break}const ae=Z[de],fe=$[De],pe=H(ae,fe);pe===0?(de+=1,De+=1):pe<0?(ie(de,1,[]),de+=1):pe>0&&(ie(de,0,[fe]),De+=1)}return V}e.sortedDiff=T;function A(Z,$,H){const V=T(Z,$,H),ie=[],de=[];for(const De of V)ie.push(...Z.slice(De.start,De.start+De.deleteCount)),de.push(...De.toInsert);return{removed:ie,added:de}}e.delta=A;function h(Z,$,H){if(H===0)return[];const V=Z.slice(0,H).sort($);return l(Z,$,V,H,Z.length),V}e.top=h;function v(Z,$,H,V,ie){return H===0?Promise.resolve([]):new Promise((de,De)=>{(async()=>{const ae=Z.length,fe=Z.slice(0,H).sort($);for(let pe=H,X=Math.min(H+V,ae);pe<ae;pe=X,X=Math.min(X+V,ae)){if(pe>H&&await new Promise(U=>setTimeout(U)),ie&&ie.isCancellationRequested)throw(0,_.canceled)();l(Z,$,fe,pe,X)}return fe})().then(de,De)})}e.topAsync=v;function l(Z,$,H,V,ie){for(const de=H.length;V<ie;V++){const De=Z[V];if($(De,H[de-1])<0){H.pop();const ae=R(H,fe=>$(De,fe)<0);H.splice(ae,0,De)}}}function d(Z){return Z.filter($=>!!$)}e.coalesce=d;function g(Z){let $=0;for(let H=0;H<Z.length;H++)Z[H]&&(Z[$]=Z[H],$+=1);Z.length=$}e.coalesceInPlace=g;function S(Z,$,H){Z.splice(H,0,Z.splice($,1)[0])}e.move=S;function c(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=c;function C(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=C;function w(Z,$=H=>H){const H=new Set;return Z.filter(V=>{const ie=$(V);return H.has(ie)?!1:(H.add(ie),!0)})}e.distinct=w;function f(Z){const $=new Set;return H=>{const V=Z(H);return $.has(V)?!1:($.add(V),!0)}}e.uniqueFilter=f;function s(Z,$){const H=a(Z,$);if(H!==-1)return Z[H]}e.findLast=s;function a(Z,$){for(let H=Z.length-1;H>=0;H--){const V=Z[H];if($(V))return H}return-1}e.lastIndex=a;function i(Z,$){return Z.length>0?Z[0]:$}e.firstOrDefault=i;function n(Z,$,H=(V,ie)=>V===ie){let V=0;for(let ie=0,de=Math.min(Z.length,$.length);ie<de&&H(Z[ie],$[ie]);ie++)V++;return V}e.commonPrefixLength=n;function r(Z){return[].concat(...Z)}e.flatten=r;function o(Z,$){let H=typeof $=="number"?Z:0;typeof $=="number"?H=Z:(H=0,$=Z);const V=[];if(H<=$)for(let ie=H;ie<$;ie++)V.push(ie);else for(let ie=H;ie>$;ie--)V.push(ie);return V}e.range=o;function u(Z,$,H){return Z.reduce((V,ie)=>(V[$(ie)]=H?H(ie):ie,V),Object.create(null))}e.index=u;function E(Z,$){return Z.push($),()=>P(Z,$)}e.insert=E;function P(Z,$){const H=Z.indexOf($);if(H>-1)return Z.splice(H,1),$}e.remove=P;function I(Z,$,H){const V=Z.slice(0,$),ie=Z.slice($);return V.concat(H,ie)}e.arrayInsert=I;function O(Z,$){let H;if(typeof $=="number"){let V=$;H=()=>{const ie=Math.sin(V++)*179426549;return ie-Math.floor(ie)}}else H=Math.random;for(let V=Z.length-1;V>0;V-=1){const ie=Math.floor(H()*(V+1)),de=Z[V];Z[V]=Z[ie],Z[ie]=de}}e.shuffle=O;function z(Z,$){const H=Z.indexOf($);H>-1&&(Z.splice(H,1),Z.unshift($))}e.pushToStart=z;function j(Z,$){const H=Z.indexOf($);H>-1&&(Z.splice(H,1),Z.push($))}e.pushToEnd=j;function m(Z,$){return Array.isArray(Z)?Z.map($):$(Z)}e.mapArrayOrNot=m;function L(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=L;function M(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=M;function Q(Z,$){for(const H of Z){const V=$(H);if(V!==void 0)return V}}e.mapFind=Q;function W(Z,$,H){const V=ne(Z,$),ie=Z.length,de=H.length;Z.length=ie+de;for(let De=ie-1;De>=V;De--)Z[De+de]=Z[De];for(let De=0;De<de;De++)Z[De+V]=H[De]}e.insertInto=W;function q(Z,$,H,V){const ie=ne(Z,$),de=Z.splice(ie,H);return W(Z,ie,V),de}e.splice=q;function ne(Z,$){return $<0?Math.max($+Z.length,0):Math.min($,Z.length)}function B(Z,$){return(H,V)=>$(Z(H),Z(V))}e.compareBy=B;const G=(Z,$)=>Z-$;e.numberComparator=G;function ee(Z,$){if(Z.length===0)return;let H=Z[0];for(let V=1;V<Z.length;V++){const ie=Z[V];$(ie,H)>0&&(H=ie)}return H}e.findMaxBy=ee;function oe(Z,$){if(Z.length===0)return;let H=Z[0];for(let V=1;V<Z.length;V++){const ie=Z[V];$(ie,H)>=0&&(H=ie)}return H}e.findLastMaxBy=oe;function se(Z,$){return ee(Z,(H,V)=>-$(H,V))}e.findMinBy=se;class me{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let H=this.firstIdx;for(;H<this.items.length&&$(this.items[H]);)H++;const V=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,V}takeFromEndWhile($){let H=this.lastIdx;for(;H>=0&&$(this.items[H]);)H--;const V=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,V}peek(){return this.items[this.firstIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}takeCount($){const H=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,H}}e.ArrayQueue=me}),define(ve[74],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(t){const p=this;let k=!1,D;return function(){return k||(k=!0,D=t.apply(p,arguments)),D}}e.once=_}),define(ve[51],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(t){function p(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=p;const k=Object.freeze([]);function D(){return k}t.empty=D;function*R(f){yield f}t.single=R;function y(f){return f||k}t.from=y;function b(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=b;function T(f){return f[Symbol.iterator]().next().value}t.first=T;function A(f,s){for(const a of f)if(s(a))return!0;return!1}t.some=A;function h(f,s){for(const a of f)if(s(a))return a}t.find=h;function*v(f,s){for(const a of f)s(a)&&(yield a)}t.filter=v;function*l(f,s){let a=0;for(const i of f)yield s(i,a++)}t.map=l;function*d(...f){for(const s of f)for(const a of s)yield a}t.concat=d;function*g(f){for(const s of f)for(const a of s)yield a}t.concatNested=g;function S(f,s,a){let i=a;for(const n of f)i=s(i,n);return i}t.reduce=S;function*c(f,s,a=f.length){for(s<0&&(s+=f.length),a<0?a+=f.length:a>f.length&&(a=f.length);s<a;s++)yield f[s]}t.slice=c;function C(f,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,f];const i=f[Symbol.iterator]();for(let n=0;n<s;n++){const r=i.next();if(r.done)return[a,t.empty()];a.push(r.value)}return[a,{[Symbol.iterator](){return i}}]}t.consume=C;function w(f,s,a=(i,n)=>i===n){const i=f[Symbol.iterator](),n=s[Symbol.iterator]();for(;;){const r=i.next(),o=n.next();if(r.done!==o.done)return!1;if(r.done)return!0;if(!a(r.value,o.value))return!1}}t.equals=w})(_=e.Iterable||(e.Iterable={}))}),define(ve[38],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var p;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(p=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(s){s.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function D(s,a=!1){let i=0,n=s.length,r="",o=0,u=16,E=0;function P(M){let Q=0,W=0;for(;Q<M;){const q=s.charCodeAt(i);if(q>=48&&q<=57)W=W*16+q-48;else if(q>=65&&q<=70)W=W*16+q-65+10;else if(q>=97&&q<=102)W=W*16+q-97+10;else break;i++,Q++}return Q<M&&(W=-1),W}function I(M){i=M,r="",o=0,u=16,E=0}function O(){const M=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&b(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&b(s.charCodeAt(i)))for(i++;i<s.length&&b(s.charCodeAt(i));)i++;else return E=3,s.substring(M,i);let Q=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&b(s.charCodeAt(i))){for(i++;i<s.length&&b(s.charCodeAt(i));)i++;Q=i}else E=3;return s.substring(M,Q)}function z(){let M="",Q=i;for(;;){if(i>=n){M+=s.substring(Q,i),E=2;break}const W=s.charCodeAt(i);if(W===34){M+=s.substring(Q,i),i++;break}if(W===92){if(M+=s.substring(Q,i),i++,i>=n){E=2;break}switch(s.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const ne=P(4);ne>=0?M+=String.fromCharCode(ne):E=4;break}default:E=5}Q=i;continue}if(W>=0&&W<=31)if(y(W)){M+=s.substring(Q,i),E=2;break}else E=6;i++}return M}function j(){if(r="",E=0,o=i,i>=n)return o=n,u=17;let M=s.charCodeAt(i);if(R(M)){do i++,r+=String.fromCharCode(M),M=s.charCodeAt(i);while(R(M));return u=15}if(y(M))return i++,r+=String.fromCharCode(M),M===13&&s.charCodeAt(i)===10&&(i++,r+=`
`),u=14;switch(M){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,r=z(),u=10;case 47:{const Q=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!y(s.charCodeAt(i));)i++;return r=s.substring(Q,i),u=12}if(s.charCodeAt(i+1)===42){i+=2;const W=n-1;let q=!1;for(;i<W;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,q=!0;break}i++}return q||(i++,E=1),r=s.substring(Q,i),u=13}return r+=String.fromCharCode(M),i++,u=16}case 45:if(r+=String.fromCharCode(M),i++,i===n||!b(s.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),u=11;default:for(;i<n&&m(M);)i++,M=s.charCodeAt(i);if(o!==i){switch(r=s.substring(o,i),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(M),i++,u=16}}function m(M){if(R(M)||y(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let M;do M=j();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>i,scan:a?L:j,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>E}}e.createScanner=D;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function y(s){return s===10||s===13||s===8232||s===8233}function b(s){return s>=48&&s<=57}var T;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(T||(T={}));function A(s,a){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function E(P,I,O,z){o.value=P,o.offset=I,o.length=O,o.type=z,o.colonOffset=void 0,r=o}try{C(s,{onObjectBegin:(P,I)=>{if(a<=P)throw n;r=void 0,u=a>P,i.push("")},onObjectProperty:(P,I,O)=>{if(a<I||(E(P,I,O,"property"),i[i.length-1]=P,a<=I+O))throw n},onObjectEnd:(P,I)=>{if(a<=P)throw n;r=void 0,i.pop()},onArrayBegin:(P,I)=>{if(a<=P)throw n;r=void 0,i.push(0)},onArrayEnd:(P,I)=>{if(a<=P)throw n;r=void 0,i.pop()},onLiteralValue:(P,I,O)=>{if(a<I||(E(P,I,O,f(P)),a<=I+O))throw n},onSeparator:(P,I,O)=>{if(a<=I)throw n;if(P===":"&&r&&r.type==="property")r.colonOffset=I,u=!1,r=void 0;else if(P===","){const z=i[i.length-1];typeof z=="number"?i[i.length-1]=z+1:(u=!0,i[i.length-1]=""),r=void 0}}})}catch(P){if(P!==n)throw P}return{path:i,previousNode:r,isAtPropertyKey:u,matches:P=>{let I=0;for(let O=0;I<P.length&&O<i.length;O++)if(P[I]===i[O]||P[I]==="*")I++;else if(P[I]!=="**")return!1;return I===P.length}}}e.getLocation=A;function h(s,a=[],i=k.DEFAULT){let n=null,r=[];const o=[];function u(P){Array.isArray(r)?r.push(P):n!==null&&(r[n]=P)}return C(s,{onObjectBegin:()=>{const P={};u(P),o.push(r),r=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const P=[];u(P),o.push(r),r=P,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:u,onError:(P,I,O)=>{a.push({error:P,offset:I,length:O})}},i),r[0]}e.parse=h;function v(s,a=[],i=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(P){n.type==="property"&&(n.length=P-n.offset,n=n.parent)}function o(P){return n.children.push(P),P}C(s,{onObjectBegin:P=>{n=o({type:"object",offset:P,length:-1,parent:n,children:[]})},onObjectProperty:(P,I,O)=>{n=o({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:P,offset:I,length:O,parent:n})},onObjectEnd:(P,I)=>{n.length=P+I-n.offset,n=n.parent,r(P+I)},onArrayBegin:(P,I)=>{n=o({type:"array",offset:P,length:-1,parent:n,children:[]})},onArrayEnd:(P,I)=>{n.length=P+I-n.offset,n=n.parent,r(P+I)},onLiteralValue:(P,I,O)=>{o({type:f(P),offset:I,length:O,parent:n,value:P}),r(I+O)},onSeparator:(P,I,O)=>{n.type==="property"&&(P===":"?n.colonOffset=I:P===","&&r(I))},onError:(P,I,O)=>{a.push({error:P,offset:I,length:O})}},i);const E=n.children[0];return E&&delete E.parent,E}e.parseTree=v;function l(s,a){if(!s)return;let i=s;for(let n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=l;function d(s){if(!s.parent||!s.parent.children)return[];const a=d(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;a.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&a.push(i)}return a}e.getNodePath=d;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const a=Object.create(null);for(let i of s.children){const n=i.children[1];n&&(a[i.children[0].value]=g(n))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function S(s,a,i=!1){return a>=s.offset&&a<s.offset+s.length||i&&a===s.offset+s.length}e.contains=S;function c(s,a,i=!1){if(S(s,a,i)){const n=s.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const o=c(n[r],a,i);if(o)return o}return s}}e.findNodeAtOffset=c;function C(s,a,i=k.DEFAULT){const n=D(s,!1);function r(me){return me?()=>me(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(me){return me?Z=>me(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=r(a.onObjectBegin),E=o(a.onObjectProperty),P=r(a.onObjectEnd),I=r(a.onArrayBegin),O=r(a.onArrayEnd),z=o(a.onLiteralValue),j=o(a.onSeparator),m=r(a.onComment),L=o(a.onError),M=i&&i.disallowComments,Q=i&&i.allowTrailingComma;function W(){for(;;){const me=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:M||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(me){case 12:case 13:M?q(10):m();break;case 16:q(1);break;case 15:case 14:break;default:return me}}}function q(me,Z=[],$=[]){if(L(me),Z.length+$.length>0){let H=n.getToken();for(;H!==17;){if(Z.indexOf(H)!==-1){W();break}else if($.indexOf(H)!==-1)break;H=W()}}}function ne(me){const Z=n.getTokenValue();return me?z(Z):E(Z),W(),!0}function B(){switch(n.getToken()){case 11:{let me=0;try{me=JSON.parse(n.getTokenValue()),typeof me!="number"&&(q(2),me=0)}catch{q(2)}z(me);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return W(),!0}function G(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(j(":"),W(),se()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function ee(){u(),W();let me=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(me||q(4,[],[]),j(","),W(),n.getToken()===2&&Q)break}else me&&q(6,[],[]);G()||q(4,[],[2,5]),me=!0}return P(),n.getToken()!==2?q(7,[2],[]):W(),!0}function oe(){I(),W();let me=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(me||q(4,[],[]),j(","),W(),n.getToken()===4&&Q)break}else me&&q(6,[],[]);se()||q(4,[],[4,5]),me=!0}return O(),n.getToken()!==4?q(8,[4],[]):W(),!0}function se(){switch(n.getToken()){case 3:return oe();case 1:return ee();case 10:return ne(!0);default:return B()}}return W(),n.getToken()===17?i.allowEmptyContent?!0:(q(4,[],[]),!1):se()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=C;function w(s,a){let i=D(s),n=[],r,o=0,u;do switch(u=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==u&&n.push(s.substring(o,u)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=w;function f(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ve[119],we([0,1,38]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(b,T,A){let h,v,l,d,g;if(T){for(d=T.offset,g=d+T.length,l=d;l>0&&!y(b,l-1);)l--;let u=g;for(;u<b.length&&!y(b,u);)u++;v=b.substring(l,u),h=D(v,A)}else v=b,h=0,l=0,d=0,g=b.length;const S=R(A,b);let c=!1,C=0,w;A.insertSpaces?w=k(" ",A.tabSize||4):w="	";const f=(0,_.createScanner)(v,!1);let s=!1;function a(){return S+k(w,h+C)}function i(){let u=f.scan();for(c=!1;u===15||u===14;)c=c||u===14,u=f.scan();return s=u===16||f.getTokenError()!==0,u}const n=[];function r(u,E,P){!s&&E<g&&P>d&&b.substring(E,P)!==u&&n.push({offset:E,length:P-E,content:u})}let o=i();if(o!==17){const u=f.getTokenOffset()+l,E=k(w,h);r(E,l,u)}for(;o!==17;){let u=f.getTokenOffset()+f.getTokenLength()+l,E=i(),P="";for(;!c&&(E===12||E===13);){const O=f.getTokenOffset()+l;r(" ",u,O),u=f.getTokenOffset()+f.getTokenLength()+l,P=E===12?a():"",E=i()}if(E===2)o!==1&&(C--,P=a());else if(E===4)o!==3&&(C--,P=a());else{switch(o){case 3:case 1:C++,P=a();break;case 5:case 12:P=a();break;case 13:c?P=a():P=" ";break;case 6:P=" ";break;case 10:if(E===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?P=" ":E!==5&&E!==17&&(s=!0);break;case 16:s=!0;break}c&&(E===12||E===13)&&(P=a())}const I=f.getTokenOffset()+l;r(P,u,I),o=E}return n}e.format=t;function p(b,T){const A=JSON.stringify(b,void 0,T.insertSpaces?T.tabSize||4:"	");return T.eol!==void 0?A.replace(/\r\n|\r|\n/g,T.eol):A}e.toFormattedString=p;function k(b,T){let A="";for(let h=0;h<T;h++)A+=b;return A}function D(b,T){let A=0,h=0;const v=T.tabSize||4;for(;A<b.length;){const l=b.charAt(A);if(l===" ")h++;else if(l==="	")h+=v;else break;A++}return Math.floor(h/v)}function R(b,T){for(let A=0;A<T.length;A++){const h=T.charAt(A);if(h==="\r")return A+1<T.length&&T.charAt(A+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=R;function y(b,T){return`\r
`.indexOf(b.charAt(T))!==-1}e.isEOL=y}),define(ve[120],we([0,1,38,119]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function p(b,T,A){return k(b,T,void 0,A)}e.removeProperty=p;function k(b,T,A,h,v){const l=T.slice(),d=[],g=(0,_.parseTree)(b,d);let S,c;for(;l.length>0&&(c=l.pop(),S=(0,_.findNodeAtLocation)(g,l),S===void 0&&A!==void 0);)typeof c=="string"?A={[c]:A}:A=[A];if(S)if(S.type==="object"&&typeof c=="string"&&Array.isArray(S.children)){const C=(0,_.findNodeAtLocation)(S,[c]);if(C!==void 0)if(A===void 0){if(!C.parent)throw new Error("Malformed AST");const w=S.children.indexOf(C.parent);let f,s=C.parent.offset+C.parent.length;if(w>0){const a=S.children[w-1];f=a.offset+a.length}else f=S.offset+1,S.children.length>1&&(s=S.children[1].offset);return D(b,{offset:f,length:s-f,content:""},h)}else return D(b,{offset:C.offset,length:C.length,content:JSON.stringify(A)},h);else{if(A===void 0)return[];const w=`${JSON.stringify(c)}: ${JSON.stringify(A)}`,f=v?v(S.children.map(a=>a.children[0].value)):S.children.length;let s;if(f>0){const a=S.children[f-1];s={offset:a.offset+a.length,length:0,content:","+w}}else S.children.length===0?s={offset:S.offset+1,length:0,content:w}:s={offset:S.offset+1,length:0,content:w+","};return D(b,s,h)}}else if(S.type==="array"&&typeof c=="number"&&Array.isArray(S.children))if(A!==void 0){const C=`${JSON.stringify(A)}`;let w;if(S.children.length===0||c===0)w={offset:S.offset+1,length:0,content:S.children.length===0?C:C+","};else{const f=c===-1||c>S.children.length?S.children.length:c,s=S.children[f-1];w={offset:s.offset+s.length,length:0,content:","+C}}return D(b,w,h)}else{const C=c,w=S.children[C];let f;if(S.children.length===1)f={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===C){const s=S.children[C-1],a=s.offset+s.length,i=S.offset+S.length;f={offset:a,length:i-2-a,content:""}}else f={offset:w.offset,length:S.children[C+1].offset-w.offset,content:""};return D(b,f,h)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${S.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return D(b,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(A)},h)}}e.setProperty=k;function D(b,T,A){let h=R(b,T),v=T.offset,l=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;v>0&&!(0,t.isEOL)(h,v-1);)v--;for(;l<h.length&&!(0,t.isEOL)(h,l);)l++}const d=(0,t.format)(h,{offset:v,length:l-v},A);for(let S=d.length-1;S>=0;S--){const c=d[S];h=R(h,c),v=Math.min(v,c.offset),l=Math.max(l,c.offset+c.length),l+=c.content.length-c.length}const g=b.length-(h.length-l)-v;return[{offset:v,length:g,content:h.substring(v,l)}]}e.withFormatting=D;function R(b,T){return b.substring(0,T.offset)+T.content+b.substring(T.offset+T.length)}e.applyEdit=R;function y(b,T){let A=T.slice(0).sort((v,l)=>{const d=v.offset-l.offset;return d===0?v.length-l.length:d}),h=b.length;for(let v=A.length-1;v>=0;v--){let l=A[v];if(l.offset+l.length<=h)b=R(b,l);else throw new Error("Overlapping edit");h=l.offset}return b}e.applyEdits=y}),define(ve[121],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(p){this.executor=p,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(p){this._error=p}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(p){return new _(()=>p(this.getValue()))}}e.Lazy=_}),define(ve[2],we([0,1,74,51]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const p=!1;let k=null;function D(n){k=n}if(e.setDisposableTracker=D,p){const n="__is_disposable_tracked__";D(new class{trackDisposable(r){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(o)},3e3)}setParent(r,o){if(r&&r!==c.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==c.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function R(n){return k?.trackDisposable(n),n}function y(n){k?.markAsDisposed(n)}function b(n,r){k?.setParent(n,r)}function T(n,r){if(!!k)for(const o of n)k.setParent(o,r)}function A(n){return k?.markAsSingleton(n),n}e.markAsSingleton=A;class h extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=h;function v(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=v;function l(n){if(t.Iterable.is(n)){let r=[];for(const o of n)if(o)try{o.dispose()}catch(u){r.push(u)}if(r.length===1)throw r[0];if(r.length>1)throw new h(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=l;function d(...n){const r=g(()=>l(n));return T(n,r),r}e.combinedDisposable=d;function g(n){const r=R({dispose:(0,_.once)(()=>{y(r),n()})});return r}e.toDisposable=g;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return b(r,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new S,R(this),b(this._store,this)}dispose(){y(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&b(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&b(r,null),r}}e.MutableDisposable=C;class w{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=w;class f{constructor(){this.references=new Map}acquire(r,...o){let u=this.references.get(r);u||(u={counter:0,object:this.createReferencedObject(r,...o)},this.references.set(r,u));const{object:E}=u,P=(0,_.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(r,u.object),this.references.delete(r))});return u.counter++,{object:E,dispose:P}}}e.ReferenceCollection=f;class s{constructor(r){this.referenceCollection=r}async acquire(r,...o){const u=this.referenceCollection.acquire(r,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(E){throw u.dispose(),E}}}e.AsyncReferenceCollection=s;class a{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=a;function i(n){const r=new S;try{n(r)}finally{r.dispose()}}e.disposeOnReturn=i}),define(ve[122],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(k){this.element=k,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class t{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){let k=this._first;for(;k!==_.Undefined;){const D=k.next;k.prev=_.Undefined,k.next=_.Undefined,k=D}this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,D){const R=new _(k);if(this._first===_.Undefined)this._first=R,this._last=R;else if(D){const b=this._last;this._last=R,R.prev=b,b.next=R}else{const b=this._first;this._first=R,R.next=b,b.prev=R}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(R))}}shift(){if(this._first!==_.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==_.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==_.Undefined&&k.next!==_.Undefined){const D=k.prev;D.next=k.next,k.next.prev=D}else k.prev===_.Undefined&&k.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):k.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):k.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==_.Undefined;)yield k.element,k=k.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[123],we([1]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(ae,fe){for(var pe=0;pe<fe.length;pe++){var X=fe[pe];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ae,X.key,X)}}function _(ae,fe,pe){return fe&&e(ae.prototype,fe),pe&&e(ae,pe),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function t(ae,fe){if(!!ae){if(typeof ae=="string")return p(ae,fe);var pe=Object.prototype.toString.call(ae).slice(8,-1);if(pe==="Object"&&ae.constructor&&(pe=ae.constructor.name),pe==="Map"||pe==="Set")return Array.from(ae);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return p(ae,fe)}}function p(ae,fe){(fe==null||fe>ae.length)&&(fe=ae.length);for(var pe=0,X=new Array(fe);pe<fe;pe++)X[pe]=ae[pe];return X}function k(ae,fe){var pe=typeof Symbol!="undefined"&&ae[Symbol.iterator]||ae["@@iterator"];if(pe)return(pe=pe.call(ae)).next.bind(pe);if(Array.isArray(ae)||(pe=t(ae))||fe&&ae&&typeof ae.length=="number"){pe&&(ae=pe);var X=0;return function(){return X>=ae.length?{done:!0}:{done:!1,value:ae[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=D();function R(ae){J.defaults=ae}var y=/[&<>"']/,b=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(fe){return h[fe]};function l(ae,fe){if(fe){if(y.test(ae))return ae.replace(b,v)}else if(T.test(ae))return ae.replace(A,v);return ae}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ae){return ae.replace(d,function(fe,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var S=/(^|[^\[])\^/g;function c(ae,fe){ae=ae.source||ae,fe=fe||"";var pe={replace:function(U,K){return K=K.source||K,K=K.replace(S,"$1"),ae=ae.replace(U,K),pe},getRegex:function(){return new RegExp(ae,fe)}};return pe}var C=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(ae,fe,pe){if(ae){var X;try{X=decodeURIComponent(g(pe)).replace(C,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}fe&&!w.test(pe)&&(pe=r(fe,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var s={},a=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(ae,fe){s[" "+ae]||(a.test(ae)?s[" "+ae]=ae+"/":s[" "+ae]=P(ae,"/",!0)),ae=s[" "+ae];var pe=ae.indexOf(":")===-1;return fe.substring(0,2)==="//"?pe?fe:ae.replace(i,"$1")+fe:fe.charAt(0)==="/"?pe?fe:ae.replace(n,"$1")+fe:ae+fe}var o={exec:function(){}};function u(ae){for(var fe=1,pe,X;fe<arguments.length;fe++){pe=arguments[fe];for(X in pe)Object.prototype.hasOwnProperty.call(pe,X)&&(ae[X]=pe[X])}return ae}function E(ae,fe){var pe=ae.replace(/\|/g,function(K,Y,ue){for(var ye=!1,Pe=Y;--Pe>=0&&ue[Pe]==="\\";)ye=!ye;return ye?"|":" |"}),X=pe.split(/ \|/),U=0;if(X[0].trim()||X.shift(),X[X.length-1].trim()||X.pop(),X.length>fe)X.splice(fe);else for(;X.length<fe;)X.push("");for(;U<X.length;U++)X[U]=X[U].trim().replace(/\\\|/g,"|");return X}function P(ae,fe,pe){var X=ae.length;if(X===0)return"";for(var U=0;U<X;){var K=ae.charAt(X-U-1);if(K===fe&&!pe)U++;else if(K!==fe&&pe)U++;else break}return ae.substr(0,X-U)}function I(ae,fe){if(ae.indexOf(fe[1])===-1)return-1;for(var pe=ae.length,X=0,U=0;U<pe;U++)if(ae[U]==="\\")U++;else if(ae[U]===fe[0])X++;else if(ae[U]===fe[1]&&(X--,X<0))return U;return-1}function O(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(ae,fe){if(fe<1)return"";for(var pe="";fe>1;)fe&1&&(pe+=ae),fe>>=1,ae+=ae;return pe+ae}function j(ae,fe,pe,X){var U=fe.href,K=fe.title?l(fe.title):null,Y=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){X.state.inLink=!0;var ue={type:"link",raw:pe,href:U,title:K,text:Y,tokens:X.inlineTokens(Y,[])};return X.state.inLink=!1,ue}else return{type:"image",raw:pe,href:U,title:K,text:l(Y)}}function m(ae,fe){var pe=ae.match(/^(\s+)(?:```)/);if(pe===null)return fe;var X=pe[1];return fe.split(`
`).map(function(U){var K=U.match(/^\s+/);if(K===null)return U;var Y=K[0];return Y.length>=X.length?U.slice(X.length):U}).join(`
`)}var L=function(){function ae(pe){this.options=pe||J.defaults}var fe=ae.prototype;return fe.space=function(X){var U=this.rules.block.newline.exec(X);if(U&&U[0].length>0)return{type:"space",raw:U[0]}},fe.code=function(X){var U=this.rules.block.code.exec(X);if(U){var K=U[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:U[0],codeBlockStyle:"indented",text:this.options.pedantic?K:P(K,`
`)}}},fe.fences=function(X){var U=this.rules.block.fences.exec(X);if(U){var K=U[0],Y=m(K,U[3]||"");return{type:"code",raw:K,lang:U[2]?U[2].trim():U[2],text:Y}}},fe.heading=function(X){var U=this.rules.block.heading.exec(X);if(U){var K=U[2].trim();if(/#$/.test(K)){var Y=P(K,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(K=Y.trim())}var ue={type:"heading",raw:U[0],depth:U[1].length,text:K,tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},fe.hr=function(X){var U=this.rules.block.hr.exec(X);if(U)return{type:"hr",raw:U[0]}},fe.blockquote=function(X){var U=this.rules.block.blockquote.exec(X);if(U){var K=U[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:U[0],tokens:this.lexer.blockTokens(K,[]),text:K}}},fe.list=function(X){var U=this.rules.block.list.exec(X);if(U){var K,Y,ue,ye,Pe,Ae,Fe,Ue,le,ge,he,_e,Me=U[1].trim(),qe=Me.length>1,Be={type:"list",raw:"",ordered:qe,start:qe?+Me.slice(0,-1):"",loose:!1,items:[]};Me=qe?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=qe?Me:"[*+-]");for(var He=new RegExp("^( {0,3}"+Me+")((?: [^\\n]*)?(?:\\n|$))");X&&(_e=!1,!(!(U=He.exec(X))||this.rules.block.hr.test(X)));){if(K=U[0],X=X.substring(K.length),Ue=U[2].split(`
`,1)[0],le=X.split(`
`,1)[0],this.options.pedantic?(ye=2,he=Ue.trimLeft()):(ye=U[2].search(/[^ ]/),ye=ye>4?1:ye,he=Ue.slice(ye),ye+=U[1].length),Ae=!1,!Ue&&/^ *$/.test(le)&&(K+=le+`
`,X=X.substring(le.length+1),_e=!0),!_e)for(var je=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:[*+-]|\\d{1,9}[.)])");X&&(ge=X.split(`
`,1)[0],Ue=ge,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!je.test(Ue));){if(Ue.search(/[^ ]/)>=ye||!Ue.trim())he+=`
`+Ue.slice(ye);else if(!Ae)he+=`
`+Ue;else break;!Ae&&!Ue.trim()&&(Ae=!0),K+=ge+`
`,X=X.substring(ge.length+1)}Be.loose||(Fe?Be.loose=!0:/\n *\n *$/.test(K)&&(Fe=!0)),this.options.gfm&&(Y=/^\[[ xX]\] /.exec(he),Y&&(ue=Y[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:K,task:!!Y,checked:ue,loose:!1,text:he}),Be.raw+=K}Be.items[Be.items.length-1].raw=K.trimRight(),Be.items[Be.items.length-1].text=he.trimRight(),Be.raw=Be.raw.trimRight();var re=Be.items.length;for(Pe=0;Pe<re;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var be=Be.items[Pe].tokens.filter(function(Le){return Le.type==="space"}),ke=be.every(function(Le){for(var Oe=Le.raw.split(""),Qe=0,We=k(Oe),Ve;!(Ve=We()).done;){var Ye=Ve.value;if(Ye===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Be.loose&&be.length&&ke&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},fe.html=function(X){var U=this.rules.block.html.exec(X);if(U){var K={type:"html",raw:U[0],pre:!this.options.sanitizer&&(U[1]==="pre"||U[1]==="script"||U[1]==="style"),text:U[0]};return this.options.sanitize&&(K.type="paragraph",K.text=this.options.sanitizer?this.options.sanitizer(U[0]):l(U[0]),K.tokens=[],this.lexer.inline(K.text,K.tokens)),K}},fe.def=function(X){var U=this.rules.block.def.exec(X);if(U){U[3]&&(U[3]=U[3].substring(1,U[3].length-1));var K=U[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:K,raw:U[0],href:U[2],title:U[3]}}},fe.table=function(X){var U=this.rules.block.table.exec(X);if(U){var K={type:"table",header:E(U[1]).map(function(Fe){return{text:Fe}}),align:U[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:U[3]?U[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(K.header.length===K.align.length){K.raw=U[0];var Y=K.align.length,ue,ye,Pe,Ae;for(ue=0;ue<Y;ue++)/^ *-+: *$/.test(K.align[ue])?K.align[ue]="right":/^ *:-+: *$/.test(K.align[ue])?K.align[ue]="center":/^ *:-+ *$/.test(K.align[ue])?K.align[ue]="left":K.align[ue]=null;for(Y=K.rows.length,ue=0;ue<Y;ue++)K.rows[ue]=E(K.rows[ue],K.header.length).map(function(Fe){return{text:Fe}});for(Y=K.header.length,ye=0;ye<Y;ye++)K.header[ye].tokens=[],this.lexer.inlineTokens(K.header[ye].text,K.header[ye].tokens);for(Y=K.rows.length,ye=0;ye<Y;ye++)for(Ae=K.rows[ye],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=[],this.lexer.inlineTokens(Ae[Pe].text,Ae[Pe].tokens);return K}}},fe.lheading=function(X){var U=this.rules.block.lheading.exec(X);if(U){var K={type:"heading",raw:U[0],depth:U[2].charAt(0)==="="?1:2,text:U[1],tokens:[]};return this.lexer.inline(K.text,K.tokens),K}},fe.paragraph=function(X){var U=this.rules.block.paragraph.exec(X);if(U){var K={type:"paragraph",raw:U[0],text:U[1].charAt(U[1].length-1)===`
`?U[1].slice(0,-1):U[1],tokens:[]};return this.lexer.inline(K.text,K.tokens),K}},fe.text=function(X){var U=this.rules.block.text.exec(X);if(U){var K={type:"text",raw:U[0],text:U[0],tokens:[]};return this.lexer.inline(K.text,K.tokens),K}},fe.escape=function(X){var U=this.rules.inline.escape.exec(X);if(U)return{type:"escape",raw:U[0],text:l(U[1])}},fe.tag=function(X){var U=this.rules.inline.tag.exec(X);if(U)return!this.lexer.state.inLink&&/^<a /i.test(U[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(U[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(U[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(U[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:U[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(U[0]):l(U[0]):U[0]}},fe.link=function(X){var U=this.rules.inline.link.exec(X);if(U){var K=U[2].trim();if(!this.options.pedantic&&/^</.test(K)){if(!/>$/.test(K))return;var Y=P(K.slice(0,-1),"\\");if((K.length-Y.length)%2==0)return}else{var ue=I(U[2],"()");if(ue>-1){var ye=U[0].indexOf("!")===0?5:4,Pe=ye+U[1].length+ue;U[2]=U[2].substring(0,ue),U[0]=U[0].substring(0,Pe).trim(),U[3]=""}}var Ae=U[2],Fe="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ue&&(Ae=Ue[1],Fe=Ue[3])}else Fe=U[3]?U[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(K)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),j(U,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},U[0],this.lexer)}},fe.reflink=function(X,U){var K;if((K=this.rules.inline.reflink.exec(X))||(K=this.rules.inline.nolink.exec(X))){var Y=(K[2]||K[1]).replace(/\s+/g," ");if(Y=U[Y.toLowerCase()],!Y||!Y.href){var ue=K[0].charAt(0);return{type:"text",raw:ue,text:ue}}return j(K,Y,K[0],this.lexer)}},fe.emStrong=function(X,U,K){K===void 0&&(K="");var Y=this.rules.inline.emStrong.lDelim.exec(X);if(!!Y&&!(Y[3]&&K.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=Y[1]||Y[2]||"";if(!ue||ue&&(K===""||this.rules.inline.punctuation.exec(K))){var ye=Y[0].length-1,Pe,Ae,Fe=ye,Ue=0,le=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,U=U.slice(-1*X.length+ye);(Y=le.exec(U))!=null;)if(Pe=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!Pe){if(Ae=Pe.length,Y[3]||Y[4]){Fe+=Ae;continue}else if((Y[5]||Y[6])&&ye%3&&!((ye+Ae)%3)){Ue+=Ae;continue}if(Fe-=Ae,!(Fe>0)){if(Ae=Math.min(Ae,Ae+Fe+Ue),Math.min(ye,Ae)%2){var ge=X.slice(1,ye+Y.index+Ae);return{type:"em",raw:X.slice(0,ye+Y.index+Ae+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var he=X.slice(2,ye+Y.index+Ae-1);return{type:"strong",raw:X.slice(0,ye+Y.index+Ae+1),text:he,tokens:this.lexer.inlineTokens(he,[])}}}}}},fe.codespan=function(X){var U=this.rules.inline.code.exec(X);if(U){var K=U[2].replace(/\n/g," "),Y=/[^ ]/.test(K),ue=/^ /.test(K)&&/ $/.test(K);return Y&&ue&&(K=K.substring(1,K.length-1)),K=l(K,!0),{type:"codespan",raw:U[0],text:K}}},fe.br=function(X){var U=this.rules.inline.br.exec(X);if(U)return{type:"br",raw:U[0]}},fe.del=function(X){var U=this.rules.inline.del.exec(X);if(U)return{type:"del",raw:U[0],text:U[2],tokens:this.lexer.inlineTokens(U[2],[])}},fe.autolink=function(X,U){var K=this.rules.inline.autolink.exec(X);if(K){var Y,ue;return K[2]==="@"?(Y=l(this.options.mangle?U(K[1]):K[1]),ue="mailto:"+Y):(Y=l(K[1]),ue=Y),{type:"link",raw:K[0],text:Y,href:ue,tokens:[{type:"text",raw:Y,text:Y}]}}},fe.url=function(X,U){var K;if(K=this.rules.inline.url.exec(X)){var Y,ue;if(K[2]==="@")Y=l(this.options.mangle?U(K[0]):K[0]),ue="mailto:"+Y;else{var ye;do ye=K[0],K[0]=this.rules.inline._backpedal.exec(K[0])[0];while(ye!==K[0]);Y=l(K[0]),K[1]==="www."?ue="http://"+Y:ue=Y}return{type:"link",raw:K[0],text:Y,href:ue,tokens:[{type:"text",raw:Y,text:Y}]}}},fe.inlineText=function(X,U){var K=this.rules.inline.text.exec(X);if(K){var Y;return this.lexer.state.inRawBlock?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(K[0]):l(K[0]):K[0]:Y=l(this.options.smartypants?U(K[0]):K[0]),{type:"text",raw:K[0],text:Y}}},ae}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=c(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=c(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=c(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=c(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=c(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=c(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=u({},M),M.gfm=u({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=c(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=c(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=u({},M.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:c(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=c(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=c(M._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=c(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=c(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=c(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=c(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=c(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=c(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=c(Q.reflink).replace("label",Q._label).replace("ref",M._label).getRegex(),Q.nolink=c(Q.nolink).replace("ref",M._label).getRegex(),Q.reflinkSearch=c(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=u({},Q),Q.pedantic=u({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=u({},Q.normal,{escape:c(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=c(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=u({},Q.gfm,{br:c(Q.br).replace("{2,}","*").getRegex(),text:c(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function W(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(ae){var fe="",pe,X,U=ae.length;for(pe=0;pe<U;pe++)X=ae.charCodeAt(pe),Math.random()>.5&&(X="x"+X.toString(16)),fe+="&#"+X+";";return fe}var ne=function(){function ae(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||J.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:M.normal,inline:Q.normal};this.options.pedantic?(X.block=M.pedantic,X.inline=Q.pedantic):this.options.gfm&&(X.block=M.gfm,this.options.breaks?X.inline=Q.breaks:X.inline=Q.gfm),this.tokenizer.rules=X}ae.lex=function(X,U){var K=new ae(U);return K.lex(X)},ae.lexInline=function(X,U){var K=new ae(U);return K.inlineTokens(X)};var fe=ae.prototype;return fe.lex=function(X){X=X.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(X,this.tokens);for(var U;U=this.inlineQueue.shift();)this.inlineTokens(U.src,U.tokens);return this.tokens},fe.blockTokens=function(X,U){var K=this;U===void 0&&(U=[]),this.options.pedantic&&(X=X.replace(/^ +$/gm,""));for(var Y,ue,ye,Pe;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(Y=Fe.call({lexer:K},X,U))?(X=X.substring(Y.raw.length),U.push(Y),!0):!1}))){if(Y=this.tokenizer.space(X)){X=X.substring(Y.raw.length),Y.raw.length===1&&U.length>0?U[U.length-1].raw+=`
`:U.push(Y);continue}if(Y=this.tokenizer.code(X)){X=X.substring(Y.raw.length),ue=U[U.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.text,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):U.push(Y);continue}if(Y=this.tokenizer.fences(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.heading(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.hr(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.blockquote(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.list(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.html(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.def(X)){X=X.substring(Y.raw.length),ue=U[U.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.raw,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.lheading(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(ye=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,Ue=X.slice(1),le=void 0;K.options.extensions.startBlock.forEach(function(ge){le=ge.call({lexer:this},Ue),typeof le=="number"&&le>=0&&(Fe=Math.min(Fe,le))}),Fe<1/0&&Fe>=0&&(ye=X.substring(0,Fe+1))}(),this.state.top&&(Y=this.tokenizer.paragraph(ye))){ue=U[U.length-1],Pe&&ue.type==="paragraph"?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):U.push(Y),Pe=ye.length!==X.length,X=X.substring(Y.raw.length);continue}if(Y=this.tokenizer.text(X)){X=X.substring(Y.raw.length),ue=U[U.length-1],ue&&ue.type==="text"?(ue.raw+=`
`+Y.raw,ue.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):U.push(Y);continue}if(X){var Ae="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,U},fe.inline=function(X,U){this.inlineQueue.push({src:X,tokens:U})},fe.inlineTokens=function(X,U){var K=this;U===void 0&&(U=[]);var Y,ue,ye,Pe=X,Ae,Fe,Ue;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)le.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+z("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+z("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Fe||(Ue=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(Y=he.call({lexer:K},X,U))?(X=X.substring(Y.raw.length),U.push(Y),!0):!1}))){if(Y=this.tokenizer.escape(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.tag(X)){X=X.substring(Y.raw.length),ue=U[U.length-1],ue&&Y.type==="text"&&ue.type==="text"?(ue.raw+=Y.raw,ue.text+=Y.text):U.push(Y);continue}if(Y=this.tokenizer.link(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(Y.raw.length),ue=U[U.length-1],ue&&Y.type==="text"&&ue.type==="text"?(ue.raw+=Y.raw,ue.text+=Y.text):U.push(Y);continue}if(Y=this.tokenizer.emStrong(X,Pe,Ue)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.codespan(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.br(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.del(X)){X=X.substring(Y.raw.length),U.push(Y);continue}if(Y=this.tokenizer.autolink(X,q)){X=X.substring(Y.raw.length),U.push(Y);continue}if(!this.state.inLink&&(Y=this.tokenizer.url(X,q))){X=X.substring(Y.raw.length),U.push(Y);continue}if(ye=X,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,_e=X.slice(1),Me=void 0;K.options.extensions.startInline.forEach(function(qe){Me=qe.call({lexer:this},_e),typeof Me=="number"&&Me>=0&&(he=Math.min(he,Me))}),he<1/0&&he>=0&&(ye=X.substring(0,he+1))}(),Y=this.tokenizer.inlineText(ye,W)){X=X.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(Ue=Y.raw.slice(-1)),Fe=!0,ue=U[U.length-1],ue&&ue.type==="text"?(ue.raw+=Y.raw,ue.text+=Y.text):U.push(Y);continue}if(X){var ge="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return U},_(ae,null,[{key:"rules",get:function(){return{block:M,inline:Q}}}]),ae}(),B=function(){function ae(pe){this.options=pe||J.defaults}var fe=ae.prototype;return fe.code=function(X,U,K){var Y=(U||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(X,Y);ue!=null&&ue!==X&&(K=!0,X=ue)}return X=X.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+l(Y,!0)+'">'+(K?X:l(X,!0))+`</code></pre>
`:"<pre><code>"+(K?X:l(X,!0))+`</code></pre>
`},fe.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},fe.html=function(X){return X},fe.heading=function(X,U,K,Y){return this.options.headerIds?"<h"+U+' id="'+this.options.headerPrefix+Y.slug(K)+'">'+X+"</h"+U+`>
`:"<h"+U+">"+X+"</h"+U+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(X,U,K){var Y=U?"ol":"ul",ue=U&&K!==1?' start="'+K+'"':"";return"<"+Y+ue+`>
`+X+"</"+Y+`>
`},fe.listitem=function(X){return"<li>"+X+`</li>
`},fe.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(X){return"<p>"+X+`</p>
`},fe.table=function(X,U){return U&&(U="<tbody>"+U+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+U+`</table>
`},fe.tablerow=function(X){return`<tr>
`+X+`</tr>
`},fe.tablecell=function(X,U){var K=U.header?"th":"td",Y=U.align?"<"+K+' align="'+U.align+'">':"<"+K+">";return Y+X+"</"+K+`>
`},fe.strong=function(X){return"<strong>"+X+"</strong>"},fe.em=function(X){return"<em>"+X+"</em>"},fe.codespan=function(X){return"<code>"+X+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(X){return"<del>"+X+"</del>"},fe.link=function(X,U,K){if(X=f(this.options.sanitize,this.options.baseUrl,X),X===null)return K;var Y='<a href="'+l(X)+'"';return U&&(Y+=' title="'+U+'"'),Y+=">"+K+"</a>",Y},fe.image=function(X,U,K){if(X=f(this.options.sanitize,this.options.baseUrl,X),X===null)return K;var Y='<img src="'+X+'" alt="'+K+'"';return U&&(Y+=' title="'+U+'"'),Y+=this.options.xhtml?"/>":">",Y},fe.text=function(X){return X},ae}(),G=function(){function ae(){}var fe=ae.prototype;return fe.strong=function(X){return X},fe.em=function(X){return X},fe.codespan=function(X){return X},fe.del=function(X){return X},fe.html=function(X){return X},fe.text=function(X){return X},fe.link=function(X,U,K){return""+K},fe.image=function(X,U,K){return""+K},fe.br=function(){return""},ae}(),ee=function(){function ae(){this.seen={}}var fe=ae.prototype;return fe.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(X,U){var K=X,Y=0;if(this.seen.hasOwnProperty(K)){Y=this.seen[X];do Y++,K=X+"-"+Y;while(this.seen.hasOwnProperty(K))}return U||(this.seen[X]=Y,this.seen[K]=0),K},fe.slug=function(X,U){U===void 0&&(U={});var K=this.serialize(X);return this.getNextSafeSlug(K,U.dryrun)},ae}(),oe=function(){function ae(pe){this.options=pe||J.defaults,this.options.renderer=this.options.renderer||new B,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new ee}ae.parse=function(X,U){var K=new ae(U);return K.parse(X)},ae.parseInline=function(X,U){var K=new ae(U);return K.parseInline(X)};var fe=ae.prototype;return fe.parse=function(X,U){U===void 0&&(U=!0);var K="",Y,ue,ye,Pe,Ae,Fe,Ue,le,ge,he,_e,Me,qe,Be,He,je,re,be,ke,Le=X.length;for(Y=0;Y<Le;Y++){if(he=X[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(ke=this.options.extensions.renderers[he.type].call({parser:this},he),ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){K+=ke||"";continue}switch(he.type){case"space":continue;case"hr":{K+=this.renderer.hr();continue}case"heading":{K+=this.renderer.heading(this.parseInline(he.tokens),he.depth,g(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{K+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(le="",Ue="",Pe=he.header.length,ue=0;ue<Pe;ue++)Ue+=this.renderer.tablecell(this.parseInline(he.header[ue].tokens),{header:!0,align:he.align[ue]});for(le+=this.renderer.tablerow(Ue),ge="",Pe=he.rows.length,ue=0;ue<Pe;ue++){for(Fe=he.rows[ue],Ue="",Ae=Fe.length,ye=0;ye<Ae;ye++)Ue+=this.renderer.tablecell(this.parseInline(Fe[ye].tokens),{header:!1,align:he.align[ye]});ge+=this.renderer.tablerow(Ue)}K+=this.renderer.table(le,ge);continue}case"blockquote":{ge=this.parse(he.tokens),K+=this.renderer.blockquote(ge);continue}case"list":{for(_e=he.ordered,Me=he.start,qe=he.loose,Pe=he.items.length,ge="",ue=0;ue<Pe;ue++)He=he.items[ue],je=He.checked,re=He.task,Be="",He.task&&(be=this.renderer.checkbox(je),qe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=be+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=be+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:be}):Be+=be),Be+=this.parse(He.tokens,qe),ge+=this.renderer.listitem(Be,re,je);K+=this.renderer.list(ge,_e,Me);continue}case"html":{K+=this.renderer.html(he.text);continue}case"paragraph":{K+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(ge=he.tokens?this.parseInline(he.tokens):he.text;Y+1<Le&&X[Y+1].type==="text";)he=X[++Y],ge+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);K+=U?this.renderer.paragraph(ge):ge;continue}default:{var Oe='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return K},fe.parseInline=function(X,U){U=U||this.renderer;var K="",Y,ue,ye,Pe=X.length;for(Y=0;Y<Pe;Y++){if(ue=X[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(ye=this.options.extensions.renderers[ue.type].call({parser:this},ue),ye!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ue.type))){K+=ye||"";continue}switch(ue.type){case"escape":{K+=U.text(ue.text);break}case"html":{K+=U.html(ue.text);break}case"link":{K+=U.link(ue.href,ue.title,this.parseInline(ue.tokens,U));break}case"image":{K+=U.image(ue.href,ue.title,ue.text);break}case"strong":{K+=U.strong(this.parseInline(ue.tokens,U));break}case"em":{K+=U.em(this.parseInline(ue.tokens,U));break}case"codespan":{K+=U.codespan(ue.text);break}case"br":{K+=U.br();break}case"del":{K+=U.del(this.parseInline(ue.tokens,U));break}case"text":{K+=U.text(ue.text);break}default:{var Ae='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return K},ae}();function se(ae,fe,pe){if(typeof ae=="undefined"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof fe=="function"&&(pe=fe,fe=null),fe=u({},se.defaults,fe||{}),O(fe),pe){var X=fe.highlight,U;try{U=ne.lex(ae,fe)}catch(ye){return pe(ye)}var K=function(Pe){var Ae;if(!Pe)try{fe.walkTokens&&se.walkTokens(U,fe.walkTokens),Ae=oe.parse(U,fe)}catch(Fe){Pe=Fe}return fe.highlight=X,Pe?pe(Pe):pe(null,Ae)};if(!X||X.length<3||(delete fe.highlight,!U.length))return K();var Y=0;se.walkTokens(U,function(ye){ye.type==="code"&&(Y++,setTimeout(function(){X(ye.text,ye.lang,function(Pe,Ae){if(Pe)return K(Pe);Ae!=null&&Ae!==ye.text&&(ye.text=Ae,ye.escaped=!0),Y--,Y===0&&K()})},0))}),Y===0&&K();return}try{var ue=ne.lex(ae,fe);return fe.walkTokens&&se.walkTokens(ue,fe.walkTokens),oe.parse(ue,fe)}catch(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+l(ye.message+"",!0)+"</pre>";throw ye}}se.options=se.setOptions=function(ae){return u(se.defaults,ae),R(se.defaults),se},se.getDefaults=D,se.defaults=J.defaults,se.use=function(){for(var ae=arguments.length,fe=new Array(ae),pe=0;pe<ae;pe++)fe[pe]=arguments[pe];var X=u.apply(void 0,[{}].concat(fe)),U=se.defaults.extensions||{renderers:{},childTokens:{}},K;fe.forEach(function(Y){if(Y.extensions&&(K=!0,Y.extensions.forEach(function(ye){if(!ye.name)throw new Error("extension name required");if(ye.renderer){var Pe=U.renderers?U.renderers[ye.name]:null;Pe?U.renderers[ye.name]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),Ue=0;Ue<Ae;Ue++)Fe[Ue]=arguments[Ue];var le=ye.renderer.apply(this,Fe);return le===!1&&(le=Pe.apply(this,Fe)),le}:U.renderers[ye.name]=ye.renderer}if(ye.tokenizer){if(!ye.level||ye.level!=="block"&&ye.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");U[ye.level]?U[ye.level].unshift(ye.tokenizer):U[ye.level]=[ye.tokenizer],ye.start&&(ye.level==="block"?U.startBlock?U.startBlock.push(ye.start):U.startBlock=[ye.start]:ye.level==="inline"&&(U.startInline?U.startInline.push(ye.start):U.startInline=[ye.start]))}ye.childTokens&&(U.childTokens[ye.name]=ye.childTokens)})),Y.renderer&&function(){var ye=se.defaults.renderer||new B,Pe=function(Ue){var le=ye[Ue];ye[Ue]=function(){for(var ge=arguments.length,he=new Array(ge),_e=0;_e<ge;_e++)he[_e]=arguments[_e];var Me=Y.renderer[Ue].apply(ye,he);return Me===!1&&(Me=le.apply(ye,he)),Me}};for(var Ae in Y.renderer)Pe(Ae);X.renderer=ye}(),Y.tokenizer&&function(){var ye=se.defaults.tokenizer||new L,Pe=function(Ue){var le=ye[Ue];ye[Ue]=function(){for(var ge=arguments.length,he=new Array(ge),_e=0;_e<ge;_e++)he[_e]=arguments[_e];var Me=Y.tokenizer[Ue].apply(ye,he);return Me===!1&&(Me=le.apply(ye,he)),Me}};for(var Ae in Y.tokenizer)Pe(Ae);X.tokenizer=ye}(),Y.walkTokens){var ue=se.defaults.walkTokens;X.walkTokens=function(ye){Y.walkTokens.call(this,ye),ue&&ue.call(this,ye)}}K&&(X.extensions=U),se.setOptions(X)})},se.walkTokens=function(ae,fe){for(var pe=function(){var Y=U.value;switch(fe.call(se,Y),Y.type){case"table":{for(var ue=k(Y.header),ye;!(ye=ue()).done;){var Pe=ye.value;se.walkTokens(Pe.tokens,fe)}for(var Ae=k(Y.rows),Fe;!(Fe=Ae()).done;)for(var Ue=Fe.value,le=k(Ue),ge;!(ge=le()).done;){var he=ge.value;se.walkTokens(he.tokens,fe)}break}case"list":{se.walkTokens(Y.items,fe);break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[Y.type]?se.defaults.extensions.childTokens[Y.type].forEach(function(_e){se.walkTokens(Y[_e],fe)}):Y.tokens&&se.walkTokens(Y.tokens,fe)}},X=k(ae),U;!(U=X()).done;)pe()},se.parseInline=function(ae,fe){if(typeof ae=="undefined"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");fe=u({},se.defaults,fe||{}),O(fe);try{var pe=ne.lexInline(ae,fe);return fe.walkTokens&&se.walkTokens(pe,fe.walkTokens),oe.parseInline(pe,fe)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+l(X.message+"",!0)+"</pre>";throw X}},se.Parser=oe,se.parser=oe.parse,se.Renderer=B,se.TextRenderer=G,se.Lexer=ne,se.lexer=ne.lex,se.Tokenizer=L,se.Slugger=ee,se.parse=se;var me=se.options,Z=se.setOptions,$=se.use,H=se.walkTokens,V=se.parseInline,ie=se,de=oe.parse,De=ne.lex;J.Lexer=ne,J.Parser=oe,J.Renderer=B,J.Slugger=ee,J.TextRenderer=G,J.Tokenizer=L,J.getDefaults=D,J.lexer=De,J.marked=se,J.options=me,J.parse=ie,J.parseInline=V,J.parser=de,J.setOptions=Z,J.use=$,J.walkTokens=H,Object.defineProperty(J,"__esModule",{value:!0})}),function(){function J(p){const k=[];typeof p=="number"&&k.push("code/timeOrigin",p);function D(y){k.push(y,Date.now())}function R(){const y=[];for(let b=0;b<k.length;b+=2)y.push({name:k[b],startTime:k[b+1]});return y}return{mark:D,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const D of performance.getEntriesByType("mark"))k.push({name:D.name,startTime:Math.round(p+D.startTime)});return k}};if(typeof process=="object"){const p=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function _(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=_(t))}(),define(ve[3],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const _="en";let t=!1,p=!1,k=!1,D=!1,R=!1,y=!1,b=!1,T=!1,A,h=_,v,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string",S=g&&d?.type==="renderer";if(e.isElectronSandboxed=S&&d?.sandboxed,typeof navigator=="object"&&!S)l=navigator.userAgent,t=l.indexOf("Windows")>=0,p=l.indexOf("Macintosh")>=0,T=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=l.indexOf("Linux")>=0,y=!0,A=navigator.language,h=A;else if(typeof d=="object"){t=d.platform==="win32",p=d.platform==="darwin",k=d.platform==="linux",D=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,b=g,A=_,h=_;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),u=o.availableLanguages["*"];A=o.locale,h=u||_,v=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var c;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function C(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let w=0;p?w=1:t?w=3:k&&(w=2),e.isWindows=t,e.isMacintosh=p,e.isLinux=k,e.isLinuxSnap=D,e.isNative=R,e.isElectron=b,e.isWeb=y,e.isIOS=T,e.platform=w,e.userAgent=l,e.language=h;var f;(function(r){function o(){return e.language}r.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=u;function E(){return e.language==="en"}r.isDefault=E})(f=e.Language||(e.Language={})),e.locale=A,e.translationsConfigFile=v,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let E=0,P=r.length;E<P;E++){const I=r[E];if(I.id===u.data.vscodeScheduleAsyncWork){r.splice(E,1),I.callback();return}}});let o=0;return u=>{const E=++o;r.push({id:E,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return r=>setTimeout(r)})();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=p||T?2:t?1:3;let a=!0,i=!1;function n(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,a=new Uint16Array(r.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[24],we([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.process!="undefined"){const p=_.globals.vscode.process;t={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[4],we([0,1,24]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,p=97,k=90,D=122,R=46,y=47,b=92,T=58,A=63;class h extends Error{constructor(w,f,s){let a;typeof f=="string"&&f.indexOf("not ")===0?(a="must not be",f=f.replace(/^not /,"")):a="must be";const i=w.indexOf(".")!==-1?"property":"argument";let n=`The "${w}" ${i} ${a} of type ${f}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function v(C,w){if(typeof C!="string")throw new h(w,"string",C)}function l(C){return C===y||C===b}function d(C){return C===y}function g(C){return C>=t&&C<=k||C>=p&&C<=D}function S(C,w,f,s){let a="",i=0,n=-1,r=0,o=0;for(let u=0;u<=C.length;++u){if(u<C.length)o=C.charCodeAt(u);else{if(s(o))break;o=y}if(s(o)){if(!(n===u-1||r===1))if(r===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const E=a.lastIndexOf(f);E===-1?(a="",i=0):(a=a.slice(0,E),i=a.length-1-a.lastIndexOf(f)),n=u,r=0;continue}else if(a.length!==0){a="",i=0,n=u,r=0;continue}}w&&(a+=a.length>0?`${f}..`:"..",i=2)}else a.length>0?a+=`${f}${C.slice(n+1,u)}`:a=C.slice(n+1,u),i=u-n-1;n=u,r=0}else o===R&&r!==-1?++r:r=-1}return a}function c(C,w){if(w===null||typeof w!="object")throw new h("pathObject","Object",w);const f=w.dir||w.root,s=w.base||`${w.name||""}${w.ext||""}`;return f?f===w.root?`${f}${s}`:`${f}${C}${s}`:s}e.win32={resolve(...C){let w="",f="",s=!1;for(let a=C.length-1;a>=-1;a--){let i;if(a>=0){if(i=C[a],v(i,"path"),i.length===0)continue}else w.length===0?i=_.cwd():(i=_.env[`=${w}`]||_.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==w.toLowerCase()&&i.charCodeAt(2)===b)&&(i=`${w}\\`));const n=i.length;let r=0,o="",u=!1;const E=i.charCodeAt(0);if(n===1)l(E)&&(r=1,u=!0);else if(l(E))if(u=!0,l(i.charCodeAt(1))){let P=2,I=P;for(;P<n&&!l(i.charCodeAt(P));)P++;if(P<n&&P!==I){const O=i.slice(I,P);for(I=P;P<n&&l(i.charCodeAt(P));)P++;if(P<n&&P!==I){for(I=P;P<n&&!l(i.charCodeAt(P));)P++;(P===n||P!==I)&&(o=`\\\\${O}\\${i.slice(I,P)}`,r=P)}}}else r=1;else g(E)&&i.charCodeAt(1)===T&&(o=i.slice(0,2),r=2,n>2&&l(i.charCodeAt(2))&&(u=!0,r=3));if(o.length>0)if(w.length>0){if(o.toLowerCase()!==w.toLowerCase())continue}else w=o;if(s){if(w.length>0)break}else if(f=`${i.slice(r)}\\${f}`,s=u,u&&w.length>0)break}return f=S(f,!s,"\\",l),s?`${w}\\${f}`:`${w}${f}`||"."},normalize(C){v(C,"path");const w=C.length;if(w===0)return".";let f=0,s,a=!1;const i=C.charCodeAt(0);if(w===1)return d(i)?"\\":C;if(l(i))if(a=!0,l(C.charCodeAt(1))){let r=2,o=r;for(;r<w&&!l(C.charCodeAt(r));)r++;if(r<w&&r!==o){const u=C.slice(o,r);for(o=r;r<w&&l(C.charCodeAt(r));)r++;if(r<w&&r!==o){for(o=r;r<w&&!l(C.charCodeAt(r));)r++;if(r===w)return`\\\\${u}\\${C.slice(o)}\\`;r!==o&&(s=`\\\\${u}\\${C.slice(o,r)}`,f=r)}}}else f=1;else g(i)&&C.charCodeAt(1)===T&&(s=C.slice(0,2),f=2,w>2&&l(C.charCodeAt(2))&&(a=!0,f=3));let n=f<w?S(C.slice(f),!a,"\\",l):"";return n.length===0&&!a&&(n="."),n.length>0&&l(C.charCodeAt(w-1))&&(n+="\\"),s===void 0?a?`\\${n}`:n:a?`${s}\\${n}`:`${s}${n}`},isAbsolute(C){v(C,"path");const w=C.length;if(w===0)return!1;const f=C.charCodeAt(0);return l(f)||w>2&&g(f)&&C.charCodeAt(1)===T&&l(C.charCodeAt(2))},join(...C){if(C.length===0)return".";let w,f;for(let i=0;i<C.length;++i){const n=C[i];v(n,"path"),n.length>0&&(w===void 0?w=f=n:w+=`\\${n}`)}if(w===void 0)return".";let s=!0,a=0;if(typeof f=="string"&&l(f.charCodeAt(0))){++a;const i=f.length;i>1&&l(f.charCodeAt(1))&&(++a,i>2&&(l(f.charCodeAt(2))?++a:s=!1))}if(s){for(;a<w.length&&l(w.charCodeAt(a));)a++;a>=2&&(w=`\\${w.slice(a)}`)}return e.win32.normalize(w)},relative(C,w){if(v(C,"from"),v(w,"to"),C===w)return"";const f=e.win32.resolve(C),s=e.win32.resolve(w);if(f===s||(C=f.toLowerCase(),w=s.toLowerCase(),C===w))return"";let a=0;for(;a<C.length&&C.charCodeAt(a)===b;)a++;let i=C.length;for(;i-1>a&&C.charCodeAt(i-1)===b;)i--;const n=i-a;let r=0;for(;r<w.length&&w.charCodeAt(r)===b;)r++;let o=w.length;for(;o-1>r&&w.charCodeAt(o-1)===b;)o--;const u=o-r,E=n<u?n:u;let P=-1,I=0;for(;I<E;I++){const z=C.charCodeAt(a+I);if(z!==w.charCodeAt(r+I))break;z===b&&(P=I)}if(I!==E){if(P===-1)return s}else{if(u>E){if(w.charCodeAt(r+I)===b)return s.slice(r+I+1);if(I===2)return s.slice(r+I)}n>E&&(C.charCodeAt(a+I)===b?P=I:I===2&&(P=3)),P===-1&&(P=0)}let O="";for(I=a+P+1;I<=i;++I)(I===i||C.charCodeAt(I)===b)&&(O+=O.length===0?"..":"\\..");return r+=P,O.length>0?`${O}${s.slice(r,o)}`:(s.charCodeAt(r)===b&&++r,s.slice(r,o))},toNamespacedPath(C){if(typeof C!="string")return C;if(C.length===0)return"";const w=e.win32.resolve(C);if(w.length<=2)return C;if(w.charCodeAt(0)===b){if(w.charCodeAt(1)===b){const f=w.charCodeAt(2);if(f!==A&&f!==R)return`\\\\?\\UNC\\${w.slice(2)}`}}else if(g(w.charCodeAt(0))&&w.charCodeAt(1)===T&&w.charCodeAt(2)===b)return`\\\\?\\${w}`;return C},dirname(C){v(C,"path");const w=C.length;if(w===0)return".";let f=-1,s=0;const a=C.charCodeAt(0);if(w===1)return l(a)?C:".";if(l(a)){if(f=s=1,l(C.charCodeAt(1))){let r=2,o=r;for(;r<w&&!l(C.charCodeAt(r));)r++;if(r<w&&r!==o){for(o=r;r<w&&l(C.charCodeAt(r));)r++;if(r<w&&r!==o){for(o=r;r<w&&!l(C.charCodeAt(r));)r++;if(r===w)return C;r!==o&&(f=s=r+1)}}}}else g(a)&&C.charCodeAt(1)===T&&(f=w>2&&l(C.charCodeAt(2))?3:2,s=f);let i=-1,n=!0;for(let r=w-1;r>=s;--r)if(l(C.charCodeAt(r))){if(!n){i=r;break}}else n=!1;if(i===-1){if(f===-1)return".";i=f}return C.slice(0,i)},basename(C,w){w!==void 0&&v(w,"ext"),v(C,"path");let f=0,s=-1,a=!0,i;if(C.length>=2&&g(C.charCodeAt(0))&&C.charCodeAt(1)===T&&(f=2),w!==void 0&&w.length>0&&w.length<=C.length){if(w===C)return"";let n=w.length-1,r=-1;for(i=C.length-1;i>=f;--i){const o=C.charCodeAt(i);if(l(o)){if(!a){f=i+1;break}}else r===-1&&(a=!1,r=i+1),n>=0&&(o===w.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=r))}return f===s?s=r:s===-1&&(s=C.length),C.slice(f,s)}for(i=C.length-1;i>=f;--i)if(l(C.charCodeAt(i))){if(!a){f=i+1;break}}else s===-1&&(a=!1,s=i+1);return s===-1?"":C.slice(f,s)},extname(C){v(C,"path");let w=0,f=-1,s=0,a=-1,i=!0,n=0;C.length>=2&&C.charCodeAt(1)===T&&g(C.charCodeAt(0))&&(w=s=2);for(let r=C.length-1;r>=w;--r){const o=C.charCodeAt(r);if(l(o)){if(!i){s=r+1;break}continue}a===-1&&(i=!1,a=r+1),o===R?f===-1?f=r:n!==1&&(n=1):f!==-1&&(n=-1)}return f===-1||a===-1||n===0||n===1&&f===a-1&&f===s+1?"":C.slice(f,a)},format:c.bind(null,"\\"),parse(C){v(C,"path");const w={root:"",dir:"",base:"",ext:"",name:""};if(C.length===0)return w;const f=C.length;let s=0,a=C.charCodeAt(0);if(f===1)return l(a)?(w.root=w.dir=C,w):(w.base=w.name=C,w);if(l(a)){if(s=1,l(C.charCodeAt(1))){let P=2,I=P;for(;P<f&&!l(C.charCodeAt(P));)P++;if(P<f&&P!==I){for(I=P;P<f&&l(C.charCodeAt(P));)P++;if(P<f&&P!==I){for(I=P;P<f&&!l(C.charCodeAt(P));)P++;P===f?s=P:P!==I&&(s=P+1)}}}}else if(g(a)&&C.charCodeAt(1)===T){if(f<=2)return w.root=w.dir=C,w;if(s=2,l(C.charCodeAt(2))){if(f===3)return w.root=w.dir=C,w;s=3}}s>0&&(w.root=C.slice(0,s));let i=-1,n=s,r=-1,o=!0,u=C.length-1,E=0;for(;u>=s;--u){if(a=C.charCodeAt(u),l(a)){if(!o){n=u+1;break}continue}r===-1&&(o=!1,r=u+1),a===R?i===-1?i=u:E!==1&&(E=1):i!==-1&&(E=-1)}return r!==-1&&(i===-1||E===0||E===1&&i===r-1&&i===n+1?w.base=w.name=C.slice(n,r):(w.name=C.slice(n,i),w.base=C.slice(n,r),w.ext=C.slice(i,r))),n>0&&n!==s?w.dir=C.slice(0,n-1):w.dir=w.root,w},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...C){let w="",f=!1;for(let s=C.length-1;s>=-1&&!f;s--){const a=s>=0?C[s]:_.cwd();v(a,"path"),a.length!==0&&(w=`${a}/${w}`,f=a.charCodeAt(0)===y)}return w=S(w,!f,"/",d),f?`/${w}`:w.length>0?w:"."},normalize(C){if(v(C,"path"),C.length===0)return".";const w=C.charCodeAt(0)===y,f=C.charCodeAt(C.length-1)===y;return C=S(C,!w,"/",d),C.length===0?w?"/":f?"./":".":(f&&(C+="/"),w?`/${C}`:C)},isAbsolute(C){return v(C,"path"),C.length>0&&C.charCodeAt(0)===y},join(...C){if(C.length===0)return".";let w;for(let f=0;f<C.length;++f){const s=C[f];v(s,"path"),s.length>0&&(w===void 0?w=s:w+=`/${s}`)}return w===void 0?".":e.posix.normalize(w)},relative(C,w){if(v(C,"from"),v(w,"to"),C===w||(C=e.posix.resolve(C),w=e.posix.resolve(w),C===w))return"";const f=1,s=C.length,a=s-f,i=1,n=w.length-i,r=a<n?a:n;let o=-1,u=0;for(;u<r;u++){const P=C.charCodeAt(f+u);if(P!==w.charCodeAt(i+u))break;P===y&&(o=u)}if(u===r)if(n>r){if(w.charCodeAt(i+u)===y)return w.slice(i+u+1);if(u===0)return w.slice(i+u)}else a>r&&(C.charCodeAt(f+u)===y?o=u:u===0&&(o=0));let E="";for(u=f+o+1;u<=s;++u)(u===s||C.charCodeAt(u)===y)&&(E+=E.length===0?"..":"/..");return`${E}${w.slice(i+o)}`},toNamespacedPath(C){return C},dirname(C){if(v(C,"path"),C.length===0)return".";const w=C.charCodeAt(0)===y;let f=-1,s=!0;for(let a=C.length-1;a>=1;--a)if(C.charCodeAt(a)===y){if(!s){f=a;break}}else s=!1;return f===-1?w?"/":".":w&&f===1?"//":C.slice(0,f)},basename(C,w){w!==void 0&&v(w,"ext"),v(C,"path");let f=0,s=-1,a=!0,i;if(w!==void 0&&w.length>0&&w.length<=C.length){if(w===C)return"";let n=w.length-1,r=-1;for(i=C.length-1;i>=0;--i){const o=C.charCodeAt(i);if(o===y){if(!a){f=i+1;break}}else r===-1&&(a=!1,r=i+1),n>=0&&(o===w.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=r))}return f===s?s=r:s===-1&&(s=C.length),C.slice(f,s)}for(i=C.length-1;i>=0;--i)if(C.charCodeAt(i)===y){if(!a){f=i+1;break}}else s===-1&&(a=!1,s=i+1);return s===-1?"":C.slice(f,s)},extname(C){v(C,"path");let w=-1,f=0,s=-1,a=!0,i=0;for(let n=C.length-1;n>=0;--n){const r=C.charCodeAt(n);if(r===y){if(!a){f=n+1;break}continue}s===-1&&(a=!1,s=n+1),r===R?w===-1?w=n:i!==1&&(i=1):w!==-1&&(i=-1)}return w===-1||s===-1||i===0||i===1&&w===s-1&&w===f+1?"":C.slice(w,s)},format:c.bind(null,"/"),parse(C){v(C,"path");const w={root:"",dir:"",base:"",ext:"",name:""};if(C.length===0)return w;const f=C.charCodeAt(0)===y;let s;f?(w.root="/",s=1):s=0;let a=-1,i=0,n=-1,r=!0,o=C.length-1,u=0;for(;o>=s;--o){const E=C.charCodeAt(o);if(E===y){if(!r){i=o+1;break}continue}n===-1&&(r=!1,n=o+1),E===R?a===-1?a=o:u!==1&&(u=1):a!==-1&&(u=-1)}if(n!==-1){const E=i===0&&f?1:i;a===-1||u===0||u===1&&a===n-1&&a===i+1?w.base=w.name=C.slice(E,n):(w.name=C.slice(E,a),w.base=C.slice(E,n),w.ext=C.slice(a,n))}return i>0?w.dir=C.slice(0,i-1):f&&(w.dir="/"),w},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[59],we([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(A){A.text="text/plain",A.binary="application/octet-stream",A.unknown="application/unknown",A.markdown="text/markdown",A.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(A){const h=(0,_.extname)(A),v=p[h.toLowerCase()];return v!==void 0?v:R(A)}e.getMediaOrTextMime=D;function R(A){const h=(0,_.extname)(A);return k[h.toLowerCase()]}e.getMediaMime=R;function y(A){for(const h in k)if(k[h]===A)return h}e.getExtensionForMimeType=y;const b=/^(.+)\/(.+?)(;.+)?$/;function T(A,h){const v=b.exec(A);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:h?void 0:A}e.normalizeMimeType=T}),define(ve[75],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var t;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function p(k,...D){const R=D.reduce((T,A)=>(T[A]=!0,T),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(T=>!R[T]).forEach(T=>{for(let A=0;A<y.length;A++)if(T.search(y[A])!==-1){delete k[T];break}})}e.sanitizeProcessEnvironment=p}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var _=e();for(var t in _)(typeof exports=="object"?exports:J)[t]=_[t]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function _(t){if(e[t])return e[t].exports;var p=e[t]={i:t,l:!1,exports:{}};return J[t].call(p.exports,p,p.exports,_),p.l=!0,p.exports}return _.m=J,_.c=e,_.d=function(t,p,k){_.o(t,p)||Object.defineProperty(t,p,{enumerable:!0,get:k})},_.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},_.t=function(t,p){if(1&p&&(t=_(t)),8&p||4&p&&typeof t=="object"&&t&&t.__esModule)return t;var k=Object.create(null);if(_.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:t}),2&p&&typeof t!="string")for(var D in t)_.d(k,D,function(R){return t[R]}.bind(null,D));return k},_.n=function(t){var p=t&&t.__esModule?function(){return t.default}:function(){return t};return _.d(p,"a",p),p},_.o=function(t,p){return Object.prototype.hasOwnProperty.call(t,p)},_.p="",_(_.s=0)}([function(J,e,_){(function(t){var p;e=J.exports=$,p=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],b=0,T=b++;y[T]="0|[1-9]\\d*";var A=b++;y[A]="[0-9]+";var h=b++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=b++;y[v]="("+y[T]+")\\.("+y[T]+")\\.("+y[T]+")";var l=b++;y[l]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var d=b++;y[d]="(?:"+y[T]+"|"+y[h]+")";var g=b++;y[g]="(?:"+y[A]+"|"+y[h]+")";var S=b++;y[S]="(?:-("+y[d]+"(?:\\."+y[d]+")*))";var c=b++;y[c]="(?:-?("+y[g]+"(?:\\."+y[g]+")*))";var C=b++;y[C]="[0-9A-Za-z-]+";var w=b++;y[w]="(?:\\+("+y[C]+"(?:\\."+y[C]+")*))";var f=b++,s="v?"+y[v]+y[S]+"?"+y[w]+"?";y[f]="^"+s+"$";var a="[v=\\s]*"+y[l]+y[c]+"?"+y[w]+"?",i=b++;y[i]="^"+a+"$";var n=b++;y[n]="((?:<|>)?=?)";var r=b++;y[r]=y[A]+"|x|X|\\*";var o=b++;y[o]=y[T]+"|x|X|\\*";var u=b++;y[u]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[S]+")?"+y[w]+"?)?)?";var E=b++;y[E]="[v=\\s]*("+y[r]+")(?:\\.("+y[r]+")(?:\\.("+y[r]+")(?:"+y[c]+")?"+y[w]+"?)?)?";var P=b++;y[P]="^"+y[n]+"\\s*"+y[u]+"$";var I=b++;y[I]="^"+y[n]+"\\s*"+y[E]+"$";var O=b++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=b++;y[z]="(?:~>?)";var j=b++;y[j]="(\\s*)"+y[z]+"\\s+",R[j]=new RegExp(y[j],"g");var m=b++;y[m]="^"+y[z]+y[u]+"$";var L=b++;y[L]="^"+y[z]+y[E]+"$";var M=b++;y[M]="(?:\\^)";var Q=b++;y[Q]="(\\s*)"+y[M]+"\\s+",R[Q]=new RegExp(y[Q],"g");var W=b++;y[W]="^"+y[M]+y[u]+"$";var q=b++;y[q]="^"+y[M]+y[E]+"$";var ne=b++;y[ne]="^"+y[n]+"\\s*("+a+")$|^$";var B=b++;y[B]="^"+y[n]+"\\s*("+s+")$|^$";var G=b++;y[G]="(\\s*)"+y[n]+"\\s*("+a+"|"+y[u]+")",R[G]=new RegExp(y[G],"g");var ee=b++;y[ee]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var oe=b++;y[oe]="^\\s*("+y[E]+")\\s+-\\s+("+y[E]+")\\s*$";var se=b++;y[se]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)p(me,y[me]),R[me]||(R[me]=new RegExp(y[me]));function Z(le,ge){if(le instanceof $)return le;if(typeof le!="string"||le.length>k||!(ge?R[i]:R[f]).test(le))return null;try{return new $(le,ge)}catch{return null}}function $(le,ge){if(le instanceof $){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof $))return new $(le,ge);p("SemVer",le,ge),this.loose=ge;var he=le.trim().match(ge?R[i]:R[f]);if(!he)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(_e){if(/^[0-9]+$/.test(_e)){var Me=+_e;if(Me>=0&&Me<D)return Me}return _e}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=Z,e.valid=function(le,ge){var he=Z(le,ge);return he?he.version:null},e.clean=function(le,ge){var he=Z(le.trim().replace(/^[=v]+/,""),ge);return he?he.version:null},e.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(le){return p("SemVer.compare",this.version,this.loose,le),le instanceof $||(le=new $(le,this.loose)),this.compareMain(le)||this.comparePre(le)},$.prototype.compareMain=function(le){return le instanceof $||(le=new $(le,this.loose)),V(this.major,le.major)||V(this.minor,le.minor)||V(this.patch,le.patch)},$.prototype.comparePre=function(le){if(le instanceof $||(le=new $(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var he=this.prerelease[ge],_e=le.prerelease[ge];if(p("prerelease compare",ge,he,_e),he===void 0&&_e===void 0)return 0;if(_e===void 0)return 1;if(he===void 0)return-1;if(he!==_e)return V(he,_e)}while(++ge)},$.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,he,_e){typeof he=="string"&&(_e=he,he=void 0);try{return new $(le,he).inc(ge,_e).version}catch{return null}},e.diff=function(le,ge){if(ae(le,ge))return null;var he=Z(le),_e=Z(ge);if(he.prerelease.length||_e.prerelease.length){for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==_e[Me])return"pre"+Me;return"prerelease"}for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==_e[Me])return Me},e.compareIdentifiers=V;var H=/^[0-9]+$/;function V(le,ge){var he=H.test(le),_e=H.test(ge);return he&&_e&&(le=+le,ge=+ge),he&&!_e?-1:_e&&!he?1:le<ge?-1:le>ge?1:0}function ie(le,ge,he){return new $(le,he).compare(new $(ge,he))}function de(le,ge,he){return ie(le,ge,he)>0}function De(le,ge,he){return ie(le,ge,he)<0}function ae(le,ge,he){return ie(le,ge,he)===0}function fe(le,ge,he){return ie(le,ge,he)!==0}function pe(le,ge,he){return ie(le,ge,he)>=0}function X(le,ge,he){return ie(le,ge,he)<=0}function U(le,ge,he,_e){var Me;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof he=="object"&&(he=he.version),Me=le===he;break;case"!==":typeof le=="object"&&(le=le.version),typeof he=="object"&&(he=he.version),Me=le!==he;break;case"":case"=":case"==":Me=ae(le,he,_e);break;case"!=":Me=fe(le,he,_e);break;case">":Me=de(le,he,_e);break;case">=":Me=pe(le,he,_e);break;case"<":Me=De(le,he,_e);break;case"<=":Me=X(le,he,_e);break;default:throw new TypeError("Invalid operator: "+ge)}return Me}function K(le,ge){if(le instanceof K){if(le.loose===ge)return le;le=le.value}if(!(this instanceof K))return new K(le,ge);p("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===Y?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(le,ge){return V(ge,le)},e.major=function(le,ge){return new $(le,ge).major},e.minor=function(le,ge){return new $(le,ge).minor},e.patch=function(le,ge){return new $(le,ge).patch},e.compare=ie,e.compareLoose=function(le,ge){return ie(le,ge,!0)},e.rcompare=function(le,ge,he){return ie(ge,le,he)},e.sort=function(le,ge){return le.sort(function(he,_e){return e.compare(he,_e,ge)})},e.rsort=function(le,ge){return le.sort(function(he,_e){return e.rcompare(he,_e,ge)})},e.gt=de,e.lt=De,e.eq=ae,e.neq=fe,e.gte=pe,e.lte=X,e.cmp=U,e.Comparator=K;var Y={};function ue(le,ge){if(le instanceof ue)return le.loose===ge?le:new ue(le.raw,ge);if(le instanceof K)return new ue(le.value,ge);if(!(this instanceof ue))return new ue(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function ye(le){return!le||le.toLowerCase()==="x"||le==="*"}function Pe(le,ge,he,_e,Me,qe,Be,He,je,re,be,ke,Le){return((ge=ye(he)?"":ye(_e)?">="+he+".0.0":ye(Me)?">="+he+"."+_e+".0":">="+ge)+" "+(He=ye(je)?"":ye(re)?"<"+(+je+1)+".0.0":ye(be)?"<"+je+"."+(+re+1)+".0":ke?"<="+je+"."+re+"."+be+"-"+ke:"<="+He)).trim()}function Ae(le,ge){for(var he=0;he<le.length;he++)if(!le[he].test(ge))return!1;if(ge.prerelease.length){for(he=0;he<le.length;he++)if(p(le[he].semver),le[he].semver!==Y&&le[he].semver.prerelease.length>0){var _e=le[he].semver;if(_e.major===ge.major&&_e.minor===ge.minor&&_e.patch===ge.patch)return!0}return!1}return!0}function Fe(le,ge,he){try{ge=new ue(ge,he)}catch{return!1}return ge.test(le)}function Ue(le,ge,he,_e){var Me,qe,Be,He,je;switch(le=new $(le,_e),ge=new ue(ge,_e),he){case">":Me=de,qe=X,Be=De,He=">",je=">=";break;case"<":Me=De,qe=pe,Be=de,He="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(le,ge,_e))return!1;for(var re=0;re<ge.set.length;++re){var be=ge.set[re],ke=null,Le=null;if(be.forEach(function(Oe){Oe.semver===Y&&(Oe=new K(">=0.0.0")),ke=ke||Oe,Le=Le||Oe,Me(Oe.semver,ke.semver,_e)?ke=Oe:Be(Oe.semver,Le.semver,_e)&&(Le=Oe)}),ke.operator===He||ke.operator===je||(!Le.operator||Le.operator===He)&&qe(le,Le.semver)||Le.operator===je&&Be(le,Le.semver))return!1}return!0}K.prototype.parse=function(le){var ge=this.loose?R[ne]:R[B],he=le.match(ge);if(!he)throw new TypeError("Invalid comparator: "+le);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new $(he[2],this.loose):this.semver=Y},K.prototype.toString=function(){return this.value},K.prototype.test=function(le){return p("Comparator.test",le,this.loose),this.semver===Y||(typeof le=="string"&&(le=new $(le,this.loose)),U(le,this.operator,this.semver,this.loose))},K.prototype.intersects=function(le,ge){if(!(le instanceof K))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new ue(le.value,ge),Fe(this.value,he,ge);if(le.operator==="")return he=new ue(this.value,ge),Fe(le.semver,he,ge);var _e=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),qe=this.semver.version===le.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),He=U(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),je=U(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return _e||Me||qe&&Be||He||je},e.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),p("range",le,ge);var he=ge?R[oe]:R[ee];le=le.replace(he,Pe),p("hyphen replace",le),le=le.replace(R[G],"$1$2$3"),p("comparator trim",le,R[G]),le=(le=(le=le.replace(R[j],"$1~")).replace(R[Q],"$1^")).split(/\s+/).join(" ");var _e=ge?R[ne]:R[B],Me=le.split(" ").map(function(qe){return function(Be,He){return p("comp",Be),Be=function(je,re){return je.trim().split(/\s+/).map(function(be){return function(ke,Le){p("caret",ke,Le);var Oe=Le?R[q]:R[W];return ke.replace(Oe,function(Qe,We,Ve,Ye,Ge){var Ze;return p("caret",ke,Qe,We,Ve,Ye,Ge),ye(We)?Ze="":ye(Ve)?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":ye(Ye)?Ze=We==="0"?">="+We+"."+Ve+".0 <"+We+"."+(+Ve+1)+".0":">="+We+"."+Ve+".0 <"+(+We+1)+".0.0":Ge?(p("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=We==="0"?Ve==="0"?">="+We+"."+Ve+"."+Ye+Ge+" <"+We+"."+Ve+"."+(+Ye+1):">="+We+"."+Ve+"."+Ye+Ge+" <"+We+"."+(+Ve+1)+".0":">="+We+"."+Ve+"."+Ye+Ge+" <"+(+We+1)+".0.0"):(p("no pr"),Ze=We==="0"?Ve==="0"?">="+We+"."+Ve+"."+Ye+" <"+We+"."+Ve+"."+(+Ye+1):">="+We+"."+Ve+"."+Ye+" <"+We+"."+(+Ve+1)+".0":">="+We+"."+Ve+"."+Ye+" <"+(+We+1)+".0.0"),p("caret return",Ze),Ze})}(be,re)}).join(" ")}(Be,He),p("caret",Be),Be=function(je,re){return je.trim().split(/\s+/).map(function(be){return function(ke,Le){var Oe=Le?R[L]:R[m];return ke.replace(Oe,function(Qe,We,Ve,Ye,Ge){var Ze;return p("tilde",ke,Qe,We,Ve,Ye,Ge),ye(We)?Ze="":ye(Ve)?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":ye(Ye)?Ze=">="+We+"."+Ve+".0 <"+We+"."+(+Ve+1)+".0":Ge?(p("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=">="+We+"."+Ve+"."+Ye+Ge+" <"+We+"."+(+Ve+1)+".0"):Ze=">="+We+"."+Ve+"."+Ye+" <"+We+"."+(+Ve+1)+".0",p("tilde return",Ze),Ze})}(be,re)}).join(" ")}(Be,He),p("tildes",Be),Be=function(je,re){return p("replaceXRanges",je,re),je.split(/\s+/).map(function(be){return function(ke,Le){ke=ke.trim();var Oe=Le?R[I]:R[P];return ke.replace(Oe,function(Qe,We,Ve,Ye,Ge,Ze){p("xRange",ke,Qe,We,Ve,Ye,Ge,Ze);var rt=ye(Ve),tt=rt||ye(Ye),nt=tt||ye(Ge);return We==="="&&nt&&(We=""),rt?Qe=We===">"||We==="<"?"<0.0.0":"*":We&&nt?(tt&&(Ye=0),nt&&(Ge=0),We===">"?(We=">=",tt?(Ve=+Ve+1,Ye=0,Ge=0):nt&&(Ye=+Ye+1,Ge=0)):We==="<="&&(We="<",tt?Ve=+Ve+1:Ye=+Ye+1),Qe=We+Ve+"."+Ye+"."+Ge):tt?Qe=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":nt&&(Qe=">="+Ve+"."+Ye+".0 <"+Ve+"."+(+Ye+1)+".0"),p("xRange return",Qe),Qe})}(be,re)}).join(" ")}(Be,He),p("xrange",Be),Be=function(je,re){return p("replaceStars",je,re),je.trim().replace(R[se],"")}(Be,He),p("stars",Be),Be}(qe,ge)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(qe){return!!qe.match(_e)})),Me=Me.map(function(qe){return new K(qe,ge)})},ue.prototype.intersects=function(le,ge){if(!(le instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(_e){return le.set.some(function(Me){return Me.every(function(qe){return _e.intersects(qe,ge)})})})})},e.toComparators=function(le,ge){return new ue(le,ge).set.map(function(he){return he.map(function(_e){return _e.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new $(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ae(this.set[ge],le))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(le,ge,he){var _e=null,Me=null;try{var qe=new ue(ge,he)}catch{return null}return le.forEach(function(Be){qe.test(Be)&&(_e&&Me.compare(Be)!==-1||(Me=new $(_e=Be,he)))}),_e},e.minSatisfying=function(le,ge,he){var _e=null,Me=null;try{var qe=new ue(ge,he)}catch{return null}return le.forEach(function(Be){qe.test(Be)&&(_e&&Me.compare(Be)!==1||(Me=new $(_e=Be,he)))}),_e},e.validRange=function(le,ge){try{return new ue(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,he){return Ue(le,ge,"<",he)},e.gtr=function(le,ge,he){return Ue(le,ge,">",he)},e.outside=Ue,e.prerelease=function(le,ge){var he=Z(le,ge);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(le,ge,he){return le=new ue(le,he),ge=new ue(ge,he),le.intersects(ge)},e.coerce=function(le){if(le instanceof $)return le;if(typeof le!="string")return null;var ge=le.match(R[O]);return ge==null?null:Z((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,_(1))},function(J,e){var _,t,p=J.exports={};function k(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(g){if(_===setTimeout)return setTimeout(g,0);if((_===k||!_)&&setTimeout)return _=setTimeout,setTimeout(g,0);try{return _(g,0)}catch{try{return _.call(null,g,0)}catch{return _.call(this,g,0)}}}(function(){try{_=typeof setTimeout=="function"?setTimeout:k}catch{_=k}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var y,b=[],T=!1,A=-1;function h(){T&&y&&(T=!1,y.length?b=y.concat(b):A=-1,b.length&&v())}function v(){if(!T){var g=R(h);T=!0;for(var S=b.length;S;){for(y=b,b=[];++A<S;)y&&y[A].run();A=-1,S=b.length}y=null,T=!1,function(c){if(t===clearTimeout)return clearTimeout(c);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(c);try{t(c)}catch{try{return t.call(null,c)}catch{return t.call(this,c)}}}(g)}}function l(g,S){this.fun=g,this.array=S}function d(){}p.nextTick=function(g){var S=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)S[c-1]=arguments[c];b.push(new l(g,S)),b.length!==1||T||R(v)},l.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=d,p.addListener=d,p.once=d,p.off=d,p.removeListener=d,p.removeAllListeners=d,p.emit=d,p.prependListener=d,p.prependOnceListener=d,p.listeners=function(g){return[]},p.binding=function(g){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(g){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(ve[124],we([0,1]),function(J,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(R,y,b){this.level=R,this.key=y,this.value=b,this.forward=[]}}const p=void 0;class k{constructor(R,y=2**16){this.comparator=R,this[_]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new t(this._maxLevel,p,p)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,p,p)}has(R){return Boolean(k._search(this,R,this.comparator))}get(R){return k._search(this,R,this.comparator)?.value}set(R,y){return k._insert(this,R,y,this.comparator)&&(this._size+=1),this}delete(R){const y=k._delete(this,R,this.comparator);return y&&(this._size-=1),y}forEach(R,y){let b=this._header.forward[0];for(;b;)R.call(y,b.value,b.key,this),b=b.forward[0]}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",y=this._header.forward[0];for(;y;)R+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return R}static _search(R,y,b){let T=R._header;for(let A=R._level-1;A>=0;A--)for(;T.forward[A]&&b(T.forward[A].key,y)<0;)T=T.forward[A];if(T=T.forward[0],T&&b(T.key,y)===0)return T}static _insert(R,y,b,T){let A=[],h=R._header;for(let v=R._level-1;v>=0;v--){for(;h.forward[v]&&T(h.forward[v].key,y)<0;)h=h.forward[v];A[v]=h}if(h=h.forward[0],h&&T(h.key,y)===0)return h.value=b,!1;{let v=k._randomLevel(R);if(v>R._level){for(let l=R._level;l<v;l++)A[l]=R._header;R._level=v}h=new t(v,y,b);for(let l=0;l<v;l++)h.forward[l]=A[l].forward[l],A[l].forward[l]=h;return!0}}static _randomLevel(R,y=.5){let b=1;for(;Math.random()<y&&b<R._maxLevel;)b+=1;return b}static _delete(R,y,b){let T=[],A=R._header;for(let h=R._level-1;h>=0;h--){for(;A.forward[h]&&b(A.forward[h].key,y)<0;)A=A.forward[h];T[h]=A}if(A=A.forward[0],!A||b(A.key,y)!==0)return!1;for(let h=0;h<R._level&&T[h].forward[h]===A;h++)T[h].forward[h]=A.forward[h];for(;R._level>0&&R._header.forward[R._level-1]===p;)R._level-=1;return!0}}e.SkipList=k}),define(ve[125],we([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=_.globals.performance&&typeof _.globals.performance.now=="function";class p{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new p(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=p}),define(ve[7],we([0,1,11,74,2,122,125]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(w){w.None=()=>p.Disposable.None;function f(ne){return(B,G=null,ee)=>{let oe=!1,se;return se=ne(me=>{if(!oe)return se?se.dispose():oe=!0,B.call(G,me)},null,ee),oe&&se.dispose(),se}}w.once=f;function s(ne,B){return u((G,ee=null,oe)=>ne(se=>G.call(ee,B(se)),null,oe))}w.map=s;function a(ne,B){return u((G,ee=null,oe)=>ne(se=>{B(se),G.call(ee,se)},null,oe))}w.forEach=a;function i(ne,B){return u((G,ee=null,oe)=>ne(se=>B(se)&&G.call(ee,se),null,oe))}w.filter=i;function n(ne){return ne}w.signal=n;function r(...ne){return(B,G=null,ee)=>(0,p.combinedDisposable)(...ne.map(oe=>oe(se=>B.call(G,se),null,ee)))}w.any=r;function o(ne,B,G){let ee=G;return s(ne,oe=>(ee=B(ee,oe),ee))}w.reduce=o;function u(ne){let B;const G=new h({onFirstListenerAdd(){B=ne(G.fire,G)},onLastListenerRemove(){B.dispose()}});return G.event}function E(ne,B,G,ee=100,oe=!1){let se,me,Z=0;return ne($=>{Z++,se=G(se,$),oe&&!me&&(B(se),se=void 0),clearTimeout(me),me=setTimeout(()=>{const H=se;se=void 0,me=void 0,(!oe||Z>1)&&B(H),Z=0},ee)})}w.debouncedListener=E;function P(ne,B,G=100,ee=!1,oe){let se,me,Z,$=0;const H=new h({leakWarningThreshold:oe,onFirstListenerAdd(){se=ne(V=>{$++,me=B(me,V),ee&&!Z&&(H.fire(me),me=void 0),clearTimeout(Z),Z=setTimeout(()=>{const ie=me;me=void 0,Z=void 0,(!ee||$>1)&&H.fire(ie),$=0},G)})},onLastListenerRemove(){se.dispose()}});return H.event}w.debounce=P;function I(ne,B=(G,ee)=>G===ee){let G=!0,ee;return i(ne,oe=>{const se=G||!B(oe,ee);return G=!1,ee=oe,se})}w.latch=I;function O(ne,B){return[w.filter(ne,B),w.filter(ne,G=>!B(G))]}w.split=O;function z(ne,B=!1,G=[]){let ee=G.slice(),oe=ne(Z=>{ee?ee.push(Z):me.fire(Z)});const se=()=>{ee&&ee.forEach(Z=>me.fire(Z)),ee=null},me=new h({onFirstListenerAdd(){oe||(oe=ne(Z=>me.fire(Z)))},onFirstListenerDidAdd(){ee&&(B?setTimeout(se):se())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return me.event}w.buffer=z;class j{constructor(B){this.event=B}map(B){return new j(s(this.event,B))}forEach(B){return new j(a(this.event,B))}filter(B){return new j(i(this.event,B))}reduce(B,G){return new j(o(this.event,B,G))}latch(){return new j(I(this.event))}debounce(B,G=100,ee=!1,oe){return new j(P(this.event,B,G,ee,oe))}on(B,G,ee){return this.event(B,G,ee)}once(B,G,ee){return f(this.event)(B,G,ee)}}function m(ne){return new j(ne)}w.chain=m;function L(ne,B,G=ee=>ee){const ee=(...Z)=>me.fire(G(...Z)),oe=()=>ne.on(B,ee),se=()=>ne.removeListener(B,ee),me=new h({onFirstListenerAdd:oe,onLastListenerRemove:se});return me.event}w.fromNodeEventEmitter=L;function M(ne,B,G=ee=>ee){const ee=(...Z)=>me.fire(G(...Z)),oe=()=>ne.addEventListener(B,ee),se=()=>ne.removeEventListener(B,ee),me=new h({onFirstListenerAdd:oe,onLastListenerRemove:se});return me.event}w.fromDOMEventEmitter=M;function Q(ne){return new Promise(B=>f(ne)(B))}w.toPromise=Q;function W(ne,B){return B(void 0),ne(G=>B(G))}w.runAndSubscribe=W;function q(ne,B){let G=null;function ee(se){G?.dispose(),G=new p.DisposableStore,B(se,G)}ee(void 0);const oe=ne(se=>ee(se));return(0,p.toDisposable)(()=>{oe.dispose(),G?.dispose()})}w.runAndSubscribeWithStore=q})(R=e.Event||(e.Event={}));class y{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${y._idPool++}`}start(f){this._stopWatch=new D.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let b=-1;function T(w){const f=b;return b=w,{dispose(){b=f}}}e.setGlobalLeakWarningThreshold=T;class A{constructor(f,s=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let s=b;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||f<s)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let n,r=0;for(const[o,u]of this._stacks)(!n||r<u)&&(n=o,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(a)||0;this._stacks.set(a,n-1)}}}class h{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=b>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(f,s,a)=>{this._listeners||(this._listeners=new k.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(s?[f,s]:f);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,s);const r=this._leakageMon?.check(this._listeners.size),o=(0,p.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof p.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,a]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(i){(0,_.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=h;class v extends h{async fireAsync(f,s,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,f]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[i,n]=this._asyncDeliveryQueue.shift(),r=[],o={...n,token:s,waitUntil:u=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");a&&(u=a(u,typeof i=="function"?i:i[0])),r.push(u)}};try{typeof i=="function"?i.call(void 0,o):i[0].call(i[1],o)}catch(u){(0,_.onUnexpectedError)(u);continue}Object.freeze(r),await Promise.allSettled(r).then(u=>{for(const E of u)E.status==="rejected"&&(0,_.onUnexpectedError)(E.reason)})}}}}e.AsyncEmitter=v;class l extends h{constructor(f){super(f);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=l;class d extends l{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=d;class g extends h{constructor(f){super(f);this._queuedEvents=[],this._mergeFn=f?.merge}fire(f){this._queuedEvents.push(f),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=g;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const s={event:f,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const a=()=>{this.hasListeners&&this.unhook(s);const i=this.events.indexOf(s);this.events.splice(i,1)};return(0,p.toDisposable)((0,t.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(s=>this.emitter.fire(s))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class c{constructor(){this.buffers=[]}wrapEvent(f){return(s,a,i)=>f(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>s.call(a,n)):s.call(a,n)},void 0,i)}bufferEvents(f){const s=[];this.buffers.push(s);const a=f();return this.buffers.pop(),s.forEach(i=>i()),a}}e.EventBufferer=c;class C{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=p.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(ve[21],we([0,1,7]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(R,y){const b=setTimeout(R.bind(y),0);return{dispose(){clearTimeout(b)}}});var p;(function(R){function y(b){return b===R.None||b===R.Cancelled||b instanceof k?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=y,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(p=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=p.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=p.None}}e.CancellationTokenSource=D}),define(ve[126],we([0,1,21]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new _.CancellationTokenSource,R=this.task(D.token);return this.result={promise:R,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=t;class p{constructor(D){this.computeFn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const R=JSON.stringify(D);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(D)),this.lastCache}}e.LRUCachedComputed=p}),define(ve[43],we([0,1,11,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function p(C){const w=C;return w?[w.on,w.pause,w.resume,w.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=p;function k(C){const w=C;return w?p(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=k;function D(C,w){return new R(C,w)}e.newWriteableStream=D;class R{constructor(w,f){this.reducer=w,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(f=>f(w))}emitError(w){this.listeners.error.length===0?(0,_.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(f=>f(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,f){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(w,f){if(this.state.destroyed)return;let s;switch(w){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const a=s.indexOf(f);a>=0&&s.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(C,w){const f=[];let s;for(;(s=C.read())!==null;)f.push(s);return w(f)}e.consumeReadable=y;function b(C,w,f){const s=[];let a;for(;(a=C.read())!==null&&s.length<f;)s.push(a);return a===null&&s.length>0?w(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return C.read()}}}e.peekReadable=b;function T(C,w){return new Promise((f,s)=>{const a=[];A(C,{onData:i=>{w&&a.push(i)},onError:i=>{w?s(i):f(void 0)},onEnd:()=>{f(w?w(a):void 0)}})})}e.consumeStream=T;function A(C,w){let f=!1;return C.on("error",s=>{f||w.onError(s)}),C.on("end",()=>{f||w.onEnd()}),C.on("data",s=>{f||w.onData(s)}),(0,t.toDisposable)(()=>f=!0)}e.listenStream=A;function h(C,w){return new Promise((f,s)=>{const a=new t.DisposableStore,i=[],n=u=>{if(i.push(u),i.length>w)return a.dispose(),C.pause(),f({stream:C,buffer:i,ended:!1})},r=u=>s(u),o=()=>f({stream:C,buffer:i,ended:!0});a.add((0,t.toDisposable)(()=>C.removeListener("error",r))),C.on("error",r),a.add((0,t.toDisposable)(()=>C.removeListener("end",o))),C.on("end",o),a.add((0,t.toDisposable)(()=>C.removeListener("data",n))),C.on("data",n)})}e.peekStream=h;function v(C,w){const f=D(w);return f.end(C),f}e.toStream=v;function l(){const C=D(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=l;function d(C){let w=!1;return{read:()=>w?null:(w=!0,C)}}e.toReadable=d;function g(C,w,f){const s=D(f);return A(C,{onData:a=>s.write(w.data(a)),onError:a=>s.error(w.error?w.error(a):a),onEnd:()=>s.end()}),s}e.transform=g;function S(C,w,f){let s=!1;return{read:()=>{const a=w.read();return s?a:(s=!0,a!==null?f([C,a]):C)}}}e.prefixedReadable=S;function c(C,w,f){let s=!1;const a=D(f);return A(w,{onData:i=>s?a.write(i):(s=!0,a.write(f([C,i]))),onError:i=>a.error(i),onEnd:()=>{s||(s=!0,a.write(C)),a.end()}}),a}e.prefixedStream=c}),define(ve[15],we([0,1,43]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let p,k;class D{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return t?new D(Buffer.allocUnsafe(E)):new D(new Uint8Array(E))}static wrap(E){return t&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new D(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(E)):(p||(p=new TextEncoder),new D(p.encode(E)))}static fromByteArray(E){const P=D.alloc(E.length);for(let I=0,O=E.length;I<O;I++)P.buffer[I]=E[I];return P}static concat(E,P){if(typeof P=="undefined"){P=0;for(let z=0,j=E.length;z<j;z++)P+=E[z].byteLength}const I=D.alloc(P);let O=0;for(let z=0,j=E.length;z<j;z++){const m=E[z];I.set(m,O),O+=m.byteLength}return I}clone(){const E=D.alloc(this.byteLength);return E.set(this),E}toString(){return t?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(E,P){return new D(this.buffer.subarray(E,P))}set(E,P){if(E instanceof D)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unkown argument 'array'")}readUInt32BE(E){return b(this.buffer,E)}writeUInt32BE(E,P){T(this.buffer,E,P)}readUInt32LE(E){return A(this.buffer,E)}writeUInt32LE(E,P){h(this.buffer,E,P)}readUInt8(E){return v(this.buffer,E)}writeUInt8(E,P){l(this.buffer,E,P)}}e.VSBuffer=D;function R(u,E){return u[E+0]<<0>>>0|u[E+1]<<8>>>0}e.readUInt16LE=R;function y(u,E,P){u[P+0]=E&255,E=E>>>8,u[P+1]=E&255}e.writeUInt16LE=y;function b(u,E){return u[E]*2**24+u[E+1]*2**16+u[E+2]*2**8+u[E+3]}e.readUInt32BE=b;function T(u,E,P){u[P+3]=E,E=E>>>8,u[P+2]=E,E=E>>>8,u[P+1]=E,E=E>>>8,u[P]=E}e.writeUInt32BE=T;function A(u,E){return u[E+0]<<0>>>0|u[E+1]<<8>>>0|u[E+2]<<16>>>0|u[E+3]<<24>>>0}e.readUInt32LE=A;function h(u,E,P){u[P+0]=E&255,E=E>>>8,u[P+1]=E&255,E=E>>>8,u[P+2]=E&255,E=E>>>8,u[P+3]=E&255}e.writeUInt32LE=h;function v(u,E){return u[E]}e.readUInt8=v;function l(u,E,P){u[P]=E}e.writeUInt8=l;function d(u){return _.consumeReadable(u,E=>D.concat(E))}e.readableToBuffer=d;function g(u){return _.toReadable(u)}e.bufferToReadable=g;function S(u){return _.consumeStream(u,E=>D.concat(E))}e.streamToBuffer=S;async function c(u){return u.ended?D.concat(u.buffer):D.concat([...u.buffer,await S(u.stream)])}e.bufferedStreamToBuffer=c;function C(u){return _.toStream(u,E=>D.concat(E))}e.bufferToStream=C;function w(u){return _.transform(u,{data:E=>typeof E=="string"?D.fromString(E):D.wrap(E)},E=>D.concat(E))}e.streamToBufferReadableStream=w;function f(u){return _.newWriteableStream(E=>D.concat(E),u)}e.newWriteableBufferStream=f;function s(u,E){return _.prefixedReadable(u,E,P=>D.concat(P))}e.prefixedBufferReadable=s;function a(u,E){return _.prefixedStream(u,E,P=>D.concat(P))}e.prefixedBufferStream=a;function i(u){let E=0,P=0,I=0;const O=new Uint8Array(Math.floor(u.length/4*3)),z=m=>{switch(P){case 3:O[I++]=E|m,P=0;break;case 2:O[I++]=E|m>>>2,E=m<<6,P=3;break;case 1:O[I++]=E|m>>>4,E=m<<4,P=2;break;default:E=m<<2,P=1}};for(let m=0;m<u.length;m++){const L=u.charCodeAt(m);if(L>=65&&L<=90)z(L-65);else if(L>=97&&L<=122)z(L-97+26);else if(L>=48&&L<=57)z(L-48+52);else if(L===43||L===45)z(62);else if(L===47||L===95)z(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${u[m]}`)}}const j=I;for(;P>0;)z(0);return D.wrap(O).slice(0,j)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:u},E=!0,P=!1){const I=P?r:n;let O="";const z=u.byteLength%3;let j=0;for(;j<u.byteLength-z;j+=3){const m=u[j+0],L=u[j+1],M=u[j+2];O+=I[m>>>2],O+=I[(m<<4|L>>>4)&63],O+=I[(L<<2|M>>>6)&63],O+=I[M&63]}if(z===1){const m=u[j+0];O+=I[m>>>2],O+=I[m<<4&63],E&&(O+="==")}else if(z===2){const m=u[j+0],L=u[j+1];O+=I[m>>>2],O+=I[(m<<4|L>>>4)&63],O+=I[L<<2&63],E&&(O+="=")}return O}e.encodeBase64=o}),define(ve[18],we([0,1,126,121]),function(J,e,_,t){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=k;const D=/{(\d+)}/g;function R(re,...be){return be.length===0?re:re.replace(D,function(ke,Le){const Oe=parseInt(Le,10);return isNaN(Oe)||Oe<0||Oe>=be.length?ke:be[Oe]})}e.format=R;const y=/{([^}]+)}/g;function b(re,be){return re.replace(y,(ke,Le)=>be[Le]??ke)}e.format2=b;function T(re){return re.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=T;function A(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function h(re,be){let ke=0;const Le=be.charCodeAt(0);for(let Oe=re.length-1;Oe>=0;Oe--)re.charCodeAt(Oe)===Le&&ke++;return ke}e.count=h;function v(re,be,ke="\u2026"){return re.length<=be?re:`${re.substr(0,be)}${ke}`}e.truncate=v;function l(re,be=" "){const ke=d(re,be);return g(ke,be)}e.trim=l;function d(re,be){if(!re||!be)return re;const ke=be.length;if(ke===0||re.length===0)return re;let Le=0;for(;re.indexOf(be,Le)===Le;)Le=Le+ke;return re.substring(Le)}e.ltrim=d;function g(re,be){if(!re||!be)return re;const ke=be.length,Le=re.length;if(ke===0||Le===0)return re;let Oe=Le,Qe=-1;for(;Qe=re.lastIndexOf(be,Oe-1),!(Qe===-1||Qe+ke!==Oe);){if(Qe===0)return"";Oe=Qe}return re.substring(0,Oe)}e.rtrim=g;function S(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=S;function c(re){return re.replace(/\*/g,"")}e.stripWildcards=c;function C(re,be,ke={}){if(!re)throw new Error("Cannot create regex from empty string");be||(re=A(re)),ke.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let Le="";return ke.global&&(Le+="g"),ke.matchCase||(Le+="i"),ke.multiline&&(Le+="m"),ke.unicode&&(Le+="u"),new RegExp(re,Le)}e.createRegExp=C;function w(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function f(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function s(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=s;function a(re){return re.split(/\r\n|\r|\n/)}e.splitLines=a;function i(re){for(let be=0,ke=re.length;be<ke;be++){const Le=re.charCodeAt(be);if(Le!==32&&Le!==9)return be}return-1}e.firstNonWhitespaceIndex=i;function n(re,be=0,ke=re.length){for(let Le=be;Le<ke;Le++){const Oe=re.charCodeAt(Le);if(Oe!==32&&Oe!==9)return re.substring(be,Le)}return re.substring(be,ke)}e.getLeadingWhitespace=n;function r(re,be=re.length-1){for(let ke=be;ke>=0;ke--){const Le=re.charCodeAt(ke);if(Le!==32&&Le!==9)return ke}return-1}e.lastNonWhitespaceIndex=r;function o(re,be){return re<be?-1:re>be?1:0}e.compare=o;function u(re,be,ke=0,Le=re.length,Oe=0,Qe=be.length){for(;ke<Le&&Oe<Qe;ke++,Oe++){let Ye=re.charCodeAt(ke),Ge=be.charCodeAt(Oe);if(Ye<Ge)return-1;if(Ye>Ge)return 1}const We=Le-ke,Ve=Qe-Oe;return We<Ve?-1:We>Ve?1:0}e.compareSubstring=u;function E(re,be){return P(re,be,0,re.length,0,be.length)}e.compareIgnoreCase=E;function P(re,be,ke=0,Le=re.length,Oe=0,Qe=be.length){for(;ke<Le&&Oe<Qe;ke++,Oe++){let Ye=re.charCodeAt(ke),Ge=be.charCodeAt(Oe);if(Ye===Ge)continue;if(Ye>=128||Ge>=128)return u(re.toLowerCase(),be.toLowerCase(),ke,Le,Oe,Qe);I(Ye)&&(Ye-=32),I(Ge)&&(Ge-=32);const Ze=Ye-Ge;if(Ze!==0)return Ze}const We=Le-ke,Ve=Qe-Oe;return We<Ve?-1:We>Ve?1:0}e.compareSubstringIgnoreCase=P;function I(re){return re>=97&&re<=122}e.isLowerAsciiLetter=I;function O(re){return re>=65&&re<=90}e.isUpperAsciiLetter=O;function z(re,be){return re.length===be.length&&P(re,be)===0}e.equalsIgnoreCase=z;function j(re,be){const ke=be.length;return be.length>re.length?!1:P(re,be,0,ke)===0}e.startsWithIgnoreCase=j;function m(re,be){let ke,Le=Math.min(re.length,be.length);for(ke=0;ke<Le;ke++)if(re.charCodeAt(ke)!==be.charCodeAt(ke))return ke;return Le}e.commonPrefixLength=m;function L(re,be){let ke,Le=Math.min(re.length,be.length);const Oe=re.length-1,Qe=be.length-1;for(ke=0;ke<Le;ke++)if(re.charCodeAt(Oe-ke)!==be.charCodeAt(Qe-ke))return ke;return Le}e.commonSuffixLength=L;function M(re){return 55296<=re&&re<=56319}e.isHighSurrogate=M;function Q(re){return 56320<=re&&re<=57343}e.isLowSurrogate=Q;function W(re,be){return(re-55296<<10)+(be-56320)+65536}e.computeCodePoint=W;function q(re,be,ke){const Le=re.charCodeAt(ke);if(M(Le)&&ke+1<be){const Oe=re.charCodeAt(ke+1);if(Q(Oe))return W(Le,Oe)}return Le}e.getNextCodePoint=q;function ne(re,be){const ke=re.charCodeAt(be-1);if(Q(ke)&&be>1){const Le=re.charCodeAt(be-2);if(M(Le))return W(Le,ke)}return ke}class B{constructor(be,ke=0){this._str=be,this._len=be.length,this._offset=ke}get offset(){return this._offset}setOffset(be){this._offset=be}prevCodePoint(){const be=ne(this._str,this._offset);return this._offset-=be>=65536?2:1,be}nextCodePoint(){const be=q(this._str,this._len,this._offset);return this._offset+=be>=65536?2:1,be}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class G{constructor(be,ke=0){this._iterator=new B(be,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const be=ge.getInstance(),ke=this._iterator,Le=ke.offset;let Oe=be.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Qe=ke.offset,We=be.getGraphemeBreakType(ke.nextCodePoint());if(Ue(Oe,We)){ke.setOffset(Qe);break}Oe=We}return ke.offset-Le}prevGraphemeLength(){const be=ge.getInstance(),ke=this._iterator,Le=ke.offset;let Oe=be.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Qe=ke.offset,We=be.getGraphemeBreakType(ke.prevCodePoint());if(Ue(We,Oe)){ke.setOffset(Qe);break}Oe=We}return Le-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function ee(re,be){return new G(re,be).nextGraphemeLength()}e.nextCharLength=ee;function oe(re,be){return new G(re,be).prevGraphemeLength()}e.prevCharLength=oe;function se(re,be){be>0&&Q(re.charCodeAt(be))&&be--;const ke=be+ee(re,be);return[ke-oe(re,ke),ke]}e.getCharContainingOffset=se;const me=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(re){return me.test(re)}e.containsRTL=Z;const $=/^[\t\n\r\x20-\x7E]*$/;function H(re){return $.test(re)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=V;function ie(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=ie;function de(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=de;function De(re,be){if(re.length<be)return re;const ke=/\b/g;let Le=0;for(;ke.test(re)&&!(re.length-ke.lastIndex<be);)Le=ke.lastIndex,ke.lastIndex+=1;return re.substring(Le).replace(/^\s/,"")}e.lcut=De;const ae=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function X(re){return re&&(re=re.replace(ae,""),re=re.replace(fe,""),re=re.replace(pe,"")),re}e.removeAnsiEscapeCodes=X,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function U(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=U;function K(re){return U(re)?re.substr(1):re}e.stripUTF8BOM=K;function Y(re,be){if(!re||!be||re.length<be.length)return!1;const ke=be.length,Le=re.toLowerCase();let Oe=0,Qe=-1;for(;Oe<ke;){const We=Le.indexOf(be[Oe],Qe+1);if(We<0)return!1;Qe=We,Oe++}return!0}e.fuzzyContains=Y;function ue(re,be=!1){return re?(be&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=ue;function ye(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=ye;function Pe(re,be=1){if(be===0)return"";let ke=-1;do ke=re.indexOf(`
`,ke+1),be--;while(be>0&&ke>=0);return ke===-1?re:(re[ke-1]==="\r"&&ke--,re.substr(0,ke))}e.getNLines=Pe;function Ae(re){const be=90-65+1;return re=re%(2*be),re<be?String.fromCharCode(97+re):String.fromCharCode(65+re-be)}e.singleLetterHash=Ae;function Fe(re){return ge.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=Fe;function Ue(re,be){return re===0?be!==5&&be!==7:re===2&&be===3?!1:re===4||re===2||re===3||be===4||be===2||be===3?!0:!(re===8&&(be===8||be===9||be===11||be===12)||(re===11||re===9)&&(be===9||be===10)||(re===12||re===10)&&be===10||be===5||be===13||be===7||re===1||re===13&&be===14||re===6&&be===6)}var le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(le=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ge{constructor(){this._data=he()}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const ke=this._data,Le=ke.length/3;let Oe=1;for(;Oe<=Le;)if(be<ke[3*Oe])Oe=2*Oe;else if(be>ke[3*Oe+1])Oe=2*Oe+1;else return ke[3*Oe+2];return 0}}ge._INSTANCE=null;function he(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function _e(re,be){if(re===0)return 0;const ke=Me(re,be);if(ke!==void 0)return ke;const Le=new B(be,re);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=_e;function Me(re,be){const ke=new B(be,re);let Le=ke.prevCodePoint();for(;qe(Le)||Le===65039||Le===8419;){if(ke.offset===0)return;Le=ke.prevCodePoint()}if(!de(Le))return;let Oe=ke.offset;return Oe>0&&ke.prevCodePoint()===8205&&(Oe=ke.offset),Oe}function qe(re){return 127995<=re&&re<=127999}var Be;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class He{constructor(be){this.confusableDictionary=be}static getInstance(be){return He.cache.get(Array.from(be))}static getLocales(){return He._locales.getValue()}isAmbiguous(be){return this.confusableDictionary.has(be)}getPrimaryConfusable(be){return this.confusableDictionary.get(be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,p=He,He.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new _.LRUCachedComputed(re=>{function be(Ge){const Ze=new Map;for(let rt=0;rt<Ge.length;rt+=2)Ze.set(Ge[rt],Ge[rt+1]);return Ze}function ke(Ge,Ze){const rt=new Map(Ge);for(const[tt,nt]of Ze)rt.set(tt,nt);return rt}function Le(Ge,Ze){if(!Ge)return Ze;const rt=new Map;for(const[tt,nt]of Ge)Ze.has(tt)&&rt.set(tt,nt);return rt}const Oe=p.ambiguousCharacterData.getValue();let Qe=re.filter(Ge=>!Ge.startsWith("_")&&Ge in Oe);Qe.length===0&&(Qe=["_default"]);let We;for(const Ge of Qe){const Ze=be(Oe[Ge]);We=Le(We,Ze)}const Ve=be(Oe._common),Ye=ke(Ve,We);return new He(Ye)}),He._locales=new t.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(re=>!re.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(be){return je.getData().has(be)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(ve[127],we([0,1,18]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(S){return p(S,0)}e.hash=t;function p(S,c){switch(typeof S){case"object":return S===null?k(349,c):Array.isArray(S)?y(S,c):b(S,c);case"string":return R(S,c);case"boolean":return D(S,c);case"number":return k(S,c);case"undefined":return k(937,c);default:return k(617,c)}}e.doHash=p;function k(S,c){return(c<<5)-c+S|0}e.numberHash=k;function D(S,c){return k(S?433:863,c)}function R(S,c){c=k(149417,c);for(let C=0,w=S.length;C<w;C++)c=k(S.charCodeAt(C),c);return c}e.stringHash=R;function y(S,c){return c=k(104579,c),S.reduce((C,w)=>p(w,C),c)}function b(S,c){return c=k(181387,c),Object.keys(S).sort().reduce((C,w)=>(C=R(w,C),p(S[w],C)),c)}class T{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=p(c,this._value),this._value}}e.Hasher=T;var A;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function h(S,c,C=32){const w=C-c,f=~((1<<w)-1);return(S<<c|(f&S)>>>w)>>>0}function v(S,c=0,C=S.byteLength,w=0){for(let f=0;f<C;f++)S[c+f]=w}function l(S,c,C="0"){for(;S.length<c;)S=C+S;return S}function d(S,c=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(C=>C.toString(16).padStart(2,"0")).join(""):l((S>>>0).toString(16),c/4)}e.toHexString=d;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const C=c.length;if(C===0)return;const w=this._buff;let f=this._buffLen,s=this._leftoverHighSurrogate,a,i;for(s!==0?(a=s,i=-1,s=0):(a=c.charCodeAt(0),i=0);;){let n=a;if(_.isHighSurrogate(a))if(i+1<C){const r=c.charCodeAt(i+1);_.isLowSurrogate(r)?(i++,n=_.computeCodePoint(a,r)):n=65533}else{s=a;break}else _.isLowSurrogate(a)&&(n=65533);if(f=this._push(w,f,n),i++,i<C)a=c.charCodeAt(i);else break}this._buffLen=f,this._leftoverHighSurrogate=s}_push(c,C,w){return w<128?c[C++]=w:w<2048?(c[C++]=192|(w&1984)>>>6,c[C++]=128|(w&63)>>>0):w<65536?(c[C++]=224|(w&61440)>>>12,c[C++]=128|(w&4032)>>>6,c[C++]=128|(w&63)>>>0):(c[C++]=240|(w&1835008)>>>18,c[C++]=128|(w&258048)>>>12,c[C++]=128|(w&4032)>>>6,c[C++]=128|(w&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=g._bigBlock32,C=this._buffDV;for(let u=0;u<64;u+=4)c.setUint32(u,C.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)c.setUint32(u,h(c.getUint32(u-12,!1)^c.getUint32(u-32,!1)^c.getUint32(u-56,!1)^c.getUint32(u-64,!1),1),!1);let w=this._h0,f=this._h1,s=this._h2,a=this._h3,i=this._h4,n,r,o;for(let u=0;u<80;u++)u<20?(n=f&s|~f&a,r=1518500249):u<40?(n=f^s^a,r=1859775393):u<60?(n=f&s|f&a|s&a,r=2400959708):(n=f^s^a,r=3395469782),o=h(w,5)+n+i+r+c.getUint32(u*4,!1)&4294967295,i=a,a=s,s=h(f,30),f=w,w=o;this._h0=this._h0+w&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(J,e,_,t,p){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?p.call(J,_):p?p.value=_:e.set(J,_),_},et=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(ve[30],we([0,1,17,18]),function(J,e,_,t){"use strict";var p,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,n,r){let o=i.get(n);return o===void 0&&(o=r,i.set(n,o)),o}e.getOrSet=R;function y(i){const n=[];return i.forEach((r,o)=>{n.push(`${o} => ${r}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=y;function b(i){const n=[];return i.forEach(r=>{n.push(r)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=b;class T{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=T;class A{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class h{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let r=n.length-1;r>=0;r--,this._valueLen--){const o=this._value.charCodeAt(r);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var v;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(v||(v={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(g||(g={}));class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new l(n))}static forPaths(n=!1){return new S(new h(void 0,!n))}static forStrings(){return new S(new T)}static forConfigKeys(){return new S(new A)}clear(){this._root=void 0}fill(n,r){if(r){const o=r.slice(0);(0,_.shuffle)(o);for(let u of o)this.set(u,n)}else{const o=n.slice(0);(0,_.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(n,r){const o=this._iter.reset(n);let u;this._root||(this._root=new d,this._root.segment=o.value());const E=[];for(u=this._root;;){const I=o.cmp(u.segment);if(I>0)u.left||(u.left=new d,u.left.segment=o.value()),E.push([-1,u]),u=u.left;else if(I<0)u.right||(u.right=new d,u.right.segment=o.value()),E.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new d,u.mid.segment=o.value()),E.push([0,u]),u=u.mid;else break}const P=u.value;u.value=r,u.key=n;for(let I=E.length-1;I>=0;I--){const O=E[I][1];O.updateHeight();const z=O.balanceFactor();if(z<-1||z>1){const j=E[I][0],m=E[I+1][0];if(j===1&&m===1)E[I][1]=O.rotateLeft();else if(j===-1&&m===-1)E[I][1]=O.rotateRight();else if(j===1&&m===-1)O.right=E[I+1][1]=E[I+1][1].rotateRight(),E[I][1]=O.rotateLeft();else if(j===-1&&m===1)O.left=E[I+1][1]=E[I+1][1].rotateLeft(),E[I][1]=O.rotateRight();else throw new Error;if(I>0)switch(E[I-1][0]){case-1:E[I-1][1].left=E[I][1];break;case 1:E[I-1][1].right=E[I][1];break;case 0:E[I-1][1].mid=E[I][1];break}else this._root=E[0][1]}}return P}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let o=this._root;for(;o;){const u=r.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const o=this._iter.reset(n),u=[];let E=this._root;for(;E;){const P=o.cmp(E.segment);if(P>0)u.push([-1,E]),E=E.left;else if(P<0)u.push([1,E]),E=E.right;else if(o.hasNext())o.next(),u.push([0,E]),E=E.mid;else break}if(!!E){if(r?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const P=this._min(E.right),{key:I,value:O,segment:z}=P;this._delete(P.key,!1),E.key=I,E.value=O,E.segment=z}else{const P=E.left??E.right;if(u.length>0){const[I,O]=u[u.length-1];switch(I){case-1:O.left=P;break;case 0:O.mid=P;break;case 1:O.right=P;break}}else this._root=P}for(let P=u.length-1;P>=0;P--){const I=u[P][1];I.updateHeight();const O=I.balanceFactor();if(O>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),u[P][1]=I.rotateLeft()):O<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),u[P][1]=I.rotateRight()),P>0)switch(u[P-1][0]){case-1:u[P-1][1].left=u[P][1];break;case 1:u[P-1][1].right=u[P][1];break;case 0:u[P-1][1].mid=u[P][1];break}else this._root=u[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const r=this._iter.reset(n);let o=this._root,u;for(;o;){const E=r.cmp(o.segment);if(E>0)o=o.left;else if(E<0)o=o.right;else if(r.hasNext())r.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(n){const r=this._iter.reset(n);let o=this._root;for(;o;){const u=r.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[r,o]of this)n(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:n(r.left)&&n(r.right)};return n(this._root)}}e.TernarySearchTree=S;class c{constructor(n,r){this.uri=n,this.value=r}}class C{constructor(n,r){this[p]="ResourceMap",n instanceof C?(this.map=new Map(n.map),this.toKey=r??C.defaultToKey):(this.map=new Map,this.toKey=n??C.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),new c(n,r)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[o,u]of this.map)n(u.value,u.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=C,C.defaultToKey=i=>i.toString();var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const o=this._map.get(n);if(!!o)return r!==0&&this.touch(o,r),o.value}set(n,r,o=0){let u=this._map.get(n);if(u)u.value=r,o!==0&&this.touch(u,o);else{switch(u={key:n,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const o=this._state;let u=this._head;for(;u;){if(r?n.bind(r)(u.value,u.key,this):n(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const E={value:o.key,done:!1};return o=o.next,E}else return{value:void 0,done:!0}}};return u}values(){const n=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const E={value:o.value,done:!1};return o=o.next,E}else return{value:void 0,done:!0}}};return u}entries(){const n=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const E={value:[o.key,o.value],done:!1};return o=o.next,E}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>n;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,o=n.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const o=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const o=n.next,u=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,o)=>{n.push([o,r])}),n}fromJSON(n){this.clear();for(const[r,o]of n)this.set(r,o)}}e.LinkedMap=f;class s extends f{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class a{constructor(n){D.set(this,void 0),Et(this,D,n,"f")}get size(){return et(this,D,"f").size}forEach(n,r){et(this,D,"f").forEach(n,r)}get(n){return et(this,D,"f").get(n)}has(n){return et(this,D,"f").has(n)}entries(){return et(this,D,"f").entries()}keys(){return et(this,D,"f").keys()}values(){return et(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return et(this,D,"f").entries()}}e.ReadonlyMapView=a}),define(ve[128],we([0,1,30,18]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function p(...U){return function(K,Y){for(let ue=0,ye=U.length;ue<ye;ue++){const Pe=U[ue](K,Y);if(Pe)return Pe}return null}}e.or=p,e.matchesStrictPrefix=k.bind(void 0,!1),e.matchesPrefix=k.bind(void 0,!0);function k(U,K,Y){if(!Y||Y.length<K.length)return null;let ue;return U?ue=t.startsWithIgnoreCase(Y,K):ue=Y.indexOf(K)===0,ue?K.length>0?[{start:0,end:K.length}]:[]:null}function D(U,K){const Y=K.toLowerCase().indexOf(U.toLowerCase());return Y===-1?null:[{start:Y,end:Y+U.length}]}e.matchesContiguousSubString=D;function R(U,K){return y(U.toLowerCase(),K.toLowerCase(),0,0)}e.matchesSubString=R;function y(U,K,Y,ue){if(Y===U.length)return[];if(ue===K.length)return null;if(U[Y]===K[ue]){let ye=null;return(ye=y(U,K,Y+1,ue+1))?S({start:ue,end:ue+1},ye):null}return y(U,K,Y,ue+1)}function b(U){return 97<=U&&U<=122}function T(U){return 65<=U&&U<=90}e.isUpper=T;function A(U){return 48<=U&&U<=57}function h(U){return U===32||U===9||U===10||U===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(U=>v.add(U.charCodeAt(0)));function l(U){return h(U)||v.has(U)}function d(U,K){return U===K||l(U)&&l(K)}function g(U){return b(U)||T(U)||A(U)}function S(U,K){return K.length===0?K=[U]:U.end===K[0].start?K[0].start=U.start:K.unshift(U),K}function c(U,K){for(let Y=K;Y<U.length;Y++){const ue=U.charCodeAt(Y);if(T(ue)||A(ue)||Y>0&&!g(U.charCodeAt(Y-1)))return Y}return U.length}function C(U,K,Y,ue){if(Y===U.length)return[];if(ue===K.length)return null;if(U[Y]!==K[ue].toLowerCase())return null;{let ye=null,Pe=ue+1;for(ye=C(U,K,Y+1,ue+1);!ye&&(Pe=c(K,Pe))<K.length;)ye=C(U,K,Y+1,Pe),Pe++;return ye===null?null:S({start:ue,end:ue+1},ye)}}function w(U){let K=0,Y=0,ue=0,ye=0,Pe=0;for(let ge=0;ge<U.length;ge++)Pe=U.charCodeAt(ge),T(Pe)&&K++,b(Pe)&&Y++,g(Pe)&&ue++,A(Pe)&&ye++;const Ae=K/U.length,Fe=Y/U.length,Ue=ue/U.length,le=ye/U.length;return{upperPercent:Ae,lowerPercent:Fe,alphaPercent:Ue,numericPercent:le}}function f(U){const{upperPercent:K,lowerPercent:Y}=U;return Y===0&&K>.6}function s(U){const{upperPercent:K,lowerPercent:Y,alphaPercent:ue,numericPercent:ye}=U;return Y>.2&&K<.8&&ue>.6&&ye<.2}function a(U){let K=0,Y=0,ue=0,ye=0;for(let Pe=0;Pe<U.length;Pe++)ue=U.charCodeAt(Pe),T(ue)&&K++,b(ue)&&Y++,h(ue)&&ye++;return(K===0||Y===0)&&ye===0?U.length<=30:K<=5}function i(U,K){if(!K||(K=K.trim(),K.length===0)||!a(U)||K.length>60)return null;const Y=w(K);if(!s(Y)){if(!f(Y))return null;K=K.toLowerCase()}let ue=null,ye=0;for(U=U.toLowerCase();ye<K.length&&(ue=C(U,K,0,ye))===null;)ye=c(K,ye+1);return ue}e.matchesCamelCase=i;function n(U,K,Y=!1){if(!K||K.length===0)return null;let ue=null,ye=0;for(U=U.toLowerCase(),K=K.toLowerCase();ye<K.length&&(ue=r(U,K,0,ye,Y))===null;)ye=o(K,ye+1);return ue}e.matchesWords=n;function r(U,K,Y,ue,ye){if(Y===U.length)return[];if(ue===K.length)return null;if(d(U.charCodeAt(Y),K.charCodeAt(ue))){let Pe=null,Ae=ue+1;if(Pe=r(U,K,Y+1,ue+1,ye),!ye)for(;!Pe&&(Ae=o(K,Ae))<K.length;)Pe=r(U,K,Y+1,Ae,ye),Ae++;return Pe===null?null:S({start:ue,end:ue+1},Pe)}else return null}function o(U,K){for(let Y=K;Y<U.length;Y++)if(l(U.charCodeAt(Y))||Y>0&&l(U.charCodeAt(Y-1)))return Y;return U.length}const u=p(e.matchesPrefix,i,D),E=p(e.matchesPrefix,i,R),P=new _.LRUCache(1e4);function I(U,K,Y=!1){if(typeof U!="string"||typeof K!="string")return null;let ue=P.get(U);ue||(ue=new RegExp(t.convertSimple2RegExpPattern(U),"i"),P.set(U,ue));const ye=ue.exec(K);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:Y?E(U,K):u(U,K)}e.matchesFuzzy=I;function O(U,K){const Y=ie(U,U.toLowerCase(),0,K,K.toLowerCase(),0,!0);return Y?j(Y):null}e.matchesFuzzy2=O;function z(U,K,Y,ue,ye,Pe){const Ae=Math.min(13,U.length);for(;Y<Ae;Y++){const Fe=ie(U,K,Y,ue,ye,Pe,!1);if(Fe)return Fe}return[0,Pe]}e.anyScore=z;function j(U){if(typeof U=="undefined")return[];const K=[],Y=U[1];for(let ue=U.length-1;ue>1;ue--){const ye=U[ue]+Y,Pe=K[K.length-1];Pe&&Pe.end===ye?Pe.end=ye+1:K.push({start:ye,end:ye+1})}return K}e.createMatches=j;const m=128;function L(){const U=[],K=[];for(let Y=0;Y<=m;Y++)K[Y]=0;for(let Y=0;Y<=m;Y++)U.push(K.slice(0));return U}function M(U){const K=[];for(let Y=0;Y<=U;Y++)K[Y]=0;return K}const Q=M(2*m),W=M(2*m),q=L(),ne=L(),B=L(),G=!1;function ee(U,K,Y,ue,ye){function Pe(Fe,Ue,le=" "){for(;Fe.length<Ue;)Fe=le+Fe;return Fe}let Ae=` |   |${ue.split("").map(Fe=>Pe(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=Y;Fe++)Fe===0?Ae+=" |":Ae+=`${K[Fe-1]}|`,Ae+=U[Fe].slice(0,ye+1).map(Ue=>Pe(Ue.toString(),3)).join("|")+`
`;return Ae}function oe(U,K,Y,ue){U=U.substr(K),Y=Y.substr(ue),console.log(ee(ne,U,U.length,Y,Y.length)),console.log(ee(B,U,U.length,Y,Y.length)),console.log(ee(q,U,U.length,Y,Y.length))}function se(U,K){if(K<0||K>=U.length)return!1;const Y=U.codePointAt(K);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Y)}}function me(U,K){if(K<0||K>=U.length)return!1;switch(U.charCodeAt(K)){case 32:case 9:return!0;default:return!1}}function Z(U,K,Y){return K[U]!==Y[U]}function $(U,K,Y,ue,ye,Pe,Ae=!1){for(;K<Y&&ye<Pe;)U[K]===ue[ye]&&(Ae&&(Q[K]=ye),K+=1),ye+=1;return K===Y}e.isPatternInWord=$;var H;(function(U){U[U.Diag=1]="Diag",U[U.Left=2]="Left",U[U.LeftLeft=3]="LeftLeft"})(H||(H={}));var V;(function(U){U.Default=[-100,0];function K(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}U.isDefault=K})(V=e.FuzzyScore||(e.FuzzyScore={}));function ie(U,K,Y,ue,ye,Pe,Ae){const Fe=U.length>m?m:U.length,Ue=ue.length>m?m:ue.length;if(Y>=Fe||Pe>=Ue||Fe-Y>Ue-Pe||!$(K,Y,Fe,ye,Pe,Ue,!0))return;de(Fe,Ue,Y,Pe,K,ye);let le=1,ge=1,he=Y,_e=Pe;const Me=[!1];for(le=1,he=Y;he<Fe;le++,he++){const re=Q[he],be=W[he],ke=he+1<Fe?W[he+1]:Ue;for(ge=re-Pe+1,_e=re;_e<ke;ge++,_e++){let Le=Number.MIN_SAFE_INTEGER,Oe=!1;_e<=be&&(Le=De(U,K,he,Y,ue,ye,_e,Ue,Pe,q[le-1][ge-1]===0,Me));let Qe=0;Le!==Number.MAX_SAFE_INTEGER&&(Oe=!0,Qe=Le+ne[le-1][ge-1]);const We=_e>re,Ve=We?ne[le][ge-1]+(q[le][ge-1]>0?-5:0):0,Ye=_e>re+1&&q[le][ge-1]>0,Ge=Ye?ne[le][ge-2]+(q[le][ge-2]>0?-5:0):0;if(Ye&&(!We||Ge>=Ve)&&(!Oe||Ge>=Qe))ne[le][ge]=Ge,B[le][ge]=3,q[le][ge]=0;else if(We&&(!Oe||Ve>=Qe))ne[le][ge]=Ve,B[le][ge]=2,q[le][ge]=0;else if(Oe)ne[le][ge]=Qe,B[le][ge]=1,q[le][ge]=q[le-1][ge-1]+1;else throw new Error("not possible")}}if(G&&oe(U,Y,ue,Pe),!Me[0]&&!Ae)return;le--,ge--;const qe=[ne[le][ge],Pe];let Be=0,He=0;for(;le>=1;){let re=ge;do{const be=B[le][re];if(be===3)re=re-2;else if(be===2)re=re-1;else break}while(re>=1);Be>1&&K[Y+le-1]===ye[Pe+ge-1]&&!Z(re+Pe-1,ue,ye)&&Be+1>q[le][re]&&(re=ge),re===ge?Be++:Be=1,He||(He=re),le--,ge=re-1,qe.push(ge)}Ue===Fe&&(qe[0]+=2);const je=He-Fe;return qe[0]-=je,qe}e.fuzzyScore=ie;function de(U,K,Y,ue,ye,Pe){let Ae=U-1,Fe=K-1;for(;Ae>=Y&&Fe>=ue;)ye[Ae]===Pe[Fe]&&(W[Ae]=Fe,Ae--),Fe--}function De(U,K,Y,ue,ye,Pe,Ae,Fe,Ue,le,ge){if(K[Y]!==Pe[Ae])return Number.MIN_SAFE_INTEGER;let he=1,_e=!1;return Ae===Y-ue?he=U[Y]===ye[Ae]?7:5:Z(Ae,ye,Pe)&&(Ae===0||!Z(Ae-1,ye,Pe))?(he=U[Y]===ye[Ae]?7:5,_e=!0):se(Pe,Ae)&&(Ae===0||!se(Pe,Ae-1))?he=5:(se(Pe,Ae-1)||me(Pe,Ae-1))&&(he=5,_e=!0),he>1&&Y===ue&&(ge[0]=!0),_e||(_e=Z(Ae,ye,Pe)||se(Pe,Ae-1)||me(Pe,Ae-1)),Y===ue?Ae>Ue&&(he-=_e?3:5):le?he+=_e?2:0:he+=_e?0:1,Ae+1===Fe&&(he-=_e?3:5),he}function ae(U,K,Y,ue,ye,Pe,Ae){return pe(U,K,Y,ue,ye,Pe,!0,Ae)}e.fuzzyScoreGracefulAggressive=ae;function fe(U,K,Y,ue,ye,Pe,Ae){return pe(U,K,Y,ue,ye,Pe,!1,Ae)}e.fuzzyScoreGraceful=fe;function pe(U,K,Y,ue,ye,Pe,Ae,Fe){let Ue=ie(U,K,Y,ue,ye,Pe,Fe);if(Ue&&!Ae)return Ue;if(U.length>=3){const le=Math.min(7,U.length-1);for(let ge=Y+1;ge<le;ge++){const he=X(U,ge);if(he){const _e=ie(he,he.toLowerCase(),Y,ue,ye,Pe,Fe);_e&&(_e[0]-=3,(!Ue||_e[0]>Ue[0])&&(Ue=_e))}}}return Ue}function X(U,K){if(K+1>=U.length)return;const Y=U[K],ue=U[K+1];if(Y!==ue)return U.slice(0,K)+ue+Y+U.slice(K+2)}}),define(ve[129],we([0,1,37,128,18]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const k=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(_.CSSIcon.iconNameCharacter),R=new RegExp(`(\\\\)?${k.source}`,"g");function y(g){return g.replace(R,(S,c)=>c?S:`\\${S}`)}e.escapeIcons=y;const b=new RegExp(`\\\\${k.source}`,"g");function T(g){return g.replace(b,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=T;const A=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function h(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(A,(S,c,C,w)=>C?S:c||w||"")}e.stripIcons=h;function v(g){const S=g.indexOf(e.iconStartMarker);return S===-1?{text:g}:l(g,S)}e.parseLabelWithIcons=v;function l(g,S){const c=[];let C="";function w(u){if(u){C+=u;for(const E of u)c.push(a)}}let f=-1,s="",a=0,i,n,r=S;const o=g.length;for(w(g.substr(0,S));r<o;)i=g[r],n=g[r+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(f=r,w(s),s=e.iconStartMarker,r++):i===")"&&f!==-1?(a+=r-f+1,f=-1,s=""):f!==-1?D.test(i)?s+=i:(w(s),f=-1,s=""):w(i),r++;return w(s),{text:C,iconOffsets:c}}function d(g,S,c=!1){const{text:C,iconOffsets:w}=S;if(!w||w.length===0)return(0,t.matchesFuzzy)(g,C,c);const f=(0,p.ltrim)(C," "),s=C.length-f.length,a=(0,t.matchesFuzzy)(g,f,c);if(a)for(const i of a){const n=w[i.start+s]+s;i.start+=n,i.end+=n}return a}e.matchesFuzzyIconAware=d}),define(ve[76],we([0,1,11,129]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(p=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(v="",l=!1){if(this.value=v,typeof this.value!="string")throw(0,_.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(v,l=0){return this.value+=b(this.supportThemeIcons?(0,t.escapeIcons)(v):v).replace(/([ \t]+)/g,(d,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,l){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=k;function D(h){return R(h)?!h.value:Array.isArray(h)?h.every(D):!0}e.isEmptyMarkdownString=D;function R(h){return h instanceof k?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function y(h,v){return h===v?!0:!h||!v?!1:h.value===v.value&&h.isTrusted===v.isTrusted&&h.supportThemeIcons===v.supportThemeIcons}e.markdownStringEqual=y;function b(h){return h.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function T(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function A(h){const v=[],l=h.split("|").map(g=>g.trim());h=l[0];const d=l[1];if(d){const g=/height=(\d+)/.exec(d),S=/width=(\d+)/.exec(d),c=g?g[1]:"",C=S?S[1]:"",w=isFinite(parseInt(C)),f=isFinite(parseInt(c));w&&v.push(`width="${C}"`),f&&v.push(`height="${c}"`)}return{href:h,dimensions:v}}e.parseHrefAndDimensions=A}),define(ve[77],we([0,1,30]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new _.LRUCache(1e4);function p(b){return y(b,"NFC",t)}e.normalizeNFC=p;const k=new _.LRUCache(1e4);function D(b){return y(b,"NFD",k)}e.normalizeNFD=D;const R=/[^\u0000-\u0080]/;function y(b,T,A){if(!b)return b;const h=A.get(b);if(h)return h;let v;return R.test(b)?v=b.normalize(T):v=b,A.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(T){return D(T).replace(b,"")}}()}),define(ve[78],we([0,1,18]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(t||(t={})),function(p){const k="error",D="warning",R="warn",y="info",b="ignore";function T(h){return h?_.equalsIgnoreCase(k,h)?p.Error:_.equalsIgnoreCase(D,h)||_.equalsIgnoreCase(R,h)?p.Warning:_.equalsIgnoreCase(y,h)?p.Info:p.Ignore:p.Ignore}p.fromValue=T;function A(h){switch(h){case p.Error:return k;case p.Warning:return D;case p.Info:return y;default:return b}}p.toString=A}(t||(t={})),e.default=t}),define(ve[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(o){return Array.isArray(o)}e.isArray=_;function t(o){return typeof o=="string"}e.isString=t;function p(o){return Array.isArray(o)&&o.every(u=>t(u))}e.isStringArray=p;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=R;function y(o){return o===!0||o===!1}e.isBoolean=y;function b(o){return typeof o=="undefined"}e.isUndefined=b;function T(o){return!A(o)}e.isDefined=T;function A(o){return b(o)||o===null}e.isUndefinedOrNull=A;function h(o,u){if(!o)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=h;function v(o){if(A(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function l(...o){const u=[];for(let E=0;E<o.length;E++){const P=o[E];if(A(P))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(P)}return u}e.assertAllDefined=l;const d=Object.prototype.hasOwnProperty;function g(o){if(!k(o))return!1;for(let u in o)if(d.call(o,u))return!1;return!0}e.isEmptyObject=g;function S(o){return typeof o=="function"}e.isFunction=S;function c(...o){return o.length>0&&o.every(S)}e.areFunctions=c;function C(o,u){const E=Math.min(o.length,u.length);for(let P=0;P<E;P++)w(o[P],u[P])}e.validateConstraints=C;function w(o,u){if(t(u)){if(typeof o!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(S(u)){try{if(o instanceof u)return}catch{}if(!A(o)&&o.constructor===u||u.length===1&&u.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function f(o){let u=[],E=Object.getPrototypeOf(o);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=f;function s(o){const u=[];for(const E of f(o))typeof o[E]=="function"&&u.push(E);return u}e.getAllMethodNames=s;function a(o,u){const E=I=>function(){const O=Array.prototype.slice.call(arguments,0);return u(I,O)};let P={};for(const I of o)P[I]=E(I);return P}e.createProxyObject=a;function i(o){return o===null?void 0:o}e.withNullAsUndefined=i;function n(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=n;function r(o,u="Unreachable"){throw new Error(u)}e.assertNever=r}),define(ve[31],we([0,1,4,3,18,12]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function R(r){return r.replace(/[\\/]/g,_.posix.sep)}e.toSlashes=R;function y(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function b(r,o=_.posix.sep){if(!r)return"";const u=r.length,E=r.charCodeAt(0);if(D(E)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const O=I;for(;I<u&&!D(r.charCodeAt(I));I++);if(O!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<u;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(S(E)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let P=r.indexOf("://");if(P!==-1){for(P+=3;P<u;P++)if(D(r.charCodeAt(P)))return r.slice(0,P+1)}return""}e.getRoot=b;function T(r){if(!t.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let u=2;const E=u;for(;u<r.length&&(o=r.charCodeAt(u),o!==92);u++);return!(E===u||(o=r.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=T;const A=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,o=t.isWindows){const u=o?A:h;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||o&&v.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=l;function d(r,o,u){const E=r===o;return!u||E?E:!r||!o?!1:(0,p.equalsIgnoreCase)(r,o)}e.isEqual=d;function g(r,o,u,E=_.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(u){if(!(0,p.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let I=o.length;return o.charAt(o.length-1)===E&&I--,r.charAt(I)===E}return o.charAt(o.length-1)!==E&&(o+=E),r.indexOf(o)===0}e.isEqualOrParent=g;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function c(r,o){return t.isWindows&&r.endsWith(":")&&(r+=_.sep),(0,_.isAbsolute)(r)||(r=(0,_.join)(o,r)),r=(0,_.normalize)(r),t.isWindows?(r=(0,p.rtrim)(r,_.sep),r.endsWith(":")&&(r+=_.sep)):(r=(0,p.rtrim)(r,_.sep),r||(r=_.sep)),r}e.sanitizeFilePath=c;function C(r){const o=(0,_.normalize)(r);return t.isWindows?r.length>3?!1:w(o)&&(r.length===2||o.charCodeAt(2)===92):o===_.posix.sep}e.isRootOrDriveLetter=C;function w(r,o){return(o!==void 0?o:t.isWindows)?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function f(r){return w(r)?r[0]:void 0}e.getDriveLetter=f;function s(r,o,u){return o.length>r.length?-1:r===o?0:(u&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=s;function a(r){const o=r.split(":");let u,E,P;for(const I of o){const O=Number(I);(0,k.isNumber)(O)?E===void 0?E=O:P===void 0&&(P=O):u=u?[u,I].join(":"):I}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:E!==void 0?E:void 0,column:P!==void 0?P:E!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,o,u=8){let E="";for(let I=0;I<u;I++)E+=i.charAt(Math.floor(Math.random()*i.length));let P;return o?P=`${o}-${E}`:P=E,r?(0,_.join)(r,P):P}e.randomPath=n}),define(ve[20],we([0,1,12]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(S=>{d[S]&&typeof d[S]=="object"?g[S]=t(d[S]):g[S]=d[S]}),g}e.deepClone=t;function p(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const S=g.shift();Object.freeze(S);for(const c in S)if(k.call(S,c)){const C=S[c];typeof C=="object"&&!Object.isFrozen(C)&&g.push(C)}}return d}e.deepFreeze=p;const k=Object.prototype.hasOwnProperty;function D(d,g){return R(d,g,new Set)}e.cloneAndChange=D;function R(d,g,S){if((0,_.isUndefinedOrNull)(d))return d;const c=g(d);if(typeof c!="undefined")return c;if((0,_.isArray)(d)){const C=[];for(const w of d)C.push(R(w,g,S));return C}if((0,_.isObject)(d)){if(S.has(d))throw new Error("Cannot clone recursive data-structure");S.add(d);const C={};for(let w in d)k.call(d,w)&&(C[w]=R(d[w],g,S));return S.delete(d),C}return d}function y(d,g,S=!0){return(0,_.isObject)(d)?((0,_.isObject)(g)&&Object.keys(g).forEach(c=>{c in d?S&&((0,_.isObject)(d[c])&&(0,_.isObject)(g[c])?y(d[c],g[c],S):d[c]=g[c]):d[c]=g[c]}),d):g}e.mixin=y;function b(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let S,c;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(S=0;S<d.length;S++)if(!b(d[S],g[S]))return!1}else{const C=[];for(c in d)C.push(c);C.sort();const w=[];for(c in g)w.push(c);if(w.sort(),!b(C,w))return!1;for(S=0;S<C.length;S++)if(!b(d[C[S]],g[C[S]]))return!1}return!0}e.equals=b;function T(d){const g=new Set;return JSON.stringify(d,(S,c)=>{if((0,_.isObject)(c)||Array.isArray(c)){if(g.has(c))return"[Circular]";g.add(c)}return c})}e.safeStringify=T;function A(d,g,S){const c=g(d);return typeof c=="undefined"?S:c}e.getOrDefault=A;function h(d,g){const S=Object.create(null);return!d||!g||Object.keys(g).forEach(C=>{const w=d[C],f=g[C];b(w,f)||(S[C]=f)}),S}e.distinct=h;function v(d,g){const S=g.toLowerCase(),c=Object.keys(d).find(C=>C.toLowerCase()===S);return c?d[c]:d[g]}e.getCaseInsensitive=v;function l(d,g){const S=Object.create(null);for(const[c,C]of Object.entries(d))g(c,C)&&(S[c]=C);return S}e.filter=l}),define(ve[5],we([0,1,4,3]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const p=/^\w[\w\d+.-]*$/,k=/^\//,D=/^\/\//;function R(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!p.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,n){return!i&&!n?"file":i}function b(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==A&&(n=A+n):n=A;break}return n}const T="",A="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(n,r,o,u,E,P=!1){typeof n=="object"?(this.scheme=n.scheme||T,this.authority=n.authority||T,this.path=n.path||T,this.query=n.query||T,this.fragment=n.fragment||T):(this.scheme=y(n,P),this.authority=r||T,this.path=b(this.scheme,o||T),this.query=u||T,this.fragment=E||T,R(this,P))}static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return C(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:o,path:u,query:E,fragment:P}=n;return r===void 0?r=this.scheme:r===null&&(r=T),o===void 0?o=this.authority:o===null&&(o=T),u===void 0?u=this.path:u===null&&(u=T),E===void 0?E=this.query:E===null&&(E=T),P===void 0?P=this.fragment:P===null&&(P=T),r===this.scheme&&o===this.authority&&u===this.path&&E===this.query&&P===this.fragment?this:new d(r,o,u,E,P)}static parse(n,r=!1){const o=h.exec(n);return o?new d(o[2]||T,a(o[4]||T),a(o[5]||T),a(o[7]||T),a(o[9]||T),r):new d(T,T,T,T,T)}static file(n){let r=T;if(t.isWindows&&(n=n.replace(/\\/g,A)),n[0]===A&&n[1]===A){const o=n.indexOf(A,2);o===-1?(r=n.substring(2),n=A):(r=n.substring(2,o),n=n.substring(o)||A)}return new d("file",r,n,T,T)}static from(n){const r=new d(n.scheme,n.authority,n.path,n.query,n.fragment);return R(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&n.scheme==="file"?o=v.file(_.win32.join(C(n,!0),...r)).path:o=_.posix.join(n.path,...r),n.with({path:o})}toString(n=!1){return w(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const r=new d(n);return r._formatted=n.external,r._fsPath=n._sep===l?n.fsPath:null,r}}else return n}}e.URI=v;const l=t.isWindows?1:void 0;class d extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(n=!1){return n?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=l),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(i,n){let r,o=-1;for(let u=0;u<i.length;u++){const E=i.charCodeAt(u);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47)o!==-1&&(r+=encodeURIComponent(i.substring(o,u)),o=-1),r!==void 0&&(r+=i.charAt(u));else{r===void 0&&(r=i.substr(0,u));const P=g[E];P!==void 0?(o!==-1&&(r+=encodeURIComponent(i.substring(o,u)),o=-1),r+=P):o===-1&&(o=u)}}return o!==-1&&(r+=encodeURIComponent(i.substring(o))),r!==void 0?r:i}function c(i){let n;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(n===void 0&&(n=i.substr(0,r)),n+=g[o]):n!==void 0&&(n+=i[r])}return n!==void 0?n:i}function C(i,n){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=C;function w(i,n){const r=n?c:S;let o="",{scheme:u,authority:E,path:P,query:I,fragment:O}=i;if(u&&(o+=u,o+=":"),(E||u==="file")&&(o+=A,o+=A),E){let z=E.indexOf("@");if(z!==-1){const j=E.substr(0,z);E=E.substr(z+1),z=j.indexOf(":"),z===-1?o+=r(j,!1):(o+=r(j.substr(0,z),!1),o+=":",o+=r(j.substr(z+1),!1)),o+="@"}E=E.toLowerCase(),z=E.indexOf(":"),z===-1?o+=r(E,!1):(o+=r(E.substr(0,z),!1),o+=E.substr(z))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const z=P.charCodeAt(1);z>=65&&z<=90&&(P=`/${String.fromCharCode(z+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const z=P.charCodeAt(0);z>=65&&z<=90&&(P=`${String.fromCharCode(z+32)}:${P.substr(2)}`)}o+=r(P,!0)}return I&&(o+="?",o+=r(I,!1)),O&&(o+="#",o+=n?O:S(O,!1)),o}function f(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+f(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(s)?i.replace(s,n=>f(n)):i}}),define(ve[79],we([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const T=b;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function p(b){const T=[];let A;try{const h=JSON.parse(b.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),A=v.__$stack),T.push(...h)}catch{T.push("Unable to log remote console arguments",b.arguments)}return{args:T,stack:A}}e.parse=p;function k(b){if(typeof b!="string")return k(p(b).stack);const T=b;if(T){const A=D(T),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(A||"");if(h&&h.length===4)return{uri:_.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=k;function D(b){if(!b)return b;const T=b.indexOf(`
`);return T===-1?b:b.substring(0,T)}function R(b,T){const{args:A,stack:h}=p(b),v=typeof A[0]=="string"&&A.length===1;let l=D(h);l&&(l=`(${l.trim()})`);let d=[];if(typeof A[0]=="string"?l&&v?d=[`%c[${T}] %c${A[0]} %c${l}`,y("blue"),y(""),y("grey")]:d=[`%c[${T}] %c${A[0]}`,y("blue"),y(""),...A.slice(1)]:d=[`%c[${T}]%`,y("blue"),...A],l&&!v&&d.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,d)}e.log=R;function y(b){return`color: ${b}`}}),define(ve[52],we([0,1,15,18,5]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(T){return JSON.stringify(T,y)}e.stringify=k;function D(T){let A=JSON.parse(T);return A=b(A),A}e.parse=D;var R;(function(T){T[T.Uri=1]="Uri",T[T.Regexp=2]="Regexp",T[T.ScmResource=3]="ScmResource",T[T.ScmResourceGroup=4]="ScmResourceGroup",T[T.ScmProvider=5]="ScmProvider",T[T.CommentController=6]="CommentController",T[T.CommentThread=7]="CommentThread",T[T.CommentThreadReply=8]="CommentThreadReply",T[T.CommentNode=9]="CommentNode",T[T.CommentThreadNode=10]="CommentThreadNode",T[T.TimelineActionContext=11]="TimelineActionContext",T[T.NotebookCellActionContext=12]="NotebookCellActionContext",T[T.TestItemContext=13]="TestItemContext",T[T.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function y(T,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function b(T,A=0){if(!T||A>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return p.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 14:return new Date(T.source)}if(T instanceof _.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let h=0;h<T.length;++h)T[h]=b(T[h],A+1);else for(const h in T)Object.hasOwnProperty.call(T,h)&&(T[h]=b(T[h],A+1))}return T}e.revive=b}),define(ve[8],we([0,1,3,5]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var p;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(p=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,b,T){this._hosts[y]=b,this._ports[y]=T}setConnectionToken(y,b){this._connectionTokens[y]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const b=y.authority;let T=this._hosts[b];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const A=this._ports[b],h=this._connectionTokens[b];let v=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:_.isWeb?this._preferredWebSchema:p.vscodeRemoteResource,authority:`${T}:${A}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new k;class D{asBrowserUri(y,b){const T=this.toUri(y,b);return T.scheme===p.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===p.file&&(_.isNative||typeof _.globals.importScripts=="function"&&_.globals.origin===`${p.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?T.with({scheme:p.vscodeFileResource,authority:T.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(y,b){const T=this.toUri(y,b);return T.scheme===p.vscodeFileResource?T.with({scheme:p.file,authority:T.authority!==D.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,b){return t.URI.isUri(y)?y:t.URI.parse(b.toUrl(y))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(ve[22],we([0,1,31,8,4,3,18,5]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=y;class b{constructor(l){this._ignorePathCasing=l}compare(l,d,g=!1){return l===d?0:(0,D.compare)(this.getComparisonKey(l,g),this.getComparisonKey(d,g))}isEqual(l,d,g=!1){return l===d?!0:!l||!d?!1:this.getComparisonKey(l,g)===this.getComparisonKey(d,g)}getComparisonKey(l,d=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,d,g=!1){if(l.scheme===d.scheme){if(l.scheme===t.Schemas.file)return _.isEqualOrParent(y(l),y(d),this._ignorePathCasing(l))&&l.query===d.query&&(g||l.fragment===d.fragment);if((0,e.isEqualAuthority)(l.authority,d.authority))return _.isEqualOrParent(l.path,d.path,this._ignorePathCasing(l),"/")&&l.query===d.query&&(g||l.fragment===d.fragment)}return!1}joinPath(l,...d){return R.URI.joinPath(l,...d)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return p.posix.basename(l.path)}extname(l){return p.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let d;return l.scheme===t.Schemas.file?d=R.URI.file(p.dirname(y(l))).path:(d=p.posix.dirname(l.path),l.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),d="/")),l.with({path:d})}normalizePath(l){if(!l.path.length)return l;let d;return l.scheme===t.Schemas.file?d=R.URI.file(p.normalize(y(l))).path:d=p.posix.normalize(l.path),l.with({path:d})}relativePath(l,d){if(l.scheme!==d.scheme||!(0,e.isEqualAuthority)(l.authority,d.authority))return;if(l.scheme===t.Schemas.file){const c=p.relative(y(l),y(d));return k.isWindows?_.toSlashes(c):c}let g=l.path||"/",S=d.path||"/";if(this._ignorePathCasing(l)){let c=0;for(const C=Math.min(g.length,S.length);c<C&&!(g.charCodeAt(c)!==S.charCodeAt(c)&&g.charAt(c).toLowerCase()!==S.charAt(c).toLowerCase());c++);g=S.substr(0,c)+g.substr(c)}return p.posix.relative(g,S)}resolvePath(l,d){if(l.scheme===t.Schemas.file){const g=R.URI.file(p.resolve(y(l),d));return l.with({authority:g.authority,path:g.path})}return d=_.toPosixPath(d),l.with({path:p.posix.resolve(l.path,d)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,d){return l===d||l!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(l,d)}hasTrailingPathSeparator(l,d=p.sep){if(l.scheme===t.Schemas.file){const g=y(l);return g.length>_.getRoot(g).length&&g[g.length-1]===d}else{const g=l.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,d=p.sep){return(0,e.hasTrailingPathSeparator)(l,d)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,d=p.sep){let g=!1;if(l.scheme===t.Schemas.file){const S=y(l);g=S!==void 0&&S.length===_.getRoot(S).length&&S[S.length-1]===d}else{d="/";const S=l.path;g=S.length===1&&S.charCodeAt(S.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(l,d)?l.with({path:l.path+"/"}):l}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===t.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(v,l){const d=[];for(let g=0;g<v.length;g++){const S=l(v[g]);v.some((c,C)=>C===g?!1:(0,e.isEqualOrParent)(S,l(c)))||d.push(v[g])}return d}e.distinctParents=T;var A;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function l(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(C=>{const[w,f]=C.split(":");w&&f&&g.set(w,f)});const c=d.path.substring(0,d.path.indexOf(";"));return c&&g.set(v.META_DATA_MIME,c),g}v.parseMetaData=l})(A=e.DataUri||(e.DataUri={}));function h(v,l,d){if(l){let g=v.path;return g&&g[0]!==p.posix.sep&&(g=p.posix.sep+g),v.with({scheme:d,authority:l,path:g})}return v.with({scheme:d})}e.toLocalResource=h}),define(ve[13],we([0,1,21,11,7,2,22,3]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=y;function b(Z){const $=new _.CancellationTokenSource,H=Z($.token),V=new Promise((ie,de)=>{const De=$.token.onCancellationRequested(()=>{De.dispose(),$.dispose(),de(new t.CancellationError)});Promise.resolve(H).then(ae=>{De.dispose(),$.dispose(),ie(ae)},ae=>{De.dispose(),$.dispose(),de(ae)})});return new class{cancel(){$.cancel()}then(ie,de){return V.then(ie,de)}catch(ie){return this.then(void 0,ie)}finally(ie){return V.finally(ie)}}}e.createCancelablePromise=b;function T(Z,$,H){return new Promise((V,ie)=>{const de=$.onCancellationRequested(()=>{de.dispose(),V(H)});Z.then(V,ie).finally(()=>de.dispose())})}e.raceCancellation=T;function A(Z,$){return new Promise((H,V)=>{const ie=$.onCancellationRequested(()=>{ie.dispose(),V(new t.CancellationError)});Z.then(H,V).finally(()=>ie.dispose())})}e.raceCancellationError=A;async function h(Z){let $=-1;const H=Z.map((ie,de)=>ie.then(De=>($=de,De))),V=await Promise.race(H);return Z.forEach((ie,de)=>{de!==$&&ie.cancel()}),V}e.raceCancellablePromises=h;function v(Z,$,H){let V;const ie=setTimeout(()=>{V?.(void 0),H?.()},$);return Promise.race([Z.finally(()=>clearTimeout(ie)),new Promise(de=>V=de)])}e.raceTimeout=v;function l(Z){return new Promise(($,H)=>{const V=Z();y(V)?V.then($,H):$(V)})}e.asPromise=l;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(H,H).then(V)})}return new Promise((H,V)=>{this.queuedPromise.then(H,V)})}return this.activePromise=$(),new Promise((H,V)=>{this.activePromise.then(ie=>{this.activePromise=null,H(ie)},ie=>{this.activePromise=null,V(ie)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=g;class S{constructor(){this.promiseMap=new Map}queue($,H){const ie=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get($)===ie&&this.promiseMap.delete($)});return this.promiseMap.set($,ie),ie}}e.SequencerByKey=S;const c=(Z,$)=>{let H=!0;const V=setTimeout(()=>{H=!1,$()},Z);return{isTriggered:()=>H,dispose:()=>{clearTimeout(V),H=!1}}},C=Z=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,Z())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class w{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,H=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,de)=>{this.doResolve=ie,this.doReject=de}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=H===e.MicrotaskDelay?C(V):c(H,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class f{constructor($){this.delayer=new w($),this.throttler=new d}trigger($,H){return this.delayer.trigger(()=>this.throttler.queue($),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class s{constructor(){this._isOpen=!1,this._promise=new Promise(($,H)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class a extends s{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function i(Z,$){return $?new Promise((H,V)=>{const ie=setTimeout(()=>{de.dispose(),H()},Z),de=$.onCancellationRequested(()=>{clearTimeout(ie),de.dispose(),V(new t.CancellationError)})}):b(H=>i(Z,H))}e.timeout=i;function n(Z,$=0){const H=setTimeout(Z,$);return(0,k.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=n;function r(Z){const $=[];let H=0;const V=Z.length;function ie(){return H<V?Z[H++]():null}function de(De){De!=null&&$.push(De);const ae=ie();return ae?ae.then(de):Promise.resolve($)}return Promise.resolve(null).then(de)}e.sequence=r;function o(Z,$=V=>!!V,H=null){let V=0;const ie=Z.length,de=()=>{if(V>=ie)return Promise.resolve(H);const De=Z[V++];return Promise.resolve(De()).then(fe=>$(fe)?Promise.resolve(fe):de())};return de()}e.first=o;function u(Z,$=V=>!!V,H=null){if(Z.length===0)return Promise.resolve(H);let V=Z.length;const ie=()=>{V=-1;for(const de of Z)de.cancel?.()};return new Promise((de,De)=>{for(const ae of Z)ae.then(fe=>{--V>=0&&$(fe)?(ie(),de(fe)):V===0&&de(H)}).catch(fe=>{--V>=0&&(ie(),De(fe))})})}e.firstParallel=u;class E{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new p.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((H,V)=>{this.outstandingPromises.push({factory:$,c:H,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const H=$.factory();H.then($.c,$.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=E;class P extends E{constructor(){super(1)}}e.Queue=P;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const $=new B;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueFor($,H=D.extUri){const V=H.getComparisonKey($);let ie=this.queues.get(V);return ie||(ie=new P,p.Event.once(ie.onFinished)(()=>{ie?.dispose(),this.queues.delete(V),this.onDidQueueFinish()}),this.queues.set(V,ie)),ie}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class O{constructor($,H){this._token=-1,typeof $=="function"&&typeof H=="number"&&this.setIfNotSet($,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},H)}setIfNotSet($,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},H))}}e.TimeoutTimer=O;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setInterval(()=>{$()},H)}}e.IntervalTimer=z;class j{constructor($,H){this.timeoutToken=-1,this.runner=$,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=j;class m{constructor($,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=m;class L extends j{constructor($,H){super($,H);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class M extends k.Disposable{constructor($,H){super();this.options=$,this.handler=H,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,R.setTimeout0)(()=>{if($)return;const H=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,H-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(Z,$)=>{const H=requestIdleCallback(Z,typeof $=="number"?{timeout:$}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(H))}}}}();class Q{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Q;async function W(Z,$,H){let V;for(let ie=0;ie<H;ie++)try{return await Z()}catch(de){V=de,await i($)}throw V}e.retry=W;class q{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,H,V){return this._pending={taskId:$,cancel:()=>V?.(),promise:H},H.then(()=>this.donePending($),()=>this.donePending($)),H}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let H,V;const ie=new Promise((de,De)=>{H=de,V=De});this._next={run:$,promise:ie,promiseResolve:H,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=q;class ne{constructor($,H=()=>Date.now()){this.interval=$,this.nowFn=H,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,H)=>{this.completeCallback=$,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(H=>{this.completeCallback($),this.resolved=!0,H()})}error($){return new Promise(H=>{this.errorCallback($),this.rejected=!0,H()})}cancel(){new Promise($=>{this.errorCallback(new t.CancellationError),this.rejected=!0,$()})}}e.DeferredPromise=B;var G;(function(Z){async function $(V){let ie;const de=await Promise.all(V.map(De=>De.then(ae=>ae,ae=>{ie||(ie=ae)})));if(typeof ie!="undefined")throw ie;return de}Z.settled=$;function H(V){return new Promise(async(ie,de)=>{try{await V(ie,de)}catch(De){de(De)}})}Z.withAsyncBody=H})(G=e.Promises||(e.Promises={}));var ee;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(ee||(ee={}));class oe{constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new p.Emitter,queueMicrotask(async()=>{const H={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve($(H)),this.resolve()}catch(V){this.reject(V)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}static fromArray($){return new oe(H=>{H.emitMany($)})}static fromPromise($){return new oe(async H=>{H.emitMany(await $)})}static fromPromises($){return new oe(async H=>{await Promise.all($.map(async V=>H.emitOne(await V)))})}static merge($){return new oe(async H=>{await Promise.all($.map(async V=>{for await(const ie of V)H.emitOne(ie)}))})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await p.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,H){return new oe(async V=>{for await(const ie of $)V.emitOne(H(ie))})}map($){return oe.map(this,$)}static filter($,H){return new oe(async V=>{for await(const ie of $)H(ie)&&V.emitOne(ie)})}filter($){return oe.filter(this,$)}static coalesce($){return oe.filter($,H=>!!H)}coalesce(){return oe.coalesce(this)}static async toPromise($){const H=[];for await(const V of $)H.push(V);return H}toPromise(){return oe.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class se extends oe{constructor($,H){super(H);this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function me(Z){const $=new _.CancellationTokenSource,H=Z($.token);return new se($,async V=>{const ie=$.token.onCancellationRequested(()=>{ie.dispose(),$.dispose(),V.reject(new t.CancellationError)});try{for await(const de of H){if($.token.isCancellationRequested)return;V.emitOne(de)}ie.dispose(),$.dispose()}catch(de){ie.dispose(),$.dispose(),V.reject(de)}})}e.createCancelableAsyncIterable=me}),define(ve[60],we([0,1,13,31,30,4,3,18]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",T="[^/\\\\]",A=/\//g;function h(B){switch(B){case 0:return"";case 1:return`${T}*?`;default:return`(?:${b}|${T}+${b}|${b}${T}+)*?`}}function v(B,G){if(!B)return[];const ee=[];let oe=!1,se=!1,me="";for(const Z of B){switch(Z){case G:if(!oe&&!se){ee.push(me),me="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":se=!0;break;case"]":se=!1;break}me+=Z}return me&&ee.push(me),ee}e.splitGlobAware=v;function l(B){if(!B)return"";let G="";const ee=v(B,e.GLOB_SPLIT);if(ee.every(oe=>oe===e.GLOBSTAR))G=".*";else{let oe=!1;ee.forEach((se,me)=>{if(se===e.GLOBSTAR){oe||(G+=h(2),oe=!0);return}let Z=!1,$="",H=!1,V="";for(const ie of se){if(ie!=="}"&&Z){$+=ie;continue}if(H&&(ie!=="]"||!V)){let de;ie==="-"?de=ie:(ie==="^"||ie==="!")&&!V?de="^":ie===e.GLOB_SPLIT?de="":de=(0,R.escapeRegExpCharacters)(ie),V+=de;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":{G+=`(?:${v($,",").map(ae=>l(ae)).join("|")})`,Z=!1,$="";break}case"]":G+="["+V+"]",H=!1,V="";break;case"?":G+=T;continue;case"*":G+=h(1);continue;default:G+=(0,R.escapeRegExpCharacters)(ie)}}me<ee.length-1&&(ee[me+1]!==e.GLOBSTAR||me+2<ee.length)&&(G+=b),oe=!1})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,f=new p.LRUCache(1e4),s=function(){return!1},a=function(){return null};function i(B,G){if(!B)return a;let ee;typeof B!="string"?ee=B.pattern:ee=B,ee=ee.trim();const oe=`${ee}_${!!G.trimForExclusions}`;let se=f.get(oe);if(se)return n(se,B);let me;if(d.test(ee)){const Z=ee.substr(4);se=function($,H){return typeof $=="string"&&$.endsWith(Z)?ee:null}}else(me=g.exec(r(ee,G)))?se=o(me[1],ee):(G.trimForExclusions?c:S).test(ee)?se=u(ee,G):(me=C.exec(r(ee,G)))?se=E(me[1].substr(1),ee,!0):(me=w.exec(r(ee,G)))?se=E(me[1],ee,!1):se=P(ee);return f.set(oe,se),n(se,B)}function n(B,G){return typeof G=="string"?B:function(ee,oe){return(0,t.isEqualOrParent)(ee,G.base,!D.isLinux)?B(ee.substr(G.base.length+1),oe):null}}function r(B,G){return G.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function o(B,G){const ee=`/${B}`,oe=`\\${B}`,se=function(Z,$){return typeof Z!="string"?null:$?$===B?G:null:Z===B||Z.endsWith(ee)||Z.endsWith(oe)?G:null},me=[B];return se.basenames=me,se.patterns=[G],se.allBasenames=me,se}function u(B,G){const ee=ne(B.slice(1,-1).split(",").map($=>i($,G)).filter($=>$!==a),B),oe=ee.length;if(!oe)return a;if(oe===1)return ee[0];const se=function($,H){for(let V=0,ie=ee.length;V<ie;V++)if(ee[V]($,H))return B;return null},me=ee.find($=>!!$.allBasenames);me&&(se.allBasenames=me.allBasenames);const Z=ee.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return Z.length&&(se.allPaths=Z),se}function E(B,G,ee){const oe=k.sep===k.posix.sep,se=oe?B:B.replace(A,k.sep),me=k.sep+se,Z=k.posix.sep+B,$=ee?function(H,V){return typeof H=="string"&&(H===se||H.endsWith(me)||!oe&&(H===B||H.endsWith(Z)))?G:null}:function(H,V){return typeof H=="string"&&(H===se||!oe&&H===B)?G:null};return $.allPaths=[(ee?"*/":"./")+B],$}function P(B){try{const G=new RegExp(`^${l(B)}$`);return function(ee){return G.lastIndex=0,typeof ee=="string"&&G.test(ee)?B:null}}catch{return a}}function I(B,G,ee){return!B||typeof G!="string"?!1:O(B)(G,void 0,ee)}e.match=I;function O(B,G={}){if(!B)return s;if(typeof B=="string"||L(B)){const ee=i(B,G);if(ee===a)return s;const oe=function(se,me){return!!ee(se,me)};return ee.allBasenames&&(oe.allBasenames=ee.allBasenames),ee.allPaths&&(oe.allPaths=ee.allPaths),oe}return W(B,G)}e.parse=O;function z(B){if(!B)return;let G;return ee=>(G||(G=(B()||Promise.resolve([])).then(oe=>oe?m(oe):{})),G.then(oe=>!!oe[ee]))}e.hasSiblingPromiseFn=z;function j(B){if(!B)return;let G;return ee=>{if(!G){const oe=B();G=oe?m(oe):{}}return!!G[ee]}}e.hasSiblingFn=j;function m(B){const G={};for(const ee of B)G[ee]=!0;return G}function L(B){const G=B;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.isRelativePattern=L;function M(B){return B.allBasenames||[]}e.getBasenameTerms=M;function Q(B){return B.allPaths||[]}e.getPathTerms=Q;function W(B,G){const ee=ne(Object.getOwnPropertyNames(B).map($=>q($,B[$],G)).filter($=>$!==a)),oe=ee.length;if(!oe)return a;if(!ee.some($=>!!$.requiresSiblings)){if(oe===1)return ee[0];const $=function(ie,de){for(let De=0,ae=ee.length;De<ae;De++){const fe=ee[De](ie,de);if(fe)return fe}return null},H=ee.find(ie=>!!ie.allBasenames);H&&($.allBasenames=H.allBasenames);const V=ee.reduce((ie,de)=>de.allPaths?ie.concat(de.allPaths):ie,[]);return V.length&&($.allPaths=V),$}const se=function($,H,V){let ie;for(let de=0,De=ee.length;de<De;de++){const ae=ee[de];ae.requiresSiblings&&V&&(H||(H=(0,k.basename)($)),ie||(ie=H.substr(0,H.length-(0,k.extname)($).length)));const fe=ae($,H,ie,V);if(fe)return fe}return null},me=ee.find($=>!!$.allBasenames);me&&(se.allBasenames=me.allBasenames);const Z=ee.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return Z.length&&(se.allPaths=Z),se}function q(B,G,ee){if(G===!1)return a;const oe=i(B,ee);if(oe===a)return a;if(typeof G=="boolean")return oe;if(G){const se=G.when;if(typeof se=="string"){const me=(Z,$,H,V)=>{if(!V||!oe(Z,$))return null;const ie=se.replace("$(basename)",H),de=V(ie);return(0,_.isThenable)(de)?de.then(De=>De?B:null):de?B:null};return me.requiresSiblings=!0,me}}return oe}function ne(B,G){const ee=B.filter($=>!!$.basenames);if(ee.length<2)return B;const oe=ee.reduce(($,H)=>{const V=H.basenames;return V?$.concat(V):$},[]);let se;if(G){se=[];for(let $=0,H=oe.length;$<H;$++)se.push(G)}else se=ee.reduce(($,H)=>{const V=H.patterns;return V?$.concat(V):$},[]);const me=function($,H){if(typeof $!="string")return null;if(!H){let ie;for(ie=$.length;ie>0;ie--){const de=$.charCodeAt(ie-1);if(de===47||de===92)break}H=$.substr(ie)}const V=oe.indexOf(H);return V!==-1?se[V]:null};me.basenames=oe,me.patterns=se,me.allBasenames=oe;const Z=B.filter($=>!$.basenames);return Z.push(me),Z}}),define(ve[61],we([0,1,31,8,4,3,22,18,5]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function b(n,r,o){if(typeof n=="string"&&(n=y.URI.file(n)),o){const E=o.getWorkspaceFolder(n);if(E){const P=o.getWorkspace().folders.length>1;let I;if((0,D.isEqual)(E.uri,n)?I="":I=(0,D.relativePath)(E.uri,n),P){const O=E.name?E.name:(0,D.basename)(E.uri);I=I?O+" \u2022 "+I:O}return I}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(n.fsPath))return(0,p.normalize)(A(n.fsPath));let u=(0,p.normalize)(n.fsPath);return!k.isWindows&&r?.userHome&&(u=v(u,r.userHome.fsPath)),u}e.getPathLabel=b;function T(n){if(!n)return;typeof n=="string"&&(n=y.URI.file(n));const r=(0,D.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return k.isWindows&&(0,_.isRootOrDriveLetter)(r)?A(r):r}e.getBaseLabel=T;function A(n,r){return(0,_.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=A;let h=Object.create(null);function v(n,r){if(k.isWindows||!n||!r)return n;let o=h.original===r?h.normalized:void 0;return o||(o=`${(0,R.rtrim)(r,p.posix.sep)}${p.posix.sep}`,h={original:r,normalized:o}),(k.isLinux?n.startsWith(o):(0,R.startsWithIgnoreCase)(n,o))&&(n=`~/${n.substr(o.length)}`),n}e.tildify=v;function l(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=l;const d="\u2026",g="\\\\",S="~";function c(n,r=p.sep){const o=new Array(n.length);let u=!1;for(let E=0;E<n.length;E++){let P=n[E];if(P===""){o[E]=`.${r}`;continue}if(!P){o[E]=P;continue}u=!0;let I="";P.indexOf(g)===0?(I=P.substr(0,P.indexOf(g)+g.length),P=P.substr(P.indexOf(g)+g.length)):P.indexOf(r)===0?(I=P.substr(0,P.indexOf(r)+r.length),P=P.substr(P.indexOf(r)+r.length)):P.indexOf(S)===0&&(I=P.substr(0,P.indexOf(S)+S.length),P=P.substr(P.indexOf(S)+S.length));const O=P.split(r);for(let z=1;u&&z<=O.length;z++)for(let j=O.length-z;u&&j>=0;j--){u=!1;let m=O.slice(j,j+z).join(r);for(let L=0;!u&&L<n.length;L++)if(L!==E&&n[L]&&n[L].indexOf(m)>-1){const M=j+z===O.length,Q=j>0&&n[L].indexOf(r)>-1?r+m:m,W=n[L].endsWith(Q);u=!M||W}if(!u){let L="";(O[0].endsWith(":")||I!=="")&&(j===1&&(j=0,z++,m=O[0]+r+m),j>0&&(L=O[0]+r),L=I+L),j>0&&(L=L+d+r),L=L+m,j+z<O.length&&(L=L+r+d),o[E]=L}}u&&(o[E]=P)}return o}e.shorten=c;var C;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(C||(C={}));function w(n,r=Object.create(null)){const o=[];let u=!1,E="";for(const P of n)if(P==="$"||u&&P==="{")E&&o.push({value:E,type:C.TEXT}),E="",u=!0;else if(P==="}"&&u){const I=r[E];if(typeof I=="string")I.length&&o.push({value:I,type:C.VARIABLE});else if(I){const O=o[o.length-1];(!O||O.type!==C.SEPARATOR)&&o.push({value:I.label,type:C.SEPARATOR})}E="",u=!1}else E+=P;return E&&!u&&o.push({value:E,type:C.TEXT}),o.filter((P,I)=>{if(P.type===C.SEPARATOR){const O=o[I-1],z=o[I+1];return[O,z].every(j=>j&&(j.type===C.VARIABLE||j.type===C.TEXT)&&j.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=w;function f(n,r){return k.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function s(n,r){return k.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):k.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function a(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=a;function i(n){const r=n.indexOf("/")!==-1?p.posix:p.win32,o=r.basename(n),u=r.dirname(n);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=i}),define(ve[62],we([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class p{constructor(A){this._uriTransformer=A}transformIncoming(A){const h=this._uriTransformer.transformIncoming(A);return h===A?A:t(_.URI.from(h))}transformOutgoing(A){const h=this._uriTransformer.transformOutgoing(A);return h===A?A:t(_.URI.from(h))}transformOutgoingURI(A){const h=this._uriTransformer.transformOutgoing(A);return h===A?A:_.URI.from(h)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=p,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function k(T,A,h){if(!T||h>200)return null;if(typeof T=="object"){if(T instanceof _.URI)return A.transformOutgoing(T);for(let v in T)if(Object.hasOwnProperty.call(T,v)){const l=k(T[v],A,h+1);l!==null&&(T[v]=l)}}return null}function D(T,A){const h=k(T,A,0);return h===null?T:h}e.transformOutgoingURIs=D;function R(T,A,h,v){if(!T||v>200)return null;if(typeof T=="object"){if(T.$mid===1)return h?_.URI.revive(A.transformIncoming(T)):A.transformIncoming(T);for(let l in T)if(Object.hasOwnProperty.call(T,l)){const d=R(T[l],A,h,v+1);d!==null&&(T[l]=d)}}return null}function y(T,A){const h=R(T,A,!1,0);return h===null?T:h}e.transformIncomingURIs=y;function b(T,A){const h=R(T,A,!0,0);return h===null?T:h}e.transformAndReviveIncomingURIs=b}),define(ve[23],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(y){return _.test(y)}e.isUUID=t;const p=new Uint8Array(16),k=[];for(let y=0;y<256;y++)k.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let b=0;b<y.length;b++)y[b]=Math.floor(Math.random()*256);return y};function R(){D(p),p[6]=p[6]&15|64,p[8]=p[8]&63|128;let y=0,b="";return b+=k[p[y++]],b+=k[p[y++]],b+=k[p[y++]],b+=k[p[y++]],b+="-",b+=k[p[y++]],b+=k[p[y++]],b+="-",b+=k[p[y++]],b+=k[p[y++]],b+="-",b+=k[p[y++]],b+=k[p[y++]],b+="-",b+=k[p[y++]],b+=k[p[y++]],b+=k[p[y++]],b+=k[p[y++]],b+=k[p[y++]],b+=k[p[y++]],b}e.generateUuid=R}),define(ve[130],we([0,1,261]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(k="utf8"){this.stringDecoder=new _.StringDecoder(k),this.remaining=null}write(k){const D=[],R=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(R.length<1)return D;let y=0,b,T=y;for(;T<R.length;)if(b=R.charCodeAt(T),b===13||b===10){if(D.push(R.substring(y,T)),T++,T<R.length){const A=b;b=R.charCodeAt(T),(A===13&&b===10||A===10&&b===13)&&T++}y=T}else T++;return this.remaining=y<R.length?R.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function J(e,_,t,p){function k(l){return new Promise(d=>t.exists(l,d))}function D(l){return new Promise((d,g)=>{const S=new Date;t.utimes(l,S,S,c=>c?g(c):d())})}function R(l){return new Promise((d,g)=>t.mkdir(l,{recursive:!0},S=>S&&S.code!=="EEXIST"?g(S):d(l)))}function y(l){return new Promise((d,g)=>t.rmdir(l,{recursive:!0},S=>S&&S.code!=="ENOENT"?g(S):d()))}function b(l){return new Promise((d,g)=>t.readFile(l,"utf8",(S,c)=>S?g(S):d(c)))}function T(l,d){return new Promise((g,S)=>t.writeFile(l,d,"utf8",c=>c?S(c):g()))}function A(l){const d=_.join(l,"languagepacks.json");try{return e(d)}catch{}}function h(l,d){try{for(;d;){if(l[d])return d;{const g=d.lastIndexOf("-");if(g>0)d=d.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function v(l,d,g,S){if(S==="pseudo")return Promise.resolve({locale:S,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:S,availableLanguages:{}});if(S&&(S==="en"||S==="en-us"))return Promise.resolve({locale:S,availableLanguages:{}});const c=S;p.mark("code/willGenerateNls");const C=function(w){return p.mark("code/didGenerateNls"),Promise.resolve({locale:w,availableLanguages:{}})};try{if(!l)return C(c);const w=A(d);if(!w||(S=h(w,S),!S))return C(c);const f=w[S];let s;return!f||typeof f.hash!="string"||!f.translations||typeof(s=f.translations.vscode)!="string"?C(c):k(s).then(a=>{if(!a)return C(c);const i=f.hash+"."+S,n=_.join(d,"clp",i),r=_.join(n,l),o=_.join(n,"tcf.json"),u=_.join(n,"corrupted.info"),E={locale:c,availableLanguages:{"*":S},_languagePackId:i,_translationsConfigFile:o,_cacheRoot:n,_resolvedLanguagePackCoreLocation:r,_corruptedFile:u};return k(u).then(P=>{let I;return P?I=y(n):I=Promise.resolve(void 0),I.then(()=>k(r).then(O=>O?(D(r).catch(()=>{}),p.mark("code/didGenerateNls"),E):R(r).then(()=>Promise.all([b(g),b(s)])).then(z=>{const j=JSON.parse(z[0]),m=JSON.parse(z[1]).contents,L=Object.keys(j.bundles),M=[];for(const Q of L){const W=j.bundles[Q],q=Object.create(null);for(const ne of W){const B=j.keys[ne],G=j.messages[ne],ee=m[ne];let oe;if(ee){oe=[];for(let se=0;se<B.length;se++){const me=B[se],Z=typeof me=="string"?me:me.key;let $=ee[Z];$===void 0&&($=G[se]),oe.push($)}}else oe=G;q[ne]=oe}M.push(T(_.join(r,Q.replace(/\//g,"!")+".nls.json"),JSON.stringify(q)))}return M.push(T(o,JSON.stringify(f.translations))),Promise.all(M)}).then(()=>(p.mark("code/didGenerateNls"),E)).catch(z=>(console.error("Generating translation files failed.",z),C(S)))))})})}catch(w){return console.error("Generating translation files failed.",w),C(S)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(ve[131],we([0,132,27,44]),function(e,_,t,p){return J(e.__$__nodeRequire,_,t,p)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),_=require("fs"),t=require("../common/performance");module.exports=J(require,e,_,t)}else throw new Error("Unknown context")}(),define(ve[133],we([0,1,25]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function p(D){const R=D.replace(/\-/g,":").toLowerCase();return!t.has(R)}function k(){const D=(0,_.networkInterfaces)();for(let R in D){const y=D[R];if(y){for(const{mac:b}of y)if(p(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(ve[80],we([0,1,25,11,30,23,133]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=p.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,A=0;const h=(0,_.networkInterfaces)();for(let v in h){const l=h[v];if(l)for(const{mac:d,internal:g}of l)g||(A+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(T+=1))}this._value=A>0?T/A:0}return this._value}};let R;async function y(){return R||(R=(async()=>await b()||k.generateUuid())()),R}e.getMachineId=y;async function b(){try{const T=await new Promise((h,v)=>{J(["crypto"],h,v)}),A=(0,D.getMac)();return T.createHash("sha256").update(A,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(ve[19],we([0,1,27,25,134,13,31,77,4,3,22,5]),function(J,e,_,t,p,k,D,R,y,b,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function v(M,Q=h.UNLINK){if((0,D.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return Q===h.UNLINK?d(M):l(M)}async function l(M){try{const Q=(0,D.randomPath)((0,t.tmpdir)());try{await _.promises.rename(M,Q)}catch{return d(M)}d(Q).catch(W=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function d(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function g(M){if((0,D.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync(M,{recursive:!0})}e.rimrafSync=g;async function S(M,Q){return w(await(Q?c(M):(0,p.promisify)(_.readdir)(M)))}async function c(M){try{return await(0,p.promisify)(_.readdir)(M,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const Q=[],W=await S(M);for(const q of W){let ne=!1,B=!1,G=!1;try{const ee=await e.Promises.lstat((0,y.join)(M,q));ne=ee.isFile(),B=ee.isDirectory(),G=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Q.push({name:q,isFile:()=>ne,isDirectory:()=>B,isSymbolicLink:()=>G})}return Q}function C(M){return w(_.readdirSync(M))}e.readdirSync=C;function w(M){return M.map(Q=>typeof Q=="string"?b.isMacintosh?(0,R.normalizeNFC)(Q):Q:(Q.name=b.isMacintosh?(0,R.normalizeNFC)(Q.name):Q.name,Q))}async function f(M){const Q=await S(M),W=[];for(const q of Q)await a.existsDirectory((0,y.join)(M,q))&&W.push(q);return W}function s(M,Q=1e3){return new Promise(W=>{let q=!1;const ne=setInterval(()=>{q||(q=!0,_.access(M,B=>{q=!1,B&&(clearInterval(ne),W(void 0))}))},Q)})}e.whenDeleted=s;var a;(function(M){async function Q(ne){let B;try{if(B=await e.Promises.lstat(ne),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(ne),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(b.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ne)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ee}throw G}}M.stat=Q;async function W(ne){try{const{stat:B,symbolicLink:G}=await M.stat(ne);return B.isFile()&&G?.dangling!==!0}catch{}return!1}M.existsFile=W;async function q(ne){try{const{stat:B,symbolicLink:G}=await M.stat(ne);return B.isDirectory()&&G?.dangling!==!0}catch{}return!1}M.existsDirectory=q})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function n(M,Q,W){return i.queueFor(A.URI.file(M),T.extUriBiasedIgnorePathCase).queue(()=>{const q=E(W);return new Promise((ne,B)=>o(M,Q,q,G=>G?B(G):ne()))})}let r=!0;function o(M,Q,W,q){if(!r)return _.writeFile(M,Q,{mode:W.mode,flag:W.flag},q);_.open(M,W.flag,W.mode,(ne,B)=>{if(ne)return q(ne);_.writeFile(B,Q,G=>{if(G)return _.close(B,()=>q(G));_.fdatasync(B,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r=!1),_.close(B,oe=>q(oe))))})})}function u(M,Q,W){const q=E(W);if(!r)return _.writeFileSync(M,Q,{mode:q.mode,flag:q.flag});const ne=_.openSync(M,q.flag,q.mode);try{_.writeFileSync(ne,Q);try{_.fdatasyncSync(ne)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r=!1}}finally{_.closeSync(ne)}}e.writeFileSync=u;function E(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function P(M,Q){if(M===Q)return;async function W(q){try{const ne=await e.Promises.lstat(q);if(ne.isDirectory()||ne.isSymbolicLink())return;await e.Promises.utimes(q,ne.atime,new Date)}catch{}}try{await e.Promises.rename(M,Q),await W(Q)}catch(q){if(M.toLowerCase()!==Q.toLowerCase()&&q.code==="EXDEV"||M.endsWith("."))await I(M,Q,{preserveSymlinks:!1}),await v(M,h.MOVE),await W(Q);else throw q}}async function I(M,Q,W){return z(M,Q,{root:{source:M,target:Q},options:W,handledSourcePaths:new Set})}const O=511;async function z(M,Q,W){if(W.handledSourcePaths.has(M))return;W.handledSourcePaths.add(M);const{stat:q,symbolicLink:ne}=await a.stat(M);if(ne){if(W.options.preserveSymlinks)try{return await L(M,Q,W)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(ne.dangling)return}return q.isDirectory()?j(M,Q,q.mode&O,W):m(M,Q,q.mode&O)}async function j(M,Q,W,q){await e.Promises.mkdir(Q,{recursive:!0,mode:W});const ne=await S(M);for(const B of ne)await z((0,y.join)(M,B),(0,y.join)(Q,B),q)}async function m(M,Q,W){await e.Promises.copyFile(M,Q),await e.Promises.chmod(Q,W)}async function L(M,Q,W){let q=await e.Promises.readlink(M);(0,D.isEqualOrParent)(q,W.root.source,!b.isLinux)&&(q=(0,y.join)(W.root.target,q.substr(W.root.source.length+1))),await e.Promises.symlink(q,Q)}e.Promises=new class{get access(){return(0,p.promisify)(_.access)}get stat(){return(0,p.promisify)(_.stat)}get lstat(){return(0,p.promisify)(_.lstat)}get utimes(){return(0,p.promisify)(_.utimes)}get read(){return(M,Q,W,q,ne)=>new Promise((B,G)=>{_.read(M,Q,W,q,ne,(ee,oe,se)=>ee?G(ee):B({bytesRead:oe,buffer:se}))})}get readFile(){return(0,p.promisify)(_.readFile)}get write(){return(M,Q,W,q,ne)=>new Promise((B,G)=>{_.write(M,Q,W,q,ne,(ee,oe,se)=>ee?G(ee):B({bytesWritten:oe,buffer:se}))})}get appendFile(){return(0,p.promisify)(_.appendFile)}get fdatasync(){return(0,p.promisify)(_.fdatasync)}get truncate(){return(0,p.promisify)(_.truncate)}get rename(){return(0,p.promisify)(_.rename)}get copyFile(){return(0,p.promisify)(_.copyFile)}get open(){return(0,p.promisify)(_.open)}get close(){return(0,p.promisify)(_.close)}get symlink(){return(0,p.promisify)(_.symlink)}get readlink(){return(0,p.promisify)(_.readlink)}get chmod(){return(0,p.promisify)(_.chmod)}get mkdir(){return(0,p.promisify)(_.mkdir)}get unlink(){return(0,p.promisify)(_.unlink)}get rmdir(){return(0,p.promisify)(_.rmdir)}get realpath(){return(0,p.promisify)(_.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return S}get readDirsInDir(){return f}get writeFile(){return n}get rm(){return v}get move(){return P}get copy(){return I}}}),define(ve[135],we([0,1,27,4,3,18,19]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(h){if(p.isLinux)return h;const v=(0,t.dirname)(h);if(h===v)return h;const l=((0,t.basename)(h)||h).toLowerCase();try{const g=(0,D.readdirSync)(v).filter(S=>S.toLowerCase()===l);if(g.length===1){const S=R(v);if(S)return(0,t.join)(S,g[0])}else if(g.length>1){const S=g.indexOf(l);if(S>=0){const c=R(v);if(c)return(0,t.join)(c,g[S])}}}catch{}return null}e.realcaseSync=R;async function y(h){if(p.isLinux)return h;const v=(0,t.dirname)(h);if(h===v)return h;const l=((0,t.basename)(h)||h).toLowerCase();try{const g=(await D.Promises.readdir(v)).filter(S=>S.toLowerCase()===l);if(g.length===1){const S=await y(v);if(S)return(0,t.join)(S,g[0])}else if(g.length>1){const S=g.indexOf(l);if(S>=0){const c=await y(v);if(c)return(0,t.join)(c,g[S])}}}catch{}return null}e.realcase=y;async function b(h){try{return await D.Promises.realpath(h)}catch{const l=A(h);return await D.Promises.access(l,_.constants.R_OK),l}}e.realpath=b;function T(h){try{return _.realpathSync(h)}catch{const l=A(h);return _.accessSync(l,_.constants.R_OK),l}}e.realpathSync=T;function A(h){return(0,k.rtrim)((0,t.normalize)(h),t.sep)}}),define(ve[136],we([0,1,81]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(R,y,b,T=1){let A=!1;return new Promise(h=>{const v=setTimeout(()=>{if(!A)return A=!0,h(0)},b);p(R,y,T,l=>{if(!A)return A=!0,clearTimeout(v),h(l)})})}e.findFreePort=t;function p(R,y,b,T){if(y===0)return T(0);const A=new _.Socket;A.once("connect",()=>(D(A),p(R+b,y-1,b,T))),A.once("data",()=>{}),A.once("error",h=>(D(A),h.code!=="ECONNREFUSED"?p(R+b,y-1,b,T):T(R))),A.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,y,b){let T=!1,A,h=1;const v=_.createServer({pauseOnConnect:!0});function l(d,g){T||(T=!0,v.removeAllListeners(),v.close(),A&&clearTimeout(A),g(d))}return new Promise(d=>{A=setTimeout(()=>{l(0,d)},b),v.on("listening",()=>{l(R,d)}),v.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<y?(R++,h++,v.listen(R,"127.0.0.1")):l(0,d)}),v.on("close",()=>{l(0,d)}),v.listen(R,"127.0.0.1")})}e.findFreePortFaster=k;function D(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(y){console.error(y)}}}),define(ve[82],we([0,1,25,4,19]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,D=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var y;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(y||(y={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class A{constructor(f,s,a){this.exePath=f,this.displayName=s,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:w=!1}={}){return w?b===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:w=!1,findPreview:f=!1}={}){const s=h({useAlternateBitness:w});if(!s)return null;const a=t.join(s,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const u of await p.Promises.readdir(a)){let E=-1;if(f){const I=u.indexOf("-");if(I<0)continue;const O=u.substring(0,I);if(!k.test(O)||u.substring(I+1)!=="preview")continue;E=parseInt(O,10)}else{if(!k.test(u))continue;E=parseInt(u,10)}if(E<=i)continue;const P=t.join(a,u,"pwsh.exe");!await p.SymlinkSupport.existsFile(P)||(n=P,i=E)}if(!n)return null;const r=s.includes("x86")?" (x86)":"",o=f?" Preview":"";return new A(n,`PowerShell${o}${r}`,!0)}async function l({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const f=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:s,pwshMsixName:a}=w?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await p.Promises.readdir(f))if(s.test(i)){const n=t.join(f,i,"pwsh.exe");return new A(n,a)}return null}function d(){const w=t.join(_.homedir(),".dotnet","tools","pwsh.exe");return new A(w,".NET Core PowerShell Global Tool")}function g(){const w=t.join(process.env.windir,b===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new A(w,"Windows PowerShell",!0)}async function*S(){let w=await v();w&&(yield w),w=await v({useAlternateBitness:!0}),w&&(yield w),w=await l(),w&&(yield w),w=d(),w&&(yield w),w=await v({findPreview:!0}),w&&(yield w),w=await l({findPreview:!0}),w&&(yield w),w=await v({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=g(),w&&(yield w)}async function*c(){for await(const w of S())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=c;async function C(){for await(const w of c())return w;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ve[83],we([0,1,39,8]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function p(D){return new Promise((R,y)=>{let b;const T=new Map;function A(v,l,d,g,S){const c=T.get(l);if(v===D||c){const C={name:h(d),cmd:d,pid:v,ppid:l,load:g,mem:S};T.set(v,C),v===D&&(b=C),c&&(c.children||(c.children=[]),c.children.push(C),c.children.length>1&&(c.children=c.children.sort((w,f)=>w.pid-f.pid)))}}function h(v){const l=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,S=/--utility-sub-type=network/,c=/--crashes-directory/,C=/\\pipe\\winpty-control/,w=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(c.exec(v))return"electron-crash-reporter";if(C.exec(v))return"winpty-process";if(w.exec(v))return"console-window-host (Windows internal process)";let s=f.exec(v);if(s&&s.length===2)return s[1]==="renderer"?l.exec(v)?"shared-process":d.exec(v)?"issue-reporter":g.exec(v)?"process-explorer":"window":s[1]==="utility"&&S.exec(v)?"utility-network-service":s[1];const a=/[a-zA-Z-]+\.js/g;let i="";do s=a.exec(v),s&&(i+=s+" ");while(s);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substr(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substr(5):l;new Promise((l,d)=>{J(["windows-process-tree"],l,d)}).then(l=>{l.getProcessList(D,d=>{l.getProcessCpuUsage(d,g=>{const S=new Map;g.forEach(c=>{const C=v(c.commandLine||"");S.set(c.pid,{name:h(C),cmd:C,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),b=S.get(D),b?(S.forEach(c=>{const C=S.get(c.ppid);C&&(C.children||(C.children=[]),C.children.push(c))}),S.forEach(c=>{c.children&&(c.children=c.children.sort((C,w)=>C.pid-w.pid))}),R(b)):y(new Error(`Root process ${D} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let v=function(){let l=[b];const d=[];for(;l.length;){const S=l.shift();S&&(d.push(S.pid),S.children&&(l=l.concat(S.children)))}let g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);g+=" "+d.join(" "),(0,_.exec)(g,{},(S,c,C)=>{if(S||C)y(S||new Error(C.toString()));else{const w=c.toString().split(`
`);for(let f=0;f<d.length;f++){const s=T.get(d[f]);s.load=parseFloat(w[f])}if(!b){y(new Error(`Root process ${D} not found`));return}R(b)}})};(0,_.exec)("which ps",{},(l,d,g)=>{if(l||g)if(process.platform!=="linux")y(l||new Error(g.toString()));else{const S=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,_.exec)(S,{},(c,C,w)=>{c||w?y(c||new Error(w.toString())):(k(C,A),v())})}else{const S=d.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,_.exec)(`${S} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,w,f)=>{C||f&&!f.includes("screen size is bogus")?y(C||new Error(f.toString())):(k(w,A),process.platform==="linux"?v():b?R(b):y(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=p;function k(D,R){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=D.toString().split(`
`);for(const T of b){const A=y.exec(T.trim());A&&A.length===6&&R(parseInt(A[1]),parseInt(A[2]),A[5],parseFloat(A[3]),parseFloat(A[4]))}}});var Te=this&&this.__decorate||function(J,e,_,t){var p=arguments.length,k=p<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,_):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,_,t);else for(var R=J.length-1;R>=0;R--)(D=J[R])&&(k=(p<3?D(k):p>3?D(e,_,k):D(e,_))||k);return p>3&&k&&Object.defineProperty(e,_,k),k};define(ve[40],we([0,1,17,13,15,21,73,11,7,2,52,18,12]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function l(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function g(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(S||(S={}));class c{constructor(G){this.buffer=G,this.pos=0}read(G){const ee=this.buffer.slice(this.pos,this.pos+G);return this.pos+=ee.byteLength,ee}}class C{constructor(){this.buffers=[]}get buffer(){return p.VSBuffer.concat(this.buffers)}write(G){this.buffers.push(G)}}var w;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(w||(w={}));function f(B){const G=p.VSBuffer.alloc(4);return G.writeUInt32BE(B,0),G}function s(B){return B.read(4).readUInt32BE(0)}function a(B){const G=p.VSBuffer.alloc(1);return G.writeUInt8(B,0),G}const i={Undefined:a(w.Undefined),String:a(w.String),Buffer:a(w.Buffer),VSBuffer:a(w.VSBuffer),Array:a(w.Array),Object:a(w.Object)},n=typeof Buffer!="undefined";function r(B,G){if(typeof G=="undefined")B.write(i.Undefined);else if(typeof G=="string"){const ee=p.VSBuffer.fromString(G);B.write(i.String),B.write(f(ee.byteLength)),B.write(ee)}else if(n&&Buffer.isBuffer(G)){const ee=p.VSBuffer.wrap(G);B.write(i.Buffer),B.write(f(ee.byteLength)),B.write(ee)}else if(G instanceof p.VSBuffer)B.write(i.VSBuffer),B.write(f(G.byteLength)),B.write(G);else if(Array.isArray(G)){B.write(i.Array),B.write(f(G.length));for(const ee of G)r(B,ee)}else{const ee=p.VSBuffer.fromString(JSON.stringify(G));B.write(i.Object),B.write(f(ee.byteLength)),B.write(ee)}}function o(B){switch(B.read(1).readUInt8(0)){case w.Undefined:return;case w.String:return B.read(s(B)).toString();case w.Buffer:return B.read(s(B)).buffer;case w.VSBuffer:return B.read(s(B));case w.Array:{const ee=s(B),oe=[];for(let se=0;se<ee;se++)oe.push(o(B));return oe}case w.Object:return JSON.parse(B.read(s(B)).toString())}}class u{constructor(G,ee,oe=null,se=1e3){this.protocol=G,this.ctx=ee,this.logger=oe,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(me=>this.onRawMessage(me)),this.sendResponse({type:200})}registerChannel(G,ee){this.channels.set(G,ee),setTimeout(()=>this.flushPendingRequests(G),0)}sendResponse(G){switch(G.type){case 200:{const ee=this.send([G.type]);this.logger&&this.logger.logOutgoing(ee,0,1,g(G.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([G.type,G.id],G.data);this.logger&&this.logger.logOutgoing(ee,G.id,1,g(G.type),G.data);return}}}send(G,ee=void 0){const oe=new C;return r(oe,G),r(oe,ee),this.sendBuffer(oe.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onRawMessage(G){const ee=new c(G),oe=o(ee),se=o(ee),me=oe[0];switch(me){case 100:return this.logger&&this.logger.logIncoming(G.byteLength,oe[1],1,`${l(me)}: ${oe[2]}.${oe[3]}`,se),this.onPromise({type:me,id:oe[1],channelName:oe[2],name:oe[3],arg:se});case 102:return this.logger&&this.logger.logIncoming(G.byteLength,oe[1],1,`${l(me)}: ${oe[2]}.${oe[3]}`,se),this.onEventListen({type:me,id:oe[1],channelName:oe[2],name:oe[3],arg:se});case 101:return this.logger&&this.logger.logIncoming(G.byteLength,oe[1],1,`${l(me)}`),this.disposeActiveRequest({type:me,id:oe[1]});case 103:return this.logger&&this.logger.logIncoming(G.byteLength,oe[1],1,`${l(me)}`),this.disposeActiveRequest({type:me,id:oe[1]})}}onPromise(G){const ee=this.channels.get(G.channelName);if(!ee){this.collectPendingRequest(G);return}const oe=new k.CancellationTokenSource;let se;try{se=ee.call(this.ctx,G.name,G.arg,oe.token)}catch($){se=Promise.reject($)}const me=G.id;se.then($=>{this.sendResponse({id:me,data:$,type:201}),this.activeRequests.delete(G.id)},$=>{$ instanceof Error?this.sendResponse({id:me,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:me,data:$,type:203}),this.activeRequests.delete(G.id)});const Z=(0,b.toDisposable)(()=>oe.cancel());this.activeRequests.set(G.id,Z)}onEventListen(G){const ee=this.channels.get(G.channelName);if(!ee){this.collectPendingRequest(G);return}const oe=G.id,me=ee.listen(this.ctx,G.name,G.arg)(Z=>this.sendResponse({id:oe,data:Z,type:204}));this.activeRequests.set(G.id,me)}disposeActiveRequest(G){const ee=this.activeRequests.get(G.id);ee&&(ee.dispose(),this.activeRequests.delete(G.id))}collectPendingRequest(G){let ee=this.pendingRequests.get(G.channelName);ee||(ee=[],this.pendingRequests.set(G.channelName,ee));const oe=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.sendResponse({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:G,timeoutTimer:oe})}flushPendingRequests(G){const ee=this.pendingRequests.get(G);if(ee){for(const oe of ee)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.onPromise(oe.request);break;case 102:this.onEventListen(oe.request);break}this.pendingRequests.delete(G)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(G=>G.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var E;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(G,ee=null){this.protocol=G,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(oe=>this.onBuffer(oe)),this.logger=ee}getChannel(G){const ee=this;return{call(oe,se,me){return ee.isDisposed?Promise.reject(R.canceled()):ee.requestPromise(G,oe,se,me)},listen(oe,se){return ee.isDisposed?Promise.reject(R.canceled()):ee.requestEvent(G,oe,se)}}}requestPromise(G,ee,oe,se=k.CancellationToken.None){const me=this.lastRequestId++,$={id:me,type:100,channelName:G,name:ee,arg:oe};if(se.isCancellationRequested)return Promise.reject(R.canceled());let H;return new Promise((ie,de)=>{if(se.isCancellationRequested)return de(R.canceled());const De=()=>{const X=U=>{switch(U.type){case 201:this.handlers.delete(me),ie(U.data);break;case 202:{this.handlers.delete(me);const K=new Error(U.data.message);K.stack=U.data.stack,K.name=U.data.name,de(K);break}case 203:this.handlers.delete(me),de(U.data);break}};this.handlers.set(me,X),this.sendRequest($)};let ae=null;this.state===S.Idle?De():(ae=(0,t.createCancelablePromise)(X=>this.whenInitialized()),ae.then(()=>{ae=null,De()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:me,type:101}),de(R.canceled())},pe=se.onCancellationRequested(fe);H=(0,b.combinedDisposable)((0,b.toDisposable)(fe),pe),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(G,ee,oe){const se=this.lastRequestId++,Z={id:se,type:102,channelName:G,name:ee,arg:oe};let $=null;const H=new y.Emitter({onFirstListenerAdd:()=>{$=(0,t.createCancelablePromise)(ie=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(H),this.sendRequest(Z)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(H),this.sendRequest({id:se,type:103}))}}),V=ie=>H.fire(ie.data);return this.handlers.set(se,V),H.event}sendRequest(G){switch(G.type){case 100:case 102:{const ee=this.send([G.type,G.id,G.channelName,G.name],G.arg);this.logger&&this.logger.logOutgoing(ee,G.id,0,`${l(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const ee=this.send([G.type,G.id]);this.logger&&this.logger.logOutgoing(ee,G.id,0,l(G.type));return}}}send(G,ee=void 0){const oe=new C;return r(oe,G),r(oe,ee),this.sendBuffer(oe.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onBuffer(G){const ee=new c(G),oe=o(ee),se=o(ee),me=oe[0];switch(me){case 200:return this.logger&&this.logger.logIncoming(G.byteLength,0,0,g(me)),this.onResponse({type:oe[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(G.byteLength,oe[1],0,g(me),se),this.onResponse({type:oe[0],id:oe[1],data:se})}}onResponse(G){if(G.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const ee=this.handlers.get(G.id);ee&&ee(G)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(G=>G.dispose()),this.activeRequests.clear()}}Te([D.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class I{constructor(G){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,G(({protocol:ee,onDidClientDisconnect:oe})=>{y.Event.once(ee.onMessage)(me=>{const Z=new c(me),$=o(Z),H=new u(ee,$),V=new P(ee);this.channels.forEach((de,De)=>H.registerChannel(De,de));const ie={channelServer:H,channelClient:V,ctx:$};this._connections.add(ie),this._onDidAddConnection.fire(ie),oe(()=>{H.dispose(),V.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const G=[];return this._connections.forEach(ee=>G.push(ee)),G}getChannel(G,ee){const oe=this;return{call(se,me,Z){let $;if((0,h.isFunction)(ee)){let V=(0,_.getRandomElement)(oe.connections.filter(ee));$=V?Promise.resolve(V):y.Event.toPromise(y.Event.filter(oe.onDidAddConnection,ee))}else $=ee.routeCall(oe,se,me);const H=$.then(V=>V.channelClient.getChannel(G));return z(H).call(se,me,Z)},listen(se,me){if((0,h.isFunction)(ee))return oe.getMulticastEvent(G,ee,se,me);const Z=ee.routeEvent(oe,se,me).then($=>$.channelClient.getChannel(G));return z(Z).listen(se,me)}}}getMulticastEvent(G,ee,oe,se){const me=this;let Z=new b.DisposableStore;const $=new y.Emitter({onFirstListenerAdd:()=>{Z=new b.DisposableStore;const H=new y.EventMultiplexer,V=new Map,ie=De=>{const fe=De.channelClient.getChannel(G).listen(oe,se),pe=H.add(fe);V.set(De,pe)},de=De=>{const ae=V.get(De);!ae||(ae.dispose(),V.delete(De))};me.connections.filter(ee).forEach(ie),y.Event.filter(me.onDidAddConnection,ee)(ie,void 0,Z),me.onDidRemoveConnection(de,void 0,Z),H.event($.fire,$,Z),Z.add(H)},onLastListenerRemove:()=>{Z.dispose()}});return $.event}registerChannel(G,ee){this.channels.set(G,ee),this._connections.forEach(oe=>{oe.channelServer.registerChannel(G,ee)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class O{constructor(G,ee,oe=null){const se=new C;r(se,ee),G.send(se.buffer),this.channelClient=new P(G,oe),this.channelServer=new u(G,ee,oe)}getChannel(G){return this.channelClient.getChannel(G)}registerChannel(G,ee){this.channelServer.registerChannel(G,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function z(B){return{call(G,ee,oe){return B.then(se=>se.call(G,ee,oe))},listen(G,ee){const oe=new y.Relay;return B.then(se=>oe.input=se.listen(G,ee)),oe.event}}}e.getDelayedChannel=z;function j(B){let G=!1;return{call(ee,oe,se){return G?B.call(ee,oe,se):(0,t.timeout)(0).then(()=>G=!0).then(()=>B.call(ee,oe,se))},listen(ee,oe){if(G)return B.listen(ee,oe);const se=new y.Relay;return(0,t.timeout)(0).then(()=>G=!0).then(()=>se.input=B.listen(ee,oe)),se.event}}}e.getNextTickChannel=j;class m{constructor(G){this.fn=G}routeCall(G){return this.route(G)}routeEvent(G){return this.route(G)}async route(G){for(const ee of G.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await y.Event.toPromise(G.onDidAddConnection),await this.route(G)}}e.StaticRouter=m;var L;(function(B){function G(me,Z){const $=me,H=Z&&Z.disableMarshalling,V=new Map;for(const ie in $)oe(ie)&&V.set(ie,y.Event.buffer($[ie],!0));return new class{listen(ie,de,De){const ae=V.get(de);if(ae)return ae;if(se(de)){const fe=$[de];if(typeof fe=="function")return fe.call($,De)}throw new Error(`Event not found: ${de}`)}call(ie,de,De){const ae=$[de];if(typeof ae=="function"){if(!H&&Array.isArray(De))for(let fe=0;fe<De.length;fe++)De[fe]=(0,T.revive)(De[fe]);return ae.apply($,De)}throw new Error(`Method not found: ${de}`)}}}B.fromService=G;function ee(me,Z){const $=Z&&Z.disableMarshalling;return new Proxy({},{get(H,V){if(typeof V=="string")return Z?.properties?.has(V)?Z.properties.get(V):se(V)?function(ie){return me.listen(V,ie)}:oe(V)?me.listen(V):async function(...ie){let de;Z&&!(0,h.isUndefinedOrNull)(Z.context)?de=[Z.context,...ie]:de=ie;const De=await me.call(V,de);return $?De:(0,T.revive)(De)};throw new Error(`Property not found: ${String(V)}`)}})}B.toService=ee;function oe(me){return me[0]==="o"&&me[1]==="n"&&A.isUpperAsciiLetter(me.charCodeAt(2))}function se(me){return/^onDynamic/.test(me)&&A.isUpperAsciiLetter(me.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let G=B.toString();if(G!=="[object Object]")return G}return B}function W(B){return Array.isArray(B)?B.map(Q):Q(B)}function q(B,G,ee,oe,se,me,Z){Z=W(Z);const $=M[se],H=$[oe%$.length];let V=[`%c[${B}]%c[${String(G).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(me)?(V=V.concat(Z),V.push(")")):V.push(Z),console.log.apply(console,V)}e.logWithColors=q;class ne{constructor(G,ee){this._outgoingPrefix=G,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(G,ee,oe,se,me){this._totalOutgoing+=G,q(this._outgoingPrefix,this._totalOutgoing,G,ee,oe,se,me)}logIncoming(G,ee,oe,se,me){this._totalIncoming+=G,q(this._incomingPrefix,this._totalIncoming,G,ee,oe,se,me)}}e.IPCLogger=ne}),define(ve[84],we([0,1,15,7,2,40]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let o=0;function u(P,I){if(!r.has(P)){const O=String(++o);r.set(P,O)}return r.get(P)}function E(P,I,O,z){if(!n.enableDiagnostics)return;const j=u(P,I);if(z instanceof _.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const m=_.VSBuffer.alloc(z.byteLength);m.set(z),n.records.push({timestamp:Date.now(),id:j,label:I,type:O,buff:m})}else n.records.push({timestamp:Date.now(),id:j,label:I,type:O,data:z})}n.traceSocketEvent=E})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function T(){return b||(b=_.VSBuffer.alloc(0)),b}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return T();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),I}if(this._chunks[0].byteLength>r){const I=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),I}let u=_.VSBuffer.alloc(r),E=0,P=0;for(;r>0;){const I=this._chunks[P];if(I.byteLength>r){const O=I.slice(0,r);u.set(O,E),E+=r,o&&(this._chunks[P]=I.slice(r),this._totalLength-=r),r-=r}else u.set(I,E),E+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):P++,r-=I.byteLength}return u}}e.ChunkStream=A;var h;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(h||(h={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var l;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(l=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,o,u,E){this.type=r,this.id=o,this.ack=u,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends p.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,E=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new d(u,E,P,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=_.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const u=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,u}_bufferTake(){const r=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class c extends p.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=c;class C extends k.IPCClient{constructor(r,o,u=null){super(r,o,u);this.protocol=r}static fromSocket(r,o){return new C(new c(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=C;class w{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=w;class f{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,u=this._first;for(;u;)r[o++]=u.data,u=u.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new f(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const r=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let u=0;for(let E=0;E<a._HISTORY_LENGTH;E++)r-this.lastRuns[E]<=o&&u++;return 1-u/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(r,o=null,u=a.getInstance()){this._onControlMessage=new w,this.onControlMessage=this._onControlMessage.event,this._onMessage=new w,this.onMessage=this._onMessage.event,this._onDidDispose=new w,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new w,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new w,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(E=>this._receiveMessage(E))),this._socketDisposables.push(this._socket.onClose(E=>this._onSocketClose.fire(E))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,p.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,T());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,T());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,T());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,p.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,T());this._socketWriter.write(r);const o=this._outgoingUnackMsg.toArray();for(let u=0,E=o.length;u<E;u++)this._socketWriter.write(o[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new d(6,0,0,T())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let u=0,E=o.length;u<E;u++)this._socketWriter.write(o[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new d(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(r){const o=new d(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,u=Date.now()-this._socketReader.lastReadTime,E=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&u>=2e4&&E>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const P=Math.max(2e4-o,2e4-u,2e4-E,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,T());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(ve[137],we([0,1,13,7,2,12]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(A){A[A.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function R(A){const h=A;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var y;(function(A){A[A.None=0]="None",A[A.Initialized=1]="Initialized",A[A.Closed=2]="Closed"})(y||(y={}));class b extends p.Disposable{constructor(h,v=Object.create(null)){super();this.database=h,this.options=v,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=new _.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,l)=>this.accept(l,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===y.Closed)return;let l=!1;(0,k.isUndefinedOrNull)(v)?l=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),l=!0),l&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const l=this.cache.get(h);return(0,k.isUndefinedOrNull)(l)?v:l}getBoolean(h,v){const l=this.get(h);return(0,k.isUndefinedOrNull)(l)?v:l==="true"}getNumber(h,v){const l=this.get(h);return(0,k.isUndefinedOrNull)(l)?v:parseInt(l,10)}async set(h,v){if(this.state===y.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(h);const l=String(v);if(this.cache.get(h)!==l)return this.cache.set(h,l),this.pendingInserts.set(h,l),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===y.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((v,l)=>this.items.set(l,v)),h.delete&&h.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=T}),define(ve[85],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(p,k){this.lineNumber=p,this.column=k}with(p=this.lineNumber,k=this.column){return p===this.lineNumber&&k===this.column?this:new _(p,k)}delta(p=0,k=0){return this.with(this.lineNumber+p,this.column+k)}equals(p){return _.equals(this,p)}static equals(p,k){return!p&&!k?!0:!!p&&!!k&&p.lineNumber===k.lineNumber&&p.column===k.column}isBefore(p){return _.isBefore(this,p)}static isBefore(p,k){return p.lineNumber<k.lineNumber?!0:k.lineNumber<p.lineNumber?!1:p.column<k.column}isBeforeOrEqual(p){return _.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,k){return p.lineNumber<k.lineNumber?!0:k.lineNumber<p.lineNumber?!1:p.column<=k.column}static compare(p,k){const D=p.lineNumber|0,R=k.lineNumber|0;if(D===R){const y=p.column|0,b=k.column|0;return y-b}return D-R}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new _(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}}e.Position=_}),define(ve[63],we([0,1,85]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(k,D,R,y){k>R||k===R&&D>y?(this.startLineNumber=R,this.startColumn=y,this.endLineNumber=k,this.endColumn=D):(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=R,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return t.containsPosition(this,k)}static containsPosition(k,D){return!(D.lineNumber<k.startLineNumber||D.lineNumber>k.endLineNumber||D.lineNumber===k.startLineNumber&&D.column<k.startColumn||D.lineNumber===k.endLineNumber&&D.column>k.endColumn)}static strictContainsPosition(k,D){return!(D.lineNumber<k.startLineNumber||D.lineNumber>k.endLineNumber||D.lineNumber===k.startLineNumber&&D.column<=k.startColumn||D.lineNumber===k.endLineNumber&&D.column>=k.endColumn)}containsRange(k){return t.containsRange(this,k)}static containsRange(k,D){return!(D.startLineNumber<k.startLineNumber||D.endLineNumber<k.startLineNumber||D.startLineNumber>k.endLineNumber||D.endLineNumber>k.endLineNumber||D.startLineNumber===k.startLineNumber&&D.startColumn<k.startColumn||D.endLineNumber===k.endLineNumber&&D.endColumn>k.endColumn)}strictContainsRange(k){return t.strictContainsRange(this,k)}static strictContainsRange(k,D){return!(D.startLineNumber<k.startLineNumber||D.endLineNumber<k.startLineNumber||D.startLineNumber>k.endLineNumber||D.endLineNumber>k.endLineNumber||D.startLineNumber===k.startLineNumber&&D.startColumn<=k.startColumn||D.endLineNumber===k.endLineNumber&&D.endColumn>=k.endColumn)}plusRange(k){return t.plusRange(this,k)}static plusRange(k,D){let R,y,b,T;return D.startLineNumber<k.startLineNumber?(R=D.startLineNumber,y=D.startColumn):D.startLineNumber===k.startLineNumber?(R=D.startLineNumber,y=Math.min(D.startColumn,k.startColumn)):(R=k.startLineNumber,y=k.startColumn),D.endLineNumber>k.endLineNumber?(b=D.endLineNumber,T=D.endColumn):D.endLineNumber===k.endLineNumber?(b=D.endLineNumber,T=Math.max(D.endColumn,k.endColumn)):(b=k.endLineNumber,T=k.endColumn),new t(R,y,b,T)}intersectRanges(k){return t.intersectRanges(this,k)}static intersectRanges(k,D){let R=k.startLineNumber,y=k.startColumn,b=k.endLineNumber,T=k.endColumn,A=D.startLineNumber,h=D.startColumn,v=D.endLineNumber,l=D.endColumn;return R<A?(R=A,y=h):R===A&&(y=Math.max(y,h)),b>v?(b=v,T=l):b===v&&(T=Math.min(T,l)),R>b||R===b&&y>T?null:new t(R,y,b,T)}equalsRange(k){return t.equalsRange(this,k)}static equalsRange(k,D){return!!k&&!!D&&k.startLineNumber===D.startLineNumber&&k.startColumn===D.startColumn&&k.endLineNumber===D.endLineNumber&&k.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(k){return new _.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(k){return new _.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,D){return new t(this.startLineNumber,this.startColumn,k,D)}setStartPosition(k,D){return new t(k,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(k){return new t(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}static fromPositions(k,D=k){return new t(k.lineNumber,k.column,D.lineNumber,D.column)}static lift(k){return k?new t(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,D){return!(k.endLineNumber<D.startLineNumber||k.endLineNumber===D.startLineNumber&&k.endColumn<D.startColumn||D.endLineNumber<k.startLineNumber||D.endLineNumber===k.startLineNumber&&D.endColumn<k.startColumn)}static areIntersecting(k,D){return!(k.endLineNumber<D.startLineNumber||k.endLineNumber===D.startLineNumber&&k.endColumn<=D.startColumn||D.endLineNumber<k.startLineNumber||D.endLineNumber===k.startLineNumber&&D.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,D){if(k&&D){const b=k.startLineNumber|0,T=D.startLineNumber|0;if(b===T){const A=k.startColumn|0,h=D.startColumn|0;if(A===h){const v=k.endLineNumber|0,l=D.endLineNumber|0;if(v===l){const d=k.endColumn|0,g=D.endColumn|0;return d-g}return v-l}return A-h}return b-T}return(k?1:0)-(D?1:0)}static compareRangesUsingEnds(k,D){return k.endLineNumber===D.endLineNumber?k.endColumn===D.endColumn?k.startLineNumber===D.startLineNumber?k.startColumn-D.startColumn:k.startLineNumber-D.startLineNumber:k.endColumn-D.endColumn:k.endLineNumber-D.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}}e.Range=t}),define(ve[138],we([0,1,60,4]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function p(k,D,R,y){if(Array.isArray(k)){let b=0;for(const T of k){const A=p(T,D,R,y);if(A===10)return A;A>b&&(b=A)}return b}else{if(typeof k=="string")return y?k==="*"?5:k===R?10:0:0;if(k){const{language:b,pattern:T,scheme:A,hasAccessToAllModels:h}=k;if(!y&&!h)return 0;let v=0;if(A)if(A===D.scheme)v=10;else if(A==="*")v=5;else return 0;if(b)if(b===R)v=10;else if(b==="*")v=Math.max(v,5);else return 0;if(T){let l;if(typeof T=="string"?l=T:l={...T,base:(0,t.normalize)(T.base)},l===D.fsPath||(0,_.match)(l,D.fsPath))v=10;else return 0}return v}else return 0}}e.score=p}),define(ve[139],we([0,1,20]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var p;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(p=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(k=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class b{constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),this.indentSize=C.tabSize|0,this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,_.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.TextModelResolvedOptions=b;class T{constructor(C,w){this._findMatchBrand=void 0,this.range=C,this.matches=w}}e.FindMatch=T;var A;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var h;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class l{constructor(C,w,f,s,a,i){this.identifier=C,this.range=w,this.text=f,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=a,this._isTracked=i}}e.ValidAnnotatedEditOperation=l;class d{constructor(C,w,f){this.regex=C,this.wordSeparators=w,this.simpleSearch=f}}e.SearchData=d;class g{constructor(C,w,f){this.reverseEdits=C,this.changes=w,this.trimAutoWhitespaceLineNumbers=f}}e.ApplyEditsResult=g;function S(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(ve[140],we([0,1,7,2,139,138]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function D(y){return typeof y=="string"?!1:Array.isArray(y)?y.every(D):!!y.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(b,T){let A={selector:b,provider:T,_score:-1,_time:this._clock++};return this._entries.push(A),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(A){const h=this._entries.indexOf(A);h>=0&&(this._entries.splice(h,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),A=void 0)}})}has(b){return this.all(b).length>0}all(b){if(!b)return[];this._updateScores(b);const T=[];for(let A of this._entries)A._score>0&&T.push(A.provider);return T}ordered(b){const T=[];return this._orderedForEach(b,A=>T.push(A.provider)),T}orderedGroups(b){const T=[];let A,h;return this._orderedForEach(b,v=>{A&&h===v._score?A.push(v.provider):(h=v._score,A=[v.provider],T.push(A))}),T}_orderedForEach(b,T){if(!!b){this._updateScores(b);for(const A of this._entries)A._score>0&&T(A)}}_updateScores(b){const T={uri:b.uri.toString(),language:b.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let A of this._entries)if(A._score=(0,k.score)(A.selector,b.uri,b.getLanguageId(),(0,p.shouldSynchronizeModel)(b)),D(A.selector)&&A._score>0){for(let h of this._entries)h._score=0;A._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(b,T){return b._score<T._score?1:b._score>T._score?-1:b._time<T._time?1:b._time>T._time?-1:0}}e.LanguageFeatureRegistry=R}),define(ve[141],we([0,1,7,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class p{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,y){return this._map.set(R,y),this.fire([R]),(0,t.toDisposable)(()=>{this._map.get(R)===y&&(this._map.delete(R),this.fire([R]))})}registerFactory(R,y){this._factories.get(R)?.dispose();const b=new k(this,R,y);return this._factories.set(R,b),(0,t.toDisposable)(()=>{const T=this._factories.get(R);!T||T!==b||(this._factories.delete(R),T.dispose())})}async getOrCreate(R){const y=this.get(R);if(y)return y;const b=this._factories.get(R);return!b||b.isResolved?null:(await b.resolve(),this.get(R))}get(R){return this._map.get(R)||null}isResolved(R){if(this.get(R))return!0;const b=this._factories.get(R);return!!(!b||b.isResolved)}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=p;class k extends t.Disposable{constructor(R,y,b){super();this._registry=R,this._languageId=y,this._factory=b,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const R=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,R&&!this._isDisposed&&this._register(this._registry.register(this._languageId,R))}}}),define(ve[142],we([0,1,5,63,140,141,37]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var R;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(R=e.LanguageId||(e.LanguageId={}));var y;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline",m[m.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var b;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(b=e.ColorId||(e.ColorId={}));var T;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=3]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var A;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=1024]="ITALIC_MASK",m[m.BOLD_MASK=2048]="BOLD_MASK",m[m.UNDERLINE_MASK=4096]="UNDERLINE_MASK",m[m.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",m[m.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(A=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&768)>>>8}static getFontStyle(L){return(L&15360)>>>10}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){const M=this.getForeground(L);let Q="mtk"+M;const W=this.getFontStyle(L);return W&1&&(Q+=" mtki"),W&2&&(Q+=" mtkb"),W&4&&(Q+=" mtku"),W&8&&(Q+=" mtks"),Q}static getInlineStyleFromMetadata(L,M){const Q=this.getForeground(L),W=this.getFontStyle(L);let q=`color: ${M[Q]};`;W&1&&(q+="font-style: italic;"),W&2&&(q+="font-weight: bold;");let ne="";return W&4&&(ne+=" underline"),W&8&&(ne+=" line-through"),ne&&(q+=`text-decoration:${ne};`),q}static getPresentationFromMetadata(L){const M=this.getForeground(L),Q=this.getFontStyle(L);return{foreground:M,italic:Boolean(Q&1),bold:Boolean(Q&2),underline:Boolean(Q&4),strikethrough:Boolean(Q&8)}}}e.TokenMetadata=h;class v{constructor(L,M,Q){this._tokenBrand=void 0,this.offset=L,this.type=M,this.language=Q}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class l{constructor(L,M){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=M}}e.TokenizationResult=l;class d{constructor(L,M){this._encodedTokenizationResultBrand=void 0,this.tokens=L,this.endState=M}}e.EncodedTokenizationResult=d;var g;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={}));var S;(function(m){const L=new Map;L.set(0,D.Codicon.symbolMethod),L.set(1,D.Codicon.symbolFunction),L.set(2,D.Codicon.symbolConstructor),L.set(3,D.Codicon.symbolField),L.set(4,D.Codicon.symbolVariable),L.set(5,D.Codicon.symbolClass),L.set(6,D.Codicon.symbolStruct),L.set(7,D.Codicon.symbolInterface),L.set(8,D.Codicon.symbolModule),L.set(9,D.Codicon.symbolProperty),L.set(10,D.Codicon.symbolEvent),L.set(11,D.Codicon.symbolOperator),L.set(12,D.Codicon.symbolUnit),L.set(13,D.Codicon.symbolValue),L.set(15,D.Codicon.symbolEnum),L.set(14,D.Codicon.symbolConstant),L.set(15,D.Codicon.symbolEnum),L.set(16,D.Codicon.symbolEnumMember),L.set(17,D.Codicon.symbolKeyword),L.set(27,D.Codicon.symbolSnippet),L.set(18,D.Codicon.symbolText),L.set(19,D.Codicon.symbolColor),L.set(20,D.Codicon.symbolFile),L.set(21,D.Codicon.symbolReference),L.set(22,D.Codicon.symbolCustomColor),L.set(23,D.Codicon.symbolFolder),L.set(24,D.Codicon.symbolTypeParameter),L.set(25,D.Codicon.account),L.set(26,D.Codicon.issues);function M(q){let ne=L.get(q);return ne||(console.info("No codicon found for CompletionItemKind "+q),ne=D.Codicon.symbolProperty),ne}m.toIcon=M;const Q=new Map;Q.set("method",0),Q.set("function",1),Q.set("constructor",2),Q.set("field",3),Q.set("variable",4),Q.set("class",5),Q.set("struct",6),Q.set("interface",7),Q.set("module",8),Q.set("property",9),Q.set("event",10),Q.set("operator",11),Q.set("unit",12),Q.set("value",13),Q.set("constant",14),Q.set("enum",15),Q.set("enum-member",16),Q.set("enumMember",16),Q.set("keyword",17),Q.set("snippet",27),Q.set("text",18),Q.set("color",19),Q.set("file",20),Q.set("reference",21),Q.set("customcolor",22),Q.set("folder",23),Q.set("type-parameter",24),Q.set("typeParameter",24),Q.set("account",25),Q.set("issue",26);function W(q,ne){let B=Q.get(q);return typeof B=="undefined"&&!ne&&(B=9),B}m.fromString=W})(S=e.CompletionItemKinds||(e.CompletionItemKinds={}));var c;(function(m){m[m.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var C;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(C=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var f;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(f=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var i;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(i=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function n(m){return m&&_.URI.isUri(m.uri)&&t.Range.isIRange(m.range)&&(t.Range.isIRange(m.originSelectionRange)||t.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=n;var r;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var o;(function(m){m[m.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var u;(function(m){const L=new Map;L.set(0,D.Codicon.symbolFile),L.set(1,D.Codicon.symbolModule),L.set(2,D.Codicon.symbolNamespace),L.set(3,D.Codicon.symbolPackage),L.set(4,D.Codicon.symbolClass),L.set(5,D.Codicon.symbolMethod),L.set(6,D.Codicon.symbolProperty),L.set(7,D.Codicon.symbolField),L.set(8,D.Codicon.symbolConstructor),L.set(9,D.Codicon.symbolEnum),L.set(10,D.Codicon.symbolInterface),L.set(11,D.Codicon.symbolFunction),L.set(12,D.Codicon.symbolVariable),L.set(13,D.Codicon.symbolConstant),L.set(14,D.Codicon.symbolString),L.set(15,D.Codicon.symbolNumber),L.set(16,D.Codicon.symbolBoolean),L.set(17,D.Codicon.symbolArray),L.set(18,D.Codicon.symbolObject),L.set(19,D.Codicon.symbolKey),L.set(20,D.Codicon.symbolNull),L.set(21,D.Codicon.symbolEnumMember),L.set(22,D.Codicon.symbolStruct),L.set(23,D.Codicon.symbolEvent),L.set(24,D.Codicon.symbolOperator),L.set(25,D.Codicon.symbolTypeParameter);function M(Q){let W=L.get(Q);return W||(console.info("No codicon found for SymbolKind "+Q),W=D.Codicon.symbolProperty),W}m.toIcon=M})(u=e.SymbolKinds||(e.SymbolKinds={}));class E{constructor(L){this.value=L}}e.FoldingRangeKind=E,E.Comment=new E("comment"),E.Imports=new E("imports"),E.Region=new E("region");var P;(function(m){function L(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}m.is=L})(P=e.Command||(e.Command={}));var I;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(I=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var O;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(O=e.CommentMode||(e.CommentMode={}));var z;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(z=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new p.LanguageFeatureRegistry,e.RenameProviderRegistry=new p.LanguageFeatureRegistry,e.CompletionProviderRegistry=new p.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new p.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new p.LanguageFeatureRegistry,e.HoverProviderRegistry=new p.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new p.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new p.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new p.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new p.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new p.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new p.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new p.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new p.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new p.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.LinkProviderRegistry=new p.LanguageFeatureRegistry,e.ColorProviderRegistry=new p.LanguageFeatureRegistry,e.SelectionRangeRegistry=new p.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new p.LanguageFeatureRegistry,e.TokenizationRegistry=new k.TokenizationRegistry;var j;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(j=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[143],we([9,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ve[144],we([0,1,143]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,p=t*60,k=p*24,D=k*7,R=k*30,y=k*365;function b(A,h,v){typeof A!="number"&&(A=A.getTime());const l=Math.round((new Date().getTime()-A)/1e3);if(l<-30)return(0,_.localize)(0,null,b(new Date().getTime()+l*1e3,!1));if(l<30)return(0,_.localize)(1,null);let d;return l<t?(d=l,h?d===1?v?(0,_.localize)(2,null,d):(0,_.localize)(3,null,d):v?(0,_.localize)(4,null,d):(0,_.localize)(5,null,d):d===1?v?(0,_.localize)(6,null,d):(0,_.localize)(7,null,d):v?(0,_.localize)(8,null,d):(0,_.localize)(9,null,d)):l<p?(d=Math.floor(l/t),h?d===1?v?(0,_.localize)(10,null,d):(0,_.localize)(11,null,d):v?(0,_.localize)(12,null,d):(0,_.localize)(13,null,d):d===1?v?(0,_.localize)(14,null,d):(0,_.localize)(15,null,d):v?(0,_.localize)(16,null,d):(0,_.localize)(17,null,d)):l<k?(d=Math.floor(l/p),h?d===1?v?(0,_.localize)(18,null,d):(0,_.localize)(19,null,d):v?(0,_.localize)(20,null,d):(0,_.localize)(21,null,d):d===1?v?(0,_.localize)(22,null,d):(0,_.localize)(23,null,d):v?(0,_.localize)(24,null,d):(0,_.localize)(25,null,d)):l<D?(d=Math.floor(l/k),h?d===1?(0,_.localize)(26,null,d):(0,_.localize)(27,null,d):d===1?(0,_.localize)(28,null,d):(0,_.localize)(29,null,d)):l<R?(d=Math.floor(l/D),h?d===1?v?(0,_.localize)(30,null,d):(0,_.localize)(31,null,d):v?(0,_.localize)(32,null,d):(0,_.localize)(33,null,d):d===1?v?(0,_.localize)(34,null,d):(0,_.localize)(35,null,d):v?(0,_.localize)(36,null,d):(0,_.localize)(37,null,d)):l<y?(d=Math.floor(l/R),h?d===1?v?(0,_.localize)(38,null,d):(0,_.localize)(39,null,d):v?(0,_.localize)(40,null,d):(0,_.localize)(41,null,d):d===1?v?(0,_.localize)(42,null,d):(0,_.localize)(43,null,d):v?(0,_.localize)(44,null,d):(0,_.localize)(45,null,d)):(d=Math.floor(l/y),h?d===1?v?(0,_.localize)(46,null,d):(0,_.localize)(47,null,d):v?(0,_.localize)(48,null,d):(0,_.localize)(49,null,d):d===1?v?(0,_.localize)(50,null,d):(0,_.localize)(51,null,d):v?(0,_.localize)(52,null,d):(0,_.localize)(53,null,d))}e.fromNow=b;function T(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ve[145],we([9,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[36],we([0,1,17,12,145]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(b,T){return T&&(b.stack||b.stacktrace)?p.localize(0,null,R(b),D(b.stack)||D(b.stacktrace)):R(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?p.localize(1,null,b.message):b.message||p.localize(2,null)}function y(b=null,T=!1){if(!b)return p.localize(3,null);if(Array.isArray(b)){const A=_.coalesce(b),h=y(A[0],T);return A.length>1?p.localize(4,null,h,A.length):h}if(t.isString(b))return b;if(b.detail){const A=b.detail;if(A.error)return k(A.error,T);if(A.exception)return k(A.exception,T)}return b.stack?k(b,T):b.message?b.message:p.localize(5,null)}e.toErrorMessage=y}),define(ve[146],we([9,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ve[147],we([0,1,146]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(p){switch(p){case 1:return(0,_.localize)(0,null);case 2:return(0,_.localize)(1,null);case 3:return(0,_.localize)(2,null);case 4:return(0,_.localize)(3,null);case 5:return(0,_.localize)(4,null);case 6:return(0,_.localize)(5,null);case 7:return(0,_.localize)(6,null);case 8:return(0,_.localize)(7,null);case 9:return(0,_.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ve[148],we([9,10]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ve[64],we([0,1,39,31,8,20,4,3,24,75,12,130,19,148]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function l(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const n=_.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{n.once("error",o=>{r({success:!1,error:o})}),n.once("exit",(o,u)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?l(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(n=>{_.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,u)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function g(s){!s||(delete s.DEBUG,R.isMacintosh&&delete s.DYLD_LIBRARY_PATH,R.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function S(s=y.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class c{constructor(a,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=a,this.args=i,this.shell=n,this.options=r;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(y.env).forEach(u=>{o[u]=y.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(D.sep);return i!==-1&&(a=a.substring(i+1)),c.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(y.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(i=>{let n,r;const o=new Promise((u,E)=>{n=u,r=E});if(i){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=_.exec(u,this.options,(E,P,I)=>{this.childProcess=null;const O=E;O&&O.killed?r({killed:this.terminateRequested,stdout:P.toString(),stderr:I.toString()}):this.handleExec(n,a,E,P,I)})}else{let u=null;const E=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,n,a,r);const I={terminated:this.terminateRequested};T.isNumber(P)&&(I.cmdCode=P),n(I)};if(this.shell&&R.isWindows){const P=k.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let I=!1,O=!1;const z=[];let j=this.ensureQuotes(this.cmd);z.push(j.value),I=j.quoted,this.args&&this.args.forEach(L=>{j=this.ensureQuotes(L),z.push(j.value),O=O&&j.quoted});const m=["/s","/c"];I?O?m.push('"'+z.join(" ")+'"'):z.length>1?m.push('"'+z[0]+'" '+z.slice(1).join(" ")):m.push('"'+z[0]+'"'):m.push(z.join(" ")),u=_.spawn(S(),m,P)}else this.cmd&&(u=_.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(T.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",P=>{this.childProcess=null,r({terminated:this.terminateRequested,error:P})}),u.pid&&(this.childProcess.on("close",E),this.handleSpawn(u,n,a,r,!0)))}return o})}handleClose(a,i,n,r){}ensureQuotes(a){return c.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,d(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=_.spawn(S(),["/s","/c"]);i.on("error",n=>a(!0)),i.on("exit",n=>a(!1))})}}e.AbstractProcess=c,c.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},c.regexp=/^[^"].* .*[^"]/;class C extends c{constructor(a,i,n,r){super(a,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,n,r,o){[r,o].forEach((u,E)=>{const P=new A.LineDecoder;P.write(u).forEach(z=>{i({line:z,source:E===0?0:1})});const O=P.end();O&&i({line:O,source:E===0?0:1})}),a({terminated:this.terminateRequested,error:n})}handleSpawn(a,i,n,r,o){const u=new A.LineDecoder,E=new A.LineDecoder;a.stdout.on("data",P=>{u.write(P).forEach(O=>n({line:O,source:0}))}),a.stderr.on("data",P=>{E.write(P).forEach(O=>n({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=E}handleClose(a,i,n,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}e.LineProcess=C;function w(s){let a=[],i=!1;const n=function(r){if(i){a.push(r);return}(!s.send(r,u=>{if(u&&console.error(u),i=!1,a.length>0){const E=a.slice(0);a=[],E.forEach(P=>n(P))}})||R.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=w;var f;(function(s){async function a(i,n,r){if(D.isAbsolute(i))return i;if(n===void 0&&(n=y.cwd()),D.dirname(i)!=="."||(r===void 0&&T.isString(y.env.PATH)&&(r=y.env.PATH.split(D.delimiter)),r===void 0||r.length===0))return D.join(n,i);async function u(E){if(await h.Promises.exists(E)){let P;try{P=await h.Promises.stat(E)}catch(I){I.message.startsWith("EACCES")&&(P=await h.Promises.lstat(E))}return P?!P.isDirectory():!1}return!1}for(let E of r){let P;if(D.isAbsolute(E)?P=D.join(E,i):P=D.join(n,E,i),await u(P))return P;let I=P+".com";if(await u(I)||(I=P+".exe",await u(I)))return I}return D.join(n,i)}s.findExecutable=a})(f=e.win32||(e.win32={}))}),define(ve[149],we([0,1,25,3,82,64]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(v,l){return v===1?t.isWindows?A():k.getWindowsShell(l):b(v,l)}e.getSystemShell=D;function R(v,l){return v===1?t.isWindows?h(l):k.getWindowsShell(l):b(v,l)}e.getSystemShellSync=R;let y=null;function b(v,l){if(t.isLinux&&v===2||t.isMacintosh&&v===3)return"/bin/bash";if(!y){let d;if(t.isWindows)d="/bin/bash";else{if(d=l.SHELL,!d)try{d=(0,_.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let T=null;async function A(){return T||(T=(await(0,p.getFirstAvailablePowerShellInstallation)()).exePath),T}function h(v){if(T)return T;const l=t.isWindows&&parseFloat((0,_.release)())>=10,d=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${v.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?g:k.getWindowsShell(v)}}),define(ve[86],we([0,1,39,13,15,21,79,11,7,2,20,64,40]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends h.ChannelServer{constructor(g){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",S=>p.VSBuffer.wrap(Buffer.from(S,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=v;class l{constructor(g,S){this.modulePath=g,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(c),this.child=null,this._client=null}getChannel(g){const S=this;return{call(c,C,w){return S.requestPromise(g,c,C,w)},listen(c,C){return S.requestEvent(g,c,C)}}}requestPromise(g,S,c,C=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(C.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(g),f=(0,t.createCancelablePromise)(i=>w.call(S,c,i)),s=C.onCancellationRequested(()=>f.cancel()),a=(0,b.toDisposable)(()=>f.cancel());return this.activeRequests.add(a),f.finally(()=>{s.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),f}requestEvent(g,S,c){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let C;const w=new y.Emitter({onFirstListenerAdd:()=>{C=this.getCachedChannel(g).listen(S,c)(w.fire,w),this.activeRequests.add(C)},onLastListenerRemove:()=>{this.activeRequests.delete(C),C.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,A.removeDangerousEnvVariables)(S.env),this.child=(0,_.fork)(this.modulePath,g,S);const c=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,D.isRemoteConsoleLog)(n)){(0,D.log)(n,`IPC Library: ${this.options.serverName}`);return}c.fire(p.VSBuffer.wrap(Buffer.from(n,"base64")))});const w=this.options.useQueue?(0,A.createQueuedSender)(this.child):this.child,f=n=>this.child&&this.child.connected&&w.send(n.buffer.toString("base64")),s=c.event,a={send:f,onMessage:s};this._client=new h.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:r})})}return this._client}getCachedChannel(g){let S=this.channels.get(g);return S||(S=this.client.getChannel(g),this.channels.set(g,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=l}),define(ve[150],we([9,10]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ve[151],we([9,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[152],we([9,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ve[153],we([9,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ve[154],we([9,10]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ve[155],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[156],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[157],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ve[158],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[159],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[160],we([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ve[161],we([9,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[162],we([9,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ve[163],we([9,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[164],we([9,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ve[165],we([9,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[166],we([9,10]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[167],we([9,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ve[168],we([9,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[169],we([9,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[170],we([9,10]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[171],we([9,10]),function(J,e){return J.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(ve[172],we([9,10]),function(J,e){return J.create("vs/server/node/serverEnvironmentService",e)}),define(ve[173],we([9,10]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ve[174],we([9,10]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[175],we([9,10]),function(J,e){return J.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(ve[176],we([0,1,7,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class p{constructor(){this._onCloseEmitter=new _.Emitter,this._onReloadEmitter=new _.Emitter,this._onTerminateEmitter=new _.Emitter,this._onAttachEmitter=new _.Emitter}call(R,y,b){switch(y){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(R,y,b){switch(y){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=p,p.ChannelName="extensionhostdebugservice";class k extends t.Disposable{constructor(R){super();this.channel=R}reload(R){this.channel.call("reload",[R])}get onReload(){return this.channel.listen("reload")}close(R){this.channel.call("close",[R])}get onClose(){return this.channel.listen("close")}attachSession(R,y,b){this.channel.call("attach",[R,y,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(R,y){this.channel.call("terminate",[R,y])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(R,y){return this.channel.call("openExtensionDevelopmentHostWindow",[R,y])}}e.ExtensionHostDebugChannelClient=k}),define(ve[177],we([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(D){this.service=D}listen(D,R,y){throw new Error("Invalid listen")}call(D,R,y){switch(R){case"download":return this.service.download(_.URI.revive(y[0]),_.URI.revive(y[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class p{constructor(D,R){this.channel=D,this.getUriTransformer=R}async download(D,R){const y=this.getUriTransformer();y&&(D=y.transformOutgoingURI(D),R=y.transformOutgoingURI(R)),await this.channel.call("download",[D,R])}}e.DownloadServiceChannelClient=p}),define(ve[178],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var _;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var t;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var p;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(p=e.EditorOpenContext||(e.EditorOpenContext={}));var k;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(k=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[179],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class _{constructor(p){this.machineId=p}encryption(){return new Promise((p,k)=>J(["vscode-encrypt"],p,k))}async encrypt(p){try{return(await this.encryption()).encrypt(this.machineId,p)}catch{return p}}async decrypt(p){try{return(await this.encryption()).decrypt(this.machineId,p)}catch{return p}}}e.EncryptionMainService=_}),define(ve[87],we([0,1,144,73,8,4,24,22,5]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(d,g,S){this._args=d,this.paths=g,this.productService=S}get appRoot(){return(0,k.dirname)(p.FileAccess.asFileUri("",J).fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(y.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return y.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return y.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?y.URI.file((0,k.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,k.resolve)(d):(0,k.normalize)((0,k.join)(p.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,k.resolve)(d):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,k.resolve)(d);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const S=D.env.VSCODE_PORTABLE;return S?(0,k.join)(S,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?y.URI.parse(g):y.URI.file((0,k.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?y.URI.parse(d):y.URI.file((0,k.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return y.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Te([t.memoize],b.prototype,"appRoot",null),Te([t.memoize],b.prototype,"userHome",null),Te([t.memoize],b.prototype,"userDataPath",null),Te([t.memoize],b.prototype,"appSettingsHome",null),Te([t.memoize],b.prototype,"tmpDir",null),Te([t.memoize],b.prototype,"cacheHome",null),Te([t.memoize],b.prototype,"userRoamingDataHome",null),Te([t.memoize],b.prototype,"settingsResource",null),Te([t.memoize],b.prototype,"userDataSyncHome",null),Te([t.memoize],b.prototype,"userDataSyncLogResource",null),Te([t.memoize],b.prototype,"sync",null),Te([t.memoize],b.prototype,"machineSettingsResource",null),Te([t.memoize],b.prototype,"globalStorageHome",null),Te([t.memoize],b.prototype,"workspaceStorageHome",null),Te([t.memoize],b.prototype,"keybindingsResource",null),Te([t.memoize],b.prototype,"keyboardLayoutResource",null),Te([t.memoize],b.prototype,"argvResource",null),Te([t.memoize],b.prototype,"snippetsHome",null),Te([t.memoize],b.prototype,"isExtensionDevelopment",null),Te([t.memoize],b.prototype,"untitledWorkspacesHome",null),Te([t.memoize],b.prototype,"installSourcePath",null),Te([t.memoize],b.prototype,"builtinExtensionsPath",null),Te([t.memoize],b.prototype,"extensionsPath",null),Te([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),Te([t.memoize],b.prototype,"extensionDevelopmentKind",null),Te([t.memoize],b.prototype,"extensionTestsLocationURI",null),Te([t.memoize],b.prototype,"debugExtensionHost",null),Te([t.memoize],b.prototype,"serviceMachineIdResource",null),Te([t.memoize],b.prototype,"telemetryLogResource",null),Te([t.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function T(l,d){return v(l["inspect-extensions"],l["inspect-brk-extensions"],5870,d,l.debugId,l.extensionEnvironment)}e.parseExtensionHostPort=T;function A(l,d){return v(l["inspect-search"],l["inspect-brk-search"],5876,d,l.extensionEnvironment)}e.parseSearchPort=A;function h(l,d){return v(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,d,l.extensionEnvironment)}e.parsePtyHostPort=h;function v(l,d,g,S,c,C){const f=Number(d||l)||(S?null:g),s=f?Boolean(!!d):!1;let a;if(C)try{a=JSON.parse(C)}catch{}return{port:f,break:s,debugId:c,env:a}}}),define(ve[53],we([0,1,262,3,152]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,p.localize)(0,null),e:(0,p.localize)(1,null),t:(0,p.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,p.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,p.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,p.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,p.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,p.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,p.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,p.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,p.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,p.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,p.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,p.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,p.localize)(14,null)},category:{type:"string",cat:"e",description:(0,p.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,p.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,p.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,p.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,p.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,p.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,p.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,p.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,p.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,p.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,p.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,p.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,p.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,p.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,p.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,p.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,p.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,p.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(l,d,g=D){const S={},c=[],C=[];for(let a in d){const i=d[a];i.alias&&(S[a]=i.alias),i.type==="string"||i.type==="string[]"?(c.push(a),i.deprecates&&c.push(...i.deprecates)):i.type==="boolean"&&(C.push(a),i.deprecates&&C.push(...i.deprecates))}const w=_(l,{string:c,boolean:C,alias:S}),f={},s=w;f._=w._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(let a in d){const i=d[a];i.alias&&delete s[i.alias];let n=s[a];if(i.deprecates)for(const r of i.deprecates)s.hasOwnProperty(r)&&(n||(n=s[r],n&&g.onDeprecatedOption(r,i.deprecationMessage||(0,p.localize)(33,null))),delete s[r]);typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),g.onMultipleValues(a,n)),f[a]=n,i.deprecationMessage&&g.onDeprecatedOption(a,i.deprecationMessage)),delete s[a]}for(let a in s)g.onUnknownOption(a);return f}e.parseArgs=R;function y(l,d){let g="";return d.args&&(Array.isArray(d.args)?g=` <${d.args.join("> <")}>`:g=` <${d.args}>`),d.alias?`-${d.alias} --${l}${g}`:`--${l}${g}`}function b(l,d){let g=0,S=[];for(const f in l){const s=l[f],a=y(f,s);g=Math.max(g,a.length),S.push([a,s.description])}let c=g+2+1;if(d-c<25)return S.reduce((f,s)=>f.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let C=d-c-1,w=[];for(const f of S){let s=f[0],a=A(f[1],C),i=T(c-s.length-2);w.push("  "+s+i+a[0]);for(let n=1;n<a.length;n++)w.push(T(c)+a[n])}return w}e.formatOptions=b;function T(l){return" ".repeat(l)}function A(l,d){let g=[];for(;l.length;){let S=l.length<d?l.length:l.lastIndexOf(" ",d),c=l.slice(0,S).trim();l=l.slice(S),g.push(c)}return g}function h(l,d,g,S,c){const C=process.stdout.isTTY&&process.stdout.columns||80,w=c?.noInputFiles!==!0?`[${(0,p.localize)(34,null)}...]`:"",f=[`${l} ${g}`];f.push(""),f.push(`${(0,p.localize)(35,null)}: ${d} [${(0,p.localize)(36,null)}]${w}`),f.push(""),c?.noPipe!==!0&&(t.isWindows?f.push((0,p.localize)(37,null,d)):f.push((0,p.localize)(38,null,d)),f.push(""));const s={};for(const a in S){const i=S[a];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[a]=i}}for(let a in s){const i=a;let n=s[i];n&&(f.push(k[i]),f.push(...b(n,C)),f.push(""))}return f.join(`
`)}e.buildHelpMessage=h;function v(l,d){return`${l||(0,p.localize)(39,null)}
${d||(0,p.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=v}),function(){"use strict";function J(e,_,t,p){function k(R){const y=D(R),b=[y];return e.isAbsolute(y)||b.unshift(p),e.resolve(...b)}function D(R){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,t);const T=R["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const A=process.env.USERPROFILE;if(typeof A!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(A,"AppData","Roaming")}break;case"darwin":b=e.join(_.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(_.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,t)}return{getUserDataPath:k}}if(typeof define=="function")define(ve[180],we([0,132,25,8,22,24]),function(e,_,t,p,k,D){const R=k.dirname(p.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(k.joinPath(R,"package.json").fsPath);return J(_,t,y.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),_=require("path"),t=require("os");module.exports=J(_,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[181],we([0,1,25,87,180]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends t.AbstractNativeEnvironmentService{constructor(R,y){super(R,{homeDir:(0,_.homedir)(),tmpDir:(0,_.tmpdir)(),userDataDir:(0,p.getUserDataPath)(R)},y)}}e.NativeEnvironmentService=k}),define(ve[182],we([0,1,20]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function p(k,D){const R=y=>{if(typeof y!="string")return;const b=t.exec(y);if(!b)return;const T=D[b[1]]??y;return typeof T=="string"?T:typeof T.message=="string"?T.message:y};return(0,_.cloneAndChange)(k,R)}e.localizeManifest=p}),define(ve[65],we([0,1,161]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function k(h){return h=h.trim(),h==="*"||t.test(h)}e.isValidVersionStr=k;function D(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=h.match(t);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=D;function R(h){if(!h)return null;let v=h.majorBase,l=h.majorMustEqual,d=h.minorBase,g=h.minorMustEqual,S=h.patchBase,c=h.patchMustEqual;h.hasCaret&&(v===0||(g=!1),c=!1);let C=0;if(h.preRelease){const w=p.exec(h.preRelease);if(w){const[,f,s,a]=w;C=Date.UTC(Number(f),Number(s)-1,Number(a))}}return{majorBase:v,majorMustEqual:l,minorBase:d,minorMustEqual:g,patchBase:S,patchMustEqual:c,isMinimum:h.hasGreaterEquals,notBefore:C}}e.normalizeVersion=R;function y(h,v,l){let d;typeof h=="string"?d=R(D(h)):d=h;let g;v instanceof Date?g=v.getTime():typeof v=="string"&&(g=new Date(v).getTime());let S;if(typeof l=="string"?S=R(D(l)):S=l,!d||!S)return!1;let c=d.majorBase,C=d.minorBase,w=d.patchBase,f=S.majorBase,s=S.minorBase,a=S.patchBase,i=S.notBefore,n=S.majorMustEqual,r=S.minorMustEqual,o=S.patchMustEqual;return S.isMinimum?c>f?!0:c<f?!1:C>s?!0:C<s||g&&g<i?!1:w>=a:(c===1&&f===0&&(!n||!r||!o)&&(f=1,s=0,a=0,n=!0,r=!1,o=!1),c<f?!1:c>f?!n:C<s?!1:C>s?!r:w<a?!1:w>a?!o:!(g&&g<i))}e.isValidVersion=y;function b(h,v,l,d){return l.isBuiltin||typeof l.main=="undefined"?!0:A(h,v,l.engines.vscode,d)}e.isValidExtensionVersion=b;function T(h,v,l){return h==="*"||A(v,l,h)}e.isEngineValid=T;function A(h,v,l,d=[]){let g=R(D(l));if(!g)return d.push(_.localize(0,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return d.push(_.localize(1,null,l)),!1}else if(!g.majorMustEqual)return d.push(_.localize(2,null,l)),!1;return y(h,v,g)?!0:(d.push(_.localize(3,null,h,l)),!1)}}),define(ve[183],we([0,1,15,23]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function p(k,D,R){let y=R&&R.get("storage.serviceMachineId",0)||null;if(y)return y;try{const T=(await D.readFile(k.serviceMachineIdResource)).value.toString();y=(0,t.isUUID)(T)?T:null}catch{y=null}if(!y){y=(0,t.generateUuid)();try{await D.writeFile(k.serviceMachineIdResource,_.VSBuffer.fromString(y))}catch{}}return R&&R.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=p}),define(ve[54],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class _{constructor(p,k=[],D=!1){this.ctor=p,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=_}),define(ve[184],we([0,1,54]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function p(D,R,y){R instanceof _.SyncDescriptor||(R=new _.SyncDescriptor(R,[],y)),t.push([D,R])}e.registerSingleton=p;function k(){return t}e.getSingletonServiceDescriptors=k}),define(ve[185],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=_;class t{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let D of this._nodes.values())D.outgoing.size===0&&k.push(D);return k}insertEdge(k,D){const R=this.lookupOrInsertNode(k),y=this.lookupOrInsertNode(D);R.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(k),R)}removeNode(k){const D=this._hashFn(k);this._nodes.delete(D);for(let R of this._nodes.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(k){const D=this._hashFn(k);let R=this._nodes.get(D);return R||(R=new _(k),this._nodes.set(D,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[D,R]of this._nodes)k.push(`${D}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,D]of this._nodes){const R=new Set([k]),y=this._findCycle(D,R);if(y)return y}}_findCycle(k,D){for(let[R,y]of k.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const b=this._findCycle(y,D);if(b)return b;D.delete(R)}}}e.Graph=t}),define(ve[6],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=R})(_=e._util||(e._util={})),e.IInstantiationService=p("instantiationService");function t(D,R,y,b){R[_.DI_TARGET]===R?R[_.DI_DEPENDENCIES].push({id:D,index:y,optional:b}):(R[_.DI_DEPENDENCIES]=[{id:D,index:y,optional:b}],R[_.DI_TARGET]=R)}function p(D){if(_.serviceIds.has(D))return _.serviceIds.get(D);const R=function(y,b,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(R,y,T,!1)};return R.toString=()=>D,_.serviceIds.set(D,R),R}e.createDecorator=p;function k(D){return D}e.refineServiceDecorator=k}),define(ve[28],we([0,1,12,5,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,p.createDecorator)("configurationService");function k(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationOverrides=k;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||_.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var R;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function b(g,S){const c=Object.create(null);for(let C in g)T(c,C,g[C],S);return c}e.toValuesTree=b;function T(g,S,c,C){const w=S.split("."),f=w.pop();let s=g;for(let a=0;a<w.length;a++){let i=w[a],n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":break;default:C(`Ignoring ${S} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[f]=c}catch{C(`Ignoring ${S} as ${w.join(".")} is ${JSON.stringify(s)}`)}else C(`Ignoring ${S} as ${w.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=T;function A(g,S){const c=S.split(".");h(g,c)}e.removeFromValueTree=A;function h(g,S){const c=S.shift();if(S.length===0){delete g[c];return}if(Object.keys(g).indexOf(c)!==-1){const C=g[c];typeof C=="object"&&!Array.isArray(C)&&(h(C,S),Object.keys(C).length===0&&delete g[c])}}function v(g,S,c){function C(s,a){let i=s;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=S.split("."),f=C(g,w);return typeof f=="undefined"?c:f}e.getConfigurationValue=v;function l(g,S,c){Object.keys(S).forEach(C=>{C!=="__proto__"&&(C in g?_.isObject(g[C])&&_.isObject(S[C])?l(g[C],S[C],c):c&&(g[C]=S[C]):g[C]=S[C])})}e.merge=l;function d(g,S,c){const C=g.inspect(S),w=g.inspect(c);return typeof C.userValue!="undefined"||typeof C.workspaceValue!="undefined"||typeof C.workspaceFolderValue!="undefined"?C.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:C.defaultValue}e.getMigratedSettingValue=d}),define(ve[88],we([0,1,3,18,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",_.isMacintosh),k.set("isLinux",_.isLinux),k.set("isWindows",_.isWindows),k.set("isWeb",_.isWeb),k.set("isMacNative",_.isMacintosh&&!_.isWeb),k.set("isEdge",_.isEdge),k.set("isFirefox",_.isFirefox),k.set("isChrome",_.isChrome),k.set("isSafari",_.isSafari);const D=Object.prototype.hasOwnProperty;var R;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return A.INSTANCE}static true(){return h.INSTANCE}static has(m){return v.create(m)}static equals(m,L){return l.create(m,L)}static notEquals(m,L){return S.create(m,L)}static regex(m,L){return i.create(m,L)}static in(m,L){return d.create(m,L)}static not(m){return c.create(m)}static and(...m){return o.create(m,null)}static or(...m){return u.create(m,null,!0)}static greater(m,L){return w.create(m,L)}static greaterEquals(m,L){return f.create(m,L)}static smaller(m,L){return s.create(m,L)}static smallerEquals(m,L){return a.create(m,L)}static deserialize(m,L=!1){if(!!m)return this._deserializeOrExpression(m,L)}static _deserializeOrExpression(m,L){let M=m.split("||");return u.create(M.map(Q=>this._deserializeAndExpression(Q,L)),null,!0)}static _deserializeAndExpression(m,L){let M=m.split("&&");return o.create(M.map(Q=>this._deserializeOne(Q,L)),null)}static _deserializeOne(m,L){if(m=m.trim(),m.indexOf("!=")>=0){let M=m.split("!=");return S.create(M[0].trim(),this._deserializeValue(M[1],L))}if(m.indexOf("==")>=0){let M=m.split("==");return l.create(M[0].trim(),this._deserializeValue(M[1],L))}if(m.indexOf("=~")>=0){let M=m.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],L))}if(m.indexOf(" in ")>=0){let M=m.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const M=m.split(">=");return f.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const M=m.split(">");return w.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const M=m.split("<=");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const M=m.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(m)?c.create(m.substr(1).trim()):v.create(m)}static _deserializeValue(m,L){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let M=/^'([^']*)'$/.exec(m);return M?M[1].trim():m}static _deserializeRegexValue(m,L){if((0,t.isFalsyOrWhitespace)(m)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=m.indexOf("/"),Q=m.lastIndexOf("/");if(M===Q||M<0){if(L)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let W=m.slice(M+1,Q),q=m[Q+1]==="i"?"i":"";try{return new RegExp(W,q)}catch(ne){if(L)throw new Error(`bad regexp-value '${m}', parse error: ${ne}`);return console.warn(`bad regexp-value '${m}', parse error: ${ne}`),null}}}e.ContextKeyExpr=y;function b(j,m){const L=j?j.substituteConstants():void 0,M=m?m.substituteConstants():void 0;return!L&&!M?!0:!L||!M?!1:L.equals(M)}e.expressionsAreEqualWithConstantSubstitution=b;function T(j,m){return j.cmp(m)}class A{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class h{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class v{constructor(m,L){this.key=m,this.negated=L,this.type=2}static create(m,L=null){const M=k.get(m);return typeof M=="boolean"?M?h.INSTANCE:A.INSTANCE:new v(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:P(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=k.get(this.key);return typeof m=="boolean"?m?h.INSTANCE:A.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class l{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=4}static create(m,L,M=null){if(typeof L=="boolean")return L?v.create(m,M):c.create(m,M);const Q=k.get(m);return typeof Q=="boolean"?L===(Q?"true":"false")?h.INSTANCE:A.INSTANCE:new l(m,L,M)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=k.get(this.key);if(typeof m=="boolean"){const L=m?"true":"false";return this.value===L?h.INSTANCE:A.INSTANCE}return this}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class d{constructor(m,L){this.key=m,this.valueKey=L,this.type=10,this.negated=null}static create(m,L){return new d(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}substituteConstants(){return this}evaluate(m){const L=m.getValue(this.valueKey),M=m.getValue(this.key);return Array.isArray(L)?L.indexOf(M)>=0:typeof M=="string"&&typeof L=="object"&&L!==null?D.call(L,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=d;class g{constructor(m){this._actual=m,this.type=11}static create(m){return new g(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new g(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class S{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=5}static create(m,L,M=null){if(typeof L=="boolean")return L?c.create(m,M):v.create(m,M);const Q=k.get(m);return typeof Q=="boolean"?L===(Q?"true":"false")?A.INSTANCE:h.INSTANCE:new S(m,L,M)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=k.get(this.key);if(typeof m=="boolean"){const L=m?"true":"false";return this.value===L?A.INSTANCE:h.INSTANCE}return this}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class c{constructor(m,L){this.key=m,this.negated=L,this.type=3}static create(m,L=null){const M=k.get(m);return typeof M=="boolean"?M?A.INSTANCE:h.INSTANCE:new c(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:P(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=k.get(this.key);return typeof m=="boolean"?m?A.INSTANCE:h.INSTANCE:this}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=c;function C(j,m){if(typeof j=="string"){const L=parseFloat(j);isNaN(L)||(j=L)}return typeof j=="string"||typeof j=="number"?m(j):A.INSTANCE}class w{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=12}static create(m,L,M=null){return C(L,Q=>new w(m,Q,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=w;class f{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=13}static create(m,L,M=null){return C(L,Q=>new f(m,Q,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class s{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=14}static create(m,L,M=null){return C(L,Q=>new s(m,Q,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class a{constructor(m,L,M){this.key=m,this.value=L,this.negated=M,this.type=15}static create(m,L,M=null){return C(L,Q=>new a(m,Q,M))}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class i{constructor(m,L){this.key=m,this.regexp=L,this.type=7,this.negated=null}static create(m,L){return new i(m,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const L=this.regexp?this.regexp.source:"",M=m.regexp?m.regexp.source:"";return L<M?-1:L>M?1:0}equals(m){if(m.type===this.type){const L=this.regexp?this.regexp.source:"",M=m.regexp?m.regexp.source:"";return this.key===m.key&&L===M}return!1}substituteConstants(){return this}evaluate(m){let L=m.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(m){this._actual=m,this.type=8}static create(m){return new n(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new n(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function r(j){let m=null;for(let L=0,M=j.length;L<M;L++){const Q=j[L].substituteConstants();if(j[L]!==Q&&m===null){m=[];for(let W=0;W<L;W++)m[W]=j[W]}m!==null&&(m[L]=Q)}return m===null?j:m}class o{constructor(m,L){this.expr=m,this.negated=L,this.type=6}static create(m,L){return o._normalizeArr(m,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let L=0,M=this.expr.length;L<M;L++){const Q=T(this.expr[L],m.expr[L]);if(Q!==0)return Q}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let L=0,M=this.expr.length;L<M;L++)if(!this.expr[L].equals(m.expr[L]))return!1;return!0}return!1}substituteConstants(){const m=r(this.expr);return m===this.expr?this:o.create(m,this.negated)}evaluate(m){for(let L=0,M=this.expr.length;L<M;L++)if(!this.expr[L].evaluate(m))return!1;return!0}static _normalizeArr(m,L){const M=[];let Q=!1;for(const W of m)if(!!W){if(W.type===1){Q=!0;continue}if(W.type===0)return A.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&Q)return h.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(T);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const q=M.pop(),ne=M.length===0,B=u.create(W.expr.map(G=>o.create([G,q],null)),null,ne);B&&(M.push(B),M.sort(T))}return M.length===1?M[0]:new o(M,L)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let L of this.expr)m.push(...L.keys());return m}map(m){return new o(this.expr.map(L=>L.map(m)),null)}negate(){if(!this.negated){const m=[];for(let L of this.expr)m.push(L.negate());this.negated=u.create(m,this,!0)}return this.negated}}class u{constructor(m,L){this.expr=m,this.negated=L,this.type=9}static create(m,L,M){return u._normalizeArr(m,L,M)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let L=0,M=this.expr.length;L<M;L++){const Q=T(this.expr[L],m.expr[L]);if(Q!==0)return Q}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let L=0,M=this.expr.length;L<M;L++)if(!this.expr[L].equals(m.expr[L]))return!1;return!0}return!1}substituteConstants(){const m=r(this.expr);return m===this.expr?this:u.create(m,this.negated,!1)}evaluate(m){for(let L=0,M=this.expr.length;L<M;L++)if(this.expr[L].evaluate(m))return!0;return!1}static _normalizeArr(m,L,M){let Q=[],W=!1;if(m){for(let q=0,ne=m.length;q<ne;q++){const B=m[q];if(!!B){if(B.type===0){W=!0;continue}if(B.type===1)return h.INSTANCE;if(B.type===9){Q=Q.concat(B.expr);continue}Q.push(B)}}if(Q.length===0&&W)return A.INSTANCE;Q.sort(T)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let q=1;q<Q.length;q++)Q[q-1].equals(Q[q])&&(Q.splice(q,1),q--);if(Q.length===1)return Q[0];if(M){for(let q=0;q<Q.length;q++)for(let ne=q+1;ne<Q.length;ne++)O(Q[q],Q[ne])&&(Q.splice(ne,1),ne--);if(Q.length===1)return Q[0]}return new u(Q,L)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let L of this.expr)m.push(...L.keys());return m}map(m){return new u(this.expr.map(L=>L.map(m)),null)}negate(){if(!this.negated){let m=[];for(let L of this.expr)m.push(L.negate());for(;m.length>1;){const L=m.shift(),M=m.shift(),Q=[];for(const q of z(L))for(const ne of z(M))Q.push(o.create([q,ne],null));const W=m.length===0;m.unshift(u.create(Q,null,W))}this.negated=m[0]}return this.negated}}class E extends v{constructor(m,L,M){super(m,null);this._defaultValue=L,typeof M=="object"?E._info.push({...M,key:m}):M!==!0&&E._info.push({key:m,description:M,type:L!=null?typeof L:void 0})}static all(){return E._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return l.create(this.key,m)}notEqualsTo(m){return S.create(this.key,m)}}e.RawContextKey=E,E._info=[],e.IContextKeyService=(0,p.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(j,m){return j<m?-1:j>m?1:0}function I(j,m,L,M){return j<L?-1:j>L?1:m<M?-1:m>M?1:0}function O(j,m){if(m.type===6&&j.type!==9&&j.type!==6){for(const Q of m.expr)if(j.equals(Q))return!0}const L=j.negate(),M=z(L).concat(z(m));M.sort(T);for(let Q=0;Q<M.length;Q++){const q=M[Q].negate();for(let ne=Q+1;ne<M.length;ne++){const B=M[ne];if(q.equals(B))return!0}}return!1}e.implies=O;function z(j){return j.type===9?j.expr:[j]}}),define(ve[89],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,_.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,_.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(k,D){return this.secretVault[k]?.[D]??null}async setPassword(k,D,R){this.secretVault[k]=this.secretVault[k]??{},this.secretVault[k][D]=R}async deletePassword(k,D){return this.secretVault[k]?.[D]?(delete this.secretVault[k][D],Object.keys(this.secretVault[k]).length===0&&delete this.secretVault[k],!0):!1}async findPassword(k){return JSON.stringify(this.secretVault[k])??null}async findCredentials(k){const D=[];for(const R of Object.keys(this.secretVault[k]||{}))D.push({account:R,password:this.secretVault[k][R]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ve[186],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,_.createDecorator)(e.ID);function t(p){return!!p.hostName&&!!p.errorMessage}e.isRemoteDiagnosticError=t}),define(ve[66],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,_.createDecorator)("downloadService")}),define(ve[187],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,_.createDecorator)("encryptionMainService")}),define(ve[26],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[16],we([0,1,30,4,18,12,5,163,6]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function b(W){return W.create===!0}e.isFileOpenForWriteOptions=b;var T;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var A;(function(W){W[W.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var h;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=v;function l(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=l;function d(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function g(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=g;function S(W){return v(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var c;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(q,ne){super(q);this.code=ne}}e.FileSystemProviderError=C;function w(W,q){const ne=new C(W.toString(),q);return s(ne,q),ne}e.createFileSystemProviderError=w;function f(W){return W||w((0,R.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=f;function s(W,q){return W.name=q?`${q} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=s;function a(W){if(!W)return c.Unknown;if(W instanceof C)return W.code;const q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!q)return c.Unknown;switch(q[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=a;function i(W){if(W instanceof P)return W.fileOperationResult;switch(a(W)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var n;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(q,ne,B){this.resource=q,this.operation=ne,this.target=B}isOperation(q){return this.operation===q}}e.FileOperationEvent=r;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class u{constructor(q,ne){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=q;const B=new Map;for(const G of q){const ee=B.get(G.type);switch(ee?ee.push([G.resource,G]):B.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,ee]of B)switch(G){case 1:this.added=_.TernarySearchTree.forUris(()=>ne),this.added.fill(ee);break;case 0:this.updated=_.TernarySearchTree.forUris(()=>ne),this.updated.fill(ee);break;case 2:this.deleted=_.TernarySearchTree.forUris(()=>ne),this.deleted.fill(ee);break}}contains(q,...ne){return this.doContains(q,{includeChildren:!1},...ne)}affects(q,...ne){return this.doContains(q,{includeChildren:!0},...ne)}doContains(q,ne,...B){if(!q)return!1;const G=B.length>0;return!!((!G||B.includes(1))&&(this.added?.get(q)||ne.includeChildren&&this.added?.findSuperstr(q))||(!G||B.includes(0))&&(this.updated?.get(q)||ne.includeChildren&&this.updated?.findSuperstr(q))||(!G||B.includes(2))&&(this.deleted?.findSubstr(q)||ne.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function E(W,q,ne){return!W||!q||W===q||q.length>W.length?!1:(q.charAt(q.length-1)!==t.sep&&(q+=t.sep),ne?(0,p.startsWithIgnoreCase)(W,q):W.indexOf(q)===0)}e.isParent=E;class P extends Error{constructor(q,ne,B){super(q);this.fileOperationResult=ne,this.options=B}}e.FileOperationError=P;class I extends P{constructor(q,ne,B){super(q,2,B);this.stat=ne}}e.NotModifiedSinceFileOperationError=I;var O;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var z;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=j;async function m(W,q){if(!q.hasProvider(D.URI.from({scheme:W.scheme})))return new Promise(ne=>{const B=q.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===W.scheme&&G.added&&(B.dispose(),ne())})})}e.whenProviderRegistered=m,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(q){return(0,k.isNumber)(q)||(q=0),q<L.KB?(0,R.localize)(1,null,q.toFixed(0)):q<L.MB?(0,R.localize)(2,null,(q/L.KB).toFixed(2)):q<L.GB?(0,R.localize)(3,null,(q/L.MB).toFixed(2)):q<L.TB?(0,R.localize)(4,null,(q/L.GB).toFixed(2)):(0,R.localize)(5,null,(q/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var M;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function Q(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=Q}),define(ve[188],we([0,1,263,153,53,16]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function D(h,v){const l={onUnknownOption:g=>{console.warn((0,t.localize)(0,null,g))},onMultipleValues:(g,S)=>{console.warn((0,t.localize)(1,null,g,S))},onDeprecatedOption:(g,S)=>{console.warn((0,t.localize)(2,null,g,S))}},d=(0,p.parseArgs)(h,p.OPTIONS,v?l:void 0);return d.goto&&d._.forEach(g=>_(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,t.localize)(3,null))),d["max-memory"]&&_(parseInt(d["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function R(h){const v=h.findIndex(l=>!/^-/.test(l));if(v>-1)return[...h.slice(0,v),...h.slice(v+1)]}function y(h){let[,...v]=h;process.env.VSCODE_DEV&&(v=R(v)||[]);const l=!A(process.env);return D(v,l)}e.parseMainProcessArgv=y;function b(h){const[,,...v]=h;return D(v,!0)}e.parseCLIProcessArgv=b;function T(h,...v){const l=h.indexOf("--");return l===-1?h.push(...v):h.splice(l,0,...v),h}e.addArg=T;function A(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=A}),define(ve[67],we([0,1,39,4,154,21,36,11,3,23,149,188,13]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let l;async function d(S,c,C){return c["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,A.isLaunchedFromCli)(C)&&!c["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,A.isLaunchedFromCli)(C)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=h.Promises.withAsyncBody(async(w,f)=>{const s=new k.CancellationTokenSource,a=setTimeout(()=>{s.dispose(!0),f(new Error((0,p.localize)(0,null)))},v);try{w(await g(S,s.token))}catch(i){!(0,R.isCancellationError)(i)&&!s.token.isCancellationRequested?f(new Error((0,p.localize)(1,null,(0,D.toErrorMessage)(i)))):w({})}finally{clearTimeout(a),s.dispose()}})),l)}e.getResolvedShellEnv=d;async function g(S,c){const C=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",C);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",w);const f=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(f+"(.*)"+f),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};S.trace("getUnixShellEnvironment#env",a);const i=await(0,T.getSystemShell)(y.OS,a);return S.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(c.isCancellationRequested)return r((0,R.canceled)());const o=(0,t.basename)(i);let u,E;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${P} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,E=["-Login","-Command"]):(u=`'${process.execPath}' ${P} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,o==="tcsh"?E=["-ic"]:E=["-ilc"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),u);const I=(0,_.spawn)(i,[...E,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});c.onCancellationRequested(()=>(I.kill(),r((0,R.canceled)()))),I.on("error",j=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(j)),r(j)});const O=[];I.stdout.on("data",j=>O.push(j));const z=[];I.stderr.on("data",j=>z.push(j)),I.on("close",(j,m)=>{const L=Buffer.concat(O).toString("utf8");S.trace("getUnixShellEnvironment#raw",L);const M=Buffer.concat(z).toString("utf8");if(M.trim()&&S.trace("getUnixShellEnvironment#stderr",M),j||m)return r(new Error((0,p.localize)(2,null,j,m)));const Q=s.exec(L),W=Q?Q[1]:"{}";try{const q=JSON.parse(W);C?q.ELECTRON_RUN_AS_NODE=C:delete q.ELECTRON_RUN_AS_NODE,w?q.ELECTRON_NO_ATTACH_CONSOLE=w:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){S.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(q)),r(q)}})})}}),define(ve[189],we([0,1,15,36,11,7,2,43,5,23,16]),function(J,e,_,t,p,k,D,R,y,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class A extends D.Disposable{constructor(v,l){super();this.channel=v,this.extraCapabilities=l,this.onDidChangeCapabilities=k.Event.None,this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,l){const{buffer:d}=await this.channel.call("readFile",[v,l]);return d}readFileStream(v,l,d){const g=(0,R.newWriteableStream)(c=>_.VSBuffer.concat(c.map(C=>_.VSBuffer.wrap(C))).buffer),S=this.channel.listen("readFileStream",[v,l])(c=>{if(c instanceof _.VSBuffer)g.write(c.buffer);else{if(c==="end")g.end();else{let C=c;C instanceof Error||(C=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(C),T.FileSystemProviderErrorCode.Unknown)),g.error(C),g.end()}S.dispose()}});return d.onCancellationRequested(()=>{g.error((0,p.canceled)()),g.end(),S.dispose()}),g}writeFile(v,l,d){return this.channel.call("writeFile",[v,_.VSBuffer.wrap(l),d])}open(v,l){return this.channel.call("open",[v,l])}close(v){return this.channel.call("close",[v])}async read(v,l,d,g,S){const[c,C]=await this.channel.call("read",[v,l,S]);return d.set(c.buffer.slice(0,C),g),C}write(v,l,d,g,S){return this.channel.call("write",[v,l,_.VSBuffer.wrap(d),g,S])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,l){return this.channel.call("delete",[v,l])}rename(v,l,d){return this.channel.call("rename",[v,l,d])}copy(v,l,d){return this.channel.call("copy",[v,l,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const l=v;this._onDidChange.fire(l.map(d=>({resource:y.URI.revive(d.resource),type:d.type})))}else{const l=v;this._onDidWatchError.fire(l)}}))}watch(v,l){const d=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,d,v,l]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=A}),define(ve[90],we([0,1,15,11,164,16]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(T,A,h,v,l,d){let g;try{await R(T,A,h,v,l,d)}catch(S){g=S}finally{g&&l.errorTransformer&&(g=l.errorTransformer(g)),typeof g!="undefined"&&h.error(g),h.end()}}e.readFileIntoStream=D;async function R(T,A,h,v,l,d){y(d);const g=await T.open(A,{create:!1});try{y(d);let S=0,c=0,C=l&&typeof l.length=="number"?l.length:void 0,w=_.VSBuffer.alloc(Math.min(l.bufferSize,typeof C=="number"?C:l.bufferSize)),f=l&&typeof l.position=="number"?l.position:0,s=0;do c=await T.read(g,f,w.buffer,s,w.byteLength-s),f+=c,s+=c,S+=c,typeof C=="number"&&(C-=c),s===w.byteLength&&(await h.write(v(w)),w=_.VSBuffer.alloc(Math.min(l.bufferSize,typeof C=="number"?C:l.bufferSize)),s=0);while(c>0&&(typeof C!="number"||C>0)&&y(d)&&b(S,l));if(s>0){let a=s;typeof C=="number"&&(a=Math.min(s,C)),h.write(v(w.slice(0,a)))}}catch(S){throw(0,k.ensureFileSystemProviderError)(S)}finally{await T.close(g)}}function y(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function b(T,A){if(A?.limits){if(typeof A.limits.memory=="number"&&T>A.limits.memory)throw(0,k.createFileSystemProviderError)((0,p.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof A.limits.size=="number"&&T>A.limits.size)throw(0,k.createFileSystemProviderError)((0,p.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[55],we([0,1,2,3,5,16]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function D(v){return v.recursive===!0}e.isRecursiveWatchRequest=D;class R extends _.Disposable{constructor(l,d,g,S){super();this.onFileChanges=l,this.onLogMessage=d,this.verboseLogging=g,this.options=S,this.watcherDisposables=this._register(new _.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new _.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),l.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),l.add(this.watcher.onDidError(d=>this.onError(d)))}onError(l){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${l}`):this.error(l)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class y extends R{constructor(l,d,g){super(l,d,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class b extends R{constructor(l,d,g){super(l,d,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function T(v){return v.map(l=>({type:l.type,resource:p.URI.file(l.path)}))}e.toFileChanges=T;function A(v){const l=new h;for(const d of v)l.processEvent(d);return l.coalesce()}e.coalesceEvents=A;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return t.isLinux?l.path:l.path.toLowerCase()}processEvent(l){const d=this.mapPathToChange.get(this.toKey(l));let g=!1;if(d){const S=d.type,c=l.type;d.path!==l.path&&(l.type===2||l.type===1)?g=!0:S===1&&c===2?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(d)):S===2&&c===1?d.type=0:S===1&&c===0||(d.type=c)}else g=!0;g&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],d=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(l.push(g),!1):!0).sort((g,S)=>g.path.length-S.path.length).filter(g=>d.some(S=>(0,k.isParent)(g.path,S,!t.isLinux))?!1:(d.push(g.path),!0)).concat(l)}}}),define(ve[190],we([0,1,27,13,21,31,60,2,77,4,3,135,19,55]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class l extends R.Disposable{constructor(S,c,C,w){super();this.request=S,this.onDidFilesChange=c,this.onLogMessage=C,this.verboseLogging=w,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(l.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(f=>(0,D.parse)(f)),this.cts=new p.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const S=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const c=await h.Promises.stat(S);this._register(await this.doWatch(S,c.isDirectory()))}catch(S){S.code!=="ENOENT"?this.error(S):this.trace(S)}}async normalizePath(S){let c=S.path;try{c=await h.Promises.realpath(S.path),S.path===c&&(c=await(0,A.realcase)(S.path)??S.path),S.path!==c&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${S.path}, real: ${c})`)}catch{}return c}async doWatch(S,c){if(T.isMacintosh&&(0,k.isEqualOrParent)(S,"/Volumes/",!0))return this.error(`Refusing to watch ${S} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const C=new p.CancellationTokenSource(this.cts.token);let w=new R.DisposableStore;try{const f=(0,b.basename)(S),s=(0,_.watch)(S);w.add((0,R.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${S}'`);const a=new Set;if(c)try{for(const n of await h.Promises.readdir(S))a.add(n)}catch(n){this.error(n)}const i=new Map;w.add((0,R.toDisposable)(()=>{for(const[,n]of i)n.dispose();i.clear()})),s.on("error",(n,r)=>{this.error(`Failed to watch ${S} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),s.on("change",(n,r)=>{if(C.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let o="";if(r&&(o=r.toString(),T.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(c)if(n==="rename"){i.get(o)?.dispose();const u=setTimeout(async()=>{if(i.delete(o),o===f&&!await h.Promises.exists(S)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.existsChildStrictCase((0,b.join)(S,o));if(C.token.isCancellationRequested)return;let P;E?a.has(o)?P=0:(P=1,a.add(o)):(a.delete(o),P=2),this.onFileChange({path:(0,b.join)(this.request.path,o),type:P})},l.FILE_DELETE_HANDLER_DELAY);i.set(o,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let u;a.has(o)?u=0:(u=1,a.add(o)),this.onFileChange({path:(0,b.join)(this.request.path,o),type:u})}else if(n==="rename"||o!==f){const u=setTimeout(async()=>{const E=await h.Promises.exists(S);C.token.isCancellationRequested||(E?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(S,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},l.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,R.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await h.Promises.exists(S)&&!C.token.isCancellationRequested&&this.error(`Failed to watch ${S} for changes using fs.watch() (${f.toString()})`)}return(0,R.toDisposable)(()=>{C.dispose(!0),w.dispose()})}async onFileChange(S,c=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`),!c&&this.excludes.some(C=>C(S.path))?this.verboseLogging&&this.trace(` >> ignored ${S.path}`):this.fileChangesBuffer.push(S);try{await this.fileChangesDelayer.trigger(async()=>{const C=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,v.coalesceEvents)(C);if(w.length>0){if(this.verboseLogging)for(const s of w)this.trace(`>> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`);this.throttledFileChangesWorker.work(w)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(S){if(T.isLinux)return h.Promises.exists(S);try{const c=(0,b.basename)(S);return(await h.Promises.readdir((0,b.dirname)(S))).some(w=>w===c)}catch(c){return this.trace(c),!1}}setVerboseLogging(S){this.verboseLogging=S}error(S){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${S}`})}warn(S){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${S}`})}trace(S){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${S}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=l,l.FILE_DELETE_HANDLER_DELAY=100,l.FILE_CHANGES_HANDLER_DELAY=50;async function d(g,S,c,C,w=512){const f=await h.Promises.open(g,"r"),s=Buffer.allocUnsafe(w),a=new p.CancellationTokenSource(C);let i,n=!1;const r={path:g,excludes:[],recursive:!1},o=new l(r,u=>{(async()=>{for(const{type:E}of u)if(E===0){if(n)return;n=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:P}=await h.Promises.read(f,s,0,w,null);if(!P||a.token.isCancellationRequested)break;S(s.slice(0,P))}}catch(P){i=new Error(P),a.dispose(!0)}finally{n=!1}}})()});return await o.ready,c(),new Promise((u,E)=>{a.token.onCancellationRequested(async()=>{o.dispose();try{await h.Promises.close(f)}catch(P){i=new Error(P)}i?E(i):u()})})}e.watchFileContents=d}),define(ve[191],we([0,1,17,7,2,3,190]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends p.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const T=this.normalizeRequests(b),A=T.filter(v=>{const l=this.watchers.get(v.path);return l?!(0,_.equals)(l.request.excludes,v.excludes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!T.find(l=>l.path===v.path&&(0,_.equals)(l.excludes,v.excludes))).map(({request:v})=>v.path);A.length&&this.trace(`Request to start watching: ${A.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of A)this.startWatching(v)}startWatching(b){const T=new D.NodeJSFileWatcherLibrary(b,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),A={request:b,instance:T};this.watchers.set(b.path,A)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const T=this.watchers.get(b);T&&(this.watchers.delete(b),T.instance.dispose())}normalizeRequests(b){const T=new Map;for(const A of b){const h=k.isLinux?A.path:A.path.toLowerCase();T.set(h,A)}return Array.from(T.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,T]of this.watchers)T.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,T){return T?`[File Watcher (node.js)] ${b} (path: ${T.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=R}),define(ve[192],we([0,1,55,191]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class p extends _.AbstractNonRecursiveWatcherClient{constructor(D,R,y){super(D,R,y);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=p}),define(ve[193],we([0,1,8,40,86,55]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends k.AbstractUniversalWatcherClient{constructor(y,b,T){super(y,b,T);this.init()}createWatcher(y){const b=y.add(new p.Client(_.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(b.onDidProcessExit(({code:T,signal:A})=>this.onError(`terminated by itself with code ${T}, signal: ${A}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ve[68],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...p){this._entries=new Map;for(let[k,D]of p)this.set(k,D)}set(p,k){const D=this._entries.get(p);return this._entries.set(p,k),D}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=_}),define(ve[91],we([0,1,13,11,54,185,6,68]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class b extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class T{constructor(l=new R.ServiceCollection,d=!1,g){this._activeInstantiations=new Set,this._services=l,this._strict=d,this._parent=g,this._services.set(D.IInstantiationService,this)}createChild(l){return new T(l,this._strict,this)}invokeFunction(l,...d){let g=h.traceInvocation(l),S=!1;try{return l({get:C=>{if(S)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const w=this._getOrCreateServiceInstance(C,g);if(!w)throw new Error(`[invokeFunction] unknown service '${C}'`);return w}},...d)}finally{S=!0,g.stop()}}createInstance(l,...d){let g,S;return l instanceof p.SyncDescriptor?(g=h.traceCreation(l.ctor),S=this._createInstance(l.ctor,l.staticArguments.concat(d),g)):(g=h.traceCreation(l),S=this._createInstance(l,d,g)),g.stop(),S}_createInstance(l,d=[],g){let S=D._util.getServiceDependencies(l).sort((w,f)=>w.index-f.index),c=[];for(const w of S){let f=this._getOrCreateServiceInstance(w.id,g);if(!f&&this._strict&&!w.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${w.id}.`);c.push(f)}let C=S.length>0?S[0].index:d.length;if(d.length!==C){console.warn(`[createInstance] First service dependency of ${l.name} at position ${C+1} conflicts with ${d.length} static arguments`);let w=C-d.length;w>0?d=d.concat(new Array(w)):d=d.slice(0,C)}return new l(...[...d,...c])}_setServiceInstance(l,d){if(this._services.get(l)instanceof p.SyncDescriptor)this._services.set(l,d);else if(this._parent)this._parent._setServiceInstance(l,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let d=this._services.get(l);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):d}_getOrCreateServiceInstance(l,d){let g=this._getServiceInstanceOrDescriptor(l);return g instanceof p.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,g,d.branch(l,!0)):(d.branch(l,!1),g)}_safeCreateAndCacheServiceInstance(l,d,g){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,d,g)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,d,g){const S=new k.Graph(w=>w.id.toString());let c=0;const C=[{id:l,desc:d,_trace:g}];for(;C.length;){const w=C.pop();if(S.lookupOrInsertNode(w),c++>1e3)throw new b(S);for(let f of D._util.getServiceDependencies(w.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(f.id);if(!s&&!f.optional&&console.warn(`[createInstance] ${l} depends on ${f.id} which is NOT registered.`),s instanceof p.SyncDescriptor){const a={id:f.id,desc:s,_trace:w._trace.branch(f.id,!0)};S.insertEdge(w,a),C.push(a)}}}for(;;){const w=S.roots();if(w.length===0){if(!S.isEmpty())throw new b(S);break}for(const{data:f}of w){if(this._getServiceInstanceOrDescriptor(f.id)instanceof p.SyncDescriptor){const a=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,a)}S.removeNode(f)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,d,g=[],S,c){if(this._services.get(l)instanceof p.SyncDescriptor)return this._createServiceInstance(d,g,S,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,d,g,S,c);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(l,d=[],g,S){if(g){const c=new _.IdleValue(()=>this._createInstance(l,d,S));return new Proxy(Object.create(null),{get(C,w){if(w in C)return C[w];let f=c.value,s=f[w];return typeof s!="function"||(s=s.bind(f),C[w]=s),s},set(C,w,f){return c.value[w]=f,!0}})}else return this._createInstance(l,d,S)}}e.InstantiationService=T;var A;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(A||(A={}));class h{constructor(l,d){this.type=l,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return y?new h(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(l){return y?new h(0,l.name):h._None}branch(l,d){let g=new h(2,l.toString());return this._dep.push([l,d,g]),g}stop(){let l=Date.now()-this._start;h._totals+=l;let d=!1;function g(c,C){let w=[],f=new Array(c+1).join("	");for(const[s,a,i]of C._dep)if(a&&i){d=!0,w.push(`${f}CREATES -> ${s}`);let n=g(c+1,i);n&&w.push(n)}else w.push(`${f}uses -> ${s}`);return w.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(l>2||d)&&console.log(S.join(`
`))}}e.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ve[194],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,_.createDecorator)("labelService")}),define(ve[69],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,_.createDecorator)("localizationsService");function t(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const k of p.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}e.isValidLocalization=t}),define(ve[14],we([0,1,36,7,2,3,6]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function R(){return new Date().toISOString()}var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function b(a,i,n){switch(i){case y.Trace:a.trace(n);break;case y.Debug:a.debug(n);break;case y.Info:a.info(n);break;case y.Warning:a.warn(n);break;case y.Error:a.error(n);break;case y.Critical:a.critical(n);break;default:throw new Error("Invalid log level")}}e.log=b;function T(a){let i="";for(let n=0;n<a.length;n++){let r=a[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(n>0?" ":"")+r}return i}e.format=T;class A extends p.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class h extends A{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,T([i,...n]))}debug(i,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,T([i,...n]))}info(i,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,T([i,...n]))}warn(i,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,T([i,...n]))}error(i,...n){if(this.checkLogLevel(y.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(y.Error,T(r))}else this.log(y.Error,T([i,...n]))}critical(i,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,T([i,...n]))}flush(){}}e.AbstractMessageLogger=h;class v extends A{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!k.isWindows}trace(i,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...n):console.log(`[main ${R()}]`,i,...n))}debug(i,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...n):console.log(`[main ${R()}]`,i,...n))}info(i,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...n):console.log(`[main ${R()}]`,i,...n))}warn(i,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...n):console.warn(`[main ${R()}]`,i,...n))}error(i,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...n):console.error(`[main ${R()}]`,i,...n))}critical(i,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...n):console.error(`[main ${R()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class l extends A{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=l;class d extends A{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,_.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class g extends A{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const r of this.logServices)r.trace(i,...n)}debug(i,...n){for(const r of this.logServices)r.debug(i,...n)}info(i,...n){for(const r of this.logServices)r.info(i,...n)}warn(i,...n){for(const r of this.logServices)r.warn(i,...n)}error(i,...n){for(const r of this.logServices)r.error(i,...n)}critical(i,...n){for(const r of this.logServices)r.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=g;class S extends p.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=S;class c extends p.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,n?.always?y.Trace:this.logLevel,n),this.loggers.set(i.toString(),r),n?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=c;class C{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=C;function w(a){if(a.verbose)return y.Trace;if(typeof a.logLevel=="string"){const i=f(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function f(a){switch(a){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=f;function s(a){switch(a){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=s});var Ne=this&&this.__param||function(J,e){return function(_,t){e(_,t,J)}};define(ve[195],we([0,1,39,13,36,7,2,8,4,19,26,14]),function(J,e,_,t,p,k,D,R,y,b,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends D.Disposable{constructor(l,d){super();this.environmentService=l,this.logService=d,this.processesLimiter=new t.Limiter(5)}async postUninstall(l){const d=this.parseScript(l,"uninstall");return d&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${g}`)))),b.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(l,d){const g=`vscode:${d}`;if(l.location.scheme===R.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[g]=="string"){const S=l.manifest.scripts[g].split(" ");return S.length<2||S[0]!=="node"||!S[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${g} should be a node script`),null):{script:(0,y.join)(l.location.fsPath,S[1]),args:S.slice(2)||[]}}return null}runLifecycleHook(l,d,g,S,c){return new Promise((C,w)=>{const f=this.start(l,d,g,c);let s;const a=i=>{s&&(clearTimeout(s),s=null),i?w(i):C(void 0)};f.on("error",i=>{a((0,p.toErrorMessage)(i)||"Unknown")}),f.on("exit",(i,n)=>{a(i?`post-${d} process exited with code ${i}`:void 0)}),S&&(s=setTimeout(()=>{s=null,f.kill(),w("timed out")},5e3))})}start(l,d,g,S){const c={silent:!0,execArgv:void 0},C=(0,_.fork)(l,[`--type=extension-post-${d}`,...g],c);C.stdout.setEncoding("utf8"),C.stderr.setEncoding("utf8");const w=k.Event.fromNodeEventEmitter(C.stdout,"data"),f=k.Event.fromNodeEventEmitter(C.stderr,"data");w(i=>this.logService.info(S.identifier.id,S.manifest.version,`post-${d}`,i)),f(i=>this.logService.error(S.identifier.id,S.manifest.version,`post-${d}`,i));const s=k.Event.any(k.Event.map(w,i=>({data:`%c${i}`,format:[""]})),k.Event.map(f,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(s,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(S.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),C}getExtensionStoragePath(l){return(0,y.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};h=Te([Ne(0,T.IEnvironmentService),Ne(1,A.ILogService)],h),e.ExtensionsLifecycle=h}),define(ve[196],we([0,1,17,13,11,7,2,4,55,14]),function(J,e,_,t,p,k,D,R,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends D.Disposable{constructor(h,v){super();this.logService=h,this.options=v,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const l={path:this.toFilePath(h),excludes:v.excludes,recursive:v.recursive},d=(0,_.insert)(this.universalPathsToWatch,l);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,p.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,y.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const l={path:this.toFilePath(h),excludes:v.excludes,recursive:!1},d=(0,_.insert)(this.nonRecursivePathsToWatch,l);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,p.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,y.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,R.normalize)(h.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ve[92],we([0,1,17,13,15,21,7,127,51,2,30,8,44,22,43,162,16,90,14]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends b.Disposable{constructor(f){super();this.logService=f,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(f,s){if(this.provider.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${f}`);const a=new b.DisposableStore;return this.provider.set(f,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:f,provider:s}),a.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new g.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&a.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),a.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:f}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:f,provider:s}),this.provider.delete(f),(0,b.dispose)(a)})}getProvider(f){return this.provider.get(f)}async activateProvider(f){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:f,join(a){s.push(a)}}),!this.provider.has(f)&&await t.Promises.settled(s)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.provider.has(f.scheme)}hasCapability(f,s){const a=this.provider.get(f.scheme);return!!(a&&a.capabilities&s)}listCapabilities(){return y.Iterable.map(this.provider,([f,s])=>({scheme:f,capabilities:s.capabilities}))}async withProvider(f){if(!(0,v.isAbsolutePath)(f))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(f)),8);await this.activateProvider(f.scheme);const s=this.provider.get(f.scheme);if(!s){const a=new Error;throw a.name="ENOPRO",a.message=(0,d.localize)(1,null,f.toString()),a}return s}async withReadProvider(f){const s=await this.withProvider(f);if((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)||(0,g.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(f){const s=await this.withProvider(f);if((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,s){try{return await this.doResolveFile(f,s)}catch(a){throw(0,g.toFileSystemProviderErrorCode)(a)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(f)),1):(0,g.ensureFileSystemProviderError)(a)}}async doResolveFile(f,s){const a=await this.withProvider(f),i=this.isPathCaseSensitive(a),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,u=await a.stat(f);let E;return this.toFileStat(a,f,u,void 0,!!o,(P,I)=>(E||(E=T.TernarySearchTree.forUris(()=>!i),E.set(f,!0),n&&E.fill(!0,n)),E.get(P.resource)||E.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&r?I===1:!1))}async toFileStat(f,s,a,i,n,r){const{providerExtUri:o}=this.getExtUri(f),u={resource:s,name:o.basename(s),isFile:(a.type&g.FileType.File)!=0,isDirectory:(a.type&g.FileType.Directory)!=0,isSymbolicLink:(a.type&g.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&g.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,g.etag)({mtime:a.mtime,size:a.size})};if(u.isDirectory&&r(u,i)){try{const E=await f.readdir(s),P=await t.Promises.settled(E.map(async([I,O])=>{try{const z=o.joinPath(s,I),j=n?await f.stat(z):{type:O};return await this.toFileStat(f,z,j,E.length,n,r)}catch(z){return this.logService.trace(z),null}}));u.children=(0,_.coalesce)(P)}catch(E){this.logService.trace(E),u.children=[]}return u}return u}async resolveAll(f){return t.Promises.settled(f.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(f){const s=await this.withProvider(f);try{return!!await s.stat(f)}catch{return!1}}async canCreateFile(f,s){try{await this.doValidateCreateFile(f,s)}catch(a){return a}return!0}async doValidateCreateFile(f,s){if(!s?.overwrite&&await this.exists(f))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(f)),3,s)}async createFile(f,s=p.VSBuffer.fromString(""),a){await this.doValidateCreateFile(f,a);const i=await this.writeFile(f,s);return this._onDidRunOperation.fire(new g.FileOperationEvent(f,0,i)),i}async writeFile(f,s,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,f,a)||await this.mkdirp(i,n.dirname(f));let o;if((0,g.hasReadWriteCapability)(i)&&!(s instanceof p.VSBuffer))if((0,l.isReadableStream)(s)){const u=await(0,l.peekStream)(s,3);u.ended?o=p.VSBuffer.concat(u.buffer):o=u}else o=(0,l.peekReadable)(s,u=>p.VSBuffer.concat(u),3);else o=s;!(0,g.hasOpenReadWriteCloseCapability)(i)||(0,g.hasReadWriteCapability)(i)&&o instanceof p.VSBuffer?await this.doWriteUnbuffered(i,f,a,o):await this.doWriteBuffered(i,f,a,o instanceof p.VSBuffer?(0,p.bufferToReadable)(o):o)}catch(r){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(f),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),a)}return this.resolve(f,{resolveMetadata:!0})}async validateWriteFile(f,s,a){if(!!a?.unlock&&!(f.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(s)));let n;try{n=await f.stat(s)}catch{return}if((n.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(s)),0,a);if(this.throwIfFileIsReadonly(s,n),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==g.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&a.mtime<n.mtime&&a.etag!==(0,g.etag)({mtime:a.mtime,size:n.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,a);return n}async readFile(f,s,a){const i=await this.withReadProvider(f);return s?.atomic?this.doReadFileAtomic(i,f,s,a):this.doReadFile(i,f,s,a)}async doReadFileAtomic(f,s,a,i){return new Promise((n,r)=>{this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(f,s,a,i);n(o)}catch(o){r(o)}})})}async doReadFile(f,s,a,i){const n=await this.doReadFileStream(f,s,{...a,preferUnbuffered:!0},i);return{...n,value:await(0,p.streamToBuffer)(n.value)}}async readFileStream(f,s,a){const i=await this.withReadProvider(f);return this.doReadFileStream(i,f,s,a)}async doReadFileStream(f,s,a,i){const n=new k.CancellationTokenSource(i),r=this.validateReadFile(s,a).then(u=>u,u=>{throw n.cancel(),u});let o;try{return typeof a?.etag=="string"&&a.etag!==g.ETAG_DISABLED&&await r,a?.atomic&&(0,g.hasFileAtomicReadCapability)(f)||!((0,g.hasOpenReadWriteCloseCapability)(f)||(0,g.hasFileReadStreamCapability)(f))||(0,g.hasReadWriteCapability)(f)&&a?.preferUnbuffered?o=this.readFileUnbuffered(f,s,a):(0,g.hasFileReadStreamCapability)(f)?o=this.readFileStreamed(f,s,n.token,a):o=this.readFileBuffered(f,s,n.token,a),{...await r,value:o}}catch(u){o&&await(0,l.consumeStream)(o);const E=(0,d.localize)(8,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(u).toString());throw u instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(E,u.stat,a):new g.FileOperationError(E,(0,g.toFileOperationResult)(u),a)}}readFileStreamed(f,s,a,i=Object.create(null)){const n=f.readFileStream(s,i,a);return(0,l.transform)(n,{data:r=>r instanceof p.VSBuffer?r:p.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),i)},r=>p.VSBuffer.concat(r))}readFileBuffered(f,s,a,i=Object.create(null)){const n=(0,p.newWriteableBufferStream)();return(0,S.readFileIntoStream)(f,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),i)},a),n}readFileUnbuffered(f,s,a){const i=(0,l.newWriteableStream)(n=>p.VSBuffer.concat(n));return(async()=>{try{let n;a?.atomic&&(0,g.hasFileAtomicReadCapability)(f)?n=await f.readFile(s,{atomic:!0}):n=await f.readFile(s),typeof a?.position=="number"&&(n=n.slice(a.position)),typeof a?.length=="number"&&(n=n.slice(0,a.length)),this.validateReadFileLimits(s,n.byteLength,a),i.end(p.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(f,s){const a=await this.resolve(f,{resolveMetadata:!0});if(a.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(f)),0,s);if(typeof s?.etag=="string"&&s.etag!==g.ETAG_DISABLED&&s.etag===a.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),a,s);return this.validateReadFileLimits(f,a.size,s),a}validateReadFileLimits(f,s,a){if(a?.limits){let i;if(typeof a.limits.memory=="number"&&s>a.limits.memory&&(i=9),typeof a.limits.size=="number"&&s>a.limits.size&&(i=7),typeof i=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(f)),i)}}async canMove(f,s,a){return this.doCanMoveCopy(f,s,"move",a)}async canCopy(f,s,a){return this.doCanMoveCopy(f,s,"copy",a)}async doCanMoveCopy(f,s,a,i){if(f.toString()!==s.toString())try{const n=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f):await this.withReadProvider(f),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,f,r,s,a,i)}catch(n){return n}return!0}async move(f,s,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,f,n,s,"move",!!a),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(f,r==="move"?2:3,o)),o}async copy(f,s,a){const i=await this.withReadProvider(f),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,f,n,s,"copy",!!a),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(f,r==="copy"?3:2,o)),o}async doMoveCopy(f,s,a,i,n,r){if(s.toString()===i.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(f,s,a,i,n,r);if(o&&!u&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(i)),n==="copy"){if(f===a&&(0,g.hasFileFolderCopyCapability)(f))await f.copy(s,i,{overwrite:r});else{const E=await this.resolve(s);E.isDirectory?await this.doCopyFolder(f,E,a,i):await this.doCopyFile(f,s,a,i)}return n}else return f===a?(await f.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(f,s,a,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(f,s,a,i){if((0,g.hasOpenReadWriteCloseCapability)(f)&&(0,g.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(f,s,a,i);if((0,g.hasOpenReadWriteCloseCapability)(f)&&(0,g.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(f,s,a,i);if((0,g.hasReadWriteCapability)(f)&&(0,g.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(f,s,a,i);if((0,g.hasReadWriteCapability)(f)&&(0,g.hasReadWriteCapability)(a))return this.doPipeUnbuffered(f,s,a,i)}async doCopyFolder(f,s,a,i){await a.mkdir(i),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(a).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(f,await this.resolve(n.resource),a,r):this.doCopyFile(f,n.resource,a,r)}))}async doValidateMoveCopy(f,s,a,i,n,r){let o=!1;if(f===a){const{providerExtUri:E,isPathCaseSensitive:P}=this.getExtUri(f);if(P||(o=E.isEqual(s,i)),o&&n==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!o&&E.isEqualOrParent(i,s))throw new Error((0,d.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!o){if(!r)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(f===a){const{providerExtUri:E}=this.getExtUri(f);if(E.isEqualOrParent(s,i))throw new Error((0,d.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:o}}getExtUri(f){const s=this.isPathCaseSensitive(f);return{providerExtUri:s?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(f){return!!(f.capabilities&1024)}async createFolder(f){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);await this.mkdirp(s,f);const a=await this.resolve(f,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(f,0,a)),a}async mkdirp(f,s){const a=[],{providerExtUri:i}=this.getExtUri(f);for(;!i.isEqual(s,i.dirname(s));)try{if(((await f.stat(s)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,g.toFileSystemProviderErrorCode)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;a.push(i.basename(s)),s=i.dirname(s)}for(let n=a.length-1;n>=0;n--){s=i.joinPath(s,a[n]);try{await f.mkdir(s)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(f,s){try{await this.doValidateDelete(f,s)}catch(a){return a}return!0}async doValidateDelete(f,s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);if(!!s?.useTrash&&!(a.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(f)));let n;try{n=await a.stat(f)}catch{}if(n)this.throwIfFileIsReadonly(f,n);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(f)),1);if(!!!s?.recursive){const o=await this.resolve(f);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(f)))}return a}async del(f,s){const a=await this.doValidateDelete(f,s),i=!!s?.useTrash,n=!!s?.recursive;await a.delete(f,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new g.FileOperationEvent(f,1))}watch(f,s={recursive:!1,excludes:[]}){const a=new b.DisposableStore;let i=!1,n=()=>{i=!0};return a.add((0,b.toDisposable)(()=>n())),(async()=>{try{const r=await this.doWatch(f,s);i?(0,b.dispose)(r):n=()=>(0,b.dispose)(r)}catch(r){this.logService.error(r)}})(),a}async doWatch(f,s){const a=await this.withProvider(f),i=(0,R.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(f),s]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:a.watch(f,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,f]of this.activeWatchers)(0,b.dispose)(f.disposable);this.activeWatchers.clear()}async doWriteBuffered(f,s,a,i){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(async()=>{const n=await f.open(s,{create:!0,unlock:a?.unlock??!1});try{(0,l.isReadableStream)(i)||(0,l.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(f,n,i):await this.doWriteReadableBufferedQueued(f,n,i)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await f.close(n)}})}async doWriteStreamBufferedQueued(f,s,a){let i=0,n;if((0,l.isReadableBufferedStream)(a)){if(a.buffer.length>0){const r=p.VSBuffer.concat(a.buffer);await this.doWriteBuffer(f,s,r,r.byteLength,i,0),i+=r.byteLength}if(a.ended)return;n=a.stream}else n=a;return new Promise((r,o)=>{(0,l.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(f,s,u,u.byteLength,i,0)}catch(E){return o(E)}i+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>o(u),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(f,s,a){let i=0,n;for(;(n=a.read())!==null;)await this.doWriteBuffer(f,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(f,s,a,i,n,r){let o=0;for(;o<i;)o+=await f.write(s,n+o,a.buffer,r+o,i-o)}async doWriteUnbuffered(f,s,a,i){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(f,s,a,i))}async doWriteUnbufferedQueued(f,s,a,i){let n;i instanceof p.VSBuffer?n=i:(0,l.isReadableStream)(i)?n=await(0,p.streamToBuffer)(i):(0,l.isReadableBufferedStream)(i)?n=await(0,p.bufferedStreamToBuffer)(i):n=(0,p.readableToBuffer)(i),await f.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(f,s,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(f,s,a,i))}async doPipeBufferedQueued(f,s,a,i){let n,r;try{n=await f.open(s,{create:!1}),r=await a.open(i,{create:!0,unlock:!1});const o=p.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,E=0,P=0;do P=await f.read(n,u,o.buffer,E,o.byteLength-E),await this.doWriteBuffer(a,r,o,P,u,E),u+=P,E+=P,E===o.byteLength&&(E=0);while(P>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await t.Promises.settled([typeof n=="number"?f.close(n):Promise.resolve(),typeof r=="number"?a.close(r):Promise.resolve()])}}async doPipeUnbuffered(f,s,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(f,s,a,i))}async doPipeUnbufferedQueued(f,s,a,i){return a.writeFile(i,await f.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(f,s,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(f,s,a,i))}async doPipeUnbufferedToBufferedQueued(f,s,a,i){const n=await a.open(i,{create:!0,unlock:!1});try{const r=await f.readFile(s);await this.doWriteBuffer(a,n,p.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await a.close(n)}}async doPipeBufferedToUnbuffered(f,s,a,i){const n=await(0,p.streamToBuffer)(this.readFileBuffered(f,s,k.CancellationToken.None));await this.doWriteUnbuffered(a,i,void 0,n)}throwIfFileSystemIsReadonly(f,s){if(f.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(s)),6);return f}throwIfFileIsReadonly(f,s){if((s.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(f)),6)}resourceForError(f){return f.scheme===A.Schemas.file?f.fsPath:f.toString(!0)}};C=Te([Ne(0,c.ILogService)],C),e.FileService=C}),define(ve[56],we([0,1,27,264,13,30,15,7,31,2,4,3,22,43,19,165,16,90,196,36,193,192]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(_)}catch(a){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(a)}`)}})();class s extends c.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new k.ResourceMap(r=>h.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,A.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await l.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await l.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,h.joinPath)(i,o.name))).type:u=this.toType(o),r.push([o.name,u])}catch(u){this.logService.trace(u)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=g.FileType.Unknown:i.isFile()?r=g.FileType.File:i.isDirectory()?r=g.FileType.Directory:r=g.FileType.Unknown,n&&(r|=g.FileType.SymbolicLink),r}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let n;for(;n=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await n.wait();const r=new p.Barrier;return this.resourceLocks.set(i,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),r.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const o=this.toFilePath(i);return await l.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}readFileStream(i,n,r){const o=(0,v.newWriteableStream)(u=>D.VSBuffer.concat(u.map(E=>D.VSBuffer.wrap(E))).buffer);return(0,S.readFileIntoStream)(this,i,o,u=>u.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const u=this.toFilePath(i);if(!r.create||!r.overwrite){if(await l.Promises.exists(u)){if(!r.overwrite)throw(0,g.createFileSystemProviderError)((0,d.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,g.createFileSystemProviderError)((0,d.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof o=="number"&&await this.close(o)}}async open(i,n){let r;(0,g.isFileOpenForWriteOptions)(n)&&(r=await this.createResourceLock(i));let o;try{const u=this.toFilePath(i);if((0,g.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:P}=await l.SymlinkSupport.stat(u);P.mode&128||await l.Promises.chmod(u,P.mode|128)}catch(P){this.logService.trace(P)}let E;if((0,g.isFileOpenForWriteOptions)(n)){if(A.isWindows)try{await l.Promises.truncate(u,0),E="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}E||(E="w")}else E="r";o=await l.Promises.open(u,E)}catch(u){throw r?.dispose(),(0,g.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}return this.mapHandleToPos.set(o,0),(0,g.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,i),r&&this.mapHandleToLock.set(o,r),o}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await l.Promises.fdatasync(i)}catch(n){this.canFlush=!1,this.logService.error(n)}return await l.Promises.close(i)}catch(n){throw this.toFileSystemProviderError(n)}finally{const n=this.mapHandleToLock.get(i);n&&(this.mapHandleToLock.delete(i),n.dispose())}}async read(i,n,r,o,u){const E=this.normalizePos(i,n);let P=null;try{P=(await l.Promises.read(i,r,o,u,E)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,E,P)}return P}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,o+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,o,u){return(0,p.retry)(()=>this.doWrite(i,n,r,o,u),100,3)}async doWrite(i,n,r,o,u){const E=this.normalizePos(i,n);let P=null;try{P=(await l.Promises.write(i,r,o,u,E)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,E,P)}return P}async mkdir(i){try{await l.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);n.recursive?await l.Promises.rm(r,l.RimRafMode.MOVE):await l.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const o=this.toFilePath(i),u=this.toFilePath(n);if(o!==u)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await l.Promises.move(o,u)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,d.localize)(2,null,(0,T.basename)(o),(0,T.basename)((0,T.dirname)(u)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(i,n,r){const o=this.toFilePath(i),u=this.toFilePath(n);if(o!==u)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await l.Promises.copy(o,u,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,d.localize)(3,null,(0,T.basename)(o),(0,T.basename)((0,T.dirname)(u)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(i,n,r,o){const u=this.toFilePath(i),E=this.toFilePath(n);let P=!1;if(!!(this.capabilities&1024)||(P=(0,y.isEqual)(u,E,!0)),P&&r==="copy")throw(0,g.createFileSystemProviderError)((0,d.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!P&&await l.Promises.exists(E)){if(!o)throw(0,g.createFileSystemProviderError)((0,d.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,n,r){return new w.UniversalWatcherClient(o=>i(o),o=>n(o),r)}createNonRecursiveWatcher(i,n,r){return new f.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}toFileSystemProviderError(i){if(i instanceof g.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await l.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(r=(0,g.createFileSystemProviderError)(n,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=s}),define(ve[197],we([0,1,7,56,2,15,43,21]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class y extends p.Disposable{constructor(A,h){super();this.provider=A,this.logService=h,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(A,h,v){const l=this.getUriTransformer(A);switch(h){case"stat":return this.stat(l,v[0]);case"readdir":return this.readdir(l,v[0]);case"open":return this.open(l,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(l,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(l,v[0],v[1],v[2]);case"rename":return this.rename(l,v[0],v[1],v[2]);case"copy":return this.copy(l,v[0],v[1],v[2]);case"mkdir":return this.mkdir(l,v[0]);case"delete":return this.delete(l,v[0],v[1]);case"watch":return this.watch(l,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${h} not found`)}listen(A,h,v){const l=this.getUriTransformer(A);switch(h){case"fileChange":return this.onFileChange(l,v[0]);case"readFileStream":return this.onReadFileStream(l,v[0],v[1])}throw new Error(`Unknown event ${h}`)}stat(A,h){const v=this.transformIncoming(A,h,!0);return this.provider.stat(v)}readdir(A,h){const v=this.transformIncoming(A,h);return this.provider.readdir(v)}async readFile(A,h,v){const l=this.transformIncoming(A,h,!0),d=await this.provider.readFile(l,v);return k.VSBuffer.wrap(d)}onReadFileStream(A,h,v){const l=this.transformIncoming(A,h,!0),d=new R.CancellationTokenSource,g=new _.Emitter({onLastListenerRemove:()=>{d.cancel()}}),S=this.provider.readFileStream(l,v,d.token);return(0,D.listenStream)(S,{onData:c=>g.fire(k.VSBuffer.wrap(c)),onError:c=>g.fire(c),onEnd:()=>{g.fire("end"),g.dispose(),d.dispose()}}),g.event}writeFile(A,h,v,l){const d=this.transformIncoming(A,h);return this.provider.writeFile(d,v.buffer,l)}open(A,h,v){const l=this.transformIncoming(A,h,!0);return this.provider.open(l,v)}close(A){return this.provider.close(A)}async read(A,h,v){const l=k.VSBuffer.alloc(v),d=0,g=await this.provider.read(A,h,l.buffer,d,v);return[l,g]}write(A,h,v,l,d){return this.provider.write(A,h,v.buffer,l,d)}mkdir(A,h){const v=this.transformIncoming(A,h);return this.provider.mkdir(v)}delete(A,h,v){const l=this.transformIncoming(A,h);return this.provider.delete(l,v)}rename(A,h,v,l){const d=this.transformIncoming(A,h),g=this.transformIncoming(A,v);return this.provider.rename(d,g,l)}copy(A,h,v,l){const d=this.transformIncoming(A,h),g=this.transformIncoming(A,v);return this.provider.copy(d,g,l)}onFileChange(A,h){const v=new _.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(h,this.createSessionFileWatcher(A,v))},onLastListenerRemove:()=>{(0,p.dispose)(this.sessionToWatcher.get(h)),this.sessionToWatcher.delete(h)}});return v.event}async watch(A,h,v,l,d){const g=this.sessionToWatcher.get(h);if(g){const S=this.transformIncoming(A,l),c=g.watch(v,S,d);this.watchRequests.set(h+v,c)}}async unwatch(A,h){const v=A+h,l=this.watchRequests.get(v);l&&((0,p.dispose)(l),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,A]of this.watchRequests)A.dispose();this.watchRequests.clear();for(const[,A]of this.sessionToWatcher)A.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=y;class b extends p.Disposable{constructor(A,h,v,l){super();this.uriTransformer=A,this.logService=v,this.environmentService=l,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(h)}registerListeners(A){const h=this._register(new _.Emitter);this._register(h.event(v=>{A.fire(v.map(l=>({resource:this.uriTransformer.transformOutgoingURI(l.resource),type:l.type})))})),this._register(this.fileWatcher.onDidChangeFile(v=>h.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>A.fire(v)))}getRecursiveWatcherOptions(A){}getExtraExcludes(A){}watch(A,h,v){const l=this.getExtraExcludes(this.environmentService);return Array.isArray(l)&&(v.excludes=[...v.excludes,...l]),this.watcherRequests.set(A,this.fileWatcher.watch(h,v)),(0,p.toDisposable)(()=>{(0,p.dispose)(this.watcherRequests.get(A)),this.watcherRequests.delete(A)})}dispose(){super.dispose();for(const[,A]of this.watcherRequests)A.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(ve[93],we([0,1,7,5,14]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(h){this.service=h,this.onDidChangeLogLevel=_.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(h,v,l){switch(v){case"setLevel":return this.service.setLevel(l)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=k;class D{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){D.setLevel(this.channel,h)}static setLevel(h,v){return h.call("setLevel",v)}}e.LogLevelChannelClient=D;class R{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,v){throw new Error(`Event not found: ${v}`)}async call(h,v,l){switch(v){case"createLogger":this.createLogger(t.URI.revive(l[0]),l[1]);return;case"log":return this.log(t.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1])}throw new Error(`Call not found: ${v}`)}createLogger(h,v){this.loggers.set(h.toString(),this.loggerService.createLogger(h,v))}consoleLog(h,v){let l=console.log;switch(h){case p.LogLevel.Error:l=console.error;break;case p.LogLevel.Warning:l=console.warn;break;case p.LogLevel.Info:l=console.info;break}l.call(console,...v)}log(h,v){const l=this.loggers.get(h.toString());if(!l)throw new Error("Create the logger before logging");for(const[d,g]of v)(0,p.log)(l,d,g)}}e.LoggerChannel=R;class y extends p.AbstractLoggerService{constructor(h,v,l){super(h,v);this.channel=l}createConsoleMainLogger(){return new p.AdapterLogger({log:(h,v)=>{this.channel.call("consoleLog",[h,v])}})}doCreateLogger(h,v,l){return new b(this.channel,h,v,l)}}e.LoggerChannelClient=y;class b extends p.AbstractMessageLogger{constructor(h,v,l,d){super(d?.always);this.channel=h,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[v,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,v){const l=[[h,v]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(h){this.channel.call("log",[this.file,h])}}class T extends p.LogService{constructor(h,v){super(v);this.parent=h,this._register(h.onDidChangeLogLevel(l=>v.setLevel(l)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=T}),define(ve[94],we([0,1,16,14]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function p(R,y,b,T,A){try{const h=await new Promise((l,d)=>{J(["spdlog"],l,d)});h.setFlushOn(t.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(R,y,b,T);return A&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function k(R,y,b){switch(y){case t.LogLevel.Trace:R.trace(b);break;case t.LogLevel.Debug:R.debug(b);break;case t.LogLevel.Info:R.info(b);break;case t.LogLevel.Warning:R.warn(b);break;case t.LogLevel.Error:R.error(b);break;case t.LogLevel.Critical:R.critical(b);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(y,b,T,A,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(y,b,T,A),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}async _createSpdLogLogger(y,b,T,A){const h=T?6:1,v=30/h*_.ByteSize.MB,l=await p(y,b,v,h,A);if(l){this._logger=l,this._logger.setLevel(this.getLevel());for(const{level:d,message:g}of this.buffer)k(this._logger,d,g);this.buffer=[]}}log(y,b){this._logger?k(this._logger,y,b):this.getLevel()<=y&&this.buffer.push({level:y,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(ve[198],we([0,1,78,166,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(k=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function b(l,d){return d-l}y.compare=b;const T=Object.create(null);T[y.Error]=(0,t.localize)(0,null),T[y.Warning]=(0,t.localize)(1,null),T[y.Info]=(0,t.localize)(2,null);function A(l){return T[l]||""}y.toString=A;function h(l){switch(l){case _.default.Error:return y.Error;case _.default.Warning:return y.Warning;case _.default.Info:return y.Info;case _.default.Ignore:return y.Hint}}y.fromSeverity=h;function v(l){switch(l){case y.Error:return _.default.Error;case y.Warning:return _.default.Warning;case y.Info:return _.default.Info;case y.Hint:return _.default.Ignore}}y.toSeverity=v}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const b="";function T(h){return A(h,!0)}y.makeKey=T;function A(h,v){let l=[b];return h.source?l.push(h.source.replace("\xA6","\\\xA6")):l.push(b),h.code?typeof h.code=="string"?l.push(h.code.replace("\xA6","\\\xA6")):l.push(h.code.value.replace("\xA6","\\\xA6")):l.push(b),h.severity!==void 0&&h.severity!==null?l.push(D.toString(h.severity)):l.push(b),h.message&&v?l.push(h.message.replace("\xA6","\\\xA6")):l.push(b),h.startLineNumber!==void 0&&h.startLineNumber!==null?l.push(h.startLineNumber.toString()):l.push(b),h.startColumn!==void 0&&h.startColumn!==null?l.push(h.startColumn.toString()):l.push(b),h.endLineNumber!==void 0&&h.endLineNumber!==null?l.push(h.endLineNumber.toString()):l.push(b),h.endColumn!==void 0&&h.endColumn!==null?l.push(h.endColumn.toString()):l.push(b),l.push(b),l.join("\xA6")}y.makeKeyOptionalMessage=A})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(ve[199],we([0,1,7,78,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,p.createDecorator)("notificationService");var k;(function(b){b[b.WORKSPACE=0]="WORKSPACE",b[b.GLOBAL=1]="GLOBAL"})(k=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(b){b[b.OFF=0]="OFF",b[b.SILENT=1]="SILENT",b[b.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=_.Event.None,this.onDidChangeVisibility=_.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y}),define(ve[45],we([0,1,8,3,24,22]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const R=t.globals.vscode.context.configuration();if(R)D=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,k.dirname)(_.FileAccess.asFileUri("",J));D=J.__$__nodeRequire((0,k.joinPath)(R,"product.json").fsPath);const y=J.__$__nodeRequire((0,k.joinPath)(R,"package.json").fsPath);p.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:y.version})}else D={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:["*","* Visual Studio Code Server","*","* Reminder: You may only use this software with Visual Studio family products,","* as described in the license https://aka.ms/vscode-remote/license","*"],serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.vscode-pull-request-github-insiders","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-ssh-nightly","ms-vscode.azure-account","ms-vscode.azure-sphere-tools","ms-vscode.js-debug","ms-vscode.vscode-selfhost-test-provider","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","VisualStudioExptTeam.vscodeintellicode","VisualStudioExptTeam.vscodeintellicode-insiders","VisualStudioExptTeam.vscodeintellicode-completions","ms-azuretools.vscode-azureappservice"],extensionEnabledApiProposals:{"ms-vscode.anycode":["languageStatus"],"ms-vscode.azure-repos":["fileSearchProvider","textSearchProvider"],"ms-vscode.vscode-github-issue-notebooks":["notebookEditor"],"tanhakabir.rest-book":["notebookEditor"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentTimestamp"],"GitHub.copilot":["inlineCompletions","textDocumentNotebook","contribIcons","contribIconFonts"],"GitHub.copilot-nightly":["inlineCompletions","textDocumentNotebook","contribIcons","contribIconFonts"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-toolsai.jupyter":["notebookConcatTextDocument","notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","textDocumentNotebook","quickPickSortByLabel"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.81",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.15",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.64.3",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.12",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.64.2",commit:"f80445acd5a3dadef24aa209168452a3d97cc326",date:"2022-02-09T21:47:44.037Z"},Object.keys(D).length===0&&Object.assign(D,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=D}),define(ve[32],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,_.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[200],we([0,1,89,7,2,14,3,26,32]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let b=class Lt extends p.Disposable{constructor(A,h,v,l){super();this.isRunningOnServer=A,this.logService=h,this.environmentMainService=v,this.productService=l,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(A,h){const v=await this.withKeytar(),l=await v.getPassword(A,h);if(l)try{let{content:d,hasNextChunk:g}=JSON.parse(l);if(!d||!g)return l;let S=1;for(;g;){const c=await v.getPassword(A,`${h}-${S}`),C=JSON.parse(c);d+=C.content,g=C.hasNextChunk,S++}return d}catch{return l}return l}async setPassword(A,h,v){const l=await this.withKeytar(),d=3,g=async(S,c,C)=>{let w=0,f;for(;w<d;)try{await l.setPassword(S,c,C);return}catch(s){f=s,this.logService.warn("Error attempting to set a password: ",s),w++,await new Promise(a=>setTimeout(a,200))}throw f};if(D.isWindows&&v.length>Lt.MAX_PASSWORD_LENGTH){let S=0,c=0,C=!0;for(;C;){const w=v.substring(S,S+Lt.PASSWORD_CHUNK_SIZE);S+=Lt.PASSWORD_CHUNK_SIZE,C=v.length-S>0;const f={content:w,hasNextChunk:C};await g(A,c?`${h}-${c}`:h,JSON.stringify(f)),c++}}else await g(A,h,v);this._onDidChangePassword.fire({service:A,account:h})}async deletePassword(A,h){const l=await(await this.withKeytar()).deletePassword(A,h);return l&&this._onDidChangePassword.fire({service:A,account:h}),l}async findPassword(A){return(await this.withKeytar()).findPassword(A)}async findCredentials(A){return(await this.withKeytar()).findCredentials(A)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new _.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((A,h)=>{J(["keytar"],A,h)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(A){this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${A.message}`),this._keytarCache=new _.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof _.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=Te([Ne(1,k.ILogService),Ne(2,R.INativeEnvironmentService),Ne(3,y.IProductService)],b),e.CredentialsMainService=b}),define(ve[35],we([0,1,118,12]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(D,R){_.ok(t.isString(D)),_.ok(t.isObject(R)),_.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,R)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new p}),define(ve[201],we([0,1,7,35]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new _.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,b){this.schemasById[p(y)]=b,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new k;t.Registry.add(e.Extensions.JSONContribution,D)}),define(ve[46],we([0,1,17,7,12,151,201,35]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=R.Registry.as(D.Extensions.JSONContribution);class A{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(f,s=!0){this.registerConfigurations([f],s)}registerConfigurations(f,s=!0){const a=this.doRegisterConfigurations(f,s);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(f){const s=this.doDeregisterConfigurations(f);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:f,remove:s}){const a=[];a.push(...this.doDeregisterConfigurations(s)),a.push(...this.doRegisterConfigurations(f,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,_.distinct)(a)})}registerDefaultConfigurations(f){const s=[],a=[];for(const{overrides:i,source:n}of f)for(const r in i)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const o={...this.configurationDefaultsOverrides.get(r)?.value||{},...i[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:o});const u={type:"object",default:o,description:k.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:p.isString(n)?void 0:n};a.push(...l(r)),this.configurationProperties[r]=u,this.defaultLanguageConfigurationOverridesNode.properties[r]=u}else{this.configurationDefaultsOverrides.set(r,{value:i[r],source:n});const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(f){const s=[];for(const{overrides:a,source:i}of f)for(const n in a){const r=this.configurationDefaultsOverrides.get(n),o=p.isString(i)?i:i?.id,u=p.isString(r?.source)?r?.source:r?.source?.id;if(o===u)if(s.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const E=this.configurationProperties[n];E&&(this.updatePropertyDefaultValue(n,E),this.updateSchema(n,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const s of f)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,s){const a=[];return f.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(f){const s=[],a=i=>{if(i.properties)for(const n in i.properties)s.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>a(n))};for(const i of f){a(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return s}validateAndRegisterProperties(f,s=!0,a,i,n=3){n=p.isUndefinedOrNull(f.scope)?n:f.scope;let r=[],o=f.properties;if(o)for(let E in o){if(s&&c(E)){delete o[E];continue}const P=o[E];if(P.source=a,P.defaultDefaultValue=o[E].default,this.updatePropertyDefaultValue(E,P),e.OVERRIDE_PROPERTY_REGEX.test(E)?P.scope=void 0:(P.scope=p.isUndefinedOrNull(P.scope)?n:P.scope,P.restricted=p.isUndefinedOrNull(P.restricted)?!!i?.includes(E):P.restricted),o[E].hasOwnProperty("included")&&!o[E].included){this.excludedConfigurationProperties[E]=o[E],delete o[E];continue}else this.configurationProperties[E]=o[E];!o[E].deprecationMessage&&o[E].markdownDeprecationMessage&&(o[E].deprecationMessage=o[E].markdownDeprecationMessage),r.push(E)}let u=f.allOf;if(u)for(let E of u)r.push(...this.validateAndRegisterProperties(E,s,a,i,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(f){const s=a=>{let i=a.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let n=a.allOf;n&&n.forEach(s)};s(f)}updateSchema(f,s){switch(e.allSettings.properties[f]=s,s.scope){case 1:e.applicationSettings.properties[f]=s;break;case 2:e.machineSettings.properties[f]=s;break;case 6:e.machineOverridableSettings.properties[f]=s;break;case 3:e.windowSettings.properties[f]=s;break;case 4:e.resourceSettings.properties[f]=s;break;case 5:e.resourceSettings.properties[f]=s,this.resourceLanguageSettingsSchema.properties[f]=s;break}}removeFromSchema(f,s){switch(delete e.allSettings.properties[f],s.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f],delete this.resourceLanguageSettingsSchema.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const s=`[${f}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const f={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,s){const a=this.configurationDefaultsOverrides.get(f);let i=a?.value,n=a?.source;p.isUndefined(i)&&(i=s.defaultDefaultValue,n=void 0),p.isUndefined(i)&&(i=g(s.type)),s.default=i,s.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",v=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(w){const f=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let s=v.exec(w);for(;s?.length;){const a=s[1].trim();a&&f.push(a),s=v.exec(w)}}return(0,_.distinct)(f)}e.overrideIdentifiersFromKey=l;function d(w){return w.reduce((f,s)=>`${f}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const S=new A;R.Registry.add(e.Extensions.Configuration,S);function c(w){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?k.localize(7,null,w):S.getConfigurationProperties()[w]!==void 0?k.localize(8,null,w):null:k.localize(6,null)}e.validateProperty=c;function C(){const w=[],f=S.getConfigurationProperties();for(const s of Object.keys(f))w.push([s,f[s].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=C}),define(ve[202],we([0,1,17,7,38,2,30,20,12,5,28,46,35]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},n=[],r=[]){this._contents=i,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,T.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,T.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return _.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return _.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=R.deepClone(this.contents),r=R.deepClone(this.overrides),o=[...this.keys];for(const u of i){this.mergeContents(n,u.contents);for(const E of u.overrides){const[P]=r.filter(I=>_.equals(I.identifiers,E.identifiers));P?(this.mergeContents(P.contents,E.contents),P.keys.push(...E.keys),P.keys=_.distinct(P.keys)):r.push(R.deepClone(E))}for(const E of u.keys)o.indexOf(E)===-1&&o.push(E)}return new v(n,o,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const o of _.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[o],E=n[o];E&&(typeof u=="object"&&typeof E=="object"?(u=R.deepClone(u),this.mergeContents(u,E)):u=E),r[o]=u}return new v(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&y.isObject(i[r])&&y.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=R.deepClone(n[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,r=null;const o=u=>{u&&(r?this.mergeContents(r,u):r=R.deepClone(u))};for(const u of this.overrides)_.equals(u.identifiers,[i])?n=u.contents:u.identifiers.includes(i)&&o(u.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,T.addToValueTree)(this.contents,i,n,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,T.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let r=0;r<n;r++)i.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class l extends v{constructor(i={}){const n=h.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),o=Object.create(null),u=[];for(const E in n){const P=i[E],I=P!==void 0?P:n[E].default;(0,T.addToValueTree)(o,E,I,O=>console.error(`Conflict in default settings: ${O}`))}for(const E of Object.keys(o))A.OVERRIDE_PROPERTY_REGEX.test(E)&&u.push({identifiers:(0,A.overrideIdentifiersFromKey)(E),keys:Object.keys(o[E]),contents:(0,T.toValuesTree)(o[E],P=>console.error(`Conflict in default settings file: ${P}`))});super(o,r,u)}}e.DefaultConfigurationModel=l;class d{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!y.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:o,overrides:u,restricted:E}=this.doParseRaw(i,n);this._configurationModel=new v(r,o,u),this._restrictedConfigurations=E||[]}doParseContent(i){let n={},r=null,o=[],u=[],E=[];function P(O){Array.isArray(o)?o.push(O):r!==null&&(o[r]=O)}let I={onObjectBegin:()=>{let O={};P(O),u.push(o),o=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let O=[];P(O),u.push(o),o=O,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:P,onError:(O,z,j)=>{E.push({error:O,offset:z,length:j})}};if(i)try{p.visit(i,I),n=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(i,n){const r=h.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,n);i=o.raw;const u=(0,T.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),E=Object.keys(i),P=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:E,overrides:P,restricted:o.restricted}}filter(i,n,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const u={},E=[];for(let P in i)if(A.OVERRIDE_PROPERTY_REGEX.test(P)&&r){const I=this.filter(i[P],n,!1,o);u[P]=I.raw,E.push(...I.restricted)}else{const I=n[P],O=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&E.push(P),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&(o.skipRestricted&&I?.restricted||(u[P]=i[P]))}return{raw:u,restricted:E}}toOverrides(i,n){const r=[];for(const o of Object.keys(i))if(A.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const E in i[o])u[E]=i[o][E];r.push({identifiers:(0,A.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,T.toValuesTree)(u,n)})}return r}}e.ConfigurationModelParser=d;class g extends k.Disposable{constructor(i,n,r,o){super();this.userSettingsResource=i,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class S{constructor(i,n,r=new v,o=new v,u=new D.ResourceMap,E=new v,P=new D.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=E,this._memoryConfigurationByResource=P,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const o=this.getConsolidateConfigurationModel(n,r),u=this.getFolderConfigurationModelForResource(n.resource,r),E=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,P=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),z=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),j=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,m=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,L=n.overrideIdentifier?E.override(n.overrideIdentifier).getValue(i):E.getValue(i),M=o.getValue(i),Q=_.distinct(_.flatten(o.overrides.map(W=>W.identifiers))).filter(W=>o.getOverrideValue(i,W)!==void 0);return{defaultValue:P,userValue:I,userLocalValue:O,userRemoteValue:z,workspaceValue:j,workspaceFolderValue:m,memoryValue:L,value:M,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:z!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:m!==void 0?{value:u?.freeze().getValue(i),override:n.overrideIdentifier?u?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:E.getValue(i),override:n.overrideIdentifier?E.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:u,removed:E}=f(this._defaultConfiguration,i);n=[...o,...u,...E]}for(const o of n)for(const u of(0,A.overrideIdentifiersFromKey)(o)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(u),P=i.getKeysForOverrideIdentifier(u),I=[...P.filter(O=>E.indexOf(O)===-1),...E.filter(O=>P.indexOf(O)===-1),...E.filter(O=>!R.equals(this._defaultConfiguration.override(u).getValue(O),i.override(u).getValue(O)))];r.push([u,I])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:u}=f(this.localUserConfiguration,i),E=[...n,...r,...o];return E.length&&this.updateLocalUserConfiguration(i),{keys:E,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:u}=f(this.remoteUserConfiguration,i);let E=[...n,...r,...o];return E.length&&this.updateRemoteUserConfiguration(i),{keys:E,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:u}=f(this.workspaceConfiguration,i);let E=[...n,...r,...o];return E.length&&this.updateWorkspaceConfiguration(i),{keys:E,overrides:u}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:o,updated:u,removed:E,overrides:P}=f(r,n);let I=[...o,...u,...E];return(I.length||!r)&&this.updateFolderConfiguration(i,n),{keys:I,overrides:P}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:u,overrides:E}=f(n,void 0);return{keys:[...r,...o,...u],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let r=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const o=n.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(n=r.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:u}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:o,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((E,P)=>(E.set(b.URI.revive(P[0]),this.parseConfigurationModel(P[1])),E),new D.ResourceMap);return new S(n,r,new v,o,u,new v,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function c(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const o of a)o.keys.forEach(u=>i.add(u)),o.overrides.forEach(([u,E])=>{const P=(0,D.getOrSet)(n,u,new Set);E.forEach(I=>P.add(I))});const r=[];return n.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=c;class C{constructor(i,n,r,o){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(P=>u.add(P)),i.overrides.forEach(([,P])=>P.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const E=new v;this.affectedKeys.forEach(P=>E.setValue(P,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!R.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let r=(0,T.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=C;class w extends C{constructor(i,n,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=w;function f(a,i){const{added:n,removed:r,updated:o}=s(i,a),u=[],E=a?.getAllOverrideIdentifiers()||[],P=i?.getAllOverrideIdentifiers()||[];if(i){const I=P.filter(O=>!E.includes(O));for(const O of I)u.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const I=E.filter(O=>!P.includes(O));for(const O of I)u.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const I of E)if(P.includes(I)){const O=s({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});u.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:r,updated:o,overrides:u}}function s(a,i){const n=a?i?a.keys.filter(u=>i.keys.indexOf(u)===-1):[...a.keys]:[],r=i?a?i.keys.filter(u=>a.keys.indexOf(u)===-1):[...i.keys]:[],o=[];if(a&&i){for(const u of i.keys)if(a.keys.indexOf(u)!==-1){const E=(0,T.getConfigurationValue)(i.contents,u),P=(0,T.getConfigurationValue)(a.contents,u);R.equals(E,P)||o.push(u)}}return{added:n,removed:r,updated:o}}}),define(ve[95],we([0,1,13,7,2,22,28,202,46,35]),function(J,e,_,t,p,k,D,R,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends p.Disposable{constructor(h,v){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,v)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new _.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(({properties:l})=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const l=typeof h=="string"?h:void 0,d=(0,D.isConfigurationOverrides)(h)?h:(0,D.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(l,d,void 0)}updateValue(h,v,l,d){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(l,v,1)}onDidDefaultConfigurationChange(h){const v=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,h);this.trigger(l,v,6)}trigger(h,v,l){const d=new R.ConfigurationChangeEvent(h,{data:v},this.configuration);d.source=l,d.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ve[96],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var t;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class p extends Error{constructor(D,R=t.Unknown,y){super(D);this._message=D,this._code=R,this._detail=y,this.isHandled=R===t.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype)}static isTemporarilyNotAvailable(D){return D instanceof p&&D._code===t.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof p&&D._code===t.NoResolverFound}static isHandled(D){return D instanceof p&&D.isHandled}}e.RemoteAuthorityResolverError=p}),define(ve[97],we([0,1,8]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(k){return k.scheme===_.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=t;function p(k){if(!k)return;const D=k.indexOf("+");return D<0?k:k.substr(0,D)}e.getRemoteName=p}),define(ve[41],we([0,1,18,6,97]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=k;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class y{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,l){if(typeof v=="undefined"||v===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof v=="string"||typeof l=="string"){let d=typeof v=="string"?v:v.value,g=typeof l=="string"?l:l.value;return _.equalsIgnoreCase(d,g)}return v._lower===l._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=y;function b(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function T(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function A(h,v){if(v){const l=`onResolveRemoteAuthority:${(0,p.getRemoteName)(v)}`;return h.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=A,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[33],we([0,1,18,41]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function p(l,d){return l.uuid&&d.uuid?l.uuid===d.uuid:l.id===d.id?!0:(0,_.compareIgnoreCase)(l.id,d.id)===0}e.areSameExtensions=p;class k{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof k?p(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=k;function D(l,d){return`${l}.${d}`}e.getExtensionId=D;function R(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function y(l,d){return R(D(l,d))}e.getGalleryExtensionId=y;function b(l,d){const g=[],S=c=>{for(const C of g)if(C.some(w=>p(d(w),d(c))))return C;return null};for(const c of l){const C=S(c);C?C.push(c):g.push([c])}return g}e.groupByExtension=b;function T(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function A(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function h(l){const d=new Set;if(l.malicious)for(const g of l.malicious)d.add(g.id);return d}e.getMaliciousExtensionsSet=h;function v(l,d){const g=[],S=d.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const c=S.shift();if(c&&g.every(C=>!p(C.identifier,{id:c}))){const C=l.filter(w=>p(w.identifier,{id:c}));C.length===1&&(g.push(C[0]),S.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=v}),define(ve[34],we([0,1,8,156,33,6]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const D=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function R(s){const a=D.exec(s);return a&&a[1]?[(0,p.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,p.adoptToGalleryExtensionId)(s),void 0]}e.getIdAndVersion=R;var y;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function b(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function T(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(s,a){switch(s){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function h(s,a){return a==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=h;function v(s,a,i){return h(a,i)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===i?!0:l(i).includes(s)}e.isTargetPlatformCompatible=v;function l(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function d(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=d;var g;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(g=e.SortBy||(e.SortBy={}));var S;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var c;(function(s){s.Install="install",s.Uninstall="uninstall"})(c=e.StatisticType||(e.StatisticType={}));var C;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var w;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(a,i){super(a);this.code=i,this.name=i}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=_.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(ve[98],we([0,1,21,11,61,8,57,5,157,34,33,41]),function(J,e,_,t,p,k,D,R,y,b,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const h=g=>(0,y.localize)(0,null,g),v=(0,y.localize)(1,null,"ms-dotnettools.csharp");function l(g,S){return S?`${g.publisher}.${g.name}@${g.version}`:`${g.publisher}.${g.name}`}let d=class{constructor(S,c){this.extensionManagementService=S,this.extensionGalleryService=c}get location(){}async listExtensions(S,c,C=console){let w=await this.extensionManagementService.getInstalled(1);const f=A.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(c&&c!==""){if(f.indexOf(c.toLowerCase())<0){C.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){C.log("Possible Categories: "),f.forEach(a=>{C.log(a)});return}this.location&&C.log((0,y.localize)(2,null,this.location)),w=w.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let s;for(let a of w)s!==a.identifier.id&&(s=a.identifier.id,C.log(l(a.manifest,S)))}async installExtensions(S,c,C,w,f=console){const s=[],a=[];S.length&&f.log(this.location?(0,y.localize)(3,null,this.location):(0,y.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),n=(u,E)=>{const P=i.find(I=>(0,T.areSameExtensions)(I.identifier,{id:u}));if(P){if(!E&&!w)return f.log((0,y.localize)(5,null,u,P.manifest.version,u)),!1;if(E&&P.manifest.version===E)return f.log((0,y.localize)(6,null,`${u}@${E}`)),!1}return!0},r=[],o=[];for(const u of S)if(u instanceof R.URI)r.push(u);else{const[E,P]=(0,b.getIdAndVersion)(u);n(E,P)&&o.push({id:E,version:P,installOptions:{...C,isBuiltin:!1}})}for(const u of c){const[E,P]=(0,b.getIdAndVersion)(u);n(E,P)&&o.push({id:E,version:P,installOptions:{...C,isBuiltin:!0}})}if(r.length&&await Promise.all(r.map(async u=>{try{const E=await this.installVSIX(u,{...C,isBuiltin:!1},w,f);E&&a.push(E)}catch(E){f.error(E.message||E.stack||E),s.push(u.toString())}})),o.length){const u=await this.getGalleryExtensions(o);await Promise.all(o.map(async E=>{const P=u.get(E.id.toLowerCase());if(P)try{const I=await this.installFromGallery(E,P,i,w,f);I&&a.push(I)}catch(I){f.error(I.message||I.stack||I),s.push(E.id)}else f.error(`${h(E.version?`${E.id}@${E.version}`:E.id)}
${v}`),s.push(E.id)}))}if(s.length)throw new Error((0,y.localize)(7,null,s.join(", ")))}async installVSIX(S,c,C,w){const f=await this.extensionManagementService.getManifest(S);if(!f)throw new Error("Invalid vsix");if(await this.validateVSIX(f,C,w))try{return await this.extensionManagementService.install(S,c),w.log((0,y.localize)(8,null,(0,p.getBaseLabel)(S))),f}catch(a){if((0,t.isCancellationError)(a))return w.log((0,y.localize)(9,null,(0,p.getBaseLabel)(S))),null;throw a}return null}async getGalleryExtensions(S){const c=new Map,C=S.some(f=>f.installOptions.installPreReleaseVersion),w=await this.extensionGalleryService.getExtensions(S.map(f=>({...f,preRelease:C})),_.CancellationToken.None);for(const f of w)c.set(f.identifier.id.toLowerCase(),f);return c}async installFromGallery({id:S,version:c,installOptions:C},w,f,s,a){const i=await this.extensionGalleryService.getManifest(w,_.CancellationToken.None);if(i&&!this.validateExtensionKind(i,a))return null;const n=f.find(r=>(0,T.areSameExtensions)(r.identifier,w.identifier));if(n){if(w.version===n.manifest.version)return a.log((0,y.localize)(10,null,c?`${S}@${c}`:S)),null;a.log((0,y.localize)(11,null,S,w.version))}try{return C.isBuiltin?a.log(c?(0,y.localize)(12,null,S,c):(0,y.localize)(13,null,S)):a.log(c?(0,y.localize)(14,null,S,c):(0,y.localize)(15,null,S)),await this.extensionManagementService.installFromGallery(w,{...C,installGivenVersion:!!c}),a.log((0,y.localize)(16,null,S,w.version)),i}catch(r){if((0,t.isCancellationError)(r))return a.log((0,y.localize)(17,null,S)),null;throw r}}validateExtensionKind(S,c){return!0}async validateVSIX(S,c,C){const w={id:(0,T.getGalleryExtensionId)(S.publisher,S.name)},s=(await this.extensionManagementService.getInstalled(1)).find(a=>(0,T.areSameExtensions)(w,a.identifier)&&(0,D.gt)(a.manifest.version,S.version));return s&&!c?(C.log((0,y.localize)(18,null,s.identifier.id,s.manifest.version,S.version)),!1):this.validateExtensionKind(S,C)}async uninstallExtensions(S,c,C=console){const w=async s=>{if(s instanceof R.URI){const a=await this.extensionManagementService.getManifest(s);return l(a)}return s},f=[];for(const s of S){const a=await w(s),n=(await this.extensionManagementService.getInstalled()).filter(r=>(0,T.areSameExtensions)(r.identifier,{id:a}));if(!n.length)throw new Error(`${this.notInstalled(a)}
${v}`);if(n.some(r=>r.type===0)){C.log((0,y.localize)(19,null,a));return}if(!c&&n.some(r=>r.isBuiltin)){C.log((0,y.localize)(20,null,a));return}C.log((0,y.localize)(21,null,a));for(const r of n)await this.extensionManagementService.uninstall(r),f.push(r);this.location?C.log((0,y.localize)(22,null,a,this.location)):C.log((0,y.localize)(23,null,a))}}async locateExtension(S,c=console){const C=await this.extensionManagementService.getInstalled();S.forEach(w=>{C.forEach(f=>{if(f.identifier.id===w&&f.location.scheme===k.Schemas.file){c.log(f.location.fsPath);return}})})}notInstalled(S){return this.location?(0,y.localize)(24,null,S,this.location):(0,y.localize)(25,null,S)}};d=Te([Ne(0,b.IExtensionManagementService),Ne(1,b.IExtensionGalleryService)],d),e.ExtensionManagementCLIService=d}),define(ve[203],we([0,1,7,2,20,5,62,34]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(d,g){return k.URI.revive(g?g.transformIncoming(d):d)}function b(d,g){return g?g.transformOutgoingURI(d):d}function T(d,g){g=g||D.DefaultURITransformer;const S=d.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...d,manifest:void 0},g),manifest:S}}function A(d,g){return g?(0,p.cloneAndChange)(d,S=>S instanceof k.URI?g.transformOutgoingURI(S):void 0):d}class h{constructor(g,S){this.service=g,this.getUriTransformer=S,this.onInstallExtension=_.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=_.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=_.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=_.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,S){const c=this.getUriTransformer(g);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return _.Event.map(this.onDidInstallExtensions,C=>C.map(w=>({...w,local:w.local?A(w.local,c):w.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,S,c){const C=this.getUriTransformer(g);switch(S){case"zip":return this.service.zip(T(c[0],C)).then(w=>b(w,C));case"unzip":return this.service.unzip(y(c[0],C));case"install":return this.service.install(y(c[0],C),c[1]);case"getManifest":return this.service.getManifest(y(c[0],C));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],c[1]);case"uninstall":return this.service.uninstall(T(c[0],C),c[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(T(c[0],C));case"getInstalled":return this.service.getInstalled(c[0]).then(w=>w.map(f=>A(f,C)));case"updateMetadata":return this.service.updateMetadata(T(c[0],C),c[1]).then(w=>A(w,C));case"updateExtensionScope":return this.service.updateExtensionScope(T(c[0],C),c[1]).then(w=>A(w,C));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class v extends t.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new _.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new _.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new _.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new _.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire({identifier:S.identifier,source:this.isUriComponents(S.source)?k.URI.revive(S.source):S.source}))),this._register(this.channel.listen("onDidInstallExtensions")(S=>this._onDidInstallExtensions.fire(S.map(c=>({...c,local:c.local?T(c.local,null):c.local,source:this.isUriComponents(c.source)?k.URI.revive(c.source):c.source}))))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const S=await this.getTargetPlatform();return g.allTargetPlatforms.some(c=>(0,R.isTargetPlatformCompatible)(c,g.allTargetPlatforms,S))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(S=>k.URI.revive(S)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,S){return Promise.resolve(this.channel.call("install",[g,S])).then(c=>T(c,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,S){return Promise.resolve(this.channel.call("installFromGallery",[g,S])).then(c=>T(c,null))}uninstall(g,S){return Promise.resolve(this.channel.call("uninstall",[g,S]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(S=>S.map(c=>T(c,null)))}updateMetadata(g,S){return Promise.resolve(this.channel.call("updateMetadata",[g,S])).then(c=>T(c,null))}updateExtensionScope(g,S){return Promise.resolve(this.channel.call("updateExtensionScope",[g,S])).then(c=>T(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=v;class l{constructor(g){this.service=g}listen(g,S){throw new Error("Invalid listen")}call(g,S,c){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=l}),define(ve[204],we([0,1,13,11,2,3,22,57,5,23,19,26,34,33,16,14]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let S=class extends p.Disposable{constructor(C,w,f,s){super();this.fileService=w,this.extensionGalleryService=f,this.logService=s,this.extensionsDownloadDir=y.URI.file(C.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(C,w){await this.cleanUpPromise;const f=this.getName(C),s=(0,D.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(s)){const a=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(C,a,w);try{await this.rename(a,s,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",C.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return s}async delete(C){await this.cleanUpPromise,await this.fileService.del(C)}async rename(C,w,f){try{await T.Promises.rename(C.fsPath,w.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${C} to ${w} with 'EPERM' error. Trying again...`),this.rename(C,w,f);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const C=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(C.children){const w=[],f=[];for(const i of C.children){const n=this.parse(i.name);n&&f.push([n,i])}const s=(0,v.groupByExtension)(f,([i])=>i),a=[];for(const i of s)i.sort((n,r)=>R.rcompare(n[0].version,r[0].version)),w.push(...i.slice(1).map(n=>n[1].resource)),a.push(i[0][1]);a.sort((i,n)=>i.mtime-n.mtime),w.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await _.Promises.settled(w.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(C){this.logService.error(C)}}getName(C){return this.cache?`${new v.ExtensionIdentifierWithVersion(C.identifier,C.version).key().toLowerCase()}${C.properties.targetPlatform!=="undefined"?`-${C.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(C){const w=g.exec(C);return w&&w[1]&&w[2]?new v.ExtensionIdentifierWithVersion({id:w[1]},w[2]):null}};S=Te([Ne(0,A.INativeEnvironmentService),Ne(1,l.IFileService),Ne(2,h.IExtensionGalleryService),Ne(3,d.ILogService)],S),e.ExtensionsDownloader=S}),define(ve[205],we([0,1,2,4,19,41]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends _.Disposable{constructor(y,b){super();this.environmentService=y,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(b.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(y){y.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){p.Promises.rm(this.extensionsManifestCache,p.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(ve[99],we([0,1,70,17,13,2,8,4,19,26,34,33,69,14]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let l=class extends k.Disposable{constructor(S,c,C){super();this.extensionManagementService=S,this.logService=C,this.cache=this._register(new d(c,C)),this.extensionManagementService.registerParticipant({postInstall:async w=>this.postInstallExtension(w),postUninstall:async w=>this.postUninstallExtension(w)})}async getLanguageIds(){const S=await this.cache.getLanguagePacks(),c=["en",...Object.keys(S)];return(0,t.distinct)(c)}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const c=await this.cache.getLanguagePacks();Object.keys(c).some(C=>c[C]&&c[C].extensions.some(w=>(0,A.areSameExtensions)(w.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),C=await this.cache.update(c);return!(0,t.equals)(Object.keys(S),Object.keys(C))}};l=Te([Ne(0,T.IExtensionManagementService),Ne(1,b.INativeEnvironmentService),Ne(2,v.ILogService)],l),e.LocalizationsService=l;let d=class extends k.Disposable{constructor(S,c){super();this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new p.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(c=>{Object.keys(c).forEach(C=>delete c[C]),this.createLanguagePacksFromExtensions(c,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...c){for(const C of c)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,C);Object.keys(S).forEach(C=>this.updateHash(S[C]))}createLanguagePacksFromExtension(S,c){const C=c.identifier,w=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const f of w)if(c.location.scheme===D.Schemas.file&&(0,h.isValidLocalization)(f)){let s=S[f.languageId];s||(s={hash:"",extensions:[],translations:{}},S[f.languageId]=s);let a=s.extensions.filter(i=>(0,A.areSameExtensions)(i.extensionIdentifier,C))[0];a?a.version=c.manifest.version:s.extensions.push({extensionIdentifier:C,version:c.manifest.version});for(const i of f.translations)s.translations[i.id]=(0,R.join)(c.location.fsPath,i.path)}}updateHash(S){if(S){const c=(0,_.createHash)("md5");for(const C of S.extensions)c.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);S.hash=c.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(c=S(C),C)).then(C=>{for(const f of Object.keys(C))C[f]||delete C[f];this.languagePacks=C,this.initializedCache=!0;const w=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",w),y.Promises.writeFile(this.languagePacksFilePath,w)}).then(()=>c,C=>this.logService.error(C))})}};d=Te([Ne(0,b.INativeEnvironmentService),Ne(1,v.ILogService)],d)}),define(ve[47],we([0,1,15,167,46,6,35]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function R(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}e.isSuccess=R;function y(l){return l.res.statusCode===204}async function b(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);return y(l)?null:(await(0,_.streamToBuffer)(l.stream)).toString()}e.asText=b;async function T(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);if(y(l))return null;const g=(await(0,_.streamToBuffer)(l.stream)).toString();try{return JSON.parse(g)}catch(S){throw S.message+=`:
`+g,S}}e.asJson=T;function A(l){v(l)}e.updateProxyConfigurationsScope=A;let h;function v(l){const d=D.Registry.as(p.Extensions.Configuration),g=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[h],remove:g?[g]:[]})}v(2)}),define(ve[206],we([0,1,21,8,16,47]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(y,b){this.requestService=y,this.fileService=b}async download(y,b,T=_.CancellationToken.None){if(y.scheme===t.Schemas.file||y.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(y,b);return}const A={type:"GET",url:y.toString()},h=await this.requestService.request(A,T);if(h.res.statusCode===200)await this.fileService.writeFile(b,h.stream);else{const v=await(0,k.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};D=Te([Ne(0,k.IRequestService),Ne(1,p.IFileService)],D),e.DownloadService=D}),define(ve[207],we([0,1,15,21]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class p{constructor(R){this.service=R}listen(R,y){throw new Error("Invalid listen")}call(R,y,b){switch(y){case"request":return this.service.request(b[0],t.CancellationToken.None).then(async({res:T,stream:A})=>{const h=await(0,_.streamToBuffer)(A);return[{statusCode:T.statusCode,headers:T.headers},h]})}throw new Error("Invalid call")}}e.RequestChannel=p;class k{constructor(R){this.channel=R}async request(R,y){return k.request(this.channel,R,y)}static async request(R,y,b){const[T,A]=await R.call("request",[y]);return{res:T,stream:(0,_.bufferToStream)(A)}}}e.RequestChannelClient=k}),define(ve[208],we([0,1,71,12]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function p(D,R){return D.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:D.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function k(D,R,y={}){const b=(0,_.parse)(D),T=y.proxyUrl||p(b,R);if(!T)return null;const A=(0,_.parse)(T);if(!/^https?:$/.test(A.protocol||""))return null;const h={host:A.hostname||"",port:A.port||(A.protocol==="https"?"443":"80"),auth:A.auth,rejectUnauthorized:(0,t.isBoolean)(y.strictSSL)?y.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((v,l)=>{J(["http-proxy-agent"],v,l)}))(h):new(await new Promise((v,l)=>{J(["https-proxy-agent"],v,l)}))(h)}e.getProxyAgent=k}),define(ve[209],we([0,1,13,7,2,44,12,137,6]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,y.createDecorator)("storageService");var T;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var A;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(A=e.StorageScope||(e.StorageScope={}));var h;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(h=e.StorageTarget||(e.StorageTarget={}));class v extends p.Disposable{constructor(S={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new _.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new p.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,_.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,p.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,c){c===b?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:c,target:this.getKeyTargets(S)[c]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,c,C){return this.getStorage(c)?.get(S,C)}getBoolean(S,c,C){return this.getStorage(c)?.getBoolean(S,C)}getNumber(S,c,C){return this.getStorage(c)?.getNumber(S,C)}store(S,c,C,w){if((0,D.isUndefinedOrNull)(c)){this.remove(S,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,C,w),this.getStorage(C)?.set(S,c)})}remove(S,c){this.withPausedEmitters(()=>{this.updateKeyTarget(S,c,void 0),this.getStorage(c)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,c){const C=[],w=this.getKeyTargets(S);for(const f of Object.keys(w))w[f]===c&&C.push(f);return C}updateKeyTarget(S,c,C){const w=this.getKeyTargets(c);typeof C=="number"?w[S]!==C&&(w[S]=C,this.getStorage(c)?.set(b,JSON.stringify(w))):typeof w[S]=="number"&&(delete w[S],this.getStorage(c)?.set(b,JSON.stringify(w)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const c=this.get(b,S);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=T.NONE){this._onWillSaveState.fire({reason:S});const c=this.getStorage(0),C=this.getStorage(1);switch(S){case T.NONE:await _.Promises.settled([c?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await _.Promises.settled([c?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve()]);break}}async logStorage(){const S=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return d(S,c,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class l extends v{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=l;async function d(g,S,c,C){const w=o=>{try{return JSON.parse(o)}catch{return o}},f=new Map,s=new Map;g.forEach((o,u)=>{f.set(u,o),s.set(u,w(o))});const a=new Map,i=new Map;S.forEach((o,u)=>{a.set(u,o),i.set(u,w(o))}),console.group(`Storage: Global (path: ${c})`);let n=[];f.forEach((o,u)=>{n.push({key:u,value:o})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${C})`);let r=[];a.forEach((o,u)=>{r.push({key:u,value:o})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=d}),define(ve[210],we([0,1,3,24,5,23]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(b){if(_.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function R(b,T,A,h,v,l,d,g,S,c){const C=Object.create(null);C["common.machineId"]=d,C.sessionID=(0,k.generateUuid)()+Date.now(),C.commitHash=v,C.version=l,C["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),C["common.platform"]=(0,_.PlatformToString)(_.platform),C["common.nodePlatform"]=t.platform,C["common.nodeArch"]=h,C["common.product"]=c||"desktop";const w=y(g||[]);w&&(C["common.msftInternal"]=w);let f=0;const s=Date.now();Object.defineProperties(C,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),_.isLinuxSnap&&(C["common.snap"]="true");const a=D(A);a&&(C["common.platformDetail"]=a);try{const i=await b.readFile(p.URI.file(S));C["common.source"]=i.value.toString().slice(0,30)}catch{}return C}e.resolveCommonProperties=R;function y(b){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const A=T.toLowerCase();return b.some(h=>A===h)}e.verifyMicrosoftInternalDomain=y}),define(ve[211],we([0,1,17,11,2,20]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var D;(function(y){function b(T,A){return T.callstack<A.callstack?-1:T.callstack>A.callstack?1:0}y.compare=b})(D=e.ErrorEvent||(e.ErrorEvent={}));class R{constructor(b,T=R.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new p.DisposableStore,this._telemetryService=b,this._flushDelay=T;const A=t.errorHandler.addListener(h=>this._onErrorEvent(h));this._disposables.add((0,p.toDisposable)(A)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(b){if(!b)return;b.detail&&b.detail.stack&&(b=b.detail);let T=Array.isArray(b.stack)?b.stack.join(`
`):b.stack,A=b.message?b.message:(0,k.safeStringify)(b);!T||this._enqueue({msg:A,callstack:T})}_enqueue(b){const T=(0,_.binarySearch)(this._buffer,b,D.compare);T<0?(b.count=1,this._buffer.splice(~T,0,b)):(this._buffer[T].count||(this._buffer[T].count=0),this._buffer[T].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let b of this._buffer)this._telemetryService.publicLogError2("UnhandledError",b);this._buffer.length=0}}e.default=R,R.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[29],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,_.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,_.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var p;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(p=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[212],we([0,1,25,51,13,38,8,4,3,5,80,19,83,186,16,32,29]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(s,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,r=new Map,o=2e4;function u(I,O,z,j){const m=O.substring(I.length+1);return p.Promises.withAsyncBody(async L=>{let M;try{M=await A.Promises.readdir(O,{withFileTypes:!0})}catch{L();return}if(j.count>=o){j.count+=M.length,j.maxReached=!0,L();return}let Q=M.length;if(Q===0){L();return}let W=M;j.count+M.length>o&&(j.maxReached=!0,Q=o-j.count,W=M.slice(0,Q)),j.count+=M.length;for(const q of W)if(q.isDirectory()){if(z.includes(q.name)||await u(I,(0,R.join)(O,q.name),z,j),--Q==0){L();return}}else{const ne=q.name.lastIndexOf(".");if(ne>=0){const B=q.name.substring(ne+1);B&&n.set(B,(n.get(B)??0)+1)}for(const B of i)B.relativePathPattern?.test(m)!==!1&&B.filePattern.test(q.name)&&r.set(B.tag,(r.get(B.tag)??0)+1);if(--Q==0){L();return}}})}const E={count:0,maxReached:!1};await u(s,s,a,E);const P=await w(s);return{configFiles:c(r),fileTypes:c(n),fileCount:E.count,maxFilesReached:E.maxReached,launchConfigFiles:P}}e.collectWorkspaceStats=S;function c(s){return[...t.Iterable.map(s.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function C(){const s={os:`${_.type()} ${_.arch()} ${_.release()}`,memory:`${(_.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},a=_.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.getMachineInfo=C;async function w(s){try{const a=new Map,i=(0,R.join)(s,".vscode","launch.json"),n=await A.Promises.readFile(i),r=[],o=(0,k.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,k.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const E=u.type;E&&(a.has(E)?a.set(E,a.get(E)+1):a.set(E,1))}return c(a)}catch{return[]}}e.collectLaunchConfigs=w;let f=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${_.type()} ${_.arch()} ${_.release()}`);const n=_.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(_.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||i.push(`Load (avg):       ${_.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,h.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async n=>{let[r,o]=n,u=this.formatProcessList(a,r);return i.forEach(E=>{if((0,v.isRemoteDiagnosticError)(E))u+=`
${E.errorMessage}`,o+=`
${E.errorMessage}`;else if(u+=`

Remote: ${E.hostName}`,E.processes&&(u+=`
${this.formatProcessList(a,E.processes)}`),E.workspaceMetadata){o+=`
|  Remote: ${E.hostName}`;for(const P of Object.keys(E.workspaceMetadata)){const I=E.workspaceMetadata[P];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${P}): ${O}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:n,vmHint:r,os:o,cpus:u}=C(),E={os:o,memory:n,cpus:u,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return y.isWindows||(E.load=`${_.loadavg().map(P=>Math.round(P)).join(", ")}`),y.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(a,i){const n=[];return(0,h.listProcesses)(a.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(a)),n.push(""),n.push(this.formatProcessList(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(a))),i.forEach(o=>{if((0,v.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.formatMachineInfo(o.machineInfo)),o.processes&&n.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const E=o.workspaceMetadata[u];let P=`${E.fileCount} files`;E.maxFilesReached&&(P=`more than ${P}`),n.push(`Folder (${u}): ${P}`),n.push(this.formatWorkspaceStats(E))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(a){const i=[],n=60;let r=0;const o=(I,O)=>{const z=` ${I}(${O})`;r+z.length>n?(i.push(u),u="|                 ",r=u.length):r+=z.length,u+=z};let u="|      File types:";const E=10;let P=a.fileTypes.length>E?E:a.fileTypes.length;for(let I=0;I<P;I++){const O=a.fileTypes[I];o(O.name,O.count)}if(i.push(u),a.configFiles.length>=0&&(u="|      Conf files:",r=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),i.push(u)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{I+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],n=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const u=b.URI.revive(o);if(u.scheme===D.Schemas.file){const E=u.fsPath;n.push(S(E,["node_modules",".git"]).then(P=>{let I=`${P.fileCount} files`;P.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,R.basename)(E)}): ${I}`),i.push(this.formatWorkspaceStats(P))}).catch(P=>{i.push(`|      Error: Unable to collect workspace stats for folder ${E} (${P.toString()})`)}))}else i.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(a,i){const n=new Map;a.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,n,r,i,0),r.join(`
`)}formatProcessItem(a,i,n,r,o){const u=o===0;let E;u?E=r.pid===a?`${this.productService.applicationName} main`:"remote agent":(E=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(E=`${E} (${i.get(r.pid)})`));const P=process.platform==="win32"?r.mem:_.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(P/l.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(r.children)&&r.children.forEach(I=>this.formatProcessItem(a,i,n,I,o+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=b.URI.revive(i);if(n.scheme!==D.Schemas.file)continue;const r=n.fsPath;try{const o=await S(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};f=Te([Ne(0,g.ITelemetryService),Ne(1,d.IProductService)],f),e.DiagnosticsService=f}),define(ve[213],we([0,1,17,13,21,11,7,2,3,12,5,155,34,33,14,32,29]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let S=class extends R.Disposable{constructor(a,i,n,r){super();this.galleryService=a,this.telemetryService=i,this.logService=n,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(n=>(0,h.isTargetPlatformCompatible)(n,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(A.localize(0,null),h.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,i)}catch(n){throw w(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,n),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(n),C(n)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(1,null));const i=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...a.identifier,preRelease:a.preRelease}],{targetPlatform:i,compatible:!0},p.CancellationToken.None);if(!n)throw new Error(A.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,n){if(!T.URI.isUri(i)){let P=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(P)return this.logService.info("Extensions is already requested to install",i.identifier.id),P.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],o=[],u=this.createInstallExtensionTask(a,i,n);T.URI.isUri(i)||this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:i}),this.logService.info("Installing extension:",u.identifier.id),r.push({task:u,manifest:a});let E=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:O,manifest:z}of I)if(E=E||!!z.extensionDependencies?.some(j=>(0,v.areSameExtensions)({id:j},u.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const j=this.createInstallExtensionTask(z,O,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(j.identifier,z.version).key(),j),this._onInstallExtension.fire({identifier:j.identifier,source:O}),this.logService.info("Installing extension:",j.identifier.id),r.push({task:j,manifest:z})}}catch(I){if(T.URI.isUri(u.source))(0,_.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,I.message),(0,_.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),I}const P=r.reduce((I,{task:O,manifest:z})=>(I.set(O.identifier.id.toLowerCase(),{task:O,manifest:z}),I),new Map);for(;P.size;){let I;const O=[...P.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(j=>P.has(j.toLowerCase())));O.length?I=P.size===1?O:O.filter(({task:z})=>!(z===u&&!E)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:z})=>z.identifier.id)),I=[...P.values()]),await this.joinAllSettled(I.map(async({task:z})=>{const j=new Date().getTime(),m=(0,b.isUndefined)(n.operation)?z.operation:n.operation;try{const L=await z.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(L,z.source,n,p.CancellationToken.None))),!T.URI.isUri(z.source)&&(w(this.telemetryService,m===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(z.source),new Date().getTime()-j,void 0),y.isWeb&&m!==3))try{await this.galleryService.reportStatistic(L.manifest.publisher,L.manifest.name,L.manifest.version,"install")}catch{}o.push({local:L,identifier:z.identifier,operation:m,source:z.source})}catch(L){throw T.URI.isUri(z.source)||w(this.telemetryService,m===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(z.source),new Date().getTime()-j,L),this.logService.error("Error while installing the extension:",z.identifier.id),L}finally{P.delete(z.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,v.areSameExtensions)(I,u.identifier))[0].local}catch(P){if(r.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<I.length;O++){const z=I[O],{identifier:j}=o[O];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",j.id):this.logService.warn("Rollback: Error while uninstalling extension",j.id,(0,k.getErrorMessage)(z.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(I),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(r.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),P}finally{for(const{task:P,manifest:I}of r)if(!T.URI.isUri(P.source)){const O=new v.ExtensionIdentifierWithVersion(P.identifier,I.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(a){const i=[],n=[],r=await Promise.allSettled(a);for(const o of r)o.status==="fulfilled"?i.push(o.value):n.push(o.reason);if(n.length)throw c(n);return i}async getAllDepsAndPackExtensionsToInstall(a,i,n,r){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const u=[a,...o.map(I=>I.identifier)],E=[],P=async(I,O)=>{const z=O.extensionDependencies||[],j=[...z];if(O.extensionPack){const m=n?o.find(L=>(0,v.areSameExtensions)(L.identifier,I)):void 0;for(const L of O.extensionPack)m&&m.manifest.extensionPack&&m.manifest.extensionPack.some(M=>(0,v.areSameExtensions)({id:M},{id:L}))||j.every(M=>!(0,v.areSameExtensions)({id:M},{id:L}))&&j.push(L)}if(j.length){const m=[...u,...E.map(M=>M.gallery.identifier)],L=j.filter(M=>m.every(Q=>!(0,v.areSameExtensions)(Q,{id:M})));if(L.length){const M=await this.galleryService.getExtensions(L.map(Q=>({id:Q,preRelease:r})),p.CancellationToken.None);for(const Q of M){if(m.find(ne=>(0,v.areSameExtensions)(ne,Q.identifier)))continue;const W=z.some(ne=>(0,v.areSameExtensions)({id:ne},Q.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(Q,!0,r)}catch(ne){if(ne instanceof h.ExtensionManagementError&&ne.code===h.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw ne}E.push({gallery:q.extension,manifest:q.manifest}),await P(q.extension.identifier,q.manifest)}}}};return await P(a,i),o=await this.getInstalled(),E.filter(I=>!o.some(O=>(0,v.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,n){const r=await this.getExtensionsControlManifest();if((0,v.getMaliciousExtensionsSet)(r).has(a.identifier.id))throw new h.ExtensionManagementError(A.localize(3,null,a.identifier.id),h.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[a.identifier.id])throw new h.ExtensionManagementError(A.localize(4,null,a.identifier.id,r.unsupportedPreReleaseExtensions[a.identifier.id].displayName),h.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const E=await this.getTargetPlatform();throw new h.ExtensionManagementError(A.localize(5,null,a.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(E)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,i,n);if(o){if(n&&i&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new h.ExtensionManagementError(A.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&a.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([a.identifier],p.CancellationToken.None))[0]?new h.ExtensionManagementError(A.localize(7,null,a.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(A.localize(8,null,a.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const u=await this.galleryService.getManifest(o,p.CancellationToken.None);if(u===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new h.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async getCompatibleVersion(a,i,n){const r=await this.getTargetPlatform();let o=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==n&&(o=(await this.galleryService.getExtensions([{...a.identifier,preRelease:n}],{targetPlatform:r,compatible:!0},p.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(a,n,r)&&(o=a),!o&&i&&(o=await this.galleryService.getCompatibleExtension(a,n,r)),o}async unininstallExtension(a,i){const n=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),n.waitUntilTaskIsFinished();const r=(P,I)=>{const O=this.createUninstallExtensionTask(P,I);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),O},o=(P,I)=>{I?this.logService.error("Failed to uninstall extension:",P.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),w(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)(P),void 0,I),this._onDidUninstallExtension.fire({identifier:P.identifier,error:I?.code})},u=[],E=[];try{u.push(r(a,{}));const P=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,P);for(const O of I)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):u.push(r(O,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(I=>I.extension),P,a),await this.joinAllSettled(u.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(I.extension,i,p.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(O){const z=O instanceof h.ExtensionManagementError?O:new h.ExtensionManagementError((0,k.getErrorMessage)(O),h.ExtensionManagementErrorCode.Internal);throw o(I.extension,z),z}finally{E.push(I)}}))}catch(P){const I=P instanceof h.ExtensionManagementError?P:new h.ExtensionManagementError((0,k.getErrorMessage)(P),h.ExtensionManagementErrorCode.Internal);for(const O of u){try{O.cancel()}catch{}E.includes(O)||o(O.extension,I)}throw I}finally{for(const P of u)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(a,i,n){for(const r of a){const o=this.getDependents(r,i);if(o.length){const u=o.filter(E=>!a.some(P=>(0,v.areSameExtensions)(P.identifier,E.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(r,u,n))}}}getDependentsErrorMessage(a,i,n){return n===a?i.length===1?A.localize(9,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?A.localize(10,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):A.localize(11,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?A.localize(12,null,n.manifest.displayName||n.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?A.localize(13,null,n.manifest.displayName||n.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):A.localize(14,null,n.manifest.displayName||n.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,n=[]){if(n.indexOf(a)!==-1)return[];n.push(a);const r=a.manifest.extensionPack?a.manifest.extensionPack:[];if(r.length){const o=i.filter(E=>!E.isBuiltin&&r.some(P=>(0,v.areSameExtensions)({id:P},E.identifier))),u=[];for(const E of o)u.push(...this.getAllPackExtensionsToUninstall(E,i,n));return[...o,...u]}return[]}getDependents(a,i){return i.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(r=>(0,v.areSameExtensions)({id:r},a.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};S=Te([Ne(0,h.IExtensionGalleryService),Ne(1,g.ITelemetryService),Ne(2,l.ILogService),Ne(3,d.IProductService)],S),e.AbstractExtensionManagementService=S;function c(s){const a=Array.isArray(s)?s:[s];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,n)=>new Error(`${i.message}${i.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=c;function C(s){if(s instanceof h.ExtensionManagementError)return s;const a=new h.ExtensionManagementError(s.message,h.ExtensionManagementErrorCode.Internal);return a.stack=s.stack,a}function w(s,a,i,n,r){const o=r?r instanceof h.ExtensionManagementError?r.code:h.ExtensionManagementErrorCode.Internal:void 0;s.publicLogError(a,{...i,success:!r,duration:n,errorcode:o})}e.reportTelemetry=w;class f{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(a=>new Promise((i,n)=>{const r=a.onCancellationRequested(()=>{r.dispose(),n((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=f}),define(ve[42],we([0,1,20,12,28,29]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class D{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,c){return Promise.resolve(void 0)}publicLog2(S,c){return this.publicLog(S,c)}publicLogError(S,c){return Promise.resolve(void 0)}publicLogError2(S,c){return this.publicLogError(S,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class R{async publicLog(S,c,C){}async publicLogError(S,c,C){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(g,S){return S.onDidChangeConfiguration(c=>{c.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(c.source),configurationKeys:l(c.sourceConfig)})})}e.configurationTelemetry=y;function b(g,S){return!(S.disableTelemetry||!g.enableTelemetry||S.extensionTestsLocationURI)}e.supportsTelemetry=b;function T(g){const S=g.getValue(k.TELEMETRY_SETTING_ID),c=g.getValue("telemetry.enableCrashReporter");if(g.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=T;function A(g){const S=Object.create(null),c=Object.create(null),C=Object.create(null);v(g,C);for(let w in C){w=w.length>150?w.substr(w.length-149):w;const f=C[w];typeof f=="number"?c[w]=f:typeof f=="boolean"?c[w]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${f.length}`),S[w]=f.substring(0,8191)):typeof f!="undefined"&&f!==null&&(S[w]=f)}return{properties:S,measurements:c}}e.validateTelemetryData=A;function h(g){if(!g)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{g.indexOf(`${C}+`)===0&&(S=C)}),S}e.cleanRemoteAuthority=h;function v(g,S,c=0,C){if(!!g)for(let w of Object.getOwnPropertyNames(g)){const f=g[w],s=C?C+w:w;Array.isArray(f)?S[s]=(0,_.safeStringify)(f):f instanceof Date?S[s]=f.toISOString():(0,t.isObject)(f)?c<2?v(f,S,c+1,s+"."):S[s]=(0,_.safeStringify)(f):S[s]=f}}function l(g){if(!g)return[];const S=[];return d(S,"",g),S}function d(g,S,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(C=>d(g,S?`${S}.${C}`:C,c[C])):g.push(S)}}),define(ve[214],we([0,1,183,42]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function p(k,D,R,y,b,T){const A={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${D.nameShort})`},h=await(0,_.getServiceMachineId)(R,b,T);return(0,t.supportsTelemetry)(D,R)&&(0,t.getTelemetryLevel)(y)===3&&(A["X-Market-User-Id"]=h),A}e.resolveMarketplaceHeaders=p}),define(ve[100],we([0,1,17,21,11,20,3,24,12,5,28,26,34,33,65,16,14,32,47,214,209,29]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=D.isWeb?"web":(0,h.getTargetPlatform)(D.platform,R.arch);var a;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished",H[H.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...H){return String(H.reduce((V,ie)=>V|ie,0))}var n;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class P{constructor(V=E){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,ie=this.state.pageSize){return new P({...this.state,pageNumber:V,pageSize:ie})}withFilter(V,...ie){const de=[...this.state.criteria,...ie.length?ie.map(De=>({filterType:V,value:De})):[{filterType:V}]];return new P({...this.state,criteria:de})}withSortBy(V){return new P({...this.state,sortBy:V})}withSortOrder(V){return new P({...this.state,sortOrder:V})}withFlags(...V){return new P({...this.state,flags:V.reduce((ie,de)=>ie|de,0)})}withAssetTypes(...V){return new P({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:ie,pageSize:de,sortBy:De,sortOrder:ae,flags:fe,assetTypes:pe}=this.state;return{filters:[{criteria:V,pageNumber:ie,pageSize:de,sortBy:De,sortOrder:ae}],assetTypes:pe,flags:fe}}get searchText(){const V=this.state.criteria.filter(ie=>ie.filterType===n.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function I(H,V){const ie=(H||[]).filter(de=>de.statisticName===V)[0];return ie?ie.value:0}function O(H){const V="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(de=>de.assetType.indexOf(V)===0).reduce((de,De)=>{const ae=L(H,De.assetType);return ae&&de.push([De.assetType.substring(V.length),ae]),de},[])}function z(H){if(H.properties){const V=H.properties.filter(De=>De.key===r.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),de=V.filter(De=>ie.test(De.value))[0];return de?{uri:de.value,fallbackUri:de.value}:null}return L(H,r.Repository)}function j(H){return{uri:`${H.fallbackAssetUri}/${r.VSIX}?redirect=true${H.targetPlatform?`&targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${r.VSIX}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}}function m(H){const V=L(H,r.Icon);if(V)return V;const ie=h.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function L(H,V){return H.files.filter(de=>de.assetType===V)[0]?{uri:`${H.assetUri}/${V}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${V}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}:null}function M(H,V){const ie=H.properties?H.properties.filter(De=>De.key===V):[],de=ie.length>0&&ie[0].value;return de?de.split(",").map(De=>(0,v.adoptToGalleryExtensionId)(De)):[]}function Q(H){const V=H.properties?H.properties.filter(ie=>ie.key===o.Engine):[];return V.length>0&&V[0].value||""}function W(H){const V=H.properties?H.properties.filter(ie=>ie.key===o.PreRelease):[];return V.length>0&&V[0].value==="true"}function q(H){const V=H.properties?H.properties.filter(de=>de.key===o.LocalizedLanguages):[],ie=V.length>0&&V[0].value||"";return ie?ie.split(","):[]}function ne(H){return H.indexOf("preview")!==-1}function B(H){return H.targetPlatform?(0,h.toTargetPlatform)(H.targetPlatform):"undefined"}function G(H){const V=(0,_.distinct)(H.versions.map(B)),ie=!!H.tags?.includes(h.WEB_EXTENSION_TAG),de=V.indexOf("web");return ie?de===-1&&V.push("web"):de!==-1&&V.splice(de,1),V}function ee(H,V){const ie=(0,h.getFallbackTargetPlarforms)(V);for(let de=0;de<H.length;de++){const De=H[de];if(De.version===H[de-1]?.version){let ae=de;const fe=B(De);if(fe===V)for(;ae>0&&H[ae-1].version===De.version;)ae--;else if(ie.includes(fe))for(;ae>0&&H[ae-1].version===De.version&&B(H[ae-1])!==V;)ae--;ae!==de&&(H.splice(de,1),H.splice(ae,0,De))}}return H}e.sortExtensionVersions=ee;function oe(H,V,ie){H.telemetryData={index:V,querySource:ie}}function se(H,V,ie){const de=H.versions[0],De={manifest:L(V,r.Manifest),readme:L(V,r.Details),changelog:L(V,r.Changelog),license:L(V,r.License),repository:z(V),download:j(V),icon:m(V),coreTranslations:O(V)};return{identifier:{id:(0,v.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:V.version,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,publisherDomain:H.publisher.domain?{link:H.publisher.domain,verified:!!H.publisher.isDomainVerified}:void 0,description:H.shortDescription||"",installCount:I(H.statistics,"install"),rating:I(H.statistics,"averagerating"),ratingCount:I(H.statistics,"ratingcount"),categories:H.categories||[],tags:H.tags||[],releaseDate:Date.parse(H.releaseDate),lastUpdated:Date.parse(H.lastUpdated),allTargetPlatforms:ie,assets:De,properties:{dependencies:M(V,o.Dependency),extensionPack:M(V,o.ExtensionPack),engine:Q(V),localizedLanguages:q(V),targetPlatform:B(V),isPreReleaseVersion:W(V)},hasPreReleaseVersion:W(de),hasReleaseVersion:!0,preview:ne(H.flags)}}let me=class{constructor(V,ie,de,De,ae,fe,pe,X){this.requestService=ie,this.logService=de,this.environmentService=De,this.telemetryService=ae,this.fileService=fe,this.productService=pe,this.configurationService=X;const U=pe.extensionsGallery;this.extensionsGalleryUrl=U&&U.serviceUrl,this.extensionsControlUrl=U&&U.controlUrl,this.commonHeadersPromise=(0,C.resolveMarketplaceHeaders)(pe.version,pe,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,ie,de){const De=t.CancellationToken.isCancellationToken(ie)?{}:ie,ae=t.CancellationToken.isCancellationToken(ie)?ie:de,fe=[],pe=[],X=[],U=[];let K=!0;for(const ye of V){ye.uuid?pe.push(ye.uuid):fe.push(ye.id);const Pe=!!(ye.version||ye.preRelease);X.push({id:ye.id,uuid:ye.uuid,includePreRelease:Pe}),ye.version&&U.push({id:ye.id,uuid:ye.uuid,version:ye.version}),K=K&&!!ye.hasPreRelease&&!Pe}if(!pe.length&&!fe.length)return[];let Y=new P().withPage(1,V.length);pe.length&&(Y=Y.withFilter(n.ExtensionId,...pe)),fe.length&&(Y=Y.withFilter(n.ExtensionName,...fe)),(De.queryAllVersions||K)&&(Y=Y.withFlags(Y.flags,a.IncludeVersions));const{extensions:ue}=await this.queryGalleryExtensions(Y,{targetPlatform:De.targetPlatform??s,includePreRelease:X,versions:U,compatible:!!De.compatible},ae);return De.source&&ue.forEach((ye,Pe)=>oe(ye,Pe,De.source)),ue}async getCompatibleExtension(V,ie,de){if((0,h.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,de))return null;if(await this.isExtensionCompatible(V,ie,de))return V;const De=new P().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,V.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(De,{targetPlatform:de,compatible:!0,includePreRelease:ie},t.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(V,ie,de){if(!(0,h.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,de)||!ie&&V.properties.isPreReleaseVersion)return!1;let De=V.properties.engine;if(!De){const ae=await this.getManifest(V,t.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");De=ae.engines.vscode}return(0,l.isEngineValid)(De,this.productService.version,this.productService.date)}async isValidVersion(V,ie,de,De,ae){if(!(0,h.isTargetPlatformCompatible)(B(V),De,ae)||ie!=="any"&&W(V)!==(ie==="prerelease"))return!1;if(de){const fe=await this.getEngine(V);if(!(0,l.isEngineValid)(fe,this.productService.version,this.productService.date))return!1}return!0}async query(V,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let de=V.text||"";const De=(0,k.getOrDefault)(V,K=>K.pageSize,50);let ae=new P().withPage(1,De);de?(de=de.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,Y,ue)=>(ae=ae.withFilter(n.Category,ue||Y),"")),de=de.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,Y,ue)=>(ae=ae.withFilter(n.Tag,ue||Y),"")),de=de.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),de=de.trim(),de&&(de=de.length<200?de:de.substring(0,200),ae=ae.withFilter(n.SearchText,de)),ae=ae.withSortBy(0)):V.ids?ae=ae.withFilter(n.ExtensionId,...V.ids):V.names?ae=ae.withFilter(n.ExtensionName,...V.names):ae=ae.withSortBy(4),typeof V.sortBy=="number"&&(ae=ae.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ae=ae.withSortOrder(V.sortOrder));const fe=async(K,Y)=>{const{extensions:ue,total:ye}=await this.queryGalleryExtensions(K,{targetPlatform:s,compatible:!1,includePreRelease:!!V.includePreRelease},Y);return ue.forEach((Pe,Ae)=>oe(Pe,(K.pageNumber-1)*K.pageSize+Ae,V.source)),{extensions:ue,total:ye}},{extensions:pe,total:X}=await fe(ae,ie),U=async(K,Y)=>{if(Y.isCancellationRequested)throw new p.CancellationError;const{extensions:ue}=await fe(ae.withPage(K+1),Y);return ue};return{firstPage:pe,total:X,pageSize:ae.pageSize,getPage:U}}async queryGalleryExtensions(V,ie,de){const De=V.flags;!!(V.flags&a.IncludeLatestVersionOnly)&&!!(V.flags&a.IncludeVersions)&&(V=V.withFlags(V.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(V.flags&a.IncludeLatestVersionOnly)&&!(V.flags&a.IncludeVersions)&&(V=V.withFlags(V.flags,a.IncludeLatestVersionOnly)),ie.versions?.length&&(V=V.withFlags(V.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),V=V.withFlags(V.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:ae,total:fe}=await this.queryRawGalleryExtensions(V,de);if(!(V.flags&a.IncludeLatestVersionOnly)){const K=[];for(const Y of ae){const ue=await this.toGalleryExtensionWithCriteria(Y,ie,!0);ue&&K.push(ue)}return{extensions:K,total:fe}}const X=[],U=new Map;for(let K=0;K<ae.length;K++){const Y=ae[K],ue={id:(0,v.getGalleryExtensionId)(Y.publisher.publisherName,Y.extensionName),uuid:Y.extensionId},ye=(0,y.isBoolean)(ie.includePreRelease)?ie.includePreRelease:!!ie.includePreRelease.find(Ae=>(0,v.areSameExtensions)(Ae,ue))?.includePreRelease;let Pe=await this.toGalleryExtensionWithCriteria(Y,ie,!1);!Pe||Pe.properties.isPreReleaseVersion&&(!ye||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==ie.targetPlatform&&Pe.hasPreReleaseVersion?U.set(Y.extensionId,K):X.push([K,Pe])}if(U.size){const K=new Date().getTime(),Y=new P().withFlags(De&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,U.size).withFilter(n.ExtensionId,...U.keys()),{extensions:ue}=await this.queryGalleryExtensions(Y,ie,de);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-K,count:U.size});for(const ye of ue){const Pe=U.get(ye.identifier.uuid);X.push([Pe,ye])}}return{extensions:X.sort((K,Y)=>K[0]-Y[0]).map(([,K])=>K),total:fe}}async toGalleryExtensionWithCriteria(V,ie,de){const De={id:(0,v.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},ae=ie.versions?.find(U=>(0,v.areSameExtensions)(U,De))?.version,fe=(0,y.isBoolean)(ie.includePreRelease)?ie.includePreRelease:!!ie.includePreRelease.find(U=>(0,v.areSameExtensions)(U,De))?.includePreRelease,pe=G(V),X=ee(V.versions,ie.targetPlatform);if(ie.compatible&&de&&(0,h.isNotWebExtensionInWebTargetPlatform)(pe,ie.targetPlatform))return null;for(let U=0;U<X.length;U++){const K=X[U];if(!(ae&&K.version!==ae)){if(await this.isValidVersion(K,fe?"any":"release",ie.compatible,pe,ie.targetPlatform))return se(V,K,pe);if(ae&&K.version===ae)return null}}return ae||ie.compatible?null:se(V,V.versions[0],pe)}async queryRawGalleryExtensions(V,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const de=await this.commonHeadersPromise,De=JSON.stringify(V.raw),ae={...de,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(De.length)},fe=new Date().getTime();let pe,X,U=0;try{if(pe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:De,headers:ae},ie),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:U};const K=await(0,c.asJson)(pe);if(K){const Y=K.results[0],ue=Y.extensions,ye=Y.resultMetadata&&Y.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return U=ye&&ye.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:U}}return{galleryExtensions:[],total:U}}catch(K){throw X=K,K}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(De.length),duration:new Date().getTime()-fe,success:!!pe&&(0,c.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:X?(0,p.isCancellationError)(X)?"canceled":(0,p.getErrorMessage)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(U)})}}async reportStatistic(V,ie,de,De){if(!this.isEnabled())return;const ae=D.isWeb?this.api(`/itemName/${V}.${ie}/version/${de}/statType/${De==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${ie}/${de}/stats?statType=${De}`),fe=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ae,headers:X},t.CancellationToken.None)}catch{}}async download(V,ie,de){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const De=(0,v.getGalleryExtensionTelemetryData)(V),ae=new Date().getTime(),fe=K=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...De,duration:K}),pe=de===2?"install":de===3?"update":"",X=pe?{uri:`${V.assets.download.uri}${b.URI.parse(V.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${V.assets.download.fallbackUri}${b.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:V.assets.download,U=await this.getAsset(X);await this.fileService.writeFile(ie,U.stream),fe(new Date().getTime()-ae)}async getReadme(V,ie){if(V.assets.readme){const de=await this.getAsset(V.assets.readme,{},ie);return await(0,c.asText)(de)||""}return""}async getManifest(V,ie){if(V.assets.manifest){const de=await this.getAsset(V.assets.manifest,{},ie),De=await(0,c.asText)(de);return De?JSON.parse(De):null}return null}async getManifestFromRawExtensionVersion(V,ie){const de=L(V,r.Manifest);if(!de)throw new Error("Manifest was not found");const De={"Accept-Encoding":"gzip"},ae=await this.getAsset(de,{headers:De});return await(0,c.asJson)(ae)}async getCoreTranslation(V,ie){const de=V.assets.coreTranslations.filter(De=>De[0]===ie.toUpperCase())[0];if(de){const De=await this.getAsset(de[1]),ae=await(0,c.asText)(De);return ae?JSON.parse(ae):null}return null}async getChangelog(V,ie){if(V.assets.changelog){const de=await this.getAsset(V.assets.changelog,{},ie);return await(0,c.asText)(de)||""}return""}async getAllCompatibleVersions(V,ie,de){let De=new P().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);V.identifier.uuid?De=De.withFilter(n.ExtensionId,V.identifier.uuid):De=De.withFilter(n.ExtensionName,V.identifier.id);const{galleryExtensions:ae}=await this.queryRawGalleryExtensions(De,t.CancellationToken.None);if(!ae.length)return[];const fe=G(ae[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(fe,de))return[];const pe=[],X=new Set;return await Promise.all(ae[0].versions.map(async U=>{try{if(X.has(U.version))return;await this.isValidVersion(U,ie?"prerelease":"release",!0,fe,de)&&(pe.push({version:U.version,date:U.lastUpdated,isPreReleaseVersion:W(U)}),X.add(U.version))}catch{}})),pe}async getAsset(V,ie={},de=t.CancellationToken.None){const De=await this.commonHeadersPromise,ae={type:"GET"},fe={...De,...ie.headers||{}};ie={...ie,...ae,headers:fe};const pe=V.uri,X=V.fallbackUri,U={...ie,url:pe};try{const K=await this.requestService.request(U,de);if(K.res.statusCode===200)return K;const Y=await(0,c.asText)(K);throw new Error(`Expected 200, got back ${K.res.statusCode} instead.

${Y}`)}catch(K){if((0,p.isCancellationError)(K))throw K;const Y=(0,p.getErrorMessage)(K);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:Y});const ue={...ie,url:X};return this.requestService.request(ue,de)}}async getEngine(V){let ie=Q(V);if(!ie){const de=await this.getManifestFromRawExtensionVersion(V,t.CancellationToken.None);if(!de)throw new Error("Manifest was not found");ie=de.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,c.asJson)(V),de=[],De={};if(ie){for(const ae of ie.malicious)de.push({id:ae});if(ie.unsupported)for(const ae of Object.keys(ie.unsupported)){const fe=ie.unsupported[ae];(0,y.isBoolean)(fe)||(De[ae.toLowerCase()]=fe.preReleaseExtension)}if(ie.migrateToPreRelease)for(const[ae,fe]of Object.entries(ie.migrateToPreRelease))(!fe.engine||(0,l.isEngineValid)(fe.engine,this.productService.version,this.productService.date))&&(De[ae.toLowerCase()]=fe)}return{malicious:de,unsupportedPreReleaseExtensions:De}}};me=Te([Ne(1,c.IRequestService),Ne(2,g.ILogService),Ne(3,A.IEnvironmentService),Ne(4,f.ITelemetryService),Ne(5,d.IFileService),Ne(6,S.IProductService),Ne(7,T.IConfigurationService)],me);let Z=class extends me{constructor(V,ie,de,De,ae,fe,pe,X){super(V,ie,de,De,ae,fe,pe,X)}};Z=Te([Ne(0,w.IStorageService),Ne(1,c.IRequestService),Ne(2,g.ILogService),Ne(3,A.IEnvironmentService),Ne(4,f.ITelemetryService),Ne(5,d.IFileService),Ne(6,S.IProductService),Ne(7,T.IConfigurationService)],Z),e.ExtensionGalleryService=Z;let $=class extends me{constructor(V,ie,de,De,ae,fe,pe){super(void 0,V,ie,de,De,ae,fe,pe)}};$=Te([Ne(0,c.IRequestService),Ne(1,g.ILogService),Ne(2,A.IEnvironmentService),Ne(3,f.ITelemetryService),Ne(4,d.IFileService),Ne(5,S.IProductService),Ne(6,T.IConfigurationService)],$),e.ExtensionGalleryServiceWithNoStorageService=$}),define(ve[215],we([0,1,2,20,3,18,168,28,46,45,35,29,42]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(g,S){this._configurationService=S,this._experimentProperties={},this._disposables=new _.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3})}setExperimentProperty(g,S){this._experimentProperties[g]=S}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let S=g.sessionID,c=g["common.machineId"],C=g["common.firstSessionDate"],w=g["common.msftInternal"];return{sessionId:S,machineId:c,firstSessionDate:C,msftInternal:w}}dispose(){this._disposables.dispose()}_log(g,S,c,C){return this.telemetryLevel<S?Promise.resolve(void 0):this._commonProperties.then(w=>{c=(0,t.mixin)(c,w),c=(0,t.mixin)(c,this._experimentProperties),c=(0,t.cloneAndChange)(c,f=>{if(typeof f=="string")return this._cleanupInfo(f,C)}),this._appenders.forEach(f=>f.log(g,c))},w=>{console.error(w)})}publicLog(g,S,c){return this._log(g,3,S,c)}publicLog2(g,S,c){return this.publicLog(g,S,c)}publicLogError(g,S){return this.sendErrorTelemetry?this._log(g,2,S,!0):Promise.resolve(void 0)}publicLogError2(g,S){return this.publicLogError(g,S)}_anonymizeFilePaths(g){let S=g;const c=[];for(let s of this._cleanupPatterns)for(;;){const a=s.exec(g);if(!a)break;c.push([a.index,s.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(S="";;){const s=w.exec(g);if(!s)break;!C.test(s[0])&&c.every(([a,i])=>s.index<a||s.index>=i)&&(S+=g.substring(f,s.index)+"<REDACTED: user-file-path>",f=w.lastIndex)}return f<g.length&&(S+=g.substr(f)),S}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const S=g.toLowerCase(),c=/@[a-zA-Z0-9-.]+/,C=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,w=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return C.test(S)?"<REDACTED: secret>":c.test(S)?"<REDACTED: email>":w.test(S)?"<REDACTED: token>":g}_cleanupInfo(g,S){let c=g;S&&(c=this._anonymizeFilePaths(c));for(let C of this._cleanupPatterns)c=c.replace(C,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=Te([Ne(1,R.IConfigurationService)],v),e.TelemetryService=v;function l(){const d=(0,D.localize)(0,null,b.default.nameLong),g=b.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=p.isWeb?"":(0,D.localize)(3,null),c=(0,D.localize)(4,null),C=(0,D.localize)(5,null),w=(0,D.localize)(6,null),f=(0,D.localize)(7,null),s=`
|       | ${c} | ${C} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,D.localize)(8,null);return`
${d} ${g} ${S}

&nbsp;

${f}
${s}

&nbsp;

${a}
`}T.Registry.as(y.Extensions.Configuration).registerConfiguration({id:A.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[A.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:l(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),T.Registry.as(y.Extensions.Configuration).registerConfiguration({id:A.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[A.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,D.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,D.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${A.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[216],we([0,1,11,20,42]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(R,y){const b=await new Promise((A,h)=>{J(["applicationinsights"],A,h)});let T;return b.defaultClient?(T=new b.TelemetryClient(R),T.channel.setUseDiskRetryCaching(!0)):(b.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),T=b.defaultClient),R.indexOf("AIF-")===0&&(T.config.endpointUrl=y?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),T}class D{constructor(y,b,T,A,h){this._eventPrefix=y,this._defaultData=b,this.testCollector=A,this.mirrored=h,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{y(b)},b=>{(0,_.onUnexpectedError)(b),console.error(b)})}}log(y,b){if(!!this._aiClient){b=(0,t.mixin)(b,this._defaultData),b=(0,p.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+y,properties:b.properties,measurements:b.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(b=>{try{b.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=D}),define(ve[217],we([0,1,11,211]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class p extends t.default{installErrorListeners(){(0,_.setUnexpectedErrorHandler)(R=>console.error(R));const D=[];process.on("unhandledRejection",(R,y)=>{D.push(y),setTimeout(()=>{const b=D.indexOf(y);b>=0&&y.catch(T=>{D.splice(b,1),(0,_.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),R&&(0,_.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const y=D.indexOf(R);y>=0&&D.splice(y,1)}),process.on("uncaughtException",R=>{(0,_.onUnexpectedError)(R)})}}e.default=p}),define(ve[218],we([0,1,13,21,7,2,14]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(b,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new p.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((T,A)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,T),this._onCreateRequest.fire({requestId:h,...b});const v=new t.CancellationTokenSource;(0,_.timeout)(this._timeout,v.token).then(()=>A(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,k.toDisposable)(()=>v.cancel())])})}acceptReply(b,T){const A=this._pendingRequests.get(b);A?(this._pendingRequests.delete(b),(0,k.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),A(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};R=Te([Ne(1,D.ILogService)],R),e.RequestStore=R}),define(ve[101],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var p;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(p=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var D;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(D=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,_.createDecorator)("ptyService");var y;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(y=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var T;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(T=e.TerminalLocation||(e.TerminalLocation={}));var A;(function(d){d.TerminalView="view",d.Editor="editor"})(A=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var l;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(l=e.ProfileSource||(e.ProfileSource={}))}),define(ve[219],we([0,1,25,20,4,3,24,12,19]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const A=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let h=0;return A&&A.length===4&&(h=parseInt(A[3])),h}e.getWindowsBuildNumber=b;async function T(A,h,v,l=D.env,d=y.Promises.exists){if(p.isAbsolute(A))return await d(A)?A:void 0;if(h===void 0&&(h=D.cwd()),p.dirname(A)!=="."){const C=p.join(h,A);return await d(C)?C:void 0}const S=(0,t.getCaseInsensitive)(l,"PATH");if(v===void 0&&(0,R.isString)(S)&&(v=S.split(p.delimiter)),v===void 0||v.length===0){const C=p.join(h,A);return await d(C)?C:void 0}for(let C of v){let w;if(p.isAbsolute(C)?w=p.join(C,A):w=p.join(h,C,A),await d(w))return w;if(k.isWindows){let f=w+".com";if(await d(f)||(f=w+".exe",await d(f)))return f}}const c=p.join(h,A);return await d(c)?c:void 0}e.findExecutable=T}),define(ve[220],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ve[102],we([0,1,37,7,2,6,35,220]),function(J,e,_,t,p,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var y;(function(g){function S(c){return c&&typeof c=="object"&&typeof c.id=="string"}g.isThemeColor=S})(y=e.ThemeColor||(e.ThemeColor={}));function b(g){return{id:g}}e.themeColorFromId=b;var T;(function(g){function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||y.isThemeColor(n.color))}g.isThemeIcon=S;const c=new RegExp(`^\\$\\((${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?)\\)$`);function C(n){const r=c.exec(n);if(!r)return;let[,o]=r;return{id:o}}g.fromString=C;function w(n){return{id:n}}g.fromId=w;function f(n,r){let o=n.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),r&&(o=`${o}~${r}`),{id:o}}g.modify=f;function s(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}g.getModifier=s;function a(n,r){return n.id===r.id&&n.color?.id===r.color?.id}g.isEqual=a;function i(n,r){return{id:n.id,color:r?b(r):void 0}}g.asThemeIcon=i,g.asClassNameArray=_.CSSIcon.asClassNameArray,g.asClassName=_.CSSIcon.asClassName,g.asCSSSelector=_.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=_.Codicon.file,e.FolderThemeIcon=_.Codicon.folder;function A(g){switch(g){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,p.toDisposable)(()=>{const c=this.themingParticipants.indexOf(S);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new h;D.Registry.add(e.Extensions.ThemingContribution,v);function l(g){return v.onColorThemeChange(g)}e.registerThemingParticipant=l;class d extends p.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,c){let C=this.theme.getColor(S);return C&&c&&(C=c(C,this.theme)),C?C.toString():null}}e.Themable=d}),define(ve[221],we([0,1,37,5,102]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(A,h){const v=A.map(l=>({name:l.profileName,description:D(l)}));return h&&v.push(...h.map(l=>({name:l.title,description:R(l)}))),{values:v.map(l=>l.name),markdownDescriptions:v.map(l=>l.description)}}e.createProfileSchemaEnums=k;function D(A){let h=`$(${p.ThemeIcon.isThemeIcon(A.icon)?A.icon.id:A.icon?A.icon:_.Codicon.terminal.id}) ${A.profileName}
- path: ${A.path}`;return A.args&&(typeof A.args=="string"?h+=`
- args: "${A.args}"`:h+=`
- args: [${A.args.length===0?"":`'${A.args.join("','")}'`}]`),A.overrideName!==void 0&&(h+=`
- overrideName: ${A.overrideName}`),A.color&&(h+=`
- color: ${A.color}`),A.env&&(h+=`
- env: ${JSON.stringify(A.env)}`),h}function R(A){return`$(${p.ThemeIcon.isThemeIcon(A.icon)?A.icon.id:A.icon?A.icon:_.Codicon.terminal.id}) ${A.title}
- extensionIdenfifier: ${A.extensionIdentifier}`}function y(A,h){if(!A&&!h)return!0;if(typeof A=="string"&&typeof h=="string")return A===h;if(Array.isArray(A)&&Array.isArray(h)){if(A.length!==h.length)return!1;for(let v=0;v<A.length;v++)if(A[v]!==h[v])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function b(A,h){if(!A&&!h)return!0;if(!A||!h)return!1;if(p.ThemeIcon.isThemeIcon(A)&&p.ThemeIcon.isThemeIcon(h))return A.id===h.id&&A.color===h.color;if(typeof A=="object"&&A&&"light"in A&&"dark"in A&&typeof h=="object"&&h&&"light"in h&&"dark"in h){const v=A,l=h;if((t.URI.isUri(v.light)||T(v.light))&&(t.URI.isUri(v.dark)||T(v.dark))&&(t.URI.isUri(l.light)||T(l.light))&&(t.URI.isUri(l.dark)||T(l.dark)))return v.light.path===l.light.path&&v.dark.path===l.dark.path}if(t.URI.isUri(A)&&t.URI.isUri(h)||T(A)||T(h)){const v=A,l=h;return v.path===l.path&&v.scheme===l.scheme}return!1}e.terminalIconsEqual=b;function T(A){return A?typeof A.path=="string"&&typeof A.scheme=="string":!1}e.isUriComponents=T}),define(ve[222],we([0,1,37,169,46,35,221]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(_.Codicon.getAll(),w=>w.id),markdownEnumDescriptions:Array.from(_.Codicon.getAll(),w=>`$(${w.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...R}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),A=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),h=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),l=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),d=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),g={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:l},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:A},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:h},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...R}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...R}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...R}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function S(){k.Registry.as(p.Extensions.Configuration).registerConfiguration(g),C()}e.registerTerminalPlatformConfiguration=S;let c;function C(w,f){const s=k.Registry.as(p.Extensions.Configuration);let a;w&&(a=(0,D.createProfileSchemaEnums)(w?.profiles,f));const i=c;c={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:w?.os===3?a?.values:void 0,markdownEnumDescriptions:w?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:w?.os===2?a?.values:void 0,markdownEnumDescriptions:w?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:w?.os===1?a?.values:void 0,markdownEnumDescriptions:w?.os===1?a?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[c],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=C}),define(ve[223],we([0,1,39,37,4,3,19,82,219,102]),function(J,e,_,t,p,k,D,R,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,A=!0;function h(a,i,n,r,o=process.env,u,E,P,I){return u=u||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},k.isWindows?v(n,u,o,E,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),I,P):w(u,E,n,a&&typeof a=="object"?{...a}:r.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,P,o)}e.detectAvailableProfiles=h;async function v(a,i,n,r,o,u,E,P,I){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),z=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let j=!1;(0,y.getWindowsBuildNumber)()>=16299&&(j=!0),await g(P);const m=new Map;a&&(m.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),m.set("Windows PowerShell",{path:`${z}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),m.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),m.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),m.set("Command Prompt",{path:`${z}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),f(u,m);const L=await l(m.entries(),E,i,n,r,I);if(a||!a&&o)try{const M=await c(`${z}\\${j?"wsl":"bash"}.exe`,E);for(const Q of M)(!u||!(Q.profileName in u))&&L.push(Q)}catch{A&&(r?.info("WSL is not installed, so could not detect WSL profiles"),A=!1)}return L}async function l(a,i,n,r=process.env,o,u){const E=[];for(const[P,I]of a){if(I===null)continue;let O,z,j;if("source"in I){const M=T?.get(I.source);if(!M)continue;O=M.paths,z=I.args||M.args,I.icon?j=d(I.icon):M.icon&&(j=M.icon)}else O=Array.isArray(I.path)?I.path:[I.path],z=k.isWindows||Array.isArray(I.args)?I.args:void 0,j=d(I.icon);const m=await u?.(O)||O.slice(),L=await s(P,i,m,n,r,z,I.env,I.overrideName,I.isAutoDetected,o);L?(L.isAutoDetected=I.isAutoDetected,L.icon=j,L.color=I.color,E.push(L)):o?.trace("profile not validated",P,O)}return E}function d(a){return typeof a=="string"?{id:a}:a}async function g(a){T&&!a||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:a||await S(),icon:b.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function S(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function c(a,i){const n=[],r=await new Promise((E,P)=>{_.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,O)=>{if(I)return P("Problem occurred when getting wsl distros");E(O)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),u=r.split(o).filter(E=>E.trim().length>0&&E!=="");for(const E of u){if(E===""||E.startsWith("docker-desktop"))continue;const P=`${E} (WSL)`,I={profileName:P,path:a,args:["-d",`${E}`],isDefault:P===i,icon:C(E),isAutoDetected:!1};n.push(I)}return n}function C(a){return a.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):a.includes("Debian")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function w(a,i,n,r,o,u,E,P){const I=new Map;if(n){const O=(await a.readFile("/etc/shells")).toString(),z=u||O.split(`
`).filter(m=>m.trim().indexOf("#")!==0&&m.trim().length>0),j=new Map;for(const m of z){let L=(0,p.basename)(m),M=j.get(L)||0;M++,M>1&&(L=`${L} (${M})`),j.set(L,M),I.set(L,{path:m,isAutoDetected:!0})}}return f(r,I),await l(I.entries(),o,a,P,i,E)}function f(a,i){if(!!a)for(const[n,r]of Object.entries(a))r===null||!("path"in r)&&!("source"in r)?i.delete(n):(r.icon=r.icon||i.get(n)?.icon,i.set(n,r))}async function s(a,i,n,r,o,u,E,P,I,O){if(n.length===0)return Promise.resolve(void 0);const z=n.shift();if(z==="")return s(a,i,n,r,o,u,E,P,I);const j={profileName:a,path:z,args:u,env:E,overrideName:P,isAutoDetected:I,isDefault:a===i};if((0,p.basename)(z)===z){const L=o.PATH?o.PATH.split(p.delimiter):void 0,M=await(0,y.findExecutable)(z,void 0,L,void 0,r.existsFile);return M?(j.path=M,j.isFromPath=!0,j):s(a,i,n,r,o,u)}return await r.existsFile((0,p.normalize)(z))?j:s(a,i,n,r,o,u,E,P,I)}}),define(ve[224],we([0,1,7,2,8,3,40,86,28,26,87,67,14,93,29,218,101,222,223]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var C;(function(s){s[s.MaxRestarts=5]="MaxRestarts"})(C||(C={}));let w=0,f=class extends t.Disposable{constructor(a,i,n,r,o){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=n,this._logService=r,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new _.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new _.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new _.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new _.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new _.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new _.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new _.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new _.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new _.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new _.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new _.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new _.Emitter),this.onProcessExit=this._onProcessExit.event,(0,S.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,A.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:w,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const n=new R.Client(p.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),D.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(E=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(E.code),this._isDisposed||(this._restartCount<=C.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${E.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${E.code}, giving up`))}));const o=n.getChannel(g.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=D.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(E=>this._onProcessData.fire(E))),this._register(u.onProcessReady(E=>this._onProcessReady.fire(E))),this._register(u.onProcessExit(E=>this._onProcessExit.fire(E))),this._register(u.onDidChangeProperty(E=>this._onDidChangeProperty.fire(E))),this._register(u.onProcessReplay(E=>this._onProcessReplay.fire(E))),this._register(u.onProcessOrphanQuestion(E=>this._onProcessOrphanQuestion.fire(E))),this._register(u.onDidRequestDetach(E=>this._onDidRequestDetach.fire(E))),[n,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,n,r,o,u,E,P,I,O,z){const j=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),m=await this._proxy.createProcess(a,i,n,r,o,u,E,P,I,O,z);return clearTimeout(j),w=Math.max(w,m),m}updateTitle(a,i,n){return this._proxy.updateTitle(a,i,n)}updateIcon(a,i,n){return this._proxy.updateIcon(a,i,n)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,n){return this._proxy.resize(a,i,n)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,n,r=!1){const o=await this._shellEnv;return(0,c.detectAvailableProfiles)(i,n,r,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,n){return this._proxy.updateProperty(a,i,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};f=Te([Ne(1,y.IConfigurationService),Ne(2,b.IEnvironmentService),Ne(3,h.ILogService),Ne(4,l.ITelemetryService)],f),e.PtyHostService=f}),define(ve[48],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,_.createDecorator)("IUriIdentityService")}),define(ve[225],we([0,1,7,2,5,26,33,16,14,48]),function(J,e,_,t,p,k,D,R,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(h,v,l,d,g){super();this.extensionsManagementService=h,this.logService=d,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new _.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(c=>{this.installedExtensions=c.map(C=>C.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(c=>this.onInstallExtension(c))),this._register(h.onDidInstallExtensions(c=>this.onDidInstallExtensions(c))),this._register(h.onDidUninstallExtension(c=>this.onDidUninstallExtension(c)));const S=p.URI.file(l.extensionsPath);this._register(v.watch(S)),this._register(_.Event.filter(v.onDidFilesChange,c=>c.rawChanges.some(C=>this.doesChangeAffects(C,S)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!(h.type!==1&&h.type!==2||this.uriIdentityService.extUri.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,D.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,D.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),v=h.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,D.areSameExtensions)(g,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),l=this.installedExtensions.filter(d=>this.installingExtensions.some(g=>(0,D.areSameExtensions)(g,d))?!1:h.every(g=>!(0,D.areSameExtensions)(g.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=h.map(d=>d.identifier),(v.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:l})}}};T=Te([Ne(1,R.IFileService),Ne(2,k.INativeEnvironmentService),Ne(3,y.ILogService),Ne(4,b.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(ve[103],we([0,1,48,184,16,22,124,7,2]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(h){this.uri=h,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let T=class{constructor(h){this._fileService=h,this._dispooables=new y.DisposableStore,this._limit=2**16;const v=new Map,l=d=>{let g=v.get(d.scheme);return g===void 0&&(g=h.hasProvider(d)&&!this._fileService.hasCapability(d,1024),v.set(d.scheme,g)),g};this._dispooables.add(R.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(d=>{v.delete(d.scheme)})),this.extUri=new k.ExtUri(l),this._canonicalUris=new D.SkipList((d,g)=>this.extUri.compare(d,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,k.normalizePath)(h));let v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new b(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((l,d)=>l[1].touch<d[1].touch?1:l[1].touch>d[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let l=0;l<v;l++)this._canonicalUris.set(h[l][0],h[l][1].touch())}};T=Te([Ne(0,p.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(_.IUriIdentityService,T,!0)}),define(ve[104],we([0,1,30,22,5,6]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var D;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function R(h){const v=h;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=R;function y(h){const v=h;return!!(v&&typeof v=="object"&&p.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=y;class b{constructor(v,l,d,g,S){this._id=v,this._transient=d,this._configuration=g,this._ignorePathCasing=S,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class T{constructor(v,l){this.raw=l,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,t.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function A(h){return new T({uri:h,index:0,name:(0,t.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=A}),define(ve[226],we([0,1,31,38,120,61,8,4,3,22,5,170,6,97,104]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(q){return(typeof q=="string"?(0,R.extname)(q):(0,b.extname)(q))===d}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,h.createDecorator)("workspacesService");function S(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function c(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=c;function C(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=C;function w(q){return q&&q.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function f(q){return q&&q.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=f;function s(q){const ne=q;return typeof ne?.id=="string"&&T.URI.isUri(ne.uri)}e.isSingleFolderWorkspaceIdentifier=s;function a(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=a;function i(q){const ne=q;return typeof ne?.id=="string"&&T.URI.isUri(ne.configPath)}e.isWorkspaceIdentifier=i;function n(q){const ne=q;if(ne?.uri)return{id:ne.id,uri:T.URI.revive(ne.uri)};const B=q;if(B?.configPath)return{id:B.id,configPath:T.URI.revive(B.configPath)};if(q?.id)return{id:q.id}}e.reviveIdentifier=n;function r(q,ne){return b.extUriBiasedIgnorePathCase.isEqualOrParent(q,ne.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function o(q){return u(q)||E(q)}e.isStoredWorkspaceFolder=o;function u(q){const ne=q;return typeof ne?.path=="string"&&(!ne.name||typeof ne.name=="string")}e.isRawFileWorkspaceFolder=u;function E(q){const ne=q;return typeof ne?.uri=="string"&&(!ne.name||typeof ne.name=="string")}e.isRawUriWorkspaceFolder=E;function P(q,ne,B,G,ee=!y.isWindows,oe){if(q.scheme!==G.scheme)return{name:B,uri:q.toString(!0)};let se=ne?void 0:oe.relativePath(G,q);if(se!==void 0)se.length===0?se=".":y.isWindows&&q.scheme===D.Schemas.file&&!ee&&(se=se.replace(/\//g,"\\"));else if(q.scheme===D.Schemas.file)se=q.fsPath,y.isWindows&&(se=(0,k.normalizeDriveLetter)(se),ee&&(se=(0,_.toSlashes)(se)));else{if(!oe.isEqualAuthority(q.authority,G.authority))return{name:B,uri:q.toString(!0)};se=q.path}return{name:B,path:se}}e.getStoredWorkspaceFolder=P;function I(q,ne,B){let G=[],ee=new Set;const oe=B.dirname(ne);for(let se of q){let me;if(u(se))se.path&&(me=B.resolvePath(oe,se.path));else if(E(se))try{me=T.URI.parse(se.uri),me.path[0]!=="/"&&(me=me.with({path:"/"+me.path}))}catch(Z){console.warn(Z)}if(me){let Z=B.getComparisonKey(me);if(!ee.has(Z)){ee.add(Z);const $=se.name||B.basenameOrAuthority(me);G.push(new l.WorkspaceFolder({uri:me,name:$,index:G.length},se))}}}return G}e.toWorkspaceFolders=I;function O(q,ne,B,G,ee){let oe=z(ne,q);const se=ee.dirname(ne),me=ee.dirname(G),Z=[],$=j(oe.folders);for(const de of oe.folders){const De=u(de)?ee.resolvePath(se,de.path):T.URI.parse(de.uri);let ae;B?ae=!1:ae=!u(de)||(0,R.isAbsolute)(de.path),Z.push(P(De,ae,de.name,me,$,ee))}const H={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},V=p.setProperty(q,["folders"],Z,H);let ie=p.applyEdits(q,V);return(0,b.isEqualAuthority)(oe.remoteAuthority,(0,v.getRemoteAuthority)(G))&&(ie=p.applyEdits(ie,p.removeProperty(ie,["remoteAuthority"],H))),ie}e.rewriteWorkspaceFileForNewLocation=O;function z(q,ne){let B=t.parse(ne);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(G=>o(G));else throw new Error(`${q} looks like an invalid workspace file.`);return B}function j(q){return y.isWindows?q.some(ne=>u(ne)&&ne.path.indexOf("/")>=0):!0}e.useSlashForPath=j;function m(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function L(q){return typeof q.folderUri=="string"}function M(q){return typeof q.fileUri=="string"}function Q(q,ne){const B={workspaces:[],files:[]};if(q){const G=function(oe,se){for(let me=0;me<oe.length;me++)try{se(oe[me],me)}catch(Z){ne.warn(`Error restoring recent entry ${JSON.stringify(oe[me])}: ${Z.toString()}. Skip entry.`)}},ee=q;if(Array.isArray(ee.entries))G(ee.entries,oe=>{const se=oe.label,me=oe.remoteAuthority;m(oe)?B.workspaces.push({label:se,remoteAuthority:me,workspace:{id:oe.workspace.id,configPath:T.URI.parse(oe.workspace.configPath)}}):L(oe)?B.workspaces.push({label:se,remoteAuthority:me,folderUri:T.URI.parse(oe.folderUri)}):M(oe)&&B.files.push({label:se,remoteAuthority:me,fileUri:T.URI.parse(oe.fileUri)})});else{const oe=q;Array.isArray(oe.workspaces3)&&G(oe.workspaces3,(se,me)=>{const Z=Array.isArray(oe.workspaceLabels)&&oe.workspaceLabels[me]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?B.workspaces.push({label:Z,workspace:{id:se.id,configPath:T.URI.parse(se.configURIPath)}}):typeof se=="string"&&B.workspaces.push({label:Z,folderUri:T.URI.parse(se)})}),Array.isArray(oe.files2)&&G(oe.files2,(se,me)=>{const Z=Array.isArray(oe.fileLabels)&&oe.fileLabels[me]||void 0;typeof se=="string"&&B.files.push({label:Z,fileUri:T.URI.parse(se)})})}}return B}e.restoreRecentlyOpened=Q;function W(q){const ne={entries:[]};for(const B of q.workspaces)c(B)?ne.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):ne.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of q.files)ne.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return ne}e.toStoreData=W}),define(ve[227],we([0,1,7,13]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function p(D){let R=0,y=0,b=0;D>=1e3&&(b=Math.floor(D/1e3),D-=b*1e3),b>=60&&(y=Math.floor(b/60),b-=y*60),y>=60&&(R=Math.floor(y/60),y-=R*60);const T=R?`${R}h`:"",A=y?`${y}m`:"",h=b?`${b}s`:"",v=D?`${D}ms`:"";return`${T}${A}${h}${v}`}e.printTime=p;class k{constructor(R,y,b,T){this._logService=R,this._reconnectionToken=y,this._onClose=new _.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=b,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${p(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${p(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${p(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(R){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${R}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${p(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const R=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),R.end(),this._onClose.fire(void 0)}acceptReconnection(R,y,b){this._remoteAddress=R,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(y,b),this.protocol.endAcceptReconnection()}}e.ManagementConnection=k}),define(ve[105],we([0,1,27,8,4,131,45]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const R=p.join(t.FileAccess.asFileUri("",J).fsPath,"nls.metadata.json"),y=new Map;function b(h){return new Promise(v=>_.exists(h,v))}function T(h,v){return b(R).then(l=>{if(!l||!D.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let d=`${h}||${v}`,g=y.get(d);return g||(g=k.getNLSConfiguration(D.default.commit,v,R,h).then(S=>(A.is(S)&&(S._languagePackSupport=!0),S)),y.set(d,g)),g})}e.getNLSConfiguration=T;var A;(function(h){function v(l){let d=l;return d&&typeof d._languagePackId=="string"}h.is=v})(A=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ve[228],we([0,1,2]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTelemetryChannel=void 0;class t extends _.Disposable{constructor(k,D){super();this.telemetryService=k,this.telemetryAppender=D}async call(k,D,R){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:y}=R;return this.telemetryService.updateInjectedTelemetryLevel(y)}case"logTelemetry":{const{eventName:y,data:b}=R;return this.telemetryAppender?this.telemetryAppender.log(y,b):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${D} not found`)}listen(k,D,R){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.RemoteTelemetryChannel=t}),define(ve[229],we([0,1,28,6,29,215,42]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteTelemetryService=e.RemoteNullTelemetryService=e.RemoteTelemetryService=void 0;let R=class extends k.TelemetryService{constructor(b,T,A){super(b,A);this._telemetryCache=[],this._injectedTelemetryLevel=T}publicLog(b,T,A){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:b,data:T,anonymizeFilePaths:A,eventType:"usage"}),Promise.resolve()):this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(b,T,A)}publicLog2(b,T,A){return this.publicLog(b,T,A)}publicLogError(b,T){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:b,data:T,eventType:"error"}),Promise.resolve()):this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(b,T)}publicLogError2(b,T){return this.publicLogError(b,T)}async flushTelemetryCache(){if(this._telemetryCache?.length!==0){for(const b of this._telemetryCache)b.eventType==="usage"?await this.publicLog(b.eventName,b.data,b.anonymizeFilePaths):await this.publicLogError(b.eventName,b.data);this._telemetryCache=[]}}async updateInjectedTelemetryLevel(b){if(b===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");if(this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,b):b,this._injectedTelemetryLevel===0)this._telemetryCache=[],this.dispose();else return this.flushTelemetryCache()}};R=Te([Ne(2,_.IConfigurationService)],R),e.RemoteTelemetryService=R,e.RemoteNullTelemetryService=new class extends D.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IRemoteTelemetryService=(0,t.refineServiceDecorator)(p.ITelemetryService)}),define(ve[49],we([0,1,62,8]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=t.FileAccess.asFileUri("vs/server/node/uriTransformer.js",J).fsPath;function p(k){const R=J.__$__nodeRequire(e.uriTransformerPath)(k);return new _.URITransformer(R)}e.createRemoteURITransformer=p}),define(ve[230],we([0,1,5,49,56,4,197]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class R extends D.AbstractDiskFileSystemProviderChannel{constructor(T,A){super(new p.DiskFileSystemProvider(T),T);this.environmentService=A,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let A=this.uriTransformerCache.get(T.remoteAuthority);return A||(A=(0,t.createRemoteURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,A)),A}transformIncoming(T,A,h=!1){if(h&&A.path==="/vscode-resource"&&A.query){const v=JSON.parse(A.query).requestResourcePath;return _.URI.from({scheme:"file",path:v})}return _.URI.revive(T.transformIncoming(A))}createSessionFileWatcher(T,A){return new y(T,A,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=R;class y extends D.AbstractSessionFileWatcher{constructor(T,A,h,v){super(T,A,h,v)}getRecursiveWatcherOptions(T){const A=T.args["file-watcher-polling"];if(A){const h=A.split(k.delimiter),v=Number(h[0]);if(v>0)return{usePolling:h.length>1?h.slice(1):!0,pollingInterval:v}}}getExtraExcludes(T){if(T.extensionsPath)return[k.posix.join(T.extensionsPath,"**")]}}}),define(ve[231],we([0,1,232,27,23,8]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const D=/^[0-9A-Za-z-]+$/;var R;(function(l){l[l.None=0]="None",l[l.Optional=1]="Optional",l[l.Mandatory=2]="Mandatory"})(R=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class y{constructor(){this.type=0}validate(d){return!0}}e.NoneServerConnectionToken=y;class b{constructor(d){this.value=d,this.type=1}validate(d){return d===this.value}}e.OptionalServerConnectionToken=b;class T{constructor(d){this.value=d,this.type=2}validate(d){return d===this.value}}e.MandatoryServerConnectionToken=T;class A{constructor(d){this.message=d}}e.ServerConnectionTokenParseError=A;function h(l){const d=l["without-connection-token"],g=l["connection-token"],S=l["connection-token-file"],c=l.compatibility==="1.63";if(d)return typeof g!="undefined"||typeof S!="undefined"?new A("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new y;if(typeof S!="undefined"){if(typeof g!="undefined")return new A("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let C;try{C=t.readFileSync(S).toString().replace(/\r?\n$/,"")}catch{return new A(`Unable to read the connection token file at '${S}'.`)}return D.test(C)?new T(C):new A(`The connection token defined in '${S} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof g!="undefined"?D.test(g)?c?new b(g):new T(g):new A(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):c?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new b((0,p.generateUuid)())):new T((0,p.generateUuid)())}e.parseServerConnectionToken=h;function v(l,d,g){if(l.validate(g.query[k.connectionTokenQueryName]))return!0;const S=_.parse(d.headers.cookie||"");return l.validate(S[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=v}),define(ve[50],we([0,1,172,181,53,6,26]),function(J,e,_,t,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:_.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:_.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:_.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:_.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:_.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:_.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:_.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:_.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:_.localize(8,null)},"user-data-dir":p.OPTIONS["user-data-dir"],driver:p.OPTIONS.driver,"disable-telemetry":p.OPTIONS["disable-telemetry"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:p.OPTIONS.log,logsPath:p.OPTIONS.logsPath,"force-disable-user-env":p.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL."},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":p.OPTIONS["extensions-dir"],"extensions-download-dir":p.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":p.OPTIONS["builtin-extensions-dir"],"install-extension":p.OPTIONS["install-extension"],"install-builtin-extension":p.OPTIONS["install-builtin-extension"],"uninstall-extension":p.OPTIONS["uninstall-extension"],"list-extensions":p.OPTIONS["list-extensions"],"locate-extension":p.OPTIONS["locate-extension"],"show-versions":p.OPTIONS["show-versions"],category:p.OPTIONS.category,force:p.OPTIONS.force,"do-not-sync":p.OPTIONS["do-not-sync"],"pre-release":p.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:_.localize(9,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:p.OPTIONS.help,version:p.OPTIONS.version,compatibility:{type:"string"},_:p.OPTIONS._},e.IServerEnvironmentService=(0,k.refineServiceDecorator)(D.IEnvironmentService);class R extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=R}),define(ve[233],we([0,1,27,71,134,232,70,31,59,3,14,50,4,8,23,32,47,21,5,15,12]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const f={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(r,o,u,E){o.writeHead(u,{"Content-Type":"text/plain"}),o.end(E)}e.serveError=s;async function a(r,o,u,E,P=Object.create(null)){try{const I=await p.promisify(_.stat)(E),O=`W/"${[I.ino,I.size,I.mtime.getTime()].join("-")}"`;if(o.headers["if-none-match"]===O)return u.writeHead(304),u.end();P["Content-Type"]=f[(0,h.extname)(E)]||(0,y.getMediaMime)(E)||"text/plain",P.Etag=O,u.writeHead(200,P),_.createReadStream(E).pipe(u)}catch(I){return I.code!=="ENOENT"&&(r.error(I),console.error(I.toString())),u.writeHead(404,{"Content-Type":"text/plain"}),u.end("Not found")}}e.serveFile=a;const i=(0,h.dirname)(v.FileAccess.asFileUri("",J).fsPath);let n=class{constructor(o,u,E,P,I){this._connectionToken=o,this._environmentService=u,this._logService=E,this._requestService=P,this._productService=I,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?c.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0}async handle(o,u,E){try{const P=E.pathname;return P==="/favicon.ico"||P==="/manifest.json"||P==="/code-192.png"||P==="/code-512.png"?a(this._logService,o,u,(0,h.join)(i,"resources","server",P.substr(1))):/^\/static\//.test(P)?this._handleStatic(o,u,E):P==="/"?this._handleRoot(o,u,E):P==="/callback"?this._handleCallback(u):/^\/web-extension-resource\//.test(P)?this._handleWebExtensionResource(o,u,E):s(o,u,404,"Not found.")}catch(P){return this._logService.error(P),console.error(P.toString()),s(o,u,500,"Internal Server Error.")}}async _handleStatic(o,u,E){const P=Object.create(null),I=decodeURIComponent(E.pathname),O=(0,h.normalize)(I.substr("/static/".length)),z=(0,h.join)(i,O);return(0,R.isEqualOrParent)(z,i,!b.isLinux)?a(this._logService,o,u,z,P):s(o,u,400,"Bad request.")}_getResourceURLTemplateAuthority(o){const u=o.authority.indexOf(".");return u!==-1?o.authority.substring(u+1):void 0}async _handleWebExtensionResource(o,u,E){if(!this._webExtensionResourceUrlTemplate)return s(o,u,500,"No extension gallery service configured.");const P=decodeURIComponent(E.pathname),I=(0,h.normalize)(P.substr("/web-extension-resource/".length)),O=c.URI.parse(I).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:I.substring(0,I.indexOf("/")),path:I.substring(I.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(O))return s(o,u,403,"Request Forbidden");const z={},j=q=>{const ne=o.headers[q];ne&&((0,w.isString)(ne)||ne[0])?z[q]=(0,w.isString)(ne)?ne:ne[0]:q!==q.toLowerCase()&&j(q.toLowerCase())};j("X-Client-Name"),j("X-Client-Version"),j("X-Machine-Id"),j("X-Client-Commit");const m=await this._requestService.request({type:"GET",url:O.toString(!0),headers:z},S.CancellationToken.None),L=m.res.statusCode||500;if(L!==200){let q=null;try{q=await(0,g.asText)(m)}catch{}return s(o,u,L,q||`Request failed with status ${L}`)}const M=Object.create(null),Q=q=>{const ne=m.res.headers[q];ne?M[q]=ne:q!==q.toLowerCase()&&Q(q.toLowerCase())};Q("Cache-Control"),Q("Content-Type"),u.writeHead(200,M);const W=await(0,C.streamToBuffer)(m.stream);return u.end(W.buffer)}async _handleRoot(o,u,E){if(!o.headers.host)return s(o,u,400,"Bad request.");const P=E.query[v.connectionTokenQueryName];if(typeof P=="string"){const W=Object.create(null);W["Set-Cookie"]=k.serialize(v.connectionTokenCookieName,P,{sameSite:"strict",maxAge:60*60*24*7});const q=Object.create(null);for(let B in E.query)B!==v.connectionTokenQueryName&&(q[B]=E.query[B]);const ne=t.format({pathname:"/",query:q});return W.Location=ne,u.writeHead(302,W),u.end()}const I=o.headers.host;function O(W){return W.replace(/"/g,"&quot;")}let z;this._environmentService.driverHandle&&(z=!1);const j=v.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",J).fsPath,m=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,l.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,L=(await p.promisify(_.readFile)(j)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",O(JSON.stringify({remoteAuthority:I,_wrapWebWorkerExtHostInIframe:z,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,productConfiguration:{extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:I,path:`web-extension-resource/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0}}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>m?O(JSON.stringify(m)):""),M=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(L).join(" ")} 'sha256-9CevbjD7QdrWdGrVTVJD74tTH4eAhisvCOlLtWUn+Iw=' http://${I};`,"child-src 'self';",`frame-src 'self' https://*.vscode-webview.net ${this._productService.webEndpointUrl||""} data:;`,"worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),Q={"Content-Type":"text/html","Content-Security-Policy":M};return this._connectionToken.type!==0&&(Q["Set-Cookie"]=k.serialize(v.connectionTokenCookieName,this._connectionToken.value,{sameSite:"strict",maxAge:60*60*24*7})),u.writeHead(200,Q),u.end(L)}_getScriptCspHashes(o){const u=/<script>([\s\S]+?)<\/script>/img,E=[];let P;for(;P=u.exec(o);){const I=D.createHash("sha256"),O=P[1].replace(/\r\n/g,`
`),z=I.update(Buffer.from(O)).digest().toString("base64");E.push(`'sha256-${z}'`)}return E}async _handleCallback(o){const u=v.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",J).fsPath,E=(await p.promisify(_.readFile)(u)).toString(),P=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(E).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return o.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":P}),o.end(E)}};n=Te([Ne(1,A.IServerEnvironmentService),Ne(2,T.ILogService),Ne(3,g.IRequestService),Ne(4,d.IProductService)],n),e.WebClientServer=n}),define(ve[234],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class t{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=t}),define(ve[106],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var _;(function(c){c[c.Upsert=0]="Upsert",c[c.RemoveChild=1]="RemoveChild",c[c.Invalidated=2]="Invalidated",c[c.SetProp=3]="SetProp",c[c.Bulk=4]="Bulk"})(_=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,p=(c,C)=>{const w={controllerId:C};return t.set(c,w),w};e.createPrivateApiFor=p;const k=c=>t.get(c);e.getPrivateApiFor=k;const D=(c,C,w,f)=>{let s=w;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!f(s,a)){const i=s;s=a,c.listener?.({op:3,key:C,value:a,previous:i})}}}},R=(c,C)=>c===C,y={range:(c,C)=>c===C?!0:!c||!C?!1:c.isEqual(C),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(c,C)=>!(c.length!==C.length||c.some(w=>!C.find(f=>w.id===f.id)))},b=Object.keys(y),T=(c,C)=>({range:D(c,"range",void 0,y.range),label:D(c,"label",C,y.label),description:D(c,"description",void 0,y.description),sortText:D(c,"sortText",void 0,y.sortText),canResolveChildren:D(c,"canResolveChildren",!1,y.canResolveChildren),busy:D(c,"busy",!1,y.busy),error:D(c,"error",void 0,y.error),tags:D(c,"tags",[],y.tags)}),A=(c,C)=>{const w=new Map;for(const f of b)y[f](c[f],C[f])||w.set(f,C[f]);return w};e.diffTestItems=A;class h extends Error{constructor(C){super(`Attempted to insert a duplicate test item ID ${C}`)}}e.DuplicateTestItemError=h;class v extends Error{constructor(C){super(`TestItem with ID "${C}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class l extends Error{constructor(C,w,f){super(`TestItem with ID "${C}" is from controller "${w}" and cannot be added as a child of an item from controller "${f}".`)}}e.MixedTestItemController=l;const d=c=>{const C=(0,e.getPrivateApiFor)(c);let w=new Map;return{get size(){return w.size},forEach(f,s){for(const a of w.values())f.call(s,a,this)},replace(f){const s=new Map,a=new Set(w.keys()),i={op:4,ops:[]};for(const n of f){if(!(n instanceof g))throw new v(n.id);const r=(0,e.getPrivateApiFor)(n).controllerId;if(r!==C.controllerId)throw new l(n.id,r,C.controllerId);if(s.has(n.id))throw new h(n.id);s.set(n.id,n),a.delete(n.id),i.ops.push({op:0,item:n})}for(const n of a.keys())i.ops.push({op:1,id:n});C.listener?.(i),w=s},add(f){if(!(f instanceof g))throw new v(f.id);w.set(f.id,f),C.listener?.({op:0,item:f})},delete(f){w.delete(f)&&C.listener?.({op:1,id:f})},get(f){return w.get(f)},toJSON(){return Array.from(w.values())},[Symbol.iterator](){return w.values()}}};class g{constructor(C,w,f,s){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,e.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof S?void 0:a.parent}},children:{value:d(this),enumerable:!0,writable:!1},...T(a,f)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class S extends g{constructor(C,w){super(C,C,w,void 0)}}e.TestItemRootImpl=S});var Et=this&&this.__classPrivateFieldSet||function(J,e,_,t,p){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?p.call(J,_):p?p.value=_:e.set(J,_),_},et=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(ve[107],we([0,1,17,11,76,30,59,18,12,5,23,16,96]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";var v,l,d,g,S,c,C,w,f,s,a,i,n,r,o,u,E,P,I,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function z(N){function F(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(F,N),Object.setPrototypeOf(F.prototype,N.prototype),F}let j=S=class{constructor(F){v.set(this,void 0),Et(this,v,F,"f")}static from(...F){let te=F;return new S(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}dispose(){typeof et(this,v,"f")=="function"&&(et(this,v,"f").call(this),Et(this,v,void 0,"f"))}};v=new WeakMap,j=S=Te([z],j),e.Disposable=j;let m=c=class{constructor(F,te){if(F<0)throw(0,t.illegalArgument)("line must be non-negative");if(te<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=F,this._character=te}static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const ze=F[Se];ze.isBefore(te)&&(te=ze)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const ze=F[Se];ze.isAfter(te)&&(te=ze)}return te}static isPosition(F){if(!F)return!1;if(F instanceof c)return!0;let{line:te,character:Se}=F;return typeof te=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,te=0){if(F===null||te===null)throw(0,t.illegalArgument)();let Se;return typeof F=="undefined"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&te===0?this:new c(this.line+Se,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,t.illegalArgument)();let Se;return typeof F=="undefined"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Se===this.line&&te===this.character?this:new c(Se,te)}toJSON(){return{line:this.line,character:this.character}}};m=c=Te([z],m),e.Position=m;let L=C=class{constructor(F,te,Se,ze){let Ke,Xe;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ke=new m(F,te),Xe=new m(Se,ze)):F instanceof m&&te instanceof m&&(Ke=F,Xe=te),!Ke||!Xe)throw new Error("Invalid arguments");Ke.isBefore(Xe)?(this._start=Ke,this._end=Xe):(this._start=Xe,this._end=Ke)}static isRange(F){return F instanceof C?!0:F?m.isPosition(F.start)&&m.isPosition(F.end):!1}get start(){return this._start}get end(){return this._end}contains(F){return F instanceof C?this.contains(F._start)&&this.contains(F._end):F instanceof m?!(F.isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const te=m.Max(F.start,this._start),Se=m.Min(F.end,this._end);if(!te.isAfter(Se))return new C(te,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=m.Min(F.start,this._start),Se=m.Max(F.end,this.end);return new C(te,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,te=this.end){if(F===null||te===null)throw(0,t.illegalArgument)();let Se;return F?m.isPosition(F)?Se=F:(Se=F.start||this.start,te=F.end||this.end):Se=this.start,Se.isEqual(this._start)&&te.isEqual(this.end)?this:new C(Se,te)}toJSON(){return[this.start,this.end]}};L=C=Te([z],L),e.Range=L;let M=w=class extends L{constructor(F,te,Se,ze){let Ke,Xe;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ke=new m(F,te),Xe=new m(Se,ze)):F instanceof m&&te instanceof m&&(Ke=F,Xe=te),!Ke||!Xe)throw new Error("Invalid arguments");super(Ke,Xe);this._anchor=Ke,this._active=Xe}static isSelection(F){return F instanceof w?!0:F?L.isRange(F)&&m.isPosition(F.anchor)&&m.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=w=Te([z],M),e.Selection=M;class Q{constructor(F,te,Se){if(typeof F!="string"||F.length===0)throw(0,t.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,t.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,t.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(te),this.connectionToken=Se}}e.ResolvedAuthority=Q;class W extends Error{constructor(F,te=h.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F);this._message=F,this._code=te,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable(F,te){return new W(F,h.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new W(F,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var q;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var ne;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(ne=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=f=class{constructor(F,te){this._range=F,this._newText=te}static isTextEdit(F){return F instanceof f?!0:F?L.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new f(F,te)}static insert(F,te){return f.replace(new L(F,F),te)}static delete(F){return f.replace(F,"")}static setEndOfLine(F){const te=new f(new L(new m(0,0),new m(0,0)),"");return te.newEol=F,te}get range(){return this._range}set range(F){if(F&&!L.isRange(F))throw(0,t.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,t.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,t.illegalArgument)("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=f=Te([z],B),e.TextEdit=B;var G;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(G=e.FileEditType||(e.FileEditType={}));let ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,te,Se,ze){this._edits.push({_type:1,from:F,to:te,options:Se,metadata:ze})}createFile(F,te,Se){this._edits.push({_type:1,from:void 0,to:F,options:te,metadata:Se})}deleteFile(F,te,Se){this._edits.push({_type:1,from:F,to:void 0,options:te,metadata:Se})}replaceNotebookMetadata(F,te,Se){this._edits.push({_type:3,metadata:Se,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(F,te,Se,ze,Ke){let Xe,Je,st=[],at;if(kt.isNotebookRange(te)&&bt.isNotebookCellDataArray(Se)&&!bt.isNotebookCellDataArray(ze)?(Xe=te.start,Je=te.end,st=Se,at=ze):typeof te=="number"&&typeof Se=="number"&&bt.isNotebookCellDataArray(ze)&&(Xe=te,Je=Se,st=ze,at=Ke),Xe===void 0||Je===void 0)throw new Error("Invalid arguments");(Xe!==Je||st.length>0)&&this._edits.push({_type:5,uri:F,index:Xe,count:Je-Xe,cells:st,metadata:at})}replaceNotebookCellMetadata(F,te,Se,ze){this._edits.push({_type:3,metadata:ze,uri:F,edit:{editType:8,index:te,metadata:Se}})}replace(F,te,Se,ze){this._edits.push({_type:2,uri:F,edit:new B(te,Se),metadata:ze})}insert(F,te,Se,ze){this.replace(F,new L(te,te),Se,ze)}delete(F,te,Se){this.replace(F,te,"",Se)}has(F){return this._edits.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Se of te)Se&&this._edits.push({_type:2,uri:F,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const ze=this._edits[Se];ze._type===2&&ze.uri.toString()===F.toString()&&(this._edits[Se]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(F){const te=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===F.toString()&&te.push(Se.edit);return te}entries(){const F=new k.ResourceMap;for(let te of this._edits)if(te._type===2){let Se=F.get(te.uri);Se||(Se=[te.uri,[]],F.set(te.uri,Se)),Se[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ee=Te([z],ee),e.WorkspaceEdit=ee;let oe=s=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof s?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=s._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this._tabstop++){if(typeof F=="function"){const Se=new s;Se._tabstop=this._tabstop,F(Se),this._tabstop=Se._tabstop,F=Se.value}else F=s._escape(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this._tabstop++){const Se=F.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Se=new s;Se._tabstop=this._tabstop,te(Se),this._tabstop=Se._tabstop,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};oe=s=Te([z],oe),e.SnippetString=oe;var se;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var me;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(me=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=a=class{constructor(F,te){if(this.uri=F,te)if(te instanceof L)this.range=te;else if(te instanceof m)this.range=new L(te,te);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof a?!0:F?L.isRange(F.range)&&b.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=a=Te([z],Z),e.Location=Z;let $=class{constructor(F,te){this.location=F,this.message=te}static is(F){return F?typeof F.message=="string"&&F.location&&L.isRange(F.location.range)&&b.URI.isUri(F.location.uri):!1}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};$=Te([z],$),e.DiagnosticRelatedInformation=$;let H=class{constructor(F,te,Se=me.Error){if(!L.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Se}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,_.equals)(F.tags,te.tags)&&(0,_.equals)(F.relatedInformation,te.relatedInformation,$.isEqual)}};H=Te([z],H),e.Diagnostic=H;let V=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};V=Te([z],V),e.Hover=V;var ie;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let de=class{constructor(F,te=ie.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:ie[this.kind]}}};de=Te([z],de),e.DocumentHighlight=de;var De;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(De=e.SymbolKind||(e.SymbolKind={}));var ae;(function(N){N[N.Deprecated=1]="Deprecated"})(ae=e.SymbolTag||(e.SymbolTag={}));let fe=i=class{constructor(F,te,Se,ze,Ke){this.name=F,this.kind=te,this.containerName=Ke,typeof Se=="string"&&(this.containerName=Se),ze instanceof Z?this.location=ze:Se instanceof L&&(this.location=new Z(ze,Se)),i.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:De[this.kind],location:this.location,containerName:this.containerName}}};fe=i=Te([z],fe),e.SymbolInformation=fe;let pe=n=class{constructor(F,te,Se,ze,Ke){this.name=F,this.detail=te,this.kind=Se,this.range=ze,this.selectionRange=Ke,this.children=[],n.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children&&F.children.forEach(n.validate)}};pe=n=Te([z],pe),e.DocumentSymbol=pe;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let U=class{constructor(F,te){this.title=F,this.kind=te}};U=Te([z],U),e.CodeAction=U;let K=r=class{constructor(F){this.value=F}append(F){return new r(this.value?this.value+r.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+r.sep)}};K.sep=".",K=r=Te([z],K),e.CodeActionKind=K,K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll");let Y=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Te([z],Y),e.SelectionRange=Y;class ue{constructor(F,te,Se,ze,Ke,Xe){this.kind=F,this.name=te,this.detail=Se,this.uri=ze,this.range=Ke,this.selectionRange=Xe}}e.CallHierarchyItem=ue;class ye{constructor(F,te){this.fromRanges=te,this.from=F}}e.CallHierarchyIncomingCall=ye;class Pe{constructor(F,te){this.fromRanges=te,this.to=F}}e.CallHierarchyOutgoingCall=Pe;var Ae;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Fe=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};Fe=Te([z],Fe),e.CodeLens=Fe;let Ue=o=class{constructor(F,te=!1){l.set(this,void 0),Et(this,l,new p.MarkdownString(F,{supportThemeIcons:te}),"f")}static isMarkdownString(F){return F instanceof o?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return et(this,l,"f").value}set value(F){et(this,l,"f").value=F}get isTrusted(){return et(this,l,"f").isTrusted}set isTrusted(F){et(this,l,"f").isTrusted=F}get supportThemeIcons(){return et(this,l,"f").supportThemeIcons}set supportThemeIcons(F){et(this,l,"f").supportThemeIcons=F}get supportHtml(){return et(this,l,"f").supportHtml}set supportHtml(F){et(this,l,"f").supportHtml=F}appendText(F){return et(this,l,"f").appendText(F),this}appendMarkdown(F){return et(this,l,"f").appendMarkdown(F),this}appendCodeblock(F,te){return et(this,l,"f").appendCodeblock(te??"",F),this}};l=new WeakMap,Ue=o=Te([z],Ue),e.MarkdownString=Ue;let le=class{constructor(F,te){this.label=F,this.documentation=te}};le=Te([z],le),e.ParameterInformation=le;let ge=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};ge=Te([z],ge),e.SignatureInformation=ge;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Te([z],he),e.SignatureHelp=he;var _e;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(_e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let qe=class{constructor(F){this.label=F}};qe=Te([z],qe),e.InlayHintLabelPart=qe;let Be=class{constructor(F,te,Se){this.label=F,this.position=te,this.kind=Se}};Be=Te([z],Be),e.InlayHint=Be;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(N){N[N.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let be=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};be=Te([z],be),e.CompletionItem=be;let ke=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};ke=Te([z],ke),e.CompletionList=ke;let Le=class{constructor(F,te,Se){this.text=F,this.range=te,this.command=Se}};Le=Te([z],Le),e.InlineSuggestion=Le;let Oe=class{constructor(F){this.items=F}};Oe=Te([z],Oe),e.InlineSuggestions=Oe;var Qe;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var We;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(We=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ve;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var rt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(rt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var tt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function F(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=F}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let nt=class{constructor(F,te){if(te&&!b.URI.isUri(te))throw(0,t.illegalArgument)("target");if(!L.isRange(F)||F.isEmpty)throw(0,t.illegalArgument)("range");this.range=F,this.target=te}};nt=Te([z],nt),e.DocumentLink=nt;let ot=class{constructor(F,te,Se,ze){this.red=F,this.green=te,this.blue=Se,this.alpha=ze}};ot=Te([z],ot),e.Color=ot;let vt=class{constructor(F,te){if(te&&!(te instanceof ot))throw(0,t.illegalArgument)("color");if(!L.isRange(F)||F.isEmpty)throw(0,t.illegalArgument)("range");this.range=F,this.color=te}};vt=Te([z],vt),e.ColorInformation=vt;let pt=class{constructor(F){if(!F||typeof F!="string")throw(0,t.illegalArgument)("label");this.label=F}};pt=Te([z],pt),e.ColorPresentation=pt;var Dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Dt=e.ColorFormat||(e.ColorFormat={}));var It;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(It=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Pt{constructor(F,te,Se){if(this.startIndex=F,this.length=te,this.tooltip=Se,typeof F!="number"||F<0)throw(0,t.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,t.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Pt;var Ee;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class Ce{constructor(F){this.options=F,typeof F!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=Ce;var ce;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var x;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(x=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=u=class{constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,t.illegalArgument)("name");this._id=F}static from(F){switch(F){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};Ie.Clean=new u("clean","Clean"),Ie.Build=new u("build","Build"),Ie.Rebuild=new u("rebuild","Rebuild"),Ie.Test=new u("test","Test"),Ie=u=Te([z],Ie),e.TaskGroup=Ie;function Re(N){let F="";for(let te=0;te<N.length;te++)F+=N[te].replace(/,/g,",,")+",";return F}let xe=class{constructor(F,te,Se){if(typeof F!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=F,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Se):this._options=te)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,t.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(let te of this._args)F.push(te);return Re(F)}};xe=Te([z],xe),e.ProcessExecution=xe;let $e=class{constructor(F,te,Se){if(this._args=[],Array.isArray(te)){if(!F)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,t.illegalArgument)("command");this._command=F,this._args=te,this._options=Se}else{if(typeof F!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=F,this._options=te}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,t.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)F.push(typeof te=="string"?te:te.value);return Re(F)}};$e=Te([z],$e),e.ShellExecution=$e;var it;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var lt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(lt=e.TaskScope||(e.TaskScope={}));class wt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=wt;let ct=E=class{constructor(F,te,Se,ze,Ke,Xe){this.__deprecated=!1,this._definition=this.definition=F;let Je;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Se,this.execution=ze,Je=Ke,this.__deprecated=!0):te===lt.Global||te===lt.Workspace?(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ke,Je=Xe):(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ke,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof xe?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof $e?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const te=this._definition.type;(E.EmptyType===te||E.ProcessType===te||E.ShellType===te||E.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=E=Te([z],ct),e.Task=ct;var ut;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor(F,te=cn.None){this.collapsibleState=te,b.URI.isUri(F)?this.resourceUri=F:this.label=F}};ft=Te([z],ft),e.TreeItem=ft;var cn;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(cn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(F){this._value=F}async asString(){return JSON.stringify(this._value)}};Ft=Te([z],Ft),e.TreeDataTransferItem=Ft;let Ot=class{constructor(){this._items=new Map}get(F){return this._items.get(F)}set(F,te){this._items.set(F,te)}forEach(F){this._items.forEach(F)}};Ot=Te([z],Ot),e.TreeDataTransfer=Ot;let yt=class{constructor(F,te){this.id=F,this.color=te}};yt=Te([z],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Nt=class{constructor(F){this.id=F}};Nt=Te([z],Nt),e.ThemeColor=Nt;var fn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(fn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor(F,te){if(typeof F!="string"&&(!F||!b.URI.isUri(F)&&!b.URI.isUri(F.uri)))throw(0,t.illegalArgument)("base");if(typeof te!="string")throw(0,t.illegalArgument)("pattern");typeof F=="string"?this.baseUri=b.URI.file(F):b.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}get base(){return this._base}set base(F){this._base=F,this._baseUri=b.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Mt=Te([z],Mt),e.RelativePattern=Mt;let St=class{constructor(F,te,Se,ze){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};St=Te([z],St),e.Breakpoint=St;let Ut=class extends St{constructor(F,te,Se,ze,Ke){super(te,Se,ze,Ke);if(F===null)throw(0,t.illegalArgument)("location");this.location=F}};Ut=Te([z],Ut),e.SourceBreakpoint=Ut;let Bt=class extends St{constructor(F,te,Se,ze,Ke){super(te,Se,ze,Ke);this.functionName=F}};Bt=Te([z],Bt),e.FunctionBreakpoint=Bt;let zt=class extends St{constructor(F,te,Se,ze,Ke,Xe,Je){super(ze,Ke,Xe,Je);if(!te)throw(0,t.illegalArgument)("dataId");this.label=F,this.dataId=te,this.canPersist=Se}};zt=Te([z],zt),e.DataBreakpoint=zt;let Wt=class{constructor(F,te,Se){this.command=F,this.args=te||[],this.options=Se}};Wt=Te([z],Wt),e.DebugAdapterExecutable=Wt;let $t=class{constructor(F,te){this.port=F,this.host=te}};$t=Te([z],$t),e.DebugAdapterServer=$t;let jt=class{constructor(F){this.path=F}};jt=Te([z],jt),e.DebugAdapterNamedPipeServer=jt;let Ht=class{constructor(F){this.implementation=F}};Ht=Te([z],Ht),e.DebugAdapterInlineImplementation=Ht;let qt=class{constructor(F,te){this.range=F,this.expression=te}};qt=Te([z],qt),e.EvaluatableExpression=qt;var hn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(F,te){this.range=F,this.text=te}};Vt=Te([z],Vt),e.InlineValueText=Vt;let Gt=class{constructor(F,te,Se=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Se}};Gt=Te([z],Gt),e.InlineValueVariableLookup=Gt;let xt=class{constructor(F,te){this.range=F,this.expression=te}};xt=Te([z],xt),e.InlineValueEvaluatableExpression=xt;let Kt=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};Kt=Te([z],Kt),e.InlineValueContext=Kt;var dn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(dn=e.FileChangeType||(e.FileChangeType={}));let Qt=P=class extends Error{constructor(F,te=A.FileSystemProviderErrorCode.Unknown,Se){super(b.URI.isUri(F)?F.toString(!0):F);this.code=Se?.name??"Unknown",(0,A.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(F){return new P(F,A.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(F){return new P(F,A.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(F){return new P(F,A.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(F){return new P(F,A.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(F){return new P(F,A.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(F){return new P(F,A.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}};Qt=P=Te([z],Qt),e.FileSystemError=Qt;let Yt=class{constructor(F,te,Se){this.start=F,this.end=te,this.kind=Se}};Yt=Te([z],Yt),e.FoldingRange=Yt;var mn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var vn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(vn=e.CommentMode||(e.CommentMode={}));class pn{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.SemanticTokensLegend=pn;function wn(N){return typeof N=="undefined"||(0,y.isStringArray)(N)}class Xt{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let te=0,Se=F.tokenTypes.length;te<Se;te++)this._tokenTypeStrToInt.set(F.tokenTypes[te],te);for(let te=0,Se=F.tokenModifiers.length;te<Se;te++)this._tokenModifierStrToInt.set(F.tokenModifiers[te],te)}}push(F,te,Se,ze,Ke){if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(F,te,Se,ze,Ke);if(L.isRange(F)&&typeof te=="string"&&wn(Se))return this._push(F,te,Se);throw(0,t.illegalArgument)()}_push(F,te,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const ze=F.start.line,Ke=F.start.character,Xe=F.end.character-F.start.character,Je=this._tokenTypeStrToInt.get(te);let st=0;if(Se)for(const at of Se){if(!this._tokenModifierStrToInt.has(at))throw new Error("`tokenModifier` is not in the provided legend");const dt=this._tokenModifierStrToInt.get(at);st|=1<<dt>>>0}this._pushEncoded(ze,Ke,Xe,Je,st)}_pushEncoded(F,te,Se,ze,Ke){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const st=this._data.length/5|0;let at=0,dt=0;for(let mt=0;mt<st;mt++){let gt=this._data[5*mt],Rt=this._data[5*mt+1];gt===0?(gt=at,Rt+=dt):gt+=at,this._data[5*mt]=gt,this._data[5*mt+1]=Rt,at=gt,dt=Rt}}let Xe=F,Je=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ke,this._prevLine=F,this._prevChar=te}static _sortAndDeltaEncode(F){let te=[];const Se=F.length/5|0;for(let Je=0;Je<Se;Je++)te[Je]=Je;te.sort((Je,st)=>{const at=F[5*Je],dt=F[5*st];if(at===dt){const mt=F[5*Je+1],gt=F[5*st+1];return mt-gt}return at-dt});const ze=new Uint32Array(F.length);let Ke=0,Xe=0;for(let Je=0;Je<Se;Je++){const st=5*te[Je],at=F[st+0],dt=F[st+1],mt=F[st+2],gt=F[st+3],Rt=F[st+4],un=at-Ke,Gn=un===0?dt-Xe:dt,_t=5*Je;ze[_t+0]=un,ze[_t+1]=Gn,ze[_t+2]=mt,ze[_t+3]=gt,ze[_t+4]=Rt,Ke=at,Xe=dt}return ze}build(F){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),F):new Jt(Xt._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Xt;class Jt{constructor(F,te){this.resultId=te,this.data=F}}e.SemanticTokens=Jt;class yn{constructor(F,te,Se){this.start=F,this.deleteCount=te,this.data=Se}}e.SemanticTokensEdit=yn;class En{constructor(F,te){this.resultId=te,this.edits=F}}e.SemanticTokensEdits=En;var bn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(bn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Sn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Sn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let At=class{constructor(){}};At.Back={iconPath:new yt("arrow-left")},At=Te([z],At),e.QuickInputButtons=At;var Cn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Cn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(F,te,Se){this.badge=F,this.tooltip=te,this.color=Se}static validate(F){if(F.badge){let te=(0,R.nextCharLength)(F.badge,0);if(te<F.badge.length&&(te+=(0,R.nextCharLength)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=In;let Zt=class{constructor(F){this.kind=F}};Zt=Te([z],Zt),e.ColorTheme=Zt;var Pn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class kt{constructor(F,te){if(F<0)throw(0,t.illegalArgument)("start must be positive");if(te<0)throw(0,t.illegalArgument)("end must be positive");F<=te?(this._start=F,this._end=te):(this._start=te,this._end=F)}static isNotebookRange(F){return F instanceof kt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let te=this._start,Se=this._end;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Se=F.end),te===this._start&&Se===this._end?this:new kt(te,Se)}}e.NotebookRange=kt;class bt{constructor(F,te,Se,ze,Ke,Xe,Je){this.kind=F,this.value=te,this.languageId=Se,this.mime=ze,this.outputs=Ke??[],this.metadata=Xe,this.executionSummary=Je,bt.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>bt.isNotebookCellData(te))}static isNotebookCellData(F){return!0}}e.NotebookCellData=bt;class kn{constructor(F){this.cells=F}}e.NotebookData=kn;class ht{constructor(F,te){this.data=F,this.mime=te;const Se=(0,D.normalizeMimeType)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(F){return F instanceof ht?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ht.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ht.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ht.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ht(F,te)}static text(F,te=D.Mimes.text){const Se=et(ht,d,"f",g).encode(String(F));return new ht(Se,te)}static json(F,te="application/json"){const Se=JSON.stringify(F,void 0,"	");return ht.text(Se,te)}}e.NotebookCellOutputItem=ht,d=ht,g={value:new TextEncoder};class Tt{constructor(F,te,Se){this.items=Tt.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,T.generateUuid)(),this.metadata=te??Se)}static isNotebookCellOutput(F){return F instanceof Tt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&(0,y.isArray)(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Se=new Set,ze=new Set;for(let Ke=0;Ke<F.length;Ke++){const Xe=F[Ke],Je=(0,D.normalizeMimeType)(Xe.mime);if(!Se.has(Je)){Se.add(Je);continue}ze.add(Ke),te&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?F:F.filter((Ke,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=Tt;var Rn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Rn=e.NotebookCellKind||(e.NotebookCellKind={}));var _n;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(_n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var An;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(An=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Tn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Tn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ln{constructor(F,te){this.text=F,this.alignment=te}}e.NotebookCellStatusBarItem=Ln;var Fn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class On{constructor(F,te=[]){this.uri=F,this.provides=(0,_.asArray)(te)}}e.NotebookRendererScript=On;let en=class{constructor(F,te){this.label=F,this.timestamp=te}};en=Te([z],en),e.TimelineItem=en;var Nn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Nn=e.ExtensionMode||(e.ExtensionMode={}));var Mn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Mn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Un;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(Un=e.StandardTokenType||(e.StandardTokenType={}));class Bn{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.LinkedEditingRanges=Bn;class zn{constructor(F,te){this._port=F,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=zn;var Wn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Wn=e.TestResultState||(e.TestResultState={}));var $n;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})($n=e.TestRunProfileKind||(e.TestRunProfileKind={}));let tn=class{constructor(F=void 0,te=void 0,Se=void 0){this.include=F,this.exclude=te,this.profile=Se}};tn=Te([z],tn),e.TestRunRequest=tn;let nn=I=class{constructor(F){this.message=F}static diff(F,te,Se){const ze=new I(F);return ze.expectedOutput=te,ze.actualOutput=Se,ze}};nn=I=Te([z],nn),e.TestMessage=nn;let rn=class{constructor(F){this.id=F}};rn=Te([z],rn),e.TestTag=rn;let Ct=class{constructor(F,te){this.covered=F,this.total=te}};Ct=Te([z],Ct),e.CoveredCount=Ct;let sn=O=class{constructor(F,te,Se,ze){this.uri=F,this.statementCoverage=te,this.branchCoverage=Se,this.functionCoverage=ze}static fromDetails(F,te){const Se=new Ct(0,0),ze=new Ct(0,0),Ke=new Ct(0,0);for(const Je of te)if("branches"in Je){Se.total+=1,Se.covered+=Je.executionCount>0?1:0;for(const st of Je.branches)ze.total+=1,ze.covered+=st.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=Je.executionCount>0?1:0;const Xe=new O(F,Se,ze.total>0?ze:void 0,Ke.total>0?Ke:void 0);return Xe.detailedCoverage=te,Xe}};sn=O=Te([z],sn),e.FileCoverage=sn;let on=class{constructor(F,te,Se=[]){this.executionCount=F,this.location=te,this.branches=Se}};on=Te([z],on),e.StatementCoverage=on;let an=class{constructor(F,te){this.executionCount=F,this.location=te}};an=Te([z],an),e.BranchCoverage=an;let ln=class{constructor(F,te){this.executionCount=F,this.location=te}};ln=Te([z],ln),e.FunctionCoverage=ln;var jn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(jn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(F,te,Se,ze,Ke,Xe){this.kind=F,this.name=te,this.detail=Se,this.uri=ze,this.range=Ke,this.selectionRange=Xe}}e.TypeHierarchyItem=Vn}),define(ve[108],we([0,1,173,12,5,2,6,35,16,17,8]),function(J,e,_,t,p,k,D,R,y,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,_.localize)(0,null),providerDisplayName:(0,_.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function A(m,L,M){for(const Q of M.visibleEditorPanes)if(Q.group.id===L&&m.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=A;function h(m){if(w(m))return!1;const L=m;return p.URI.isUri(L?.resource)}e.isResourceEditorInput=h;function v(m){if(w(m))return!1;const L=m;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=v;function l(m){if(w(m)||v(m))return!1;const L=m;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function d(m){if(w(m))return!1;const L=m;return L?L.resource===void 0||L.resource.scheme===T.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;var g;(function(m){m[m.SHORT=0]="SHORT",m[m.MEDIUM=1]="MEDIUM",m[m.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var S;(function(m){m[m.EXPLICIT=1]="EXPLICIT",m[m.AUTO=2]="AUTO",m[m.FOCUS_CHANGE=3]="FOCUS_CHANGE",m[m.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var c;(function(m){m[m.None=0]="None",m[m.Readonly=2]="Readonly",m[m.Untitled=4]="Untitled",m[m.Singleton=8]="Singleton",m[m.RequiresTrust=16]="RequiresTrust",m[m.CanSplitInGroup=32]="CanSplitInGroup",m[m.ForceDescription=64]="ForceDescription"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class C extends k.Disposable{}e.AbstractEditorInput=C;function w(m){return m instanceof C}e.isEditorInput=w;function f(m){const L=m;return p.URI.isUri(L?.preferredResource)}function s(m){const L=m;return w(L?.primary)&&w(L?.secondary)}e.isSideBySideEditorInput=s;function a(m){const L=m;return w(L?.modified)&&w(L?.original)}e.isDiffEditorInput=a;function i(m){return w(m?.editor)}e.isEditorInputWithOptions=i;function n(m){const L=m;return i(m)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function r(m){const L=m;return typeof L?.groupId=="number"&&w(L.editor)}e.isEditorIdentifier=r;var o;(function(m){m[m.UNKNOWN=0]="UNKNOWN",m[m.REPLACE=1]="REPLACE",m[m.MOVE=2]="MOVE",m[m.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var u;(function(m){m[m.GROUP_ACTIVE=0]="GROUP_ACTIVE",m[m.GROUP_INDEX=1]="GROUP_INDEX",m[m.GROUP_LOCKED=2]="GROUP_LOCKED",m[m.EDITOR_OPEN=3]="EDITOR_OPEN",m[m.EDITOR_CLOSE=4]="EDITOR_CLOSE",m[m.EDITOR_MOVE=5]="EDITOR_MOVE",m[m.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",m[m.EDITOR_LABEL=7]="EDITOR_LABEL",m[m.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",m[m.EDITOR_PIN=9]="EDITOR_PIN",m[m.EDITOR_STICKY=10]="EDITOR_STICKY",m[m.EDITOR_DIRTY=11]="EDITOR_DIRTY",m[m.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(u=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var E;(function(m){m[m.PRIMARY=1]="PRIMARY",m[m.SECONDARY=2]="SECONDARY",m[m.BOTH=3]="BOTH",m[m.ANY=4]="ANY"})(E=e.SideBySideEditor||(e.SideBySideEditor={}));class P{getOriginalUri(L,M){if(!L)return;if(M?.supportSideBySide){const{primary:W,secondary:q}=this.getSideEditors(L);if(W&&q){if(M?.supportSideBySide===E.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(q,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===E.ANY)return this.getOriginalUri(W,{filterByScheme:M.filterByScheme})??this.getOriginalUri(q,{filterByScheme:M.filterByScheme});L=M.supportSideBySide===E.PRIMARY?W:q}}if(v(L)||l(L))return;const Q=f(L)?L.preferredResource:L.resource;return!Q||!M||!M.filterByScheme?Q:this.filterUri(Q,M.filterByScheme)}getSideEditors(L){return s(L)||l(L)?{primary:L.primary,secondary:L.secondary}:a(L)||v(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,M){if(!L)return;if(M?.supportSideBySide){const{primary:W,secondary:q}=this.getSideEditors(L);if(W&&q){if(M?.supportSideBySide===E.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(q,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===E.ANY)return this.getCanonicalUri(W,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(q,{filterByScheme:M.filterByScheme});L=M.supportSideBySide===E.PRIMARY?W:q}}if(v(L)||l(L))return;const Q=L.resource;return!Q||!M||!M.filterByScheme?Q:this.filterUri(Q,M.filterByScheme)}filterUri(L,M){if(Array.isArray(M)){if(M.some(Q=>L.scheme===Q))return L}else if(M===L.scheme)return L}}e.EditorResourceAccessor=new P;var I;(function(m){m[m.LEFT=0]="LEFT",m[m.RIGHT=1]="RIGHT"})(I=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const M=this.instantiationService=L.get(D.IInstantiationService);for(const[Q,W]of this.editorSerializerConstructors)this.createEditorSerializer(Q,W,M);this.editorSerializerConstructors.clear()}createEditorSerializer(L,M,Q){const W=Q.createInstance(M);this.editorSerializerInstances.set(L,W)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,M){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,M,this.instantiationService):this.editorSerializerConstructors.set(L,M),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new O);async function z(m,L){if(!m||!m.length)return[];const M=await Promise.all(m.map(async Q=>{const W=p.URI.revive(Q.fileUri);if(!W||!await L.canHandleResource(W))return;let ne=Q.exists,B=Q.type;if(typeof ne!="boolean"||typeof B!="number")try{B=(await L.resolve(W)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ne=!0}catch{ne=!1}if(!ne&&Q.openOnlyIfExists||B===y.FileType.Directory)return;const G={selection:ne?Q.selection:void 0,pinned:!0,override:Q.editorOverrideId};let ee;return ne?ee={resource:W,options:G}:ee={resource:W,options:G,forceUntitled:!0},ee}));return(0,b.coalesce)(M)}e.pathsToEditors=z;var j;(function(m){m[m.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",m[m.SEQUENTIAL=1]="SEQUENTIAL"})(j=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[235],we([0,1,60,51,59,8,4,3,88]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var b;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(b=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",p.Mimes.latex,p.Mimes.markdown,"image/png","image/jpeg",p.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[p.Mimes.latex,p.Mimes.markdown,"application/json",p.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var A;(function(I){I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(A=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var h;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(h=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeLanguage=5]="ChangeLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var S;(function(I){I.scheme=k.Schemas.vscodeNotebookCell;const O=/^ch(\d{7,})/;function z(W,q){return W.with({scheme:I.scheme,fragment:`ch${q.toString().padStart(7,"0")}${W.scheme!==k.Schemas.file?W.scheme:""}`})}I.generate=z;function j(W){if(W.scheme!==I.scheme)return;const q=O.exec(W.fragment);return q?{handle:Number(q[1]),notebook:W.with({scheme:W.fragment.substring(q[0].length)||k.Schemas.file,fragment:null})}:void 0}I.parse=j;function m(W,q,ne){return W.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`ch${q.toString().padStart(7,"0")},${ne??""},${W.scheme!==k.Schemas.file?W.scheme:""}`})}I.generateCellOutputUri=m;function L(W){if(W.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const q=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!q)return;const ne=Number(q[1]),B=q[2]&&q[2]!==""?q[2]:void 0,G=q[3];return{handle:ne,outputId:B,notebook:W.with({scheme:G||k.Schemas.file,fragment:null})}}I.parseCellOutputUri=L;function M(W,q,ne){return W.with({scheme:ne,fragment:`ch${q.toString().padStart(7,"0")}${W.scheme!==k.Schemas.file?W.scheme:""}`})}I.generateCellUri=M;function Q(W,q){if(W.scheme!==q)return;const ne=O.exec(W.fragment);return ne?{handle:Number(ne[1]),notebook:W.with({scheme:W.fragment.substring(ne[0].length)||k.Schemas.file,fragment:null})}:void 0}I.parseCellUri=Q})(S=e.CellUri||(e.CellUri={}));const c=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[p.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function C(I){return c.get(I)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=C;function w(I){return c.get(I)?.supportedByCore??!1}e.mimeTypeSupportedByCore=w;function f(I){return c.get(I)?.mergeable??!1}e.mimeTypeIsMergeable=f;const s=I=>R.isWindows?I.replace(/\//g,"\\"):I;class a{constructor(O=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=z,this.order=[...new Set(O)].map(j=>({pattern:j,matches:_.parse(s(j))}))}sort(O){const z=new Map(t.Iterable.map(O,m=>[m,s(m)]));let j=[];for(const{matches:m}of this.order)for(const[L,M]of z)if(m(M)){j.push(L),z.delete(L);break}return z.size&&(j=j.concat([...z.keys()].sort((m,L)=>this.defaultOrder.indexOf(m)-this.defaultOrder.indexOf(L)))),j}prioritize(O,z){const j=this.findIndex(O);if(j===-1){this.order.unshift({pattern:O,matches:_.parse(s(O))});return}const m=new Set(z.map(M=>this.findIndex(M,j)));m.delete(-1);const L=Array.from(m).sort();this.order.splice(j+1,0,...L.map(M=>this.order[M]));for(let M=L.length-1;M>=0;M--)this.order.splice(L[M],1)}toArray(){return this.order.map(O=>O.pattern)}findIndex(O,z=this.order.length){const j=s(O);for(let m=0;m<z;m++)if(this.order[m].matches(j))return m;return-1}}e.MimeTypeDisplayOrder=a;function i(I,O,z,j=(m,L)=>m===L){const m=[];function L(W,q,ne){if(q===0&&ne.length===0)return;const B=m[m.length-1];B&&B.start+B.deleteCount===W?(B.deleteCount+=q,B.toInsert.push(...ne)):m.push({start:W,deleteCount:q,toInsert:ne})}let M=0,Q=0;for(;;){if(M===I.length){L(M,0,O.slice(Q));break}if(Q===O.length){L(M,I.length-M,[]);break}const W=I[M],q=O[Q];if(j(W,q)){M+=1,Q+=1;continue}z(q)?(L(M,1,[]),M+=1):(L(M,0,[q]),Q+=1)}return m}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(I){I.default="default",I.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(I){const O=I;return!!((typeof O.include=="string"||_.isRelativePattern(O.include))&&(typeof O.exclude=="string"||_.isRelativePattern(O.exclude)))}e.isDocumentExcludePattern=r;function o(I,O,z){if(Array.isArray(I.viewType)&&I.viewType.indexOf(O)>=0||I.viewType===O)return!0;if(I.filenamePattern){const j=r(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,m=r(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(_.match(j,(0,D.basename)(z.fsPath).toLowerCase()))return!(m&&_.match(m,(0,D.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class u{constructor(O){this.textModel=O}getElements(){const O=new Int32Array(this.textModel.cells.length);for(let z=0;z<this.textModel.cells.length;z++)O[z]=this.textModel.cells[z].getHashValue();return O}}e.CellSequence=u,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var E;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(E=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(O){return`${P._prefix}${O}`}static parse(O){if(O.startsWith(P._prefix))return O.substring(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(ve[109],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,_.createDecorator)("environmentVariableService");var t;(function(p){p[p.Replace=1]="Replace",p[p.Append=2]="Append",p[p.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[236],we([0,1,3,109]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class p{constructor(y){this.map=new Map,y.forEach((b,T)=>{const A=b.map.entries();let h=A.next();for(;!h.done;){const v=h.value[0];let l=this.map.get(v);if(l||(l=[],this.map.set(v,l)),l.length>0&&l[0].type===t.EnvironmentVariableMutatorType.Replace){h=A.next();continue}const d=h.value[1];l.unshift({extensionIdentifier:T,value:d.value,type:d.type}),h=A.next()}})}applyToProcessEnvironment(y,b){let T;_.isWindows&&(T={},Object.keys(y).forEach(A=>T[A.toLowerCase()]=A)),this.map.forEach((A,h)=>{const v=_.isWindows&&T[h.toLowerCase()]||h;A.forEach(l=>{const d=b?b(l.value):l.value;switch(l.type){case t.EnvironmentVariableMutatorType.Append:y[v]=(y[v]||"")+d;break;case t.EnvironmentVariableMutatorType.Prepend:y[v]=d+(y[v]||"");break;case t.EnvironmentVariableMutatorType.Replace:y[v]=d;break}})})}diff(y){const b=new Map,T=new Map,A=new Map;if(y.map.forEach((h,v)=>{const l=this.map.get(v),d=k(h,l);d&&b.set(v,d)}),this.map.forEach((h,v)=>{const l=y.map.get(v),d=k(h,l);d&&A.set(v,d)}),this.map.forEach((h,v)=>{const l=y.map.get(v),d=D(h,l);d&&T.set(v,d)}),!(b.size===0&&T.size===0&&A.size===0))return{added:b,changed:T,removed:A}}}e.MergedEnvironmentVariableCollection=p;function k(R,y){if(!y)return R;const b=new Set;y.forEach(A=>b.add(A.extensionIdentifier));const T=[];return R.forEach(A=>{b.has(A.extensionIdentifier)||T.push(A)}),T.length===0?void 0:T}function D(R,y){if(!y)return;const b=new Map;y.forEach(A=>b.set(A.extensionIdentifier,A));const T=[];return R.forEach(A=>{const h=b.get(A.extensionIdentifier);h&&(A.type!==h.type||A.value!==h.value)&&T.push(h)}),T.length===0?void 0:T}}),define(ve[110],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=_;function t(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=t}),define(ve[237],we([0,1,4,75,3]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.injectShellIntegrationArgs=e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function k(o,u){if(!!u)if(p.isWindows)for(const E in u){let P=E;for(const O in o)if(E.toLowerCase()===O.toLowerCase()){P=O;break}const I=u[E];I!==void 0&&D(o,P,I)}else Object.keys(u).forEach(E=>{const P=u[E];P!==void 0&&D(o,E,P)})}e.mergeEnvironments=k;function D(o,u,E){typeof E=="string"?o[u]=E:delete o[u]}function R(o,u,E,P){o.TERM_PROGRAM="vscode",u&&(o.TERM_PROGRAM_VERSION=u),T(o,P)&&(o.LANG=A(E)),o.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=R;function y(o,u){if(!!u)for(const E of Object.keys(u)){const P=u[E];P&&(o[E]=P)}}function b(o,u){return Object.keys(u).forEach(E=>{const P=u[E];if(typeof P=="string")try{u[E]=o(P)}catch{u[E]=P}}),u}function T(o,u){if(u==="on")return!0;if(u==="auto"){const E=o.LANG;return!E||E.search(/\.UTF\-8$/)===-1&&E.search(/\.utf8$/)===-1&&E.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function A(o){const u=o?o.split("-"):[],E=u.length;if(E===0)return"en_US.UTF-8";if(E===1){const P={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};u[0]in P&&u.push(P[u[0]])}else u[1]=u[1].toUpperCase();return u.join("_")+".UTF-8"}e.getLangEnvVariable=A;function h(o,u,E,P,I,O){if(o.cwd){const j=typeof o.cwd=="object"?o.cwd.fsPath:o.cwd,m=v(j,E);return l(m||j)}let z;return!o.ignoreConfigurationCwd&&I&&(E&&(I=v(I,E,O)),I&&(_.isAbsolute(I)?z=I:P&&(z=_.join(P.fsPath,I)))),z||(z=P?P.fsPath:u||""),l(z)}e.getCwd=h;function v(o,u,E){if(u)try{return u(o)}catch(P){E?.error("Could not resolve terminal cwd",P);return}return o}function l(o){return p.OS===1&&o&&o[1]===":"?o[0].toUpperCase()+o.substr(1):o}function d(o,u,E){if(!!E)return P=>E.resolveWithEnvironment(u,o,P)}e.createVariableResolver=d;function g(o,u,E,P,I,O,z,j=p.platform){let m;z&&(m=c(o,"automationShell",j)),m||(m=c(o,"shell",j));let L=m||u;if(j===3&&!E&&P){const M=_.join(P,"Sysnative").replace(/\//g,"\\").toLowerCase();L&&L.toLowerCase().indexOf(M)===0&&(L=_.join(P,"System32",L.substr(M.length+1)))}if(L&&j===3&&(L=L.replace(/\//g,"\\")),I)try{L=I(L)}catch(M){O.error("Could not resolve shell",M)}return L}e.getDefaultShell=g;function S(o,u,E,P,I=p.platform){if(u&&c(o,"automationShell",I))return[];const O=I===3?"windows":I===1?"osx":"linux";let z=o(`terminal.integrated.shellArgs.${O}`);if(!z)return[];if(typeof z=="string"&&I===3)return E?E(z):z;if(E){const j=[];for(const m of z)try{j.push(E(m))}catch(L){P.error(`Could not resolve terminal.integrated.shellArgs.${O}`,L),j.push(m)}z=j}return z}e.getDefaultShellArgs=S;function c(o,u,E=p.platform){return o(`terminal.integrated.${u}.${E===3?"windows":E===1?"osx":"linux"}`)}function C(o,u,E,P,I,O){const z={};if(o.strictEnv)y(z,o.env);else{y(z,O);const j={...u};E&&(j&&b(E,j),o.env&&b(E,o.env)),(0,t.sanitizeProcessEnvironment)(z,"VSCODE_IPC_HOOK_CLI"),k(z,j),k(z,o.env),R(z,P,p.locale,I)}return z}e.createTerminalEnvironment=C;var w;(function(o){o.WindowsPwsh="windows-pwsh",o.WindowsPwshLogin="windows-pwsh-login",o.Pwsh="pwsh",o.PwshLogin="pwsh-login",o.Zsh="zsh",o.ZshLogin="zsh-login",o.Bash="bash"})(w=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(w.WindowsPwsh,["-noexit"," -command",'. "${execInstallFolder}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"']),e.shellIntegrationArgs.set(w.WindowsPwshLogin,["-l","-noexit"," -command",'. "${execInstallFolder}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"']),e.shellIntegrationArgs.set(w.Pwsh,["-noexit","-command",'. "${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(w.PwshLogin,["-l","-noexit","-command",'. "${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(w.Zsh,["-c",'"${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-zsh.sh"; zsh -i']),e.shellIntegrationArgs.set(w.ZshLogin,["-c",'"${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-zsh.sh"; zsh -il']),e.shellIntegrationArgs.set(w.Bash,["--init-file","${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],s=["-nol","-nologo"];function a(o,u,E,P,I){if(!E||!P.executable||P.isFeatureTerminal)return{args:P.args,enableShellIntegration:!1};const O=P.args,z=_.basename(P.executable).toLowerCase();let j;if(I===1)z==="pwsh.exe"&&(!O||n(O)?j=e.shellIntegrationArgs.get(w.WindowsPwsh):i(O)?j=e.shellIntegrationArgs.get(w.WindowsPwshLogin):o.warn(`Shell integration cannot be enabled when custom args ${O} are provided for ${z} on Windows.`));else{switch(z){case"bash":!O||O.length===0?j=e.shellIntegrationArgs.get(w.Bash):r(O)&&(u.VSCODE_SHELL_LOGIN="1",j=e.shellIntegrationArgs.get(w.Bash));break;case"pwsh":!O||n(O)?j=e.shellIntegrationArgs.get(w.Pwsh):i(O)&&(j=e.shellIntegrationArgs.get(w.PwshLogin));break;case"zsh":!O||O.length===0?j=e.shellIntegrationArgs.get(w.Zsh):r(O)&&(j=e.shellIntegrationArgs.get(w.ZshLogin));break}j||o.warn(`Shell integration cannot be enabled when custom args ${O} are provided for ${z}.`)}return{args:j||O,enableShellIntegration:j!==void 0}}e.injectShellIntegrationArgs=a;function i(o){return typeof o=="string"?f.includes(o.toLowerCase()):o.length===1&&f.includes(o[0].toLowerCase())||o.length===2&&(f.includes(o[0].toLowerCase())||f.includes(o[1].toLowerCase()))&&(s.includes(o[0].toLowerCase())||s.includes(o[1].toLowerCase()))}function n(o){return typeof o=="string"?s.includes(o.toLowerCase()):o.length===0||o?.length===1&&s.includes(o[0].toLowerCase())}function r(o){return o==="string"&&f.includes(o.toLowerCase())||typeof o!="string"&&o.length===1&&f.includes(o[0].toLowerCase())}}),define(ve[238],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var _;(function(k){k.Delimiter="\0"})(_=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class p{constructor(D,R=D.length){if(this.path=D,this.viewEnd=R,D.length===0||R<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,R,y=D.parent){if(D.id===R)return new p([R]);let b=[D.id];for(let T=y;T&&T.id!==R;T=T.parent)b.push(T.id);return b.push(R),new p(b.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const R=D.indexOf("\0");return R===-1?D:D.slice(0,R)}static fromString(D){return new p(D.split("\0"))}static join(D,R){return new p([...D.path,R])}static joinToString(D,R){return D.toString()+"\0"+R}static compare(D,R){return D===R?0:R.startsWith(D+"\0")?2:D.startsWith(R+"\0")?3:1}get parentId(){return this.viewEnd>1?new p(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new p(this.path,D)}compare(D){if(typeof D=="string")return p.compare(this.toString(),D);for(let R=0;R<D.viewEnd&&R<this.viewEnd;R++)if(D.path[R]!==this.path[R])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=p}),define(ve[239],we([0,1,28,6]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(_.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[240],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,_.createDecorator)("configurationResolverService")}),define(ve[241],we([0,1,4,24,12,20,3,61,174]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(A,h,v){this._contributedVariables=new Map,this._context=A,this._labelService=h,v&&(this._envVariablesPromise=v.then(l=>this.prepareEnv(l)))}prepareEnv(A){if(D.isWindows){const h=Object.create(null);return Object.keys(A).forEach(v=>{h[v.toLowerCase()]=A[v]}),h}return A}resolveWithEnvironment(A,h,v){return this.recursiveResolve(this.prepareEnv(A),h?h.uri:void 0,v)}async resolveAsync(A,h){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,h)}async resolveAnyBase(A,h,v,l){const d=k.deepClone(h);return D.isWindows&&d.windows?Object.keys(d.windows).forEach(g=>d[g]=d.windows[g]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(g=>d[g]=d.osx[g]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(g=>d[g]=d.linux[g]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,d,v,l)}async resolveAnyAsync(A,h,v){return this.resolveAnyBase(A,h,v)}async resolveAnyMap(A,h,v){const l=new Map;return{newConfig:await this.resolveAnyBase(A,h,v,l),resolvedVariables:l}}resolveWithInteractionReplace(A,h,v,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,h,v,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,h){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,h)}recursiveResolve(A,h,v,l,d){if(p.isString(v))return this.resolveString(A,h,v,l,d);if(p.isArray(v))return v.map(g=>this.recursiveResolve(A,h,g,l,d));if(p.isObject(v)){let g=Object.create(null);return Object.keys(v).forEach(S=>{const c=this.resolveString(A,h,S,l,d);g[c]=this.recursiveResolve(A,h,v[S],l,d)}),g}return v}resolveString(A,h,v,l,d){return v.replace(b.VARIABLE_REGEXP,(S,c)=>{if(c.includes(b.VARIABLE_LHS))return S;let C=this.evaluateSingleVariable(A,S,c,h,l);return d&&d.set(c,C),C!==S&&p.isString(C)&&C.match(b.VARIABLE_REGEXP)&&(C=this.resolveString(A,h,C,l,d)),C})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,h,v,l,d){let g;const S=v.split(":");S.length>1&&(v=S[0],g=S[1]);const c=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,y.localize)(0,null,h))},C=()=>{const f=c();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,y.localize)(1,null,h,_.basename(f)))},w=()=>{if(g){const f=this._context.getFolderUri(g);if(f)return f;throw new Error((0,y.localize)(2,null,h,g))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,h)):new Error((0,y.localize)(4,null,h))};switch(v){case"env":if(g){if(A){const f=A[D.isWindows?g.toLowerCase():g];if(p.isString(f))return f}return""}throw new Error((0,y.localize)(5,null,h));case"config":if(g){const f=this._context.getConfigurationValue(l,g);if(p.isUndefinedOrNull(f))throw new Error((0,y.localize)(6,null,h,g));if(p.isObject(f))throw new Error((0,y.localize)(7,null,h,g));return f}throw new Error((0,y.localize)(8,null,h));case"command":return this.resolveFromMap(h,g,d,"command");case"input":return this.resolveFromMap(h,g,d,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(w()));case"cwd":return l||g?(0,R.normalizeDriveLetter)(this.fsPath(w())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(w()));case"lineNumber":{const f=this._context.getLineNumber();if(f)return f;throw new Error((0,y.localize)(9,null,h))}case"selectedText":{const f=this._context.getSelectedText();if(f)return f;throw new Error((0,y.localize)(10,null,h))}case"file":return c();case"fileWorkspaceFolder":return C();case"relativeFile":return l||g?_.relative(this.fsPath(w()),c()):c();case"relativeFileDirname":{const f=_.dirname(c());if(l||g){const s=_.relative(this.fsPath(w()),f);return s.length===0?".":s}return f}case"fileDirname":return _.dirname(c());case"fileExtname":return _.extname(c());case"fileBasename":return _.basename(c());case"fileBasenameNoExtension":{const f=_.basename(c());return f.slice(0,f.length-_.extname(f).length)}case"fileDirnameBasename":return _.basename(_.dirname(c()));case"execPath":{const f=this._context.getExecPath();return f||h}case"execInstallFolder":{const f=this._context.getAppRoot();return f||h}case"pathSeparator":return _.sep;default:try{const f=g?`${v}:${g}`:v;return this.resolveFromMap(h,f,d,void 0)}catch{return h}}}}resolveFromMap(A,h,v,l){if(h&&v){const d=l===void 0?v[h]:v[l+":"+h];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[242],we([0,1,6,108]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var p;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(p=e.GroupDirection||(e.GroupDirection={}));var k;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var R;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function b(l){const d=l;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=b;var T;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function h(l){const d=l;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=h;function v(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(ve[111],we([0,1,6,242]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function p(k){const D=k;return typeof k=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=p}),define(ve[243],we([0,1,17,15,76,123,52,20,12,5,63,142,178,198,106,235,238,111,107]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var C;(function(Ee){function Ce(x){const{selectionStartLineNumber:Ie,selectionStartColumn:Re,positionLineNumber:xe,positionColumn:$e}=x,it=new c.Position(Ie-1,Re-1),lt=new c.Position(xe-1,$e-1);return new c.Selection(it,lt)}Ee.to=Ce;function ce(x){const{anchor:Ie,active:Re}=x;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}Ee.from=ce})(C=e.Selection||(e.Selection={}));var w;(function(Ee){function Ce(x){if(!x)return;const{start:Ie,end:Re}=x;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}Ee.from=Ce;function ce(x){if(!x)return;const{startLineNumber:Ie,startColumn:Re,endLineNumber:xe,endColumn:$e}=x;return new c.Range(Ie-1,Re-1,xe-1,$e-1)}Ee.to=ce})(w=e.Range||(e.Range={}));var f;(function(Ee){function Ce(ce){switch(ce){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Ee.to=Ce})(f=e.TokenType||(e.TokenType={}));var s;(function(Ee){function Ce(x){return new c.Position(x.lineNumber-1,x.column-1)}Ee.to=Ce;function ce(x){return{lineNumber:x.line+1,column:x.character+1}}Ee.from=ce})(s=e.Position||(e.Position={}));var a;(function(Ee){function Ce(Ie,Re){return(0,_.coalesce)((0,_.asArray)(Ie).map(xe=>ce(xe,Re)))}Ee.from=Ce;function ce(Ie,Re){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:x(Ie.scheme,Re),pattern:je.from(Ie.pattern)??void 0,exclusive:Ie.exclusive}}function x(Ie,Re){return Re&&typeof Ie=="string"?Re.transformOutgoingScheme(Ie):Ie}})(a=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Ee){function Ce(x){switch(x){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function ce(x){switch(x){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Ee){function Ce(x){let Ie;return x.code&&((0,y.isString)(x.code)||(0,y.isNumber)(x.code)?Ie=String(x.code):Ie={value:String(x.code.value),target:x.code.target}),{...w.from(x.range),message:x.message,source:x.source,code:Ie,severity:o.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(r.from),tags:Array.isArray(x.tags)?(0,_.coalesce)(x.tags.map(i.from)):void 0}}Ee.from=Ce;function ce(x){const Ie=new c.Diagnostic(w.to(x),x.message,o.to(x.severity));return Ie.source=x.source,Ie.code=(0,y.isString)(x.code)?x.code:x.code?.value,Ie.relatedInformation=x.relatedInformation&&x.relatedInformation.map(r.to),Ie.tags=x.tags&&(0,_.coalesce)(x.tags.map(i.to)),Ie}Ee.to=ce})(n=e.Diagnostic||(e.Diagnostic={}));var r;(function(Ee){function Ce(x){return{...w.from(x.location.range),message:x.message,resource:x.location.uri}}Ee.from=Ce;function ce(x){return new c.DiagnosticRelatedInformation(new c.Location(x.resource,w.to(x)),x.message)}Ee.to=ce})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(Ee){function Ce(x){switch(x){case c.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}Ee.from=Ce;function ce(x){switch(x){case v.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Ee.to=ce})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(Ee){function Ce(x){return typeof x=="number"&&x>=c.ViewColumn.One?x-1:x===c.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}Ee.from=Ce;function ce(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(u=e.ViewColumn||(e.ViewColumn={}));function E(Ee){return typeof Ee.range!="undefined"}function P(Ee){return Ee.length===0?!0:!!E(Ee[0])}e.isDecorationOptionsArr=P;var I;(function(Ee){function Ce($e){return $e.map(Ee.from)}Ee.fromMany=Ce;function ce($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function x($e){let it;if(ce($e)){const{language:ut,value:ft}=$e;it={value:"```"+ut+`
`+ft+"\n```\n"}}else c.MarkdownString.isMarkdownString($e)?it={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml}:typeof $e=="string"?it={value:$e}:it={value:""};const lt=Object.create(null);it.uris=lt;const wt=ut=>{try{let ft=b.URI.parse(ut,!0);ft=ft.with({query:Ie(ft.query,lt)}),lt[ut]=ft}catch{}return""},ct=new k.marked.Renderer;return ct.link=wt,ct.image=ut=>typeof ut=="string"?wt(p.parseHrefAndDimensions(ut).href):"",(0,k.marked)(it.value,{renderer:ct}),it}Ee.from=x;function Ie($e,it){if(!$e)return $e;let lt;try{lt=(0,D.parse)($e)}catch{}if(!lt)return $e;let wt=!1;return lt=(0,R.cloneAndChange)(lt,ct=>{if(b.URI.isUri(ct)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=ct,wt=!0,ut}else return}),wt?JSON.stringify(lt):$e}function Re($e){const it=new c.MarkdownString($e.value,$e.supportThemeIcons);return it.isTrusted=$e.isTrusted,it.supportHtml=$e.supportHtml,it}Ee.to=Re;function xe($e){if(!!$e)return typeof $e=="string"?$e:Ee.from($e)}Ee.fromStrict=xe})(I=e.MarkdownString||(e.MarkdownString={}));function O(Ee){return P(Ee)?Ee.map(Ce=>({range:w.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?I.fromMany(Ce.hoverMessage):Ce.hoverMessage?I.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:w.from(Ce)}))}e.fromRangeOrRangeWithMessage=O;function z(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?b.URI.file(Ee):Ee}e.pathOrURIToURI=z;var j;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?z(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=Ce})(j=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var m;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?z(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?j.from(ce.before):void 0,after:ce.after?j.from(ce.after):void 0}}Ee.from=Ce})(m=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(Ee){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(Ee){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?L.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?m.from(ce.light):void 0,dark:ce.dark?m.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?z(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?j.from(ce.before):void 0,after:ce.after?j.from(ce.after):void 0}}Ee.from=Ce})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(Ee){function Ce(x){return{text:x.newText,eol:x.newEol&&_e.from(x.newEol),range:w.from(x.range)}}Ee.from=Ce;function ce(x){const Ie=new c.TextEdit(w.to(x.range),x.text);return Ie.newEol=typeof x.eol=="undefined"?void 0:_e.to(x.eol),Ie}Ee.to=ce})(Q=e.TextEdit||(e.TextEdit={}));var W;(function(Ee){function Ce(x,Ie,Re){const xe={edits:[]};if(x instanceof c.WorkspaceEdit)for(let $e of x._allEntries())if($e._type===1)xe.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata});else if($e._type===2){const it=Ie?.getDocument($e.uri);xe.edits.push({_type:2,resource:$e.uri,edit:Q.from($e.edit),modelVersionId:it?.version,metadata:$e.metadata})}else $e._type===3?xe.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Re?.getNotebookDocument($e.uri,!0)?.apiNotebook.version}):$e._type===5&&xe.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:Re?.getNotebookDocument($e.uri,!0)?.apiNotebook.version,edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(Qe.from)}});return xe}Ee.from=Ce;function ce(x){const Ie=new c.WorkspaceEdit;for(const Re of x.edits)Re.edit?Ie.replace(b.URI.revive(Re.resource),w.to(Re.edit.range),Re.edit.text):Ie.renameFile(b.URI.revive(Re.oldUri),b.URI.revive(Re.newUri),Re.options);return Ie}Ee.to=ce})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var q;(function(Ee){const Ce=Object.create(null);Ce[c.SymbolKind.File]=0,Ce[c.SymbolKind.Module]=1,Ce[c.SymbolKind.Namespace]=2,Ce[c.SymbolKind.Package]=3,Ce[c.SymbolKind.Class]=4,Ce[c.SymbolKind.Method]=5,Ce[c.SymbolKind.Property]=6,Ce[c.SymbolKind.Field]=7,Ce[c.SymbolKind.Constructor]=8,Ce[c.SymbolKind.Enum]=9,Ce[c.SymbolKind.Interface]=10,Ce[c.SymbolKind.Function]=11,Ce[c.SymbolKind.Variable]=12,Ce[c.SymbolKind.Constant]=13,Ce[c.SymbolKind.String]=14,Ce[c.SymbolKind.Number]=15,Ce[c.SymbolKind.Boolean]=16,Ce[c.SymbolKind.Array]=17,Ce[c.SymbolKind.Object]=18,Ce[c.SymbolKind.Key]=19,Ce[c.SymbolKind.Null]=20,Ce[c.SymbolKind.EnumMember]=21,Ce[c.SymbolKind.Struct]=22,Ce[c.SymbolKind.Event]=23,Ce[c.SymbolKind.Operator]=24,Ce[c.SymbolKind.TypeParameter]=25;function ce(Ie){return typeof Ce[Ie]=="number"?Ce[Ie]:6}Ee.from=ce;function x(Ie){for(const Re in Ce)if(Ce[Re]===Ie)return Number(Re);return c.SymbolKind.Property}Ee.to=x})(q=e.SymbolKind||(e.SymbolKind={}));var ne;(function(Ee){function Ce(x){switch(x){case c.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function ce(x){switch(x){case 1:return c.SymbolTag.Deprecated}}Ee.to=ce})(ne=e.SymbolTag||(e.SymbolTag={}));var B;(function(Ee){function Ce(x){return{name:x.name,kind:q.from(x.kind),tags:x.tags&&x.tags.map(ne.from),containerName:x.containerName,location:me.from(x.location)}}Ee.from=Ce;function ce(x){const Ie=new c.SymbolInformation(x.name,q.to(x.kind),x.containerName,me.to(x.location));return Ie.tags=x.tags&&x.tags.map(ne.to),Ie}Ee.to=ce})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(Ee){function Ce(x){const Ie={name:x.name||"!!MISSING: name!!",detail:x.detail,range:w.from(x.range),selectionRange:w.from(x.selectionRange),kind:q.from(x.kind),tags:x.tags?.map(ne.from)??[]};return x.children&&(Ie.children=x.children.map(Ce)),Ie}Ee.from=Ce;function ce(x){const Ie=new c.DocumentSymbol(x.name,x.detail,q.to(x.kind),w.to(x.range),w.to(x.selectionRange));return(0,_.isNonEmptyArray)(x.tags)&&(Ie.tags=x.tags.map(ne.to)),x.children&&(Ie.children=x.children.map(ce)),Ie}Ee.to=ce})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Ee){function Ce(x){const Ie=new c.CallHierarchyItem(q.to(x.kind),x.name,x.detail||"",b.URI.revive(x.uri),w.to(x.range),w.to(x.selectionRange));return Ie._sessionId=x._sessionId,Ie._itemId=x._itemId,Ie}Ee.to=Ce;function ce(x,Ie,Re){if(Ie=Ie??x._sessionId,Re=Re??x._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,name:x.name,detail:x.detail,kind:q.from(x.kind),uri:x.uri,range:w.from(x.range),selectionRange:w.from(x.selectionRange),tags:x.tags?.map(ne.from)}}Ee.from=ce})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(Ee){function Ce(ce){return new c.CallHierarchyIncomingCall(ee.to(ce.from),ce.fromRanges.map(x=>w.to(x)))}Ee.to=Ce})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var se;(function(Ee){function Ce(ce){return new c.CallHierarchyOutgoingCall(ee.to(ce.to),ce.fromRanges.map(x=>w.to(x)))}Ee.to=Ce})(se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(Ee){function Ce(x){return{range:x.range&&w.from(x.range),uri:x.uri}}Ee.from=Ce;function ce(x){return new c.Location(b.URI.revive(x.uri),w.to(x.range))}Ee.to=ce})(me=e.location||(e.location={}));var Z;(function(Ee){function Ce(x){const Ie=x,Re=x;return{originSelectionRange:Ie.originSelectionRange?w.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Re.uri,range:w.from(Ie.targetRange?Ie.targetRange:Re.range),targetSelectionRange:Ie.targetSelectionRange?w.from(Ie.targetSelectionRange):void 0}}Ee.from=Ce;function ce(x){return{targetUri:b.URI.revive(x.uri),targetRange:w.to(x.range),targetSelectionRange:x.targetSelectionRange?w.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?w.to(x.originSelectionRange):void 0}}Ee.to=ce})(Z=e.DefinitionLink||(e.DefinitionLink={}));var $;(function(Ee){function Ce(x){return{range:w.from(x.range),contents:I.fromMany(x.contents)}}Ee.from=Ce;function ce(x){return new c.Hover(x.contents.map(I.to),w.to(x.range))}Ee.to=ce})($=e.Hover||(e.Hover={}));var H;(function(Ee){function Ce(x){return{range:w.from(x.range),expression:x.expression}}Ee.from=Ce;function ce(x){return new c.EvaluatableExpression(w.to(x.range),x.expression)}Ee.to=ce})(H=e.EvaluatableExpression||(e.EvaluatableExpression={}));var V;(function(Ee){function Ce(x){if(x instanceof c.InlineValueText)return{type:"text",range:w.from(x.range),text:x.text};if(x instanceof c.InlineValueVariableLookup)return{type:"variable",range:w.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function ce(x){switch(x.type){case"text":return{range:w.to(x.range),text:x.text};case"variable":return{range:w.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:w.to(x.range),expression:x.expression}}}Ee.to=ce})(V=e.InlineValue||(e.InlineValue={}));var ie;(function(Ee){function Ce(x){return{frameId:x.frameId,stoppedLocation:w.from(x.stoppedLocation)}}Ee.from=Ce;function ce(x){return new c.InlineValueContext(x.frameId,w.to(x.stoppedLocation))}Ee.to=ce})(ie=e.InlineValueContext||(e.InlineValueContext={}));var de;(function(Ee){function Ce(x){return{range:w.from(x.range),kind:x.kind}}Ee.from=Ce;function ce(x){return new c.DocumentHighlight(w.to(x.range),x.kind)}Ee.to=ce})(de=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(Ee){function Ce(ce){switch(ce){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Ee.to=Ce})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Ee){function Ce(ce){return{triggerKind:De.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=Ce})(ae=e.CompletionContext||(e.CompletionContext={}));var fe;(function(Ee){function Ce(x){switch(x){case c.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function ce(x){switch(x){case 1:return c.CompletionItemTag.Deprecated}}Ee.to=ce})(fe=e.CompletionItemTag||(e.CompletionItemTag={}));var pe;(function(Ee){const Ce=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ce(Re){return Ce.get(Re)??9}Ee.from=ce;const x=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ie(Re){return x.get(Re)??c.CompletionItemKind.Property}Ee.to=Ie})(pe=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Ee){function Ce(ce,x){const Ie=new c.CompletionItem(ce.label);return Ie.insertText=ce.insertText,Ie.kind=pe.to(ce.kind),Ie.tags=ce.tags?.map(fe.to),Ie.detail=ce.detail,Ie.documentation=p.isMarkdownString(ce.documentation)?I.to(ce.documentation):ce.documentation,Ie.sortText=ce.sortText,Ie.filterText=ce.filterText,Ie.preselect=ce.preselect,Ie.commitCharacters=ce.commitCharacters,T.Range.isIRange(ce.range)?Ie.range=w.to(ce.range):typeof ce.range=="object"&&(Ie.range={inserting:w.to(ce.range.insert),replacing:w.to(ce.range.replace)}),Ie.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ie.insertText=new c.SnippetString(ce.insertText):(Ie.insertText=ce.insertText,Ie.textEdit=Ie.range instanceof c.Range?new c.TextEdit(Ie.range,Ie.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ce.additionalTextEdits.map(Re=>Q.to(Re))),Ie.command=x&&ce.command?x.fromInternal(ce.command):void 0,Ie}Ee.to=Ce})(X=e.CompletionItem||(e.CompletionItem={}));var U;(function(Ee){function Ce(x){return{label:x.label,documentation:x.documentation?I.fromStrict(x.documentation):void 0}}Ee.from=Ce;function ce(x){return{label:x.label,documentation:p.isMarkdownString(x.documentation)?I.to(x.documentation):x.documentation}}Ee.to=ce})(U=e.ParameterInformation||(e.ParameterInformation={}));var K;(function(Ee){function Ce(x){return{label:x.label,documentation:x.documentation?I.fromStrict(x.documentation):void 0,parameters:Array.isArray(x.parameters)?x.parameters.map(U.from):[],activeParameter:x.activeParameter}}Ee.from=Ce;function ce(x){return{label:x.label,documentation:p.isMarkdownString(x.documentation)?I.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(U.to):[],activeParameter:x.activeParameter}}Ee.to=ce})(K=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(Ee){function Ce(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(K.from):[]}}Ee.from=Ce;function ce(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(K.to):[]}}Ee.to=ce})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ue;(function(Ee){function Ce(ce,x){const Ie=new c.InlayHint(typeof x.label=="string"?x.label:x.label.map(ye.to.bind(void 0,ce)),s.to(x.position),Pe.to(x.kind));return Ie.tooltip=p.isMarkdownString(x.tooltip)?I.to(x.tooltip):x.tooltip,Ie.paddingLeft=x.paddingLeft,Ie.paddingRight=x.paddingRight,Ie}Ee.to=Ce})(ue=e.InlayHint||(e.InlayHint={}));var ye;(function(Ee){function Ce(ce,x){const Ie=new c.InlayHintLabelPart(x.label);return Ie.tooltip=p.isMarkdownString(x.tooltip)?I.to(x.tooltip):x.tooltip,A.Command.is(x.command)&&(Ie.command=ce.fromInternal(x.command)),x.location&&(Ie.location=me.to(x.location)),Ie}Ee.to=Ce})(ye=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Pe;(function(Ee){function Ce(x){return x}Ee.from=Ce;function ce(x){return x}Ee.to=ce})(Pe=e.InlayHintKind||(e.InlayHintKind={}));var Ae;(function(Ee){function Ce(x){return{range:w.from(x.range),url:x.target,tooltip:x.tooltip}}Ee.from=Ce;function ce(x){let Ie;if(x.url)try{Ie=typeof x.url=="string"?b.URI.parse(x.url,!0):b.URI.revive(x.url)}catch{}return new c.DocumentLink(w.to(x.range),Ie)}Ee.to=ce})(Ae=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(Ee){function Ce(x){const Ie=new c.ColorPresentation(x.label);return x.textEdit&&(Ie.textEdit=Q.to(x.textEdit)),x.additionalTextEdits&&(Ie.additionalTextEdits=x.additionalTextEdits.map(Re=>Q.to(Re))),Ie}Ee.to=Ce;function ce(x){return{label:x.label,textEdit:x.textEdit?Q.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Ie=>Q.from(Ie)):void 0}}Ee.from=ce})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(Ee){function Ce(x){return new c.Color(x[0],x[1],x[2],x[3])}Ee.to=Ce;function ce(x){return[x.red,x.green,x.blue,x.alpha]}Ee.from=ce})(Ue=e.Color||(e.Color={}));var le;(function(Ee){function Ce(x){return{range:w.from(x.range)}}Ee.from=Ce;function ce(x){return new c.SelectionRange(w.to(x.range))}Ee.to=ce})(le=e.SelectionRange||(e.SelectionRange={}));var ge;(function(Ee){function Ce(ce){switch(ce){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(Ee){function Ce(x){switch(x){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function ce(x){switch(x){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Ee.to=ce})(he=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var _e;(function(Ee){function Ce(x){if(x===c.EndOfLine.CRLF)return 1;if(x===c.EndOfLine.LF)return 0}Ee.from=Ce;function ce(x){if(x===1)return c.EndOfLine.CRLF;if(x===0)return c.EndOfLine.LF}Ee.to=ce})(_e=e.EndOfLine||(e.EndOfLine={}));var Me;(function(Ee){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(Me=e.ProgressLocation||(e.ProgressLocation={}));var qe;(function(Ee){function Ce(ce){const x={start:ce.start+1,end:ce.end+1};return ce.kind&&(x.kind=Be.from(ce.kind)),x}Ee.from=Ce})(qe=e.FoldingRange||(e.FoldingRange={}));var Be;(function(Ee){function Ce(ce){if(ce)switch(ce){case c.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}Ee.from=Ce})(Be=e.FoldingRangeKind||(e.FoldingRangeKind={}));var He;(function(Ee){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?w.from(ce.selection):void 0,override:typeof ce.override=="boolean"?h.EditorResolution.DISABLED:void 0}}Ee.from=Ce})(He=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var je;(function(Ee){function Ce(Re){return Re instanceof c.RelativePattern?Re.toJSON():typeof Re=="string"?Re:ce(Re)||x(Re)?new c.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}Ee.from=Ce;function ce(Re){const xe=Re;return xe?b.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function x(Re){const xe=Re;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ie(Re){return typeof Re=="string"?Re:new c.RelativePattern(b.URI.revive(Re.baseUri),Re.pattern)}Ee.to=Ie})(je=e.GlobPattern||(e.GlobPattern={}));var re;(function(Ee){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const x=ce;return{language:x.language,scheme:x.scheme,pattern:je.from(x.pattern),exclusive:x.exclusive}}}else return}Ee.from=Ce})(re=e.LanguageSelector||(e.LanguageSelector={}));var be;(function(Ee){function Ce(x){return{start:x.start,end:x.end}}Ee.from=Ce;function ce(x){return new c.NotebookRange(x.start,x.end)}Ee.to=ce})(be=e.NotebookRange||(e.NotebookRange={}));var ke;(function(Ee){function Ce(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Ee.to=Ce;function ce(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Ee.from=ce})(ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Ee){function Ce(x){switch(x){case c.NotebookCellKind.Markup:return d.CellKind.Markup;case c.NotebookCellKind.Code:default:return d.CellKind.Code}}Ee.from=Ce;function ce(x){switch(x){case d.CellKind.Markup:return c.NotebookCellKind.Markup;case d.CellKind.Code:default:return c.NotebookCellKind.Code}}Ee.to=ce})(Le=e.NotebookCellKind||(e.NotebookCellKind={}));var Oe;(function(Ee){function Ce(x){const Ie={metadata:x.metadata??Object.create(null),cells:[]};for(let Re of x.cells)c.NotebookCellData.validate(Re),Ie.cells.push(Qe.from(Re));return Ie}Ee.from=Ce;function ce(x){const Ie=new c.NotebookData(x.cells.map(Qe.to));return(0,y.isEmptyObject)(x.metadata)||(Ie.metadata=x.metadata),Ie}Ee.to=ce})(Oe=e.NotebookData||(e.NotebookData={}));var Qe;(function(Ee){function Ce(x){return{cellKind:Le.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:ke.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Ve.from):[]}}Ee.from=Ce;function ce(x){return new c.NotebookCellData(Le.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Ve.to):void 0,x.metadata,x.internalMetadata?ke.to(x.internalMetadata):void 0)}Ee.to=ce})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var We;(function(Ee){function Ce(x){return{mime:x.mime,valueBytes:t.VSBuffer.wrap(x.data)}}Ee.from=Ce;function ce(x){return new c.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}Ee.to=ce})(We=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ve;(function(Ee){function Ce(x){return{outputId:x.id,items:x.items.map(We.from),metadata:x.metadata}}Ee.from=Ce;function ce(x){const Ie=x.items.map(We.to);return new c.NotebookCellOutput(Ie,x.outputId,x.metadata)}Ee.to=ce})(Ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ye;(function(Ee){function Ce(Ie){return x(Ie)?{include:(0,y.withNullAsUndefined)(je.from(Ie.include)),exclude:(0,y.withNullAsUndefined)(je.from(Ie.exclude))}:(0,y.withNullAsUndefined)(je.from(Ie))}Ee.from=Ce;function ce(Ie){return x(Ie)?{include:je.to(Ie.include),exclude:je.to(Ie.exclude)}:je.to(Ie)}Ee.to=ce;function x(Ie){const Re=Ie;return Re?!!Re.include&&!!Re.exclude:!1}})(Ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ge;(function(Ee){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?j.from(ce.top):void 0}}Ee.from=Ce})(Ge=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ze;(function(Ee){function Ce(ce,x,Ie){const Re=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Re,Ie),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Ee.from=Ce})(Ze=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(Ee){function Ce(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}Ee.from=Ce})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(Ee){function Ce(x){return{uri:x.uri,provides:x.provides}}Ee.from=Ce;function ce(x){return new c.NotebookRendererScript(b.URI.revive(x.uri),x.provides)}Ee.to=ce})(tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var nt;(function(Ee){function Ce(x){return{message:I.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location?me.from(x.location):void 0}}Ee.from=Ce;function ce(x){const Ie=new c.TestMessage(typeof x.message=="string"?x.message:I.to(x.message));return Ie.actualOutput=x.actual,Ie.expectedOutput=x.expected,Ie.location=x.location?me.to(x.location):void 0,Ie}Ee.to=ce})(nt=e.TestMessage||(e.TestMessage={}));var ot;(function(Ee){let Ce;(function(ce){ce.Delimiter="\0"})(Ce||(Ce={})),Ee.namespace=(ce,x)=>ce+"\0"+x,Ee.denamespace=ce=>{const x=ce.indexOf("\0");return{ctrlId:ce.slice(0,x),tagId:ce.slice(x+1)}}})(ot=e.TestTag||(e.TestTag={}));var vt;(function(Ee){function Ce(Re){const xe=(0,l.getPrivateApiFor)(Re).controllerId;return{extId:g.TestId.fromExtHostTestItem(Re,xe).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map($e=>ot.namespace(xe,$e.id)),range:w.from(Re.range)||null,description:Re.description||null,sortText:Re.sortText||null,error:Re.error&&I.fromStrict(Re.error)||null}}Ee.from=Ce;function ce(Re){return{parent:void 0,error:void 0,id:g.TestId.fromString(Re.extId).localId,label:Re.label,uri:b.URI.revive(Re.uri),tags:(Re.tags||[]).map(xe=>{const{tagId:$e}=ot.denamespace(xe);return new c.TestTag($e)}),range:w.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0,sortText:Re.sortText||void 0}}Ee.toPlain=ce;function x(Re){const xe=g.TestId.fromString(Re.extId),$e=new l.TestItemImpl(xe.controllerId,xe.localId,Re.label,b.URI.revive(Re.uri));return $e.range=w.to(Re.range||void 0),$e.description=Re.description||void 0,$e.sortText=Re.sortText||void 0,$e}function Ie(Re){let xe;for(const $e of Re.tests){const it=x($e.item);(0,l.getPrivateApiFor)(it).parent=xe,xe=it}return xe}Ee.toItemFromContext=Ie})(vt=e.TestItem||(e.TestItem={})),function(Ee){function Ce(x){return{id:x.id}}Ee.from=Ce;function ce(x){return new c.TestTag(x.id)}Ee.to=ce}(ot=e.TestTag||(e.TestTag={}));var pt;(function(Ee){const Ce=(x,Ie)=>{const Re={...vt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter($e=>$e.type===0).map(nt.to)})),children:x.children.map(xe=>Ie.get(xe)).filter(y.isDefined).map(xe=>Ce(xe,Ie))};for(const xe of Re.children)xe.parent=Re;return Re};function ce(x){const Ie=[],Re=new Map;for(const xe of x.items)Re.set(xe.item.extId,xe),x.request.targets.some($e=>$e.controllerId===xe.controllerId&&$e.testIds.includes(xe.item.extId))&&Ie.push(xe);return{completedAt:x.completedAt,results:Ie.map(xe=>Ce(xe,Re))}}Ee.to=ce})(pt=e.TestResults||(e.TestResults={}));var Dt;(function(Ee){function Ce(Re){return{covered:Re.covered,total:Re.covered}}function ce(Re){return"line"in Re?s.from(Re):w.from(Re)}function x(Re){return"branches"in Re?{count:Re.executionCount,location:ce(Re.location),type:1,branches:Re.branches.length?Re.branches.map(xe=>({count:xe.executionCount,location:xe.location&&ce(xe.location)})):void 0}:{type:0,count:Re.executionCount,location:ce(Re.location)}}Ee.fromDetailed=x;function Ie(Re){return{uri:Re.uri,statement:Ce(Re.statementCoverage),branch:Re.branchCoverage&&Ce(Re.branchCoverage),function:Re.functionCoverage&&Ce(Re.functionCoverage),details:Re.detailedCoverage?.map(x)}}Ee.fromFile=Ie})(Dt=e.TestCoverage||(e.TestCoverage={}));var It;(function(Ee){function Ce(ce){switch(ce){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(It=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Ee){function Ce(x){const Ie=new c.TypeHierarchyItem(q.to(x.kind),x.name,x.detail||"",b.URI.revive(x.uri),w.to(x.range),w.to(x.selectionRange));return Ie._sessionId=x._sessionId,Ie._itemId=x._itemId,Ie}Ee.to=Ce;function ce(x,Ie,Re){if(Ie=Ie??x._sessionId,Re=Re??x._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,kind:q.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:w.from(x.range),selectionRange:w.from(x.selectionRange),tags:x.tags?.map(ne.from)}}Ee.from=ce})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[244],we([0,1,12,239,14,96,104,110,240,108,111,8,194,109]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let l=class{constructor(g,S,c,C,w,f,s,a,i,n){this._remoteAuthority=g,this._channel=S,this._configurationService=c,this._workspaceContextService=C,this._resolverService=w,this._environmentVariableService=f,this._remoteAuthorityResolverService=s,this._logService=a,this._editorService=i,this._labelService=n}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(g,S,c,C,w,f,s){await this._configurationService.whenRemoteConfigurationLoaded();const a=Object.create(null),i=c?(0,_.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(c)):void 0;let n;try{n=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:g,configuration:S})).resolvedVariables}catch(j){this._logService.error(j)}if(n)for(const[j,m]of n.entries())(/^config:/.test(j)||j==="selectedText"||j==="lineNumber")&&(a[j]=m);const r=[];for(const[j,m]of this._environmentVariableService.collections.entries())r.push([j,(0,R.serializeEnvironmentVariableCollection)(m.map)]);const o=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),u=o.options&&o.options.extensionHostEnv,E=this._workspaceContextService.getWorkspace(),P=E.folders,I=c?this._workspaceContextService.getWorkspaceFolder(c):null,O=b.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:b.SideBySideEditor.PRIMARY,filterByScheme:[A.Schemas.file,A.Schemas.userData,A.Schemas.vscodeRemote]}),z={configuration:S,resolvedVariables:a,envVariableCollections:r,shellLaunchConfig:g,workspaceId:E.id,workspaceName:this._labelService.getWorkspaceLabel(E),workspaceFolders:P,activeWorkspaceFolder:I,activeFileResource:O,shouldPersistTerminal:C,cols:w,rows:f,unicodeVersion:s,resolverEnv:u};return await this._channel.call("$createProcess",z)}requestDetachInstance(g,S){return this._channel.call("$requestDetachInstance",[g,S])}acceptDetachInstanceReply(g,S){return this._channel.call("$acceptDetachInstanceReply",[g,S])}attachToProcess(g){return this._channel.call("$attachToProcess",[g])}detachFromProcess(g){return this._channel.call("$detachFromProcess",[g])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(g,S){return this._channel.call("$processBinary",[g,S])}start(g){return this._channel.call("$start",[g])}input(g,S){return this._channel.call("$input",[g,S])}acknowledgeDataEvent(g,S){return this._channel.call("$acknowledgeDataEvent",[g,S])}setUnicodeVersion(g,S){return this._channel.call("$setUnicodeVersion",[g,S])}shutdown(g,S){return this._channel.call("$shutdown",[g,S])}resize(g,S,c){return this._channel.call("$resize",[g,S,c])}getInitialCwd(g){return this._channel.call("$getInitialCwd",[g])}getCwd(g){return this._channel.call("$getCwd",[g])}orphanQuestionReply(g){return this._channel.call("$orphanQuestionReply",[g])}sendCommandResult(g,S,c){return this._channel.call("$sendCommandResult",[g,S,c])}installAutoReply(g,S){return this._channel.call("$installAutoReply",[g,S])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(g){return this._channel.call("$getDefaultSystemShell",[g])}getProfiles(g,S,c){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,g,S,c])}acceptPtyHostResolvedVariables(g,S){return this._channel.call("$acceptPtyHostResolvedVariables",[g,S])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(g){return this._channel.call("$getWslPath",[g])}setTerminalLayoutInfo(g){const c={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:g?g.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",c)}updateTitle(g,S,c){return this._channel.call("$updateTitle",[g,S,c])}updateIcon(g,S,c){return this._channel.call("$updateIcon",[g,S,c])}refreshProperty(g,S){return this._channel.call("$refreshProperty",[g,S])}updateProperty(g,S,c){return this._channel.call("$updateProperty",[g,S,c])}getTerminalLayoutInfo(){const S={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",S)}reviveTerminalProcesses(g,S){return this._channel.call("$reviveTerminalProcesses",[g,S])}serializeTerminalState(g){return this._channel.call("$serializeTerminalState",[g])}};l=Te([Ne(2,t.IWorkbenchConfigurationService),Ne(3,D.IWorkspaceContextService),Ne(4,y.IConfigurationResolverService),Ne(5,v.IEnvironmentVariableService),Ne(6,k.IRemoteAuthorityResolverService),Ne(7,p.ILogService),Ne(8,T.IEditorService),Ne(9,h.ILabelService)],l),e.RemoteTerminalChannelClient=l}),define(ve[245],we([0,1,199]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var t;(function(k){function D(R,y){if(R===y)return!0;let b=Object.keys(R),T=new Set;for(let A of Object.keys(y))T.add(A);if(b.length!==T.size)return!1;for(let A of b){if(R[A]!==y[A])return!1;T.delete(A)}return T.size===0}k.equals=D})(t=e.Translations||(e.Translations={}));class p{constructor(D){this._messageHandler=D}error(D,R){this._messageHandler(_.Severity.Error,D,R)}warn(D,R){this._messageHandler(_.Severity.Warning,D,R)}info(D,R){this._messageHandler(_.Severity.Info,D,R)}}e.Logger=p}),define(ve[112],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const t=[];function p(R){const y=new _(R);return t[y.nid]=y,y}e.createProxyIdentifier=p;function k(R){return t[R].sid}e.getStringIdentifierForProxy=k;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(ve[246],we([0,1,52,5,112]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var k;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var D;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var R;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class h{static mixin(C){return C._id=h._n++,C}}e.IdObject=h,h._n=0;var v;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(c){if(c&&c.edits)for(const C of c.edits)typeof C.resource=="object"?C.resource=t.URI.revive(C.resource):(C.newUri=t.URI.revive(C.newUri),C.oldUri=t.URI.revive(C.oldUri)),C.metadata&&C.metadata.iconPath&&(C.metadata=(0,_.revive)(C.metadata));return c}e.reviveWorkspaceEditDto=g;var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}});var Et=this&&this.__classPrivateFieldSet||function(J,e,_,t,p){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?p.call(J,_):p?p.value=_:e.set(J,_),_},et=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(ve[247],we([0,1,12,107,243,20,246,17,14,52,63,85,5,2,6,234,106,15,112,36]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(o,u){w.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Et(this,w,o.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=u,this.converter=new s(this,E=>{const P=this._apiCommands.get(E);return P?.result===i.Void?P:void 0},u),this._argumentProcessors=[{processArgument(E){return(0,b.revive)(E)}},{processArgument(E){return(0,k.cloneAndChange)(E,function(P){if(T.Range.isIRange(P))return p.Range.to(P);if(A.Position.isIPosition(P))return p.Position.to(P);if(T.Range.isIRange(P.range)&&h.URI.isUri(P.uri))return p.location.to(P);if(P instanceof S.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const u=this.registerCommand(!1,o.id,async(...E)=>{const P=o.args.map((O,z)=>{if(!O.validate(E[z]))throw new Error(`Invalid argument '${O.name}' when running '${o.id}', received: ${E[z]}`);return O.convert(E[z])}),I=await this.executeCommand(o.internalId,...P);return o.result.convert(I,E,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{u.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,u,E,P,I,O){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:E,thisArg:P,description:I,extension:O}),o&&et(this,w,"f").$registerCommand(u),new t.Disposable(()=>{this._commands.delete(u)&&o&&et(this,w,"f").$unregisterCommand(u)})}executeCommand(o,...u){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,u,!0)}async _doExecuteCommand(o,u,E){if(this._commands.has(o))return this._executeContributedCommand(o,u,!1);{let P=!1;const I=(0,k.cloneAndChange)(u,function(O){if(O instanceof t.Position)return p.Position.from(O);if(O instanceof t.Range)return p.Range.from(O);if(O instanceof t.Location)return p.location.from(O);if(t.NotebookRange.isNotebookRange(O))return p.NotebookRange.from(O);if(O instanceof ArrayBuffer)return P=!0,S.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return P=!0,S.VSBuffer.wrap(O);if(!Array.isArray(O))return O});try{const O=await et(this,w,"f").$executeCommand(o,P?new c.SerializableObjectWithBuffers(I):I,E);return(0,b.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(o,u,!1);throw O}}}async _executeContributedCommand(o,u,E){const P=this._commands.get(o);if(!P)throw new Error("Unknown command");let{callback:I,thisArg:O,description:z}=P;if(z)for(let j=0;j<z.args.length;j++)try{(0,_.validateConstraint)(u[j],z.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${z.args[j].name}' - ${z.args[j].description}`)}try{return await I.apply(O,u)}catch(j){if(o===this.converter.delegatingCommandId){const m=this.converter.getActualCommand(...u);m&&(o=m.command)}throw this._logService.error(j,o,P.extension?.identifier),E?new class extends Error{constructor(){super((0,C.toErrorMessage)(j));this.id=o,this.source=P.extension?.displayName??P.extension?.name}}:j}}$executeContributedCommand(o,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(u=u.map(E=>this._argumentProcessors.reduce((P,I)=>I.processArgument(P),E)),this._executeContributedCommand(o,u,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),et(this,w,"f").$getCommands().then(u=>(o&&(u=u.filter(E=>E[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[u,E]of this._commands){let{description:P}=E;P&&(o[u]=P)}return Promise.resolve(o)}};w=new WeakMap,f=Te([Ne(0,d.IExtHostRpcService),Ne(1,y.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class s{constructor(o,u,E){this._commands=o,this._lookupApiCommand=u,this._logService=E,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,u){if(!o)return;const E={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return E;const P=this._lookupApiCommand(o.command);if(P)E.id=P.internalId,E.arguments=P.args.map((I,O)=>I.convert(o.arguments&&o.arguments[O]));else if((0,R.isNonEmptyArray)(o.arguments)){const I=++this._cachIdPool;this._cache.set(I,o),u.add((0,v.toDisposable)(()=>{this._cache.delete(I),this._logService.trace("CommandsConverter#DISPOSE",I)})),E.$ident=I,E.id=this.delegatingCommandId,E.arguments=[I],this._logService.trace("CommandsConverter#CREATE",o.command,I)}return E}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const u=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class a{constructor(o,u,E,P){this.name=o,this.description=u,this.validate=E,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,u){return new a(o??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",r=>h.URI.isUri(r),r=>r),a.Position=new a("position","A position in a text document",r=>t.Position.isPosition(r),p.Position.from),a.Range=new a("range","A range in a text document",r=>t.Range.isRange(r),p.Range.from),a.Selection=new a("selection","A selection in a text document",r=>t.Selection.isSelection(r),p.Selection.from),a.Number=new a("number","",r=>typeof r=="number",r=>r),a.String=new a("string","",r=>typeof r=="string",r=>r),a.CallHierarchyItem=new a("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,p.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,p.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",r=>r instanceof g.TestItemImpl,p.TestItem.from);class i{constructor(o,u){this.description=o,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class n{constructor(o,u,E,P,I){this.id=o,this.internalId=u,this.description=E,this.args=P,this.result=I}}e.ApiCommand=n}),define(ve[248],we([0,1,79]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function t(k,D,R=null){const y=(0,_.parse)(D).args;let b=y.shift();if(typeof b=="string")switch(D.severity||(D.severity="info"),R&&(/^\[/.test(R)||(R=`[${R}]`),/ $/.test(R)||(R=`${R} `),b=R+b),D.severity){case"log":case"info":k.info(b,...y);break;case"warn":k.warn(b,...y);break;case"error":k.error(b,...y);break}}e.logRemoteEntry=t;function p(k,D,R){const y=(0,_.parse)(D).args,b=y.shift();typeof b!="string"||D.severity!=="error"||(/^\[/.test(R)||(R=`[${R}]`),/ $/.test(R)||(R=`${R} `),k.error(R+b,...y))}e.logRemoteEntryIfError=p}),define(ve[249],we([0,1,175,4,57,38,17,147,12,5,19,33,65,41,245]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const d="package.json";class g{constructor(i,n,r,o,u,E){this._ourVersion=i,this._ourProductDate=n,this._log=r,this._absoluteFolderPath=o,this._isBuiltin=u,this._isUnderDevelopment=E,this._absoluteManifestPath=t.join(o,d)}}class S extends g{static _fastParseJSON(i,n){try{return JSON.parse(i)}catch{return k.parse(i,n)}}parse(){return T.Promises.readFile(this._absoluteManifestPath).then(i=>{const n=[],r=S._fastParseJSON(i.toString(),n);if(k.getNodeType(r)!=="object")this._log.error(this._absoluteFolderPath,_.localize(0,null,this._absoluteManifestPath));else{if(n.length===0)return r.__metadata&&(r.uuid=r.__metadata.id),r.isUserBuiltin=!!r.__metadata?.isBuiltin,delete r.__metadata,r;n.forEach(o=>{this._log.error(this._absoluteFolderPath,_.localize(1,null,this._absoluteManifestPath,o.offset,o.length,(0,R.getParseErrorMessage)(o.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,_.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class c extends g{constructor(i,n,r,o,u,E,P){super(i,n,r,o,u,E);this._nlsConfig=P}replaceNLS(i){const n=(O,z)=>{z.forEach(j=>{this._log.error(this._absoluteFolderPath,_.localize(3,null,O,(0,R.getParseErrorMessage)(j.error)))})},r=O=>{this._log.error(this._absoluteFolderPath,_.localize(4,null,O))};let o=t.extname(this._absoluteManifestPath),u=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-o.length);const E=`${i.publisher}.${i.name}`;let P=this._nlsConfig.translations[E],I;return P?I=T.Promises.readFile(P,"utf8").then(O=>{let z=[],j=k.parse(O,z);return z.length>0?(n(P,z),{values:void 0,default:`${u}.nls.json`}):k.getNodeType(j)!=="object"?(r(P),{values:void 0,default:`${u}.nls.json`}):{values:j.contents?j.contents.package:void 0,default:`${u}.nls.json`}},O=>({values:void 0,default:`${u}.nls.json`})):I=T.SymlinkSupport.existsFile(u+".nls"+o).then(O=>{if(!!O)return c.findMessageBundles(this._nlsConfig,u).then(z=>z.localized?T.Promises.readFile(z.localized,"utf8").then(j=>{let m=[],L=k.parse(j,m);return m.length>0?(n(z.localized,m),{values:void 0,default:z.original}):k.getNodeType(L)!=="object"?(r(z.localized),{values:void 0,default:z.original}):{values:L,default:z.original}},j=>({values:void 0,default:z.original})):{values:void 0,default:z.original},z=>{})}),I.then(O=>{if(O===void 0)return i;let z=[];return c.resolveOriginalMessageBundle(O.default,z).then(j=>{if(z.length>0)return n(O.default,z),i;if(k.getNodeType(O)!=="object")return r(O.default),i;const m=O.values||Object.create(null);return c._replaceNLStrings(this._nlsConfig,i,m,j,this._log,this._absoluteFolderPath),i})},O=>i)}static resolveOriginalMessageBundle(i,n){return new Promise((r,o)=>{i?T.Promises.readFile(i).then(u=>{r(k.parse(u.toString(),n))},u=>{r(null)}):r(null)})}static findMessageBundles(i,n){return new Promise((r,o)=>{function u(E,P){let I=`${E}.nls.${P}.json`;T.SymlinkSupport.existsFile(I).then(O=>{O&&r({localized:I,original:`${E}.nls.json`});let z=P.lastIndexOf("-");z===-1?r({localized:`${E}.nls.json`,original:null}):(P=P.substring(0,z),u(E,P))})}if(i.devMode||i.pseudo||!i.locale)return r({localized:n+".nls.json",original:null});u(n,i.locale)})}static _replaceNLStrings(i,n,r,o,u,E){function P(I,O,z){const j=I[O];if(y.isString(j)){const m=j,L=m.length;if(L>1&&m[0]==="%"&&m[L-1]==="%"){const M=m.substr(1,L-2);let Q=r[M];Q===void 0&&o&&(Q=o[M]);let W=typeof Q=="string"?Q:typeof Q?.message=="string"?Q.message:void 0;W!==void 0?(i.pseudo&&(W="\uFF3B"+W.replace(/[aouei]/g,"$&$&")+"\uFF3D"),I[O]=z&&(O==="title"||O==="category")&&o?{value:W,original:o[M]}:W):u.warn(E,_.localize(5,null,M))}}else if(y.isObject(j))for(let m in j)j.hasOwnProperty(m)&&(m==="commands"?P(j,m,!0):P(j,m,z));else if(y.isArray(j))for(let m=0;m<j.length;m++)P(j,m,z)}for(let I in n)n.hasOwnProperty(I)&&P(n,I)}}class C extends g{validate(i){let n=i;n.isBuiltin=this._isBuiltin,n.isUserBuiltin=!this._isBuiltin&&!!n.isUserBuiltin,n.isUnderDevelopment=this._isUnderDevelopment;let r=[];return C.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,n,r)?(r.forEach(o=>{this._log.warn(this._absoluteFolderPath,o)}),n.publisher||(n.publisher=v.UNDEFINED_PUBLISHER),n.id=(0,A.getExtensionId)(n.publisher,n.name),n.identifier=new v.ExtensionIdentifier(n.id),n.extensionLocation=b.URI.file(this._absoluteFolderPath),n):(r.forEach(o=>{this._log.error(this._absoluteFolderPath,o)}),null)}static isValidExtensionDescription(i,n,r,o,u){return C.baseIsValidExtensionDescription(r,o,u)?p.valid(o.version)?(0,h.isValidExtensionVersion)(i,n,o,u):(u.push(_.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,n,r){if(!n)return r.push(_.localize(7,null)),!1;if(typeof n.publisher!="undefined"&&typeof n.publisher!="string")return r.push(_.localize(8,null)),!1;if(typeof n.name!="string")return r.push(_.localize(9,null,"name")),!1;if(typeof n.version!="string")return r.push(_.localize(10,null,"version")),!1;if(!n.engines)return r.push(_.localize(11,null,"engines")),!1;if(typeof n.engines.vscode!="string")return r.push(_.localize(12,null,"engines.vscode")),!1;if(typeof n.extensionDependencies!="undefined"&&!C._isStringArray(n.extensionDependencies))return r.push(_.localize(13,null,"extensionDependencies")),!1;if(typeof n.activationEvents!="undefined"){if(!C._isStringArray(n.activationEvents))return r.push(_.localize(14,null,"activationEvents")),!1;if(typeof n.main=="undefined"&&typeof n.browser=="undefined")return r.push(_.localize(15,null,"activationEvents","main")),!1}if(typeof n.main!="undefined"){if(typeof n.main!="string")return r.push(_.localize(16,null,"main")),!1;{const o=t.join(i,n.main);o.startsWith(i)||r.push(_.localize(17,null,o,i))}if(typeof n.activationEvents=="undefined")return r.push(_.localize(18,null,"activationEvents","main")),!1}if(typeof n.browser!="undefined"){if(typeof n.browser!="string")return r.push(_.localize(19,null,"browser")),!1;{const o=t.join(i,n.browser);o.startsWith(i)||r.push(_.localize(20,null,o,i))}if(typeof n.activationEvents=="undefined")return r.push(_.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let n=0,r=i.length;n<r;n++)if(typeof i[n]!="string")return!1;return!0}}class w{constructor(i,n,r,o,u,E,P,I,O){this.ourVersion=i,this.ourProductDate=n,this.commit=r,this.locale=o,this.devMode=u,this.absoluteFolderPath=E,this.isBuiltin=P,this.isUnderDevelopment=I,this.translations=O}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,n){return i.ourVersion===n.ourVersion&&i.ourProductDate===n.ourProductDate&&i.commit===n.commit&&i.locale===n.locale&&i.devMode===n.devMode&&i.absoluteFolderPath===n.absoluteFolderPath&&i.isBuiltin===n.isBuiltin&&i.isUnderDevelopment===n.isUnderDevelopment&&i.mtime===n.mtime&&l.Translations.equals(i.translations,n.translations)}}e.ExtensionScannerInput=w;class f{constructor(i){this.root=i}resolveExtensions(){return T.Promises.readDirsInDir(this.root).then(i=>i.map(n=>({name:n,path:t.join(this.root,n)})))}}class s{static scanExtension(i,n,r,o,u,E,P){return o=t.normalize(o),new S(i,n,r,o,u,E).parse().then(O=>O===null?null:new c(i,n,r,o,u,E,P).replaceNLS(O)).then(O=>O===null?null:new C(i,n,r,o,u,E).validate(O))}static async scanExtensions(i,n,r=null){const o=i.absoluteFolderPath,u=i.isBuiltin,E=i.isUnderDevelopment;r||(r=new f(o));try{let P={};if(!u)try{const m=await T.Promises.readFile(t.join(o,".obsolete"),"utf8");P=JSON.parse(m)}catch{}let I=await r.resolveExtensions();I.sort((m,L)=>m.name<L.name?-1:1),u||(I=I.filter(m=>m.name.indexOf(".")!==0));const O=w.createNLSConfig(i);let z=await Promise.all(I.map(m=>this.scanExtension(i.ourVersion,i.ourProductDate,n,m.path,u,E,O))),j=D.coalesce(z);return j=j.filter(m=>m!==null&&!P[new A.ExtensionIdentifierWithVersion({id:(0,A.getGalleryExtensionId)(m.publisher,m.name)},m.version).key()]),u||(j=(0,A.groupByExtension)(j,L=>({id:L.identifier.value,uuid:L.uuid})).map(L=>L.sort((M,Q)=>p.rcompare(M.version,Q.version))[0])),j.sort((m,L)=>m.extensionLocation.fsPath<L.extensionLocation.fsPath?-1:1),j}catch(P){return n.error(o,P),[]}}static scanOneOrMultipleExtensions(i,n){const r=i.absoluteFolderPath,o=i.isBuiltin,u=i.isUnderDevelopment;return T.SymlinkSupport.existsFile(t.join(r,d)).then(E=>{if(E){const P=w.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,n,r,o,u,P).then(I=>I===null?[]:[I])}return this.scanExtensions(i,n)},E=>(n.error(r,E),[]))}static scanSingleExtension(i,n){const r=i.absoluteFolderPath,o=i.isBuiltin,u=i.isUnderDevelopment,E=w.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,n,r,o,u,E)}static mergeBuiltinExtensions(i,n){return Promise.all([i,n]).then(([r,o])=>{let u=Object.create(null);for(let P=0,I=r.length;P<I;P++)u[v.ExtensionIdentifier.toKey(r[P].identifier)]=r[P];for(let P=0,I=o.length;P<I;P++)u[v.ExtensionIdentifier.toKey(o[P].identifier)]=o[P];let E=Object.keys(u).map(P=>u[P]);return E.sort((P,I)=>{const O=t.basename(P.extensionLocation.fsPath),z=t.basename(I.extensionLocation.fsPath);return O<z?-1:O>z?1:0}),E})}}e.ExtensionScanner=s}),define(ve[250],we([0,1,3,44,5,49,171,8,249,41,62,105,88,83,212,4,24,19]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let c=null;function C(){return c||(c=(0,d.normalize)((0,d.join)(R.FileAccess.asFileUri("",J).fsPath,"..","extensions"))),c}let w=null;function f(){return w||(w=(0,d.normalize)((0,d.join)(R.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),w}class s{constructor(i,n,r,o,u){if(this._connectionToken=i,this.environmentService=n,this.logService=o,this.productService=u,this._logger=new class{error(P,I){o.error(P,I)}warn(P,I){o.warn(P,I)}info(P,I){o.info(P,I)}},n.args["install-builtin-extension"]){const P={isMachineScoped:!!n.args["do-not-sync"],installPreReleaseVersion:!!n.args["pre-release"]};this.whenExtensionsReady=r.installExtensions([],n.args["install-builtin-extension"],P,!!n.args.force).then(null,I=>{o.error(I)})}else this.whenExtensionsReady=Promise.resolve();const E=n.args["install-extension"];if(E){const P=E.map(I=>/\.vsix$/i.test(I)?p.URI.file((0,d.isAbsolute)(I)?I:(0,d.join)((0,g.cwd)(),I)):I);this.whenExtensionsReady.then(()=>r.installExtensions(P,[],{isMachineScoped:!!n.args["do-not-sync"],installPreReleaseVersion:!!n.args["pre-release"]},!!n.args.force)).then(null,I=>{o.error(I)})}}async call(i,n,r){switch(n){case"getEnvironmentData":{const o=r,u=(0,k.createRemoteURITransformer)(o.remoteAuthority);let E=await this._getEnvironmentData();return E=(0,T.transformOutgoingURIs)(E,u),E}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const o=r,u=o.language;this.logService.trace(`Scanning extensions using UI language: ${u}`);const E=(0,k.createRemoteURITransformer)(o.remoteAuthority),P=o.extensionDevelopmentPath&&o.extensionDevelopmentPath.map(z=>p.URI.revive(E.transformIncoming(z))),I=P?P.filter(z=>z.scheme===R.Schemas.file).map(z=>z.fsPath):void 0;let O=await this._scanExtensions(u,I);return O=(0,T.transformOutgoingURIs)(O,E),this.logService.trace("Scanned Extensions",O),s._massageWhenConditions(O),O}case"scanSingleExtension":{await this.whenExtensionsReady;const o=r,u=o.language,E=o.isBuiltin,P=(0,k.createRemoteURITransformer)(o.remoteAuthority),I=p.URI.revive(P.transformIncoming(o.extensionLocation)),O=I.scheme===R.Schemas.file?I.fsPath:null;if(!O)return null;const z=await this._getTranslations(u);let j=await this._scanSingleExtension(O,E,u,z);return j?(j=(0,T.transformOutgoingURIs)(j,P),s._massageWhenConditions([j]),j):null}case"getDiagnosticInfo":{const o=r,u={machineInfo:(0,l.getMachineInfo)()},E=o.includeProcesses?(0,v.listProcesses)(process.pid):Promise.resolve();let P=[];const I={};if(o.folders){const O=(0,k.createRemoteURITransformer)("");P=o.folders.map(j=>p.URI.revive(O.transformIncoming(j))).filter(j=>j.scheme==="file").map(j=>(0,l.collectWorkspaceStats)(j.fsPath,["node_modules",".git"]).then(m=>{I[(0,d.basename)(j.fsPath)]=m}))}return Promise.all([E,...P]).then(([O,z])=>(u.processes=O||void 0,u.workspaceMetadata=o.folders?I:void 0,u))}}throw new Error(`IPC Command ${n} not found`)}listen(i,n,r){throw new Error("Not supported")}static _massageWhenConditions(i){const n=(I,O)=>I.replace(/file/g,"vscode-remote"),r=I=>{let O="";return O+=I.global?"g":"",O+=I.ignoreCase?"i":"",O+=I.multiline?"m":"",new RegExp(n(I.source,!0),O)},o=new class{mapDefined(I){return h.ContextKeyDefinedExpr.create(I)}mapNot(I){return h.ContextKeyNotExpr.create(I)}mapEquals(I,O){return I==="resourceScheme"&&typeof O=="string"?h.ContextKeyEqualsExpr.create(I,n(O,!1)):h.ContextKeyEqualsExpr.create(I,O)}mapNotEquals(I,O){return I==="resourceScheme"&&typeof O=="string"?h.ContextKeyNotEqualsExpr.create(I,n(O,!1)):h.ContextKeyNotEqualsExpr.create(I,O)}mapGreater(I,O){return h.ContextKeyGreaterExpr.create(I,O)}mapGreaterEquals(I,O){return h.ContextKeyGreaterEqualsExpr.create(I,O)}mapSmaller(I,O){return h.ContextKeySmallerExpr.create(I,O)}mapSmallerEquals(I,O){return h.ContextKeySmallerEqualsExpr.create(I,O)}mapRegex(I,O){return I==="resourceScheme"&&O?h.ContextKeyRegexExpr.create(I,r(O)):h.ContextKeyRegexExpr.create(I,O)}mapIn(I,O){return h.ContextKeyInExpr.create(I,O)}},u=I=>{if(!I||!I.when||!/resourceScheme/.test(I.when))return;const O=h.ContextKeyExpr.deserialize(I.when);if(!O)return;const z=O.map(o);I.when=z.serialize()},E=I=>{if(Array.isArray(I))for(let O of I)u(O);else u(I)},P=I=>{for(let O in I)E(I[O])};i.forEach(I=>{I.contributes&&(I.contributes.menus&&P(I.contributes.menus),I.contributes.keybindings&&E(I.contributes.keybindings),I.contributes.views&&P(I.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:p.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:p.URI.file(this.environmentService.logsPath),extensionsPath:p.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:p.URI.file((0,d.join)(this.environmentService.logsPath,`exthost${s._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:_.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this.environmentService.args["use-host-proxy"]}}async _getTranslations(i){const n=await(0,A.getNLSConfiguration)(i,this.environmentService.userDataPath);if(A.InternalNLSConfiguration.is(n))try{const r=await S.Promises.readFile(n._translationsConfigFile,"utf8");return JSON.parse(r)}catch{return Object.create(null)}else return Object.create(null)}async _scanExtensions(i,n){const r=await this._getTranslations(i),[o,u,E]=await Promise.all([this._scanBuiltinExtensions(i,r),this._scanInstalledExtensions(i,r),this._scanDevelopedExtensions(i,r,n)]);let P=new Map;o.forEach(O=>{!O||P.set(b.ExtensionIdentifier.toKey(O.identifier),O)}),u.forEach(O=>{!O||(P.has(b.ExtensionIdentifier.toKey(O.identifier))&&console.warn(D.localize(0,null,P.get(b.ExtensionIdentifier.toKey(O.identifier)).extensionLocation.fsPath,O.extensionLocation.fsPath)),P.set(b.ExtensionIdentifier.toKey(O.identifier),O))}),E.forEach(O=>{!O||P.set(b.ExtensionIdentifier.toKey(O.identifier),O)});const I=[];return P.forEach(O=>I.push(O)),I}_scanDevelopedExtensions(i,n,r){if(r){const o=r.map(u=>y.ExtensionScanner.scanOneOrMultipleExtensions(new y.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,!0,u,!1,!0,n),this._logger));return Promise.all(o).then(u=>{let E=[];for(let P of u)E=E.concat(P);return E})}return Promise.resolve([])}_scanBuiltinExtensions(i,n){const r=this.productService.version,o=this.productService.commit,u=this.productService.date,E=!!process.env.VSCODE_DEV,P=new y.ExtensionScannerInput(r,u,o,i,E,C(),!0,!1,n),I=y.ExtensionScanner.scanExtensions(P,this._logger);let O=I;if(E){class z{constructor(Q){this.builtInExtensions=Q}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(Q=>({name:Q.name,path:(0,d.join)(f(),Q.name)})))}}const j=Promise.resolve(this.productService.builtInExtensions||[]),m=new y.ExtensionScannerInput(r,u,o,i,E,f(),!0,!1,{}),L=j.then(M=>new z(M)).then(M=>y.ExtensionScanner.scanExtensions(m,this._logger,M));O=y.ExtensionScanner.mergeBuiltinExtensions(I,L)}return O}_scanInstalledExtensions(i,n){const r=!!process.env.VSCODE_DEV,o=new y.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,r,this.environmentService.extensionsPath,!1,!1,n);return y.ExtensionScanner.scanExtensions(o,this._logger)}_scanSingleExtension(i,n,r,o){const u=!!process.env.VSCODE_DEV,E=new y.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,r,u,i,n,!1,o);return y.ExtensionScanner.scanSingleExtension(E,this._logger)}}e.RemoteAgentEnvironmentChannel=s,s._namePool=1}),define(ve[113],we([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ve[251],we([0,1,11,2,8,189]),function(J,e,_,t,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class D extends k.DiskFileSystemProviderClient{static register(y,b,T){const A=y.getConnection();if(!A)return t.Disposable.None;const h=new t.DisposableStore,v=(async()=>{try{const l=await y.getRawEnvironment();l?b.registerProvider(p.Schemas.vscodeRemote,h.add(new D(l,A))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(l){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,_.getErrorMessage)(l))}})();return h.add(b.onWillActivateFileSystemProvider(l=>{l.scheme===p.Schemas.vscodeRemote&&l.join(v)})),h}constructor(y,b){super(b.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:y.os===3})}}e.RemoteFileSystemProviderClient=D}),define(ve[72],we([0,1,27,13,4,12,19,150,265,266]),function(J,e,_,t,p,k,D,R,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(s,a){let i=a.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=s,this.cause=a}}e.ExtractError=T;function A(f){const s=f.externalFileAttributes>>16||33188;return[448,56,7].map(a=>s&a).reduce((a,i)=>a+i,s&61440)}function h(f){if(f instanceof T)return f;let s;return/end of central directory record signature not found/.test(f.message)&&(s="CorruptZip"),new T(s,f)}function v(f,s,a,i,n,r){const o=p.dirname(s),u=p.join(i,o);if(!u.startsWith(i))return Promise.reject(new Error(R.localize(0,null,s)));const E=p.join(i,s);let P;return r.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(D.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((I,O)=>{if(!r.isCancellationRequested)try{P=(0,_.createWriteStream)(E,{mode:a}),P.once("close",()=>I()),P.once("error",O),f.once("error",O),f.pipe(P)}catch(z){O(z)}}))}function l(f,s,a,i){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),f.close()}),new Promise((o,u)=>{const E=new t.Sequencer,P=I=>{I.isCancellationRequested||(r++,f.readEntry())};f.once("error",u),f.once("close",()=>n.then(()=>{i.isCancellationRequested||f.entryCount===r?o():u(new T("Incomplete",new Error(R.localize(1,null,r,f.entryCount))))},u)),f.readEntry(),f.on("entry",I=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){P(i);return}const O=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const m=p.join(s,O);n=(0,t.createCancelablePromise)(L=>D.Promises.mkdir(m,{recursive:!0}).then(()=>P(L)).then(void 0,u));return}const z=g(f,I),j=A(I);n=(0,t.createCancelablePromise)(m=>E.queue(()=>z.then(L=>v(L,O,j,s,a,m).then(()=>P(m)))).then(null,u))})})}function d(f,s=!1){return new Promise((a,i)=>{(0,y.open)(f,s?{lazyEntries:!0}:void 0,(n,r)=>{n?i(h(n)):a((0,k.assertIsDefined)(r))})})}function g(f,s){return new Promise((a,i)=>{f.openReadStream(s,(n,r)=>{n?i(h(n)):a((0,k.assertIsDefined)(r))})})}function S(f,s){return new Promise((a,i)=>{const n=new b.ZipFile;s.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,_.createWriteStream)(f);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>a(f))})}e.zip=S;function c(f,s,a={},i){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=d(f,!0);return a.overwrite&&(r=r.then(o=>D.Promises.rm(s).then(()=>o))),r.then(o=>l(o,s,{sourcePathRegex:n},i))}e.extract=c;function C(f,s){return d(f).then(a=>new Promise((i,n)=>{a.on("entry",r=>{r.fileName===s&&g(a,r).then(o=>i(o),o=>n(o))}),a.once("close",()=>n(new Error(R.localize(2,null,s))))}))}function w(f,s){return C(f,s).then(a=>new Promise((i,n)=>{const r=[];a.once("error",n),a.on("data",o=>r.push(o)),a.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=w}),define(ve[252],we([0,1,72,159]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function p(k){return(0,_.buffer)(k,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=p}),define(ve[253],we([0,1,17,13,11,2,8,4,3,22,57,5,23,19,72,160,26,34,33,182,41,16,14,32]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends k.Disposable{constructor(r,o,u,E,P){super();this.beforeRemovingExtension=r,this.fileService=o,this.logService=u,this.environmentService=E,this.productService=P,this._devSystemExtensionsPath=null,this.systemExtensionsPath=E.builtinExtensionsPath,this.extensionsPath=E.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const o=[];(r===null||r===0)&&o.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new S.ExtensionManagementError(this.joinErrors(u).message,S.ExtensionManagementErrorCode.Internal)))),(r===null||r===1)&&o.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new S.ExtensionManagementError(this.joinErrors(u).message,S.ExtensionManagementErrorCode.Internal))));try{const u=await Promise.all(o);return(0,_.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[o,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(E=>!o[new c.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()]),r&&(u=(0,c.groupByExtension)(u,P=>P.identifier).map(P=>P.sort((I,O)=>T.rcompare(I.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(r,o,u,E){const P=r.key(),I=R.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),O=R.join(this.extensionsPath,P);try{await v.Promises.rm(O)}catch{try{await v.Promises.rm(O)}catch{}throw new S.ExtensionManagementError((0,d.localize)(0,null,O,r.id),S.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,o,I,E);let z=await this.scanExtension(A.URI.file(I),1);if(!z)throw new Error((0,d.localize)(1,null,I));await this.storeMetadata(z,{...u,installedTimestamp:Date.now()});try{await this.rename(r,I,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(j){try{await v.Promises.rm(I)}catch{}if(j.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,p.getErrorMessage)(j)}. Deleted from extracted location`,I),j}try{z=await this.scanExtension(A.URI.file(O),1)}catch{}if(z)return z;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(r,o){return this.setMetadata(r,o),await this.storeMetadata(r,{...o,installedTimestamp:r.installedTimestamp}),r}async storeMetadata(r,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const u=R.join(r.location.fsPath,"package.json"),E=await v.Promises.readFile(u,"utf8"),{manifest:P}=await this.parseManifest(E);return P.__metadata=o,await v.Promises.writeFile(u,JSON.stringify(P,null,"	")),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const o=r.map(u=>new c.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version));await this.withUninstalledExtensions(u=>{o.forEach(E=>u[E.key()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(E=>delete E[r.key()]);const u=(await this.scanExtensions(1)).find(E=>new c.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).equals(r))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,1)):null}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(E){if(E.code!=="ENOENT")throw E}let u={};if(o)try{u=JSON.parse(o)}catch{}return r&&(r(u),Object.keys(u).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await v.Promises.rm(this.uninstalledPath)),u})}async removeExtension(r,o){this.logService.trace(`Deleting ${o} extension from disk`,r.identifier.id,r.location.fsPath),await v.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new c.ExtensionIdentifierWithVersion(r.identifier,r.manifest.version).key()])}async extractAtLocation(r,o,u,E){this.logService.trace(`Started extracting the extension from ${o} to ${u}`);try{await v.Promises.rm(u)}catch(P){throw new S.ExtensionManagementError(this.joinErrors(P).message,S.ExtensionManagementErrorCode.Delete)}try{await(0,l.extract)(o,u,{sourcePath:"extension",overwrite:!0},E),this.logService.info(`Extracted extension to ${u}:`,r.id)}catch(P){try{await v.Promises.rm(u)}catch{}let I=S.ExtensionManagementErrorCode.Extract;throw P instanceof l.ExtractError&&(P.type==="CorruptZip"?I=S.ExtensionManagementErrorCode.CorruptZip:P.type==="Incomplete"&&(I=S.ExtensionManagementErrorCode.IncompleteZip)),new S.ExtensionManagementError(P.message,I)}}async rename(r,o,u,E){try{await v.Promises.rename(o,u)}catch(P){if(y.isWindows&&P&&P.code==="EPERM"&&Date.now()<E)return this.logService.info(`Failed renaming ${o} to ${u} with 'EPERM' error. Trying again...`,r.id),this.rename(r,o,u,E);throw new S.ExtensionManagementError(P.message||(0,d.localize)(3,null,o,u),P.code||S.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return r;const o=this.scanDevSystemExtensions(),[u,E]=await Promise.all([r,o]);return[...u,...E]}async scanExtensionsInDir(r,o){const u=new t.Limiter(10),E=await this.fileService.resolve(A.URI.file(r));return E.children?(await Promise.all(E.children.filter(I=>I.isDirectory).map(I=>u.queue(async()=>o===1&&(0,b.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,o))))).filter(I=>I&&I.identifier):[]}async scanExtension(r,o){try{const u=await this.fileService.resolve(r);if(u.children){const{manifest:E,metadata:P}=await this.readManifest(r.fsPath),I=u.children.find(({name:m})=>/^readme(\.txt|\.md|)$/i.test(m))?.resource,O=u.children.find(({name:m})=>/^changelog(\.txt|\.md|)$/i.test(m))?.resource,z={id:(0,c.getGalleryExtensionId)(E.publisher,E.name)},j={type:o,identifier:z,manifest:E,location:r,readmeUrl:I,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(j,P),j}}catch(u){o!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){const r=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){const r=this.getDevSystemExtensionsList();if(r.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(u=>r.some(E=>(0,c.areSameExtensions)(u.identifier,{id:E})))}else return[]}setMetadata(r,o){r.publisherDisplayName=o?.publisherDisplayName||null,r.publisherId=o?.publisherId||null,r.identifier.uuid=o?.id,r.isMachineScoped=!!o?.isMachineScoped,r.isPreReleaseVersion=!!o?.isPreReleaseVersion,r.preRelease=!!o?.preRelease,r.isBuiltin=r.type===0||!!o?.isBuiltin,r.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),u=new Set;for(const I of o)r[new c.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||u.add(I.identifier.id.toLowerCase());const E=(0,c.groupByExtension)(o,I=>I.identifier);await t.Promises.settled(E.map(async I=>{const O=I.sort((z,j)=>T.rcompare(z.manifest.version,j.manifest.version))[0];u.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const P=o.filter(I=>r[new c.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await t.Promises.settled(P.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const r=await this.scanAllUserExtensions(),o=[],u=(0,c.groupByExtension)(r,E=>E.identifier);o.push(...(0,_.flatten)(u.map(E=>E.sort((P,I)=>T.rcompare(P.manifest.version,I.manifest.version)).slice(1)))),await t.Promises.settled(o.map(E=>this.removeExtension(E,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const o=Array.isArray(r)?r:[r];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((u,E)=>new Error(`${u.message}${u.message?",":""}${E instanceof Error?E.message:E}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(D.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(r){const o=[v.Promises.readFile(R.join(r,"package.json"),"utf8").then(I=>this.parseManifest(I)),v.Promises.readFile(R.join(r,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:u,metadata:E},P]=await Promise.all(o);return{manifest:(0,C.localizeManifest)(u,P),metadata:E}}parseManifest(r){return new Promise((o,u)=>{try{const E=JSON.parse(r);E.publisher||(E.publisher=w.UNDEFINED_PUBLISHER);const P=E.__metadata||null;o({manifest:E,metadata:P})}catch{u(new Error((0,d.localize)(4,null)))}})}};i=Te([Ne(1,f.IFileService),Ne(2,s.ILogService),Ne(3,g.INativeEnvironmentService),Ne(4,a.IProductService)],i),e.ExtensionsScanner=i}),define(ve[114],we([0,1,36,11,8,4,3,24,22,57,5,23,19,72,158,66,26,213,34,33,204,195,252,205,253,225,65,16,6,14,32,29,48]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f,s,a,i,n,r,o,u,E,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let z=class extends S.AbstractExtensionManagementService{constructor(W,q,ne,B,G,ee,oe,se,me){super(W,q,ne,se);this.environmentService=B,this.downloadService=G,this.fileService=oe;const Z=this._register(ee.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(ee.createInstance(i.ExtensionsScanner,H=>Z.postUninstall(H))),this.manifestCache=this._register(new a.ExtensionsManifestCache(B,this)),this.extensionsDownloader=this._register(ee.createInstance(w.ExtensionsDownloader));const $=this._register(new n.ExtensionsWatcher(this,oe,B,ne,me));this._register($.onDidChangeExtensionsByAnotherSource(({added:H,removed:V})=>{H.length&&this._onDidInstallExtensions.fire(H.map(ie=>({identifier:ie.identifier,operation:1,local:ie}))),V.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),q=(0,c.getTargetPlatform)(W?"alpine":D.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let W;try{W=(await this.fileService.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{W=(await this.fileService.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(ne))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const q=await this.collectFiles(W),ne=await(0,v.zip)((0,y.joinPath)(this.environmentService.tmpDir,(0,A.generateUuid)()).fsPath,q);return T.URI.file(ne)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const q=await this.downloadVsix(W),ne=k.resolve(q.fsPath);return(0,s.getManifest)(ne)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,q={}){this.logService.trace("ExtensionManagementService#install",W.toString());const ne=await this.downloadVsix(W),B=await(0,s.getManifest)(k.resolve(ne.fsPath));if(B.engines&&B.engines.vscode&&!(0,r.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(l.localize(0,null,(0,C.getGalleryExtensionId)(B.publisher,B.name),this.productService.version));return this.installExtension(B,ne,q)}async updateMetadata(W,q){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const ne={...W.manifest.__metadata||{},...q};return q.isPreReleaseVersion&&(ne.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,ne),this.manifestCache.invalidate(),W}async updateExtensionScope(W,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===p.Schemas.file)return W;const q=(0,y.joinPath)(this.environmentService.tmpDir,(0,A.generateUuid)());return await this.downloadService.download(W,q),q}createInstallExtensionTask(W,q,ne){return T.URI.isUri(q)?new L(W,q,ne,this.galleryService,this.extensionsScanner,this.logService):new m(q,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,q){return new M(W,q,this.extensionsScanner)}async collectFiles(W){const q=async B=>{let G=await h.Promises.readdir(B);G=G.map(se=>k.join(B,se));const ee=await Promise.all(G.map(se=>h.Promises.stat(se)));let oe=Promise.resolve([]);return ee.forEach((se,me)=>{const Z=G[me];se.isFile()&&(oe=oe.then($=>[...$,Z])),se.isDirectory()&&(oe=oe.then($=>q(Z).then(H=>[...$,...H])))}),oe};return(await q(W.location.fsPath)).map(B=>({path:`extension/${k.relative(W.location.fsPath,B)}`,localPath:B}))}};z=Te([Ne(0,c.IExtensionGalleryService),Ne(1,I.ITelemetryService),Ne(2,E.ILogService),Ne(3,g.INativeEnvironmentService),Ne(4,d.IDownloadService),Ne(5,u.IInstantiationService),Ne(6,o.IFileService),Ne(7,P.IProductService),Ne(8,O.IUriIdentityService)],z),e.ExtensionManagementService=z;class j extends S.AbstractExtensionTask{constructor(W,q,ne,B){super();this.identifier=W,this.source=q,this.extensionsScanner=ne,this.logService=B,this._operation=2}get operation(){return this._operation}async installExtension(W,q){try{const ne=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(ne)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...W.metadata}):ne}catch{throw D.isMacintosh?new c.ExtensionManagementError(l.localize(1,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(l.localize(2,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(W,q)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const ne=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),ne}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:q,metadata:ne},B){let G=await this.extensionsScanner.extractUserExtension(q,W,ne,B);return this.logService.info("Extracting completed.",q.id),G}}class m extends j{constructor(W,q,ne,B,G){super(W.identifier,W,B,G);this.gallery=W,this.options=q,this.extensionsDownloader=ne}async doRun(W){const ne=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,C.areSameExtensions)(G.identifier,this.gallery.identifier));ne&&(this._operation=3);const B=await this.downloadInstallableExtension(this.gallery,this._operation);B.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,B.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,B.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,B.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ne?.preRelease||this.options.installPreReleaseVersion;try{const G=await this.installExtension(B,W);return ne&&b.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),G}catch(G){throw await this.deleteDownloadedVSIX(B.zipPath),G}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(T.URI.file(W))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,t.getErrorMessage)(q))}}async downloadInstallableExtension(W,q){const ne={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let B;try{this.logService.trace("Started downloading extension:",W.identifier.id),B=(await this.extensionsDownloader.downloadExtension(W,q)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,B)}catch(G){throw new c.ExtensionManagementError((0,S.joinErrors)(G).message,c.ExtensionManagementErrorCode.Download)}try{const G=await(0,s.getManifest)(B);return{zipPath:B,identifierWithVersion:new C.ExtensionIdentifierWithVersion(W.identifier,G.version),metadata:ne}}catch(G){throw await this.deleteDownloadedVSIX(B),new c.ExtensionManagementError((0,S.joinErrors)(G).message,c.ExtensionManagementErrorCode.Invalid)}}}class L extends j{constructor(W,q,ne,B,G,ee){super({id:(0,C.getGalleryExtensionId)(W.publisher,W.name)},q,G,ee);this.manifest=W,this.location=q,this.options=ne,this.galleryService=B}async doRun(W){const q=new C.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),B=(await this.extensionsScanner.scanExtensions(1)).find(ee=>(0,C.areSameExtensions)(this.identifier,ee.identifier)),G=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(G.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||B?.isBuiltin,B)if(this._operation=3,q.equals(new C.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version)))try{await this.extensionsScanner.removeExtension(B,"existing")}catch{throw new Error(l.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(B.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(B);else{const ee=await this.unsetUninstalledAndGetLocal(q);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(l.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:k.resolve(this.location.fsPath),identifierWithVersion:q,metadata:G},W)}async getMetadata(W,q,ne){try{let[B]=await this.galleryService.getExtensions([{id:W,version:q}],ne);if(B||([B]=await this.galleryService.getExtensions([{id:W}],ne)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class M extends S.AbstractExtensionTask{constructor(W,q,ne){super();this.extension=W,this.options=q,this.extensionsScanner=ne}async doRun(W){const q=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const B=new C.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...ne.filter(G=>B.equals(new C.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version))))}else q.push(...ne.filter(B=>(0,C.areSameExtensions)(B.identifier,this.extension.identifier)));if(!q.length)throw new Error(l.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const B of q)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(B)}catch(G){throw new Error(l.localize(6,null,(0,_.toErrorMessage)(G)))}}}}),define(ve[58],we([0,1,70,81,25,15,11,7,2,4,3,23,40,84,254]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(I,O=""){this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=z=>{if(this.traceSocketEvent("error",{code:z?.code,message:z?.message}),z){if(z.code==="EPIPE")return;(0,D.onUnexpectedError)(z)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,O){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const O=z=>{this.traceSocketEvent("read",z),I(k.VSBuffer.wrap(z))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=z=>{this.traceSocketEvent("close",{hadError:z}),I({type:0,hadError:z,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,D.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,D.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const z=()=>{this.socket.off("close",z),this.socket.off("end",z),this.socket.off("error",z),this.socket.off("timeout",z),this.socket.off("drain",z),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",z),this.socket.on("end",z),this.socket.on("error",z),this.socket.on("timeout",z),this.socket.on("drain",z)})}}e.NodeSocket=d;var g;(function(P){P[P.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var S;(function(P){P[P.PeekHeader=1]="PeekHeader",P[P.ReadHeader=2]="ReadHeader",P[P.ReadBody=3]="ReadBody",P[P.Fin=4]="Fin"})(S||(S={}));class c extends y.Disposable{constructor(I,O,z,j){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:z?.byteLength||0,recordInflateBytes:j}),this._flowManager=this._register(new C(this,O,z,j,this._onData,(m,L)=>this._write(m,L))),this._register(this._flowManager.onError(m=>{console.error(m),(0,D.onUnexpectedError)(m),this._onClose.fire({type:0,hadError:!0,error:m})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(m=>this._acceptChunk(m))),this._register(this.socket.onClose(m=>this._onClose.fire(m)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let z=2;I.byteLength<126?z+=0:I.byteLength<2**16?z+=2:z+=8;const j=k.VSBuffer.alloc(z);if(O?j.writeUInt8(194,0):j.writeUInt8(130,0),I.byteLength<126)j.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){j.writeUInt8(126,1);let m=1;j.writeUInt8(I.byteLength>>>8&255,++m),j.writeUInt8(I.byteLength>>>0&255,++m)}else{j.writeUInt8(127,1);let m=1;j.writeUInt8(0,++m),j.writeUInt8(0,++m),j.writeUInt8(0,++m),j.writeUInt8(0,++m),j.writeUInt8(I.byteLength>>>24&255,++m),j.writeUInt8(I.byteLength>>>16&255,++m),j.writeUInt8(I.byteLength>>>8&255,++m),j.writeUInt8(I.byteLength>>>0&255,++m)}this.socket.write(k.VSBuffer.concat([j,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),z=O.readUInt8(0),j=(z&128)>>>7,m=(z&64)>>>6,L=O.readUInt8(1),M=(L&128)>>>7,Q=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(Q===126?2:0)+(Q===127?8:0),this._state.fin=j,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(m)),this._state.firstFrameOfMessage=Boolean(j),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),z=O.readUInt8(1),j=(z&128)>>>7;let m=z&127,L=1;m===126?m=O.readUInt8(++L)*2**8+O.readUInt8(++L):m===127&&(m=O.readUInt8(++L)*0+O.readUInt8(++L)*0+O.readUInt8(++L)*0+O.readUInt8(++L)*0+O.readUInt8(++L)*2**24+O.readUInt8(++L)*2**16+O.readUInt8(++L)*2**8+O.readUInt8(++L));let M=0;j&&(M=O.readUInt8(++L)*2**24+O.readUInt8(++L)*2**16+O.readUInt8(++L)*2**8+O.readUInt8(++L)),this._state.state=3,this._state.readLen=m,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),s(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class C extends y.Disposable{constructor(I,O,z,j,m,L){super();this._tracer=I,this._onData=m,this._writeFn=L,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new w(this._tracer,j,z,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(O,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,O){return new Promise((z,j)=>{I.write(O),I.flush(m=>z(m))})}acceptFrame(I,O,z){this._readQueue.push({data:I,isCompressed:O,isLastFrameOfMessage:z}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,O,z){return new Promise((j,m)=>{I.write(O),z&&I.write(k.VSBuffer.fromByteArray([0,0,255,255])),I.flush(L=>j(L))})}}class w extends y.Disposable{constructor(I,O,z,j){super();this._tracer=I,this._recordInflateBytes=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=l.createInflateRaw(j),this._zlibInflate.on("error",m=>{this._tracer.traceSocketEvent("zlibInflateError",{message:m?.message,code:m?.code}),this._onError.fire(m)}),this._zlibInflate.on("data",m=>{this._tracer.traceSocketEvent("zlibInflateData",m),this._pendingInflateData.push(k.VSBuffer.wrap(m))}),z&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",z.buffer),this._zlibInflate.write(z.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(O)})}}class f extends y.Disposable{constructor(I,O){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=l.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",z=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibDeflate.on("data",z=>{this._tracer.traceSocketEvent("zlibDeflateData",z),this._pendingDeflateData.push(k.VSBuffer.wrap(z))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function s(P,I){if(I===0)return;let O=P.byteLength>>>2;for(let Q=0;Q<O;Q++){const W=P.readUInt32BE(Q*4);P.writeUInt32BE(W^I,Q*4)}let z=O*4,j=P.byteLength-z;const m=I>>>24&255,L=I>>>16&255,M=I>>>8&255;j>=1&&P.writeUInt8(P.readUInt8(z)^m,z),j>=2&&P.writeUInt8(P.readUInt8(z+1)^L,z+1),j>=3&&P.writeUInt8(P.readUInt8(z+2)^M,z+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const P=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${P}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${P}.sock`):I=(0,b.join)((0,p.tmpdir)(),`vscode-ipc-${P}.sock`),r(I),I}e.createRandomIPCHandle=i;function n(P,I,O){const z=(0,_.createHash)("md5").update(P).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${z}-${O}-${I}-sock`;let j;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${z.substr(0,8)}-${O}-${I}.sock`):j=(0,b.join)(P,`${O}-${I}.sock`),r(j),j}e.createStaticIPCHandle=n;function r(P){const I=a[T.platform];typeof I=="number"&&P.length>=I&&console.warn(`WARNING: IPC handle "${P}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends h.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const O=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(O,z=>({protocol:new v.Protocol(new d(z,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(z,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(P){return new Promise((I,O)=>{const z=(0,t.createServer)();z.on("error",O),z.listen(P,()=>{z.removeListener("error",O),I(new o(z))})})}e.serve=u;function E(P,I){return new Promise((O,z)=>{const j=(0,t.createConnection)(P,()=>{j.removeListener("error",z),O(v.Client.fromSocket(new d(j,`ipc-client${I}`),I))});j.once("error",z)})}e.connect=E}),define(ve[115],we([0,1,71,13,15,11,2,12,28,26,67,14,208,254]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let l=class extends D.Disposable{constructor(g,S,c){super();this.environmentService=S,this.logService=c,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,S){this.logService.trace("RequestService#request",g.url);const{proxyUrl:c,strictSSL:C}=this;let w;try{w=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",a))}const f={...process.env,...w},s=g.agent?g.agent:await(0,h.getProxyAgent)(g.url||"",f,{proxyUrl:c,strictSSL:C});return g.agent=s,g.strictSSL=C,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,S)}async getNodeRequest(g){return((0,_.parse)(g.url).protocol==="https:"?await new Promise((C,w)=>{J(["https"],C,w)}):await new Promise((C,w)=>{J(["http"],C,w)})).request}_request(g,S){return t.Promises.withAsyncBody(async(c,C)=>{let w;const f=(0,_.parse)(g.url),s=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),a={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(a.auth=g.user+":"+g.password),w=s(a,i=>{const n=(0,R.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...g,url:i.headers.location,followRedirects:n-1},S).then(c,C);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,v.createGunzip)())),c({res:i,stream:(0,p.streamToBufferReadableStream)(r)})}}),w.on("error",C),g.timeout&&w.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&w.write(g.data),w.end(),S.onCancellationRequested(()=>{w.abort(),C((0,k.canceled)())})})}async resolveProxy(g){}};l=Te([Ne(0,y.IConfigurationService),Ne(1,b.INativeEnvironmentService),Ne(2,A.ILogService)],l),e.RequestService=l}),define(ve[116],we([0,1,39,105,49,8,4,15,7,58,67,3,248,64]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function l(C={},w,f,s,a){const i=await(0,t.getNLSConfiguration)(w,s.userDataPath);let n;try{n=await(0,T.getResolvedShellEnv)(a,s.args,process.env)}catch(I){a.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",I),n={}}const r=s.isBuilt?(0,D.join)(s.appRoot,"bin"):(0,D.join)(s.appRoot,"resources","server","bin-dev"),o=(0,D.join)(r,"remote-cli"),u=process.env;let E=C.PATH||(n?n.PATH:void 0)||u.PATH;E?E=o+D.delimiter+E:E=o;const P={...u,...n,VSCODE_LOG_NATIVE:String(f),VSCODE_AMD_ENTRYPOINT:"vs/workbench/services/extensions/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(i,void 0,0),...C};return s.args["without-browser-env-var"]||(P.BROWSER=(0,D.join)(r,"helpers",A.isWindows?"browser.cmd":"browser.sh")),S(P,"PATH",E),c(P),P}e.buildUserEnvironment=l;class d{constructor(w,f,s,a,i,n){this.socket=w,this.socketDrain=f,this.initialDataChunk=s,this.skipWebSocketFrames=a,this.permessageDeflate=i,this.inflateBytes=n}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class g{constructor(w,f,s,a,i,n){this._environmentService=w,this._logService=f,this._reconnectionToken=s,this._onClose=new y.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=g._toConnectionData(i,n),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(w){this._logService.info(`${this._logPrefix}${w}`)}_logError(w){this._logService.error(`${this._logPrefix}${w}`)}static _toConnectionData(w,f){return w instanceof b.NodeSocket?new d(w.socket,w.drain(),f,!0,!1,R.VSBuffer.alloc(0)):new d(w.socket.socket,w.drain(),f,!1,w.permessageDeflate,w.recordedInflateBytes)}async _sendSocketToExtensionHost(w,f){await f.socketDrain;const s=f.toIExtHostSocketMessage();w.send(s,f.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const w={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(w)}acceptReconnection(w,f,s){this._remoteAddress=w,this._log("The client has reconnected.");const a=g._toConnectionData(f,s);if(!this._extensionHostProcess){this._connectionData=a;return}this._sendSocketToExtensionHost(this._extensionHostProcess,a)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(w){try{let f=[];w.port&&!process.pkg&&(f=[`--inspect${w.break?"-brk":""}=${w.port}`]);const s=await l(w.env,w.language,!!w.debugId,this._environmentService,this._logService);(0,v.removeDangerousEnvVariables)(s);const a={env:s,execArgv:f,silent:!0},i=["--type=extensionHost",`--uriTransformerPath=${p.uriTransformerPath}`],n=this._environmentService.args["use-host-proxy"];i.push(`--useHostProxy=${n?"true":"false"}`),this._extensionHostProcess=_.fork(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,i,a);const r=this._extensionHostProcess.pid;this._log(`<${r}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const o=y.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),u=y.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");o(P=>this._log(`<${r}> ${P}`)),u(P=>this._log(`<${r}><stderr> ${P}`)),this._extensionHostProcess.on("message",P=>{P&&P.type==="__$console"&&(0,h.logRemoteEntry)(this._logService,P,`${this._logPrefix}<${r}>`)}),this._extensionHostProcess.on("error",P=>{this._logError(`<${r}> Extension Host Process had an error`),this._logService.error(P),this._cleanResources()}),this._extensionHostProcess.on("exit",(P,I)=>{this._log(`<${r}> Extension Host Process exited with code: ${P}, signal: ${I}.`),this._cleanResources()});const E=P=>{P.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",E),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",E)}catch(f){console.error("ExtensionHostConnection errored"),f&&console.error(f)}}}e.ExtensionHostConnection=g;function S(C,w,f){const s=Object.keys(C).filter(i=>i.toLowerCase()===w.toLowerCase()),a=s.length>0?s[0]:w;C[a]=f}function c(C){for(let w of Object.keys(C))C[w]===null&&delete C[w]}}),define(ve[255],we([0,1,68,14,54,95,28,47,115,42,29,34,100,114,91,45,2,92,56,8,16,32,94,113,50,98,69,99,11,5,4,24,206,66,48,103,53,3]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f,s,a,i,n,r,o,u,E,P,I,O,z,j,m,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class Q extends g.Disposable{constructor(B,G){super();this.args=B,this.remoteDataFolder=G,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async G=>{const ee=G.get(t.ILogService),oe=G.get(A.IExtensionManagementCLIService);try{await this.doRun(oe)}catch(se){throw ee.error(se),console.error((0,u.getErrorMessage)(se)),se}})}async initServices(){const B=new _.ServiceCollection,G={_serviceBrand:void 0,...d.default};B.set(f.IProductService,G);const ee=new i.ServerEnvironmentService(this.args,G);B.set(i.IServerEnvironmentService,ee);const oe=new t.LogService(new s.SpdLogLogger(a.RemoteExtensionLogFileName,(0,P.join)(ee.logsPath,`${a.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(ee)));B.set(t.ILogService,oe),oe.trace(`Remote configuration data at ${this.remoteDataFolder}`),oe.trace("process arguments:",this.args);const se=this._register(new S.FileService(oe));B.set(w.IFileService,se),se.registerProvider(C.Schemas.file,this._register(new c.DiskFileSystemProvider(oe)));const me=this._register(new k.ConfigurationService(ee.settingsResource,se));return await me.initialize(),B.set(D.IConfigurationService,me),B.set(j.IUriIdentityService,new m.UriIdentityService(se)),B.set(R.IRequestService,new p.SyncDescriptor(y.RequestService)),B.set(z.IDownloadService,new p.SyncDescriptor(O.DownloadService)),B.set(T.ITelemetryService,b.NullTelemetryService),B.set(A.IExtensionGalleryService,new p.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService)),B.set(A.IExtensionManagementService,new p.SyncDescriptor(v.ExtensionManagementService)),B.set(A.IExtensionManagementCLIService,new p.SyncDescriptor(n.ExtensionManagementCLIService)),B.set(r.ILocalizationsService,new p.SyncDescriptor(o.LocalizationsService)),new l.InstantiationService(B)}async doRun(B){if(this.args["list-extensions"])return B.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const G={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return B.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],G,!!this.args.force)}else{if(this.args["uninstall-extension"])return B.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return B.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(B){return B.map(G=>/\.vsix$/i.test(G)?E.URI.file((0,P.isAbsolute)(G)?G:(0,P.join)((0,I.cwd)(),G)):G)}}function W(ne){setTimeout(()=>process.exit(ne),0)}async function q(ne,B,G){if(ne.help){const oe=d.default.serverApplicationName+(M.isWindows?".cmd":"");console.log((0,L.buildHelpMessage)(d.default.nameLong,oe,d.default.version,G,{noInputFiles:!0,noPipe:!0}));return}if(ne.version){console.log((0,L.buildVersionMessage)(d.default.version,d.default.commit));return}const ee=new Q(ne,B);try{await ee.run(),W(0)}catch{W(1)}finally{ee.dispose()}}e.run=q}),define(ve[256],we([0,1,58,267,27,247,5,226,14]),function(J,e,_,t,p,k,D,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class b{constructor(h,v,l){this._commands=h,this.logService=v,this._ipcHandlePath=l,this._server=t.createServer((d,g)=>this.onRequest(d,g)),this.setup().catch(d=>(v.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",h=>this.logService.error(h))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(h,v){const l=[];h.setEncoding("utf8"),h.on("data",d=>l.push(d)),h.on("end",()=>{const d=JSON.parse(l.join(""));switch(d.type){case"open":this.open(d,v);break;case"openExternal":this.openExternal(d,v);break;case"status":this.getStatus(d,v);break;case"extensionManagement":this.manageExtensions(d,v).catch(this.logService.error);break;default:v.writeHead(404),v.write(`Unknown message type: ${d.type}`,g=>{g&&this.logService.error(g)}),v.end();break}})}open(h,v){const{fileURIs:l,folderURIs:d,forceNewWindow:g,diffMode:S,addMode:c,forceReuseWindow:C,gotoLineMode:w,waitMarkerFilePath:f,remoteAuthority:s}=h,a=[];if(Array.isArray(d))for(const o of d)try{a.push({folderUri:D.URI.parse(o)})}catch{}if(Array.isArray(l))for(const o of l)try{(0,R.hasWorkspaceFileExtension)(o)?a.push({workspaceUri:D.URI.parse(o)}):a.push({fileUri:D.URI.parse(o)})}catch{}const i=f?D.URI.file(f):void 0,r={forceNewWindow:g,diffMode:S,addMode:c,gotoLineMode:w,forceReuseWindow:C,preferNewWindow:!C&&!i&&!c,waitMarkerFileURI:i,remoteAuthority:s};this._commands.executeCommand("_remoteCLI.windowOpen",a,r),v.writeHead(200),v.end()}async openExternal(h,v){for(const l of h.uris){const d=D.URI.parse(l),g=d.scheme==="file"?d:l;await this._commands.executeCommand("_remoteCLI.openExternal",g)}v.writeHead(200),v.end()}async manageExtensions(h,v){try{const l=S=>S?.map(c=>/\.vsix$/i.test(c)?D.URI.parse(c):c),d={list:h.list,install:l(h.install),uninstall:l(h.uninstall),force:h.force},g=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);v.writeHead(200),v.write(g)}catch(l){v.writeHead(500),v.write(String(l),d=>{d&&this.logService.error(d)})}v.end()}async getStatus(h,v){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");v.writeHead(200),v.write(l),v.end()}catch(l){v.writeHead(500),v.write(String(l),d=>{d&&this.logService.error(d)}),v.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&p.existsSync(this._ipcHandlePath)&&p.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=b;let T=class extends b{constructor(h,v){super(h,v,(0,_.createRandomIPCHandle)())}};T=Te([Ne(0,k.IExtHostCommands),Ne(1,y.ILogService)],T),e.CLIServer=T}),define(ve[257],we([0,1,25,7,20,2,4,3,5,58,49,256,236,110,237,241,116]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class S extends d.AbstractVariableResolverService{constructor(w,f,s,a){super({getFolderUri:i=>{const n=f.filter(r=>r.name===i);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(i,n)=>a[`config:${n}`],getExecPath:()=>w.VSCODE_EXEC_PATH,getAppRoot:()=>w.VSCODE_CWD,getFilePath:()=>{if(s)return D.normalize(s.fsPath)},getSelectedText:()=>a.selectedText,getLineNumber:()=>a.lineNumber},void 0,Promise.resolve(w))}}class c extends k.Disposable{constructor(w,f,s,a){super();this._environmentService=w,this._logService=f,this._ptyService=s,this._productService=a,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(w,f,s){switch(f){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,s);case"$createProcess":{const a=(0,T.createRemoteURITransformer)(w.remoteAuthority);return this._createProcess(a,s)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,s);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,s);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,s);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,s);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,s);case"$start":return this._ptyService.start.apply(this._ptyService,s);case"$input":return this._ptyService.input.apply(this._ptyService,s);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,s);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,s);case"$resize":return this._ptyService.resize.apply(this._ptyService,s);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,s);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,s);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,s);case"$sendCommandResult":return this._sendCommandResult(s[0],s[1],s[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,s);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,s);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,s);case"$getProfiles":return this._getProfiles.apply(this,s);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(s[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(s);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(s);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,s);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,s);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,s);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,s);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,s);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,s);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,s);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(s[0],s[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(s[0],s[1])}throw new Error(`IPC Command ${f} not found`)}listen(w,f,s){switch(f){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(w,f){const s={name:f.shellLaunchConfig.name,executable:f.shellLaunchConfig.executable,args:f.shellLaunchConfig.args,cwd:typeof f.shellLaunchConfig.cwd=="string"||typeof f.shellLaunchConfig.cwd=="undefined"?f.shellLaunchConfig.cwd:y.URI.revive(w.transformIncoming(f.shellLaunchConfig.cwd)),env:f.shellLaunchConfig.env,useShellEnvironment:f.shellLaunchConfig.useShellEnvironment};let a;f.shellLaunchConfig.useShellEnvironment?(this._logService.trace("*"),a=await(0,g.buildUserEnvironment)(f.resolverEnv,R.language,!1,this._environmentService,this._logService)):a=this._getEnvironment(),this._logService.trace("baseEnv",a);const i=Q=>({uri:y.URI.revive(w.transformIncoming(Q.uri)),name:Q.name,index:Q.index,toResource:()=>{throw new Error("Not implemented")}}),n=f.workspaceFolders.map(i),r=f.activeWorkspaceFolder?i(f.activeWorkspaceFolder):void 0,o=f.activeFileResource?y.URI.revive(w.transformIncoming(f.activeFileResource)):void 0,u=new S(a,n,o,f.resolvedVariables),E=l.createVariableResolver(r,process.env,u),P=l.getCwd(s,_.homedir(),E,r?.uri,f.configuration["terminal.integrated.cwd"],this._logService);s.cwd=P;const I=R.isWindows?"terminal.integrated.env.windows":R.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=f.configuration[I],z=l.createTerminalEnvironment(s,O,E,this._productService.version,f.configuration["terminal.integrated.detectLocale"],a);if(!s.strictEnv){const Q=[];for(const[ne,B]of f.envVariableCollections)Q.push([ne,{map:(0,v.deserializeEnvironmentVariableCollection)(B)}]);const W=new Map(Q);new h.MergedEnvironmentVariableCollection(W).applyToProcessEnvironment(z)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:s,initialCwd:P,cols:f.cols,rows:f.rows,env:z});const j=(0,b.createRandomIPCHandle)();z.VSCODE_IPC_HOOK_CLI=j;const m={executeCommand:(Q,...W)=>this._executeCommand(Q,W,w)},L=new A.CLIServerBase(m,this._logService,j),M=await this._ptyService.createProcess(s,P,f.cols,f.rows,f.unicodeVersion,z,a,!1,f.shouldPersistTerminal,f.workspaceId,f.workspaceName);return this._ptyService.onProcessExit(Q=>Q.id===M&&L.dispose()),{persistentTerminalId:M,resolvedShellLaunchConfig:s}}_executeCommand(w,f,s){let a,i;const n=new Promise((u,E)=>{a=u,i=E}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:a,reject:i,uriTransformer:s});const o=(0,p.cloneAndChange)(f,u=>{if(u&&u.$mid===1)return s.transformOutgoing(u);if(u&&u instanceof y.URI)return s.transformOutgoingURI(u)});return this._onExecuteCommand.fire({reqId:r,commandId:w,commandArgs:o}),n}_sendCommandResult(w,f,s){const a=this._pendingCommands.get(w);if(!a)return;this._pendingCommands.delete(w);const i=(0,p.cloneAndChange)(s,n=>{if(n&&n.$mid===1)return a.uriTransformer.transformIncoming(n)});f?a.reject(i):a.resolve(i)}_getDefaultSystemShell(w){return this._ptyService.getDefaultSystemShell(w)}async _getProfiles(w,f,s,a){return this._ptyService.getProfiles?.(w,f,s,a)||[]}_getEnvironment(){return{...process.env}}_getWslPath(w){return this._ptyService.getWslPath(w)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=c}),define(ve[258],we([0,1,25,7,2,8,4,80,19,40,28,95,89,200,176,66,177,187,179,26,100,34,98,203,114,16,92,56,54,91,68,69,99,14,93,94,45,32,47,207,115,210,29,42,216,217,101,224,48,103,250,230,228,229,257,49,50,244,113,251]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f,s,a,i,n,r,o,u,E,P,I,O,z,j,m,L,M,Q,W,q,ne,B,G,ee,oe,se,me,Z,$,H,V,ie,de,De,ae,fe,pe,X,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const K="monacoworkbench",Y=Object.create(null);function ue(ge){return Y[ge]||(Y[ge]=(0,ae.createRemoteURITransformer)(ge)),Y[ge]}async function ye(ge,he,_e,Me){const qe=new P.ServiceCollection,Be=new Pe,He={_serviceBrand:void 0,...L.default};qe.set(M.IProductService,He);const je=new fe.ServerEnvironmentService(he,He);qe.set(C.IEnvironmentService,je),qe.set(C.INativeEnvironmentService,je);const re=new z.LogService(new m.SpdLogLogger(X.RemoteExtensionLogFileName,D.join(je.logsPath,`${X.RemoteExtensionLogFileName}.log`),!0,!1,(0,z.getLogLevel)(je))),be=new z.MultiplexLogService([new Ae((0,z.getLogLevel)(je)),re]);qe.set(z.ILogService,be),setTimeout(()=>le(je.logsPath).then(null,tt=>be.error(tt)),1e4),be.trace(`Remote configuration data at ${_e}`),be.trace("process arguments:",je.args);const ke=He.serverGreeting.join(`
`);ke&&re.info(`

${ke}

`),Be.registerChannel(l.ExtensionHostDebugBroadcastChannel.ChannelName,new l.ExtensionHostDebugBroadcastChannel);const Le=new b.StaticRouter(tt=>tt.clientId==="renderer");Be.registerChannel("logger",new j.LogLevelChannel(be));const Oe=Me.add(new r.FileService(be));qe.set(n.IFileService,Oe),Oe.registerProvider(k.Schemas.file,Me.add(new o.DiskFileSystemProvider(be)));const Qe=new A.ConfigurationService(je.machineSettingsResource,Oe);qe.set(T.IConfigurationService,Qe),qe.set(Z.IUriIdentityService,new $.UriIdentityService(Oe)),qe.set(Q.IRequestService,new u.SyncDescriptor(q.RequestService));let We=G.NullAppender;const Ve=await(0,R.getMachineId)();if((0,G.supportsTelemetry)(He,je)){He.aiConfig&&He.aiConfig.asimovKey&&(We=new ee.AppInsightsAppender(K,null,He.aiConfig.asimovKey),Me.add((0,p.toDisposable)(()=>We.flush())));const tt={appenders:[We],commonProperties:(0,ne.resolveCommonProperties)(Oe,(0,_.release)(),(0,_.hostname)(),process.arch,He.commit,He.version+"-remote",Ve,He.msftInternalDomains,je.installSourcePath,"remoteAgent"),piiPaths:[je.appRoot]},nt=je.args["telemetry-level"];let ot;nt==="all"?ot=3:nt==="error"?ot=2:nt==="crash"?ot=1:nt!==void 0&&(ot=0),qe.set(de.IRemoteTelemetryService,new u.SyncDescriptor(de.RemoteTelemetryService,[tt,ot]))}else qe.set(de.IRemoteTelemetryService,de.RemoteNullTelemetryService);qe.set(f.IExtensionGalleryService,new u.SyncDescriptor(w.ExtensionGalleryServiceWithNoStorageService));const Ye=Be.getChannel("download",Le);qe.set(d.IDownloadService,new g.DownloadServiceChannelClient(Ye,()=>ue("renderer"))),qe.set(f.IExtensionManagementService,new u.SyncDescriptor(i.ExtensionManagementService));const Ge=new E.InstantiationService(qe);qe.set(I.ILocalizationsService,Ge.createInstance(O.LocalizationsService));const Ze=Ge.createInstance(s.ExtensionManagementCLIService);qe.set(f.IExtensionManagementCLIService,Ze);const rt=Ge.createInstance(me.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Qe.getValue("terminal.integrated.persistentSessionScrollback")??100});return qe.set(se.IPtyService,rt),qe.set(S.IEncryptionMainService,new u.SyncDescriptor(c.EncryptionMainService,[Ve])),qe.set(h.ICredentialsMainService,new u.SyncDescriptor(v.CredentialsMainService,[!0])),Ge.invokeFunction(tt=>{const nt=new H.RemoteAgentEnvironmentChannel(ge,je,Ze,be,He);Be.registerChannel("remoteextensionsenvironment",nt);const ot=new ie.RemoteTelemetryChannel(tt.get(de.IRemoteTelemetryService),We);Be.registerChannel("telemetry",ot),Be.registerChannel(pe.REMOTE_TERMINAL_CHANNEL_NAME,new De.RemoteTerminalChannel(je,be,rt,He));const vt=new V.RemoteAgentFileSystemProviderChannel(be,je);Be.registerChannel(U.REMOTE_FILE_SYSTEM_CHANNEL_NAME,vt),Be.registerChannel("request",new W.RequestChannel(tt.get(Q.IRequestService)));const pt=tt.get(f.IExtensionManagementService),Dt=new a.ExtensionManagementChannel(pt,Ee=>ue(Ee.remoteAuthority));Be.registerChannel("extensions",Dt);const It=b.ProxyChannel.fromService(tt.get(S.IEncryptionMainService));Be.registerChannel("encryption",It);const Pt=b.ProxyChannel.fromService(tt.get(h.ICredentialsMainService));return Be.registerChannel("credentials",Pt),pt.removeDeprecatedExtensions(),Me.add(new oe.default(tt.get(B.ITelemetryService))),{telemetryService:tt.get(B.ITelemetryService)}}),{socketServer:Be,instantiationService:Ge}}e.setupServerServices=ye;class Pe extends b.IPCServer{constructor(){const he=new t.Emitter;super(he.event);this._onDidConnectEmitter=he}acceptConnection(he,_e){this._onDidConnectEmitter.fire({protocol:he,onDidClientDisconnect:_e})}}e.SocketServer=Pe;class Ae extends z.AbstractLogger{constructor(he=z.DEFAULT_LOG_LEVEL){super();this.setLevel(he),this.useColors=Boolean(process.stdout.isTTY)}trace(he,..._e){this.getLevel()<=z.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Fe()}][0m`,he,..._e):console.log(`[${Fe()}]`,he,..._e))}debug(he,..._e){this.getLevel()<=z.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Fe()}][0m`,he,..._e):console.log(`[${Fe()}]`,he,..._e))}info(he,..._e){this.getLevel()<=z.LogLevel.Info&&(this.useColors?console.log(`[90m[${Fe()}][0m`,he,..._e):console.log(`[${Fe()}]`,he,..._e))}warn(he,..._e){this.getLevel()<=z.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Fe()}][0m`,he,..._e):console.warn(`[${Fe()}]`,he,..._e))}error(he,..._e){this.getLevel()<=z.LogLevel.Error&&(this.useColors?console.error(`[91m[${Fe()}][0m`,he,..._e):console.error(`[${Fe()}]`,he,..._e))}critical(he,..._e){this.getLevel()<=z.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Fe()}][0m`,he,..._e):console.error(`[${Fe()}]`,he,..._e))}dispose(){}flush(){}}function Fe(){const ge=new Date;return`${Ue(ge.getHours())}:${Ue(ge.getMinutes())}:${Ue(ge.getSeconds())}`}function Ue(ge){return ge<10?`0${ge}`:String(ge)}async function le(ge){const he=D.basename(ge),_e=D.dirname(ge),Be=(await y.Promises.readdir(_e)).filter(je=>/^\d{8}T\d{6}$/.test(je)).sort().filter(je=>je!==he),He=Be.slice(0,Math.max(0,Be.length-9));await Promise.all(He.map(je=>y.Promises.rm(D.join(_e,je))))}}),define(ve[259],we([0,1,70,27,81,260,71,117,15,31,2,8,4,44,3,5,23,136,84,58,6,14,32,29,116,227,231,50,258,233]),function(J,e,_,t,p,k,D,R,y,b,T,A,h,v,l,d,g,S,c,C,w,f,s,a,i,n,r,o,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const P=5*60*1e3;let I=class extends T.Disposable{constructor(j,m,L,M,Q,W,q){super();this._socketServer=j,this._connectionToken=m,this._environmentService=M,this._productService=Q,this._logService=W,this._instantiationService=q,this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=L?this._instantiationService.createInstance(E.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(j,m){if(j.method!=="GET")return(0,E.serveError)(j,m,405,`Unsupported method ${j.method}`);if(!j.url)return(0,E.serveError)(j,m,400,"Bad request.");const L=D.parse(j.url,!0),M=L.pathname;if(!M)return(0,E.serveError)(j,m,400,"Bad request.");if(M==="/version")return m.writeHead(200,{"Content-Type":"text/plain"}),m.end(this._productService.commit||"");if(M==="/delay-shutdown")return this._delayShutdown(),m.writeHead(200),m.end("OK");if(!(0,r.requestHasValidConnectionToken)(this._connectionToken,j,L))return(0,E.serveError)(j,m,403,"Forbidden.");if(M==="/vscode-remote-resource"){const Q=L.query.path;if(typeof Q!="string")return(0,E.serveError)(j,m,400,"Bad request.");let W;try{W=d.URI.from({scheme:A.Schemas.file,path:Q}).fsPath}catch{return(0,E.serveError)(j,m,400,"Bad request.")}const q=Object.create(null);return this._environmentService.isBuilt&&((0,b.isEqualOrParent)(W,this._environmentService.builtinExtensionsPath,!l.isLinux)||(0,b.isEqualOrParent)(W,this._environmentService.extensionsPath,!l.isLinux))&&(q["Cache-Control"]="public, max-age=31536000"),(0,E.serveFile)(this._logService,j,m,W,q)}if(this._webClientServer){this._webClientServer.handle(j,m,L);return}return m.writeHead(404,{"Content-Type":"text/plain"}),m.end("Not found")}handleUpgrade(j,m){let L=(0,g.generateUuid)(),M=!1,Q=!1;if(j.url){const ee=D.parse(j.url,!0).query;typeof ee.reconnectionToken=="string"&&(L=ee.reconnectionToken),ee.reconnection==="true"&&(M=!0),ee.skipWebSocketFrames==="true"&&(Q=!0)}if(j.headers.upgrade!=="websocket"){m.end("HTTP/1.1 400 Bad Request");return}const W=j.headers["sec-websocket-key"],q=_.createHash("sha1");q.update(W+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ne=q.digest("base64"),B=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ne}`];let G=!1;if(!Q&&!this._environmentService.args["disable-websocket-compression"]&&j.headers["sec-websocket-extensions"]){const ee=Array.isArray(j.headers["sec-websocket-extensions"])?j.headers["sec-websocket-extensions"]:[j.headers["sec-websocket-extensions"]];for(const oe of ee)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(oe)){if(/\b(permessage-deflate)\b/.test(oe)){G=!0,B.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(oe)){G=!0,B.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}m.write(B.join(`\r
`)+`\r
\r
`),m.setTimeout(0),m.setNoDelay(!0),Q?this._handleWebSocketConnection(new C.NodeSocket(m,`server-connection-${L}`),M,L):this._handleWebSocketConnection(new C.WebSocketNodeSocket(new C.NodeSocket(m,`server-connection-${L}`),G,null,!0),M,L)}handleServerError(j){this._logService.error("Error occurred in server"),this._logService.error(j)}_getRemoteAddress(j){let m;return j instanceof C.NodeSocket?m=j.socket:m=j.socket.socket,m.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(j,m,L){const M=m.getSocket();this._logService.error(`${j} ${L}.`);const Q={type:"error",reason:L};m.sendControl(y.VSBuffer.fromString(JSON.stringify(Q))),m.dispose(),await M.drain(),M.dispose()}_handleWebSocketConnection(j,m,L){const M=this._getRemoteAddress(j),Q=`[${M}][${L.substr(0,8)}]`,W=new c.PersistentProtocol(j);let q,ne;try{const se=J.__$__nodeRequire("vsda");q=new se.validator,ne=new se.signer}catch{}let B;(function(se){se[se.WaitingForAuth=0]="WaitingForAuth",se[se.WaitingForConnectionType=1]="WaitingForConnectionType",se[se.Done=2]="Done",se[se.Error=3]="Error"})(B||(B={}));let G=0;const ee=se=>{G=3,oe.dispose(),this._rejectWebSocketConnection(Q,W,se)},oe=W.onControlMessage(se=>{if(G===0){let me;try{me=JSON.parse(se.toString())}catch{return ee("Malformed first message")}if(me.type!=="auth")return ee("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(me.auth))return ee("Unauthorized client refused: auth mismatch");let Z=(0,g.generateUuid)();if(ne)try{Z=ne.sign(me.data)}catch{}let $=(0,g.generateUuid)();if(q)try{$=q.createNewMessage($)}catch{}const H={type:"sign",data:$,signedData:Z};W.sendControl(y.VSBuffer.fromString(JSON.stringify(H))),G=1}else if(G===1){let me;try{me=JSON.parse(se.toString())}catch{return ee("Malformed second message")}if(me.type!=="connectionType")return ee("Invalid second message");if(typeof me.signedData!="string")return ee("Invalid second message field type");const Z=me.commit,$=this._productService.commit;if(Z&&$&&Z!==$)return ee("Client refused: version mismatch");let H=!1;if(!q)H=!0;else if(this._connectionToken.validate(me.signedData))H=!0;else try{H=q.validate(me.signedData)==="ok"}catch{}if(!H){if(this._environmentService.isBuilt)return ee("Unauthorized client refused");this._logService.error(`${Q} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let V in this._managementConnections)this._managementConnections[V].shortenReconnectionGraceTimeIfNecessary();for(let V in this._extHostConnections)this._extHostConnections[V].shortenReconnectionGraceTimeIfNecessary();G=2,oe.dispose(),this._handleConnectionType(M,Q,W,j,m,L,me)}})}async _handleConnectionType(j,m,L,M,Q,W,q){const ne=q.desiredConnectionType===1?`${m}[ManagementConnection]`:q.desiredConnectionType===2?`${m}[ExtensionHostConnection]`:m;if(q.desiredConnectionType===1)if(Q){if(!this._managementConnections[W])return this._allReconnectionTokens.has(W)?this._rejectWebSocketConnection(ne,L,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ne,L,"Unknown reconnection token (never seen)");L.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const B=L.readEntireBuffer();L.dispose(),this._managementConnections[W].acceptReconnection(j,M,B)}else{if(this._managementConnections[W])return this._rejectWebSocketConnection(ne,L,"Duplicate reconnection token");L.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const B=new n.ManagementConnection(this._logService,W,j,L);this._socketServer.acceptConnection(B.protocol,B.onClose),this._managementConnections[W]=B,this._allReconnectionTokens.add(W),B.onClose(()=>{delete this._managementConnections[W]})}else if(q.desiredConnectionType===2){const B=q.args||{language:"en"},G=await this._updateWithFreeDebugPort(B);if(G.port&&this._logService.trace(`${ne} - startParams debug port ${G.port}`),this._logService.trace(`${ne} - startParams language: ${G.language}`),this._logService.trace(`${ne} - startParams env: ${JSON.stringify(G.env)}`),Q){if(!this._extHostConnections[W])return this._allReconnectionTokens.has(W)?this._rejectWebSocketConnection(ne,L,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ne,L,"Unknown reconnection token (never seen)");L.sendPause(),L.sendControl(y.VSBuffer.fromString(JSON.stringify(G.port?{debugPort:G.port}:{})));const ee=L.readEntireBuffer();L.dispose(),this._extHostConnections[W].acceptReconnection(j,M,ee)}else{if(this._extHostConnections[W])return this._rejectWebSocketConnection(ne,L,"Duplicate reconnection token");L.sendPause(),L.sendControl(y.VSBuffer.fromString(JSON.stringify(G.port?{debugPort:G.port}:{})));const ee=L.readEntireBuffer();L.dispose();const oe=new i.ExtensionHostConnection(this._environmentService,this._logService,W,j,M,ee);this._extHostConnections[W]=oe,this._allReconnectionTokens.add(W),oe.onClose(()=>{delete this._extHostConnections[W],this._onDidCloseExtHostConnection()}),oe.start(G)}}else if(q.desiredConnectionType===3){const B=q.args;this._createTunnel(L,B)}else return this._rejectWebSocketConnection(ne,L,"Unknown initial data received")}async _createTunnel(j,m){const L=j.getSocket().socket,M=j.readEntireBuffer();j.dispose(),L.pause();const Q=await this._connectTunnelSocket(m.host,m.port);M.byteLength>0&&Q.write(M.buffer),Q.on("end",()=>L.end()),Q.on("close",()=>L.end()),Q.on("error",()=>L.destroy()),L.on("end",()=>Q.end()),L.on("close",()=>Q.end()),L.on("error",()=>Q.destroy()),Q.pipe(L),L.pipe(Q)}_connectTunnelSocket(j,m){return new Promise((L,M)=>{const Q=p.createConnection({host:j,port:m},()=>{Q.removeListener("error",M),Q.pause(),L(Q)});Q.once("error",M)})}_updateWithFreeDebugPort(j){return typeof j.port=="number"?(0,S.findFreePort)(j.port,10,5e3).then(m=>(j.port=m,j)):(j.debugId=void 0,j.port=void 0,j.break=void 0,Promise.resolve(j))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},P))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};I=Te([Ne(3,o.IServerEnvironmentService),Ne(4,s.IProductService),Ne(5,f.ILogService),Ne(6,w.IInstantiationService)],I),e.RemoteExtensionHostAgentServer=I;async function O(z,j,m){const L=(0,r.parseServerConnectionToken)(j);L instanceof r.ServerConnectionTokenParseError&&(console.warn(L.message),process.exit(1));const M=new T.DisposableStore,{socketServer:Q,instantiationService:W}=await(0,u.setupServerServices)(L,j,m,M);W.invokeFunction(se=>{const me=se.get(f.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Z=(0,h.join)(process.env.HOMEDRIVE,"node_modules"),$=(0,h.dirname)((0,h.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),H=(0,h.join)($,"node_modules");if(t.existsSync(Z)||t.existsSync(H)){const V=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Z}
* ${H}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;me.warn(V),console.warn(V),process.exit(0)}}});const q=t.existsSync(A.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",J).fsPath);if(q&&z&&typeof z!="string"){const se=L.type!==0?`?${A.connectionTokenQueryName}=${L.value}`:"";console.log(`Web UI available at http://localhost${z.port===80?"":`:${z.port}`}/${se}`)}const ne=W.createInstance(I,Q,L,q);v.mark("code/server/ready");const B=k.performance.now(),G=global.vscodeServerStartTime,ee=global.vscodeServerListenTime,oe=global.vscodeServerCodeLoadedTime;if(W.invokeFunction(se=>{se.get(a.ITelemetryService).publicLog2("serverStart",{startTime:G,startedTime:ee,codeLoadedTime:oe,readyTime:B})}),j["print-startup-performance"]){const se=R.LoaderStats.get();let me="";me+=`

### Load AMD-module
`,me+=R.LoaderStats.toMarkdownTable(["Module","Duration"],se.amdLoad),me+=`

### Load commonjs-module
`,me+=R.LoaderStats.toMarkdownTable(["Module","Duration"],se.nodeRequire),me+=`

### Invoke AMD-module factory
`,me+=R.LoaderStats.toMarkdownTable(["Module","Duration"],se.amdInvoke),me+=`

### Invoke commonjs-module
`,me+=R.LoaderStats.toMarkdownTable(["Module","Duration"],se.nodeEval),me+=`Start-up time: ${ee-G}
`,me+=`Code loading time: ${oe-G}
`,me+=`Initialized time: ${B-G}
`,me+=`
`,console.log(me)}return ne}e.createServer=O}),define(ve[268],we([0,1,25,27,8,255,259,53,4,260,50,45,44]),function(J,e,_,t,p,k,D,R,y,b,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,h.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const v={onMultipleValues:(i,n)=>{console.error(`Option ${i} can only be defined once. Using value ${n}.`)},onUnknownOption:i=>{console.error(`Ignoring option ${i}: not supported for server.`)},onDeprecatedOption:(i,n)=>{console.warn(`Option '${i}' is deprecated: ${n}`)}},l=(0,R.parseArgs)(process.argv.slice(2),T.serverOptions,v),d=l["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.join)(_.homedir(),A.default.serverDataFolderName||".vscode-remote"),g=(0,y.join)(d,"data"),S=(0,y.join)(g,"User"),c=(0,y.join)(S,"globalStorage"),C=(0,y.join)(g,"Machine");l["user-data-dir"]=g;const w=(0,y.dirname)(p.FileAccess.asFileUri("",J).fsPath),f=(0,y.join)(w,"extensions");l["builtin-extensions-dir"]=f,l["extensions-dir"]=l["extensions-dir"]||(0,y.join)(d,"extensions"),[d,l["extensions-dir"],g,S,C,c].forEach(i=>{try{t.existsSync(i)||t.mkdirSync(i,{mode:448})}catch(n){console.error(n)}});function s(){(0,k.run)(l,d,T.serverOptions)}e.spawnCli=s;function a(i){return(0,D.createServer)(i,l,d)}e.createServer=a})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f80445acd5a3dadef24aa209168452a3d97cc326/core/vs/server/node/server.main.js.map
